--[[
	活动弹窗
	唐实聪
	2016.6.1儿童节
]]
local ActivityPop = class("ActivityPop", function(params)
	local _params = params or {}
	local _activityType = tonumber(_params.sType) or 0
	return zc.createNormalDialog({
		showBack = _activityType == 0,
		showFlower = _activityType == 0
	})
end)

function ActivityPop:onCleanup()
	zc.removeEventListener( CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT )
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( "res/animation/roukuai/roukuai.csb", true )
    self:removeAllChildren()
    helper.collectMemory(true)
end

function ActivityPop:create( params )
	return ActivityPop.new( params )
end

function ActivityPop:ctor( params )
	local _params = params or {}
	self._activityType = tonumber(_params.sType) or 0
	self.entrance = tonumber(_params.entrance) or 1-- 控制新服活动

	self.finallRedStatus = false

	self:getOpenStatus()

	local _idx = tonumber(_params.idx)
	if _idx then
		for k,v in pairs(self._openStatus) do
			if _idx == v.id then
				self._activityIndex = tonumber(k)
			end
		end
	end
	self._activityIndex = self._activityIndex or 1
	self._size = self:getContentSize()

	self:initUI()

	zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT,
        callback = function(data)
            local _id = data.data.id
            if _id then
            	local _cell = nil
            	for i, v in ipairs( self._openStatus ) do
            		if v.id == _id then
            			_cell = self._tabTableview:cellAtIndex( i - 1 )
            			self:freshRed( _cell, _id , nil , i)
            			break
            		end
            	end
            	-- local sount = 0
            	-- for i, v in ipairs( self._openStatus ) do
            	-- 	_cell = self._tabTableview:cellAtIndex( i - 1 )
            	-- 	print("i,",i)
            	-- 	print("ice;ll,",_cell)
            	-- 	if not _cell._redPoint:isVisible() then
            	-- 		sount = sount + 1
            	-- 	end
            	-- end
            	-- if sount == #self._openStatus then
            	-- 	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
            	-- end
            end
        end
    })
end

-- 获取活动开启状态
function ActivityPop:getOpenStatus()
	local _infos = {
		{
			id = 1,
			sortId = 10,
			op = "MonthSign_main",
			file = "src/layer/activity/MonthSignLayer.lua",
		},
		{
			id = 2,
			sortId = 20,
			op = "Speed_main",
			file = "src/layer/activity/SpeedLayer.lua",
		},
		{
			id = 9,
			sortId = 30,
			op = "RechargeFirst_main",
			file = "src/layer/activity/RechargeFirstLayer.lua",
		},
		{
			id = 10,
			sortId = 40,
			op = "EveryDayCard_main",
			file = "src/layer/activity/MounthCardLayer.lua",
		},
		{
			id = 11,
			sortId = 50,
			op = "ReceiveEnergy_main",
			file = "src/layer/activity/ReceiveEnergyLayer.lua",
		},
		{
			id = 3,
			sortId = 80,
			op = "TurnTable_main",
			file = "src/layer/activity/TurntableLayer.lua",
		},
		{
			id = 4,
			sortId = 90,
			op = "HotPacks_main",
			file = "src/layer/activity/HotPacksLayer.lua",
		},
		{
			id = 5,
			sortId = 100,
			op = "BlackMarket_main",
			file = "src/layer/activity/BlackMarketLayer.lua",
		},
		{
			id = 6,
			sortId = 110,
			op = "WeaponBox_main",
			file = "src/layer/activity/WeaponBoxLayer.lua",
		},
		{
			id = 7,
			sortId = 70,
			op = "FightingRank_main",
			file = "src/layer/activity/FightingRankLayer.lua",
		},
		{
			id = 8,
			sortId = 60,
			op = "GrowUp_main",
			file = "src/layer/activity/GrowUpLayer.lua",
		},
		{
			id = 12,
			sortId = 11,
			op = "MonthSignNew_main",
			file = "src/layer/activity/MonthSignNewLayer.lua",
		},
		{
			id = 14,
			sortId = 121,
			op = "RecruitAcc_main",
			file = "src/layer/activity/RecruitAccumulateLayer.lua",
		},
		{
			id = 15,
			sortId = 130,
			op = "Dekaron_main",
			file = "src/layer/activity/DekaronLayer.lua",
		},
		{
			id = 16,
			sortId = 130,
			op = "HouseShop_activityMain",
			file = "src/layer/activity/ExchangeLayer.lua",
		},
		{
			id = 18,
			sortId = 130,
			op = "DiscountShop_main",
			file = "src/layer/activity/DiscountShopLayer.lua",
		},
		{
			id = 19,
			sortId = 130,
			file = "src/layer/activity/ArenaDoubleAwardsLayer.lua",
		},
		{
			id = 20,
			sortId = 130,
			file = "src/layer/activity/TollgateDoubleAwardsLayer.lua",
		},
		{
			id = 21,
			sortId = 130,
			op = "CountryTask_main",
			file = "src/layer/activity/ChengjiuCountry.lua",
		},
		{
			id = 30,
			sortId = 130,
			op = "ReardLevel_Main",
			file = "src/layer/activity/RewardLevel.lua",
		},
		{
			id = 31,
			sortId = 130,
			op = "Continuity_Main",
			file = "src/layer/activity/ContinuityLogin.lua",
		},
		{
			id = 32, -- 每日充值
			op = "DayChongzhi_Main",
			file = "src/layer/activity/DaiChongZhi.lua"
		},
		{
			id = 33, -- 删档封测
			file = "src/layer/activity/FengceLayer.lua"
		},
	}
	local _removeTable
	if APPSTORE_REVIEW then
		_removeTable = {10, 4}
	elseif APP_REVIEW 
	  or APP_SERVER == 2 then
		_removeTable = {9, 10, 3, 4, 5, 6, 7, 8}
	end
	if _removeTable then
		for _k, _v in pairs(_removeTable or {}) do
			for k,v in pairs(_infos) do
				if v.id == _v then
					table.remove(_infos, k)
					break
				end
			end
		end
	end
	
	self._openStatus = {}
	local _pLevel = PlayerData:getUserLevel()

	if self.entrance == 0 then
		for k,v in pairs(_infos) do
			local _info = PlayerData:getActivityInfoById(v.id)
			if _info and next(_info) ~= nil then
				local _level = tonumber(_info.level) or 1
				local _type = tonumber(_info.type) or 0
				local _entrance = tonumber(_info.entrance) or 0
				-- print("_type:",_type,"self._activityType:",self._activityType,"self.entrance:",self.entrance,"_entrance:",_entrance)
				if _pLevel >= _level and _type == 1 and (_entrance == 0) then
					v.name = zc.getActivityGtChangeTest(_info.name)
					v.sortId = tonumber(_info.sort) or 0
					table.insert(self._openStatus, v)
				end
			end
		end
	else
		for k,v in pairs(_infos) do
			local _info = PlayerData:getActivityInfoById(v.id)
			if _info and next(_info) ~= nil then
				local _level = tonumber(_info.level) or 1
				local _type = tonumber(_info.type) 
				local _entrance = tonumber(_info.entrance)
				-- print("_type:",_type,"self._activityType:",self._activityType)
				if (not _type and not _entrance ) or _entrance == 1 then
				-- if _pLevel >= _level and _type == self._activityType then
					v.name = zc.getActivityGtChangeTest(_info.name)
					v.sortId = tonumber(_info.sort) or 0
					table.insert(self._openStatus, v)
				end
			end
		end
	end
	
	--根据sortId排序活动
	table.sort( self._openStatus, function(a, b)
		return a.sortId < b.sortId
	end)
end

function ActivityPop:initUI()
	-- bg
	if self._activityType == 0 then
		local bg = zc.createNormalPop({
			src = "res/Main/common/popBg/popBg_orange.png",
			bianZOrder = 0,
			height = 527 + 31,
		})
		bg:setPosition( self._size.width/2, self._size.height/2 )
		self:addChild( bg )
		local bgSize = bg:getContentSize()
		self._bg = bg
		self._rightPos = cc.p( self._bg:getContentSize().width - 372, 245 )

		-- tab
		self:initTab()

		-- activityBg
		local activityBg = zc.createSprite( "res/Main/shop/shopBg.jpg" )
		activityBg:setAnchorPoint( 0.5, 1 )
		activityBg:setScaleY( 0.99 )
		activityBg:setPosition( bgSize.width/2, bgSize.height - 49 )
		bg:addChild( activityBg )

		-- 标题
		local title = zc.createSprite( "res/Main/activity/fuli.png" )
		title:setPosition( -35, bgSize.height + 40 )
		title:setAnchorPoint( 0, 1 )
		bg:addChild( title, 2 )
	else
		local _bg = zc.createSprite("res/Main/activity/bg.png")
		_bg:setPosition( self._size.width/2, self._size.height/2 )
		self:addChild( _bg )
		self._bg = _bg
		local bgSize = _bg:getContentSize()
		self._rightPos = cc.p( bgSize.width - 408, 260 )

		local bg = zc.createSprite( "res/Main/activity/bigDi.jpg" )
        bg:setPosition(self._rightPos.x + 40, self._rightPos.y + 10)
        self:addChild(bg, -1)

		self:initTab()


		local _btn = zc.createBackButton({
	        pos = cc.p(bgSize.width + 10, bgSize.height - 55),
	        listener = function () 
				LayerManager.removeLayout()
	        end,
	    })
		self:addChild(_btn, 5)
	end

	self:createInitTab()
end

function ActivityPop:initTab()
	-- tabBg
	local tabBg, cellWidth, cellHeight
	if self._activityType == 0 then
		tabBg = zc.createTabButtonBg({tag = 3})
	    tabBg:setAnchorPoint( 0, 0 )
	    tabBg:setPosition( 5, 8 )
	    self._bg:addChild(tabBg, 1)
	    cellWidth = 153
	    cellHeight = 62
	else
		tabBg = cc.Node:create()
		tabBg:setContentSize(215, 395)
	    tabBg:setAnchorPoint( 0, 0 )
	    tabBg:setPosition( 20, 58 )
	    self._bg:addChild(tabBg, 1)
	    cellWidth = 225
	    cellHeight = 68
	end
	local _tbnTag = self._activityType == 0 and 4 or 5

    --防止同时点击
    local touchSize = cc.size(tabBg:getContentSize().width+25,tabBg:getContentSize().height)
    local touchBtn = zc.createPushButton({
        needSwallow = true,
        noScaleAction = true,
        touchSize = touchSize,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(tabBg:getContentSize().width/2, tabBg:getContentSize().height/2)
    })
	tabBg:addChild(touchBtn)

	if self._activityType == 0 then
	    local splitY = cc.Sprite:create( "res/Main/common/tab_split_y.png" )
		splitY:setPosition( tabBg:getContentSize().width + 3, tabBg:getContentSize().height/2 )
		splitY:setScaleY( 463/493 )
		tabBg:addChild( splitY )
	end

    -- tableview
    local tabBgSize = tabBg:getBoundingBox()
    local tabTableview = zc.ZCTableView:create( cc.size( cellWidth, tabBgSize.height ) )
    tabTableview:setBounceable( true )
    tabTableview:setInertia( true )
    tabTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tabTableview:setPosition( cc.p( 0, 5 ) )
    tabTableview:setDelegate()
    tabTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
        end
        cell:removeAllChildren()

        -- index
        local _index = index + 1
        cell._index = _index

		if _index > 1 and self._activityType == 0 then
			local splitX = cc.Sprite:create( "res/Main/common/tab_split_x_new.png" )
			splitX:setAnchorPoint(0.5, 1)
			splitX:setPosition( cellWidth/2, cellHeight)
			cell:addChild( splitX )
		end
        -- btn
        local tabBtn = zc.createComTabButton({
			tag = _tbnTag,
			btnText = self._openStatus[_index].name,
			touchSize = cc.size( cellWidth, cellHeight),
			needSwallow = false,
			needEnableWhenOut = true,
			needEnableWhenMoving = true,
			pos = cc.p( cellWidth/2 - 5, cellHeight/2 - 7),
			endCallback = function()
				if self._activityIndex ~= _index then
					self:createActivity( _index, cell )
				end
			end
		})
		cell:addChild( tabBtn )
		cell._tabBtn = tabBtn
		local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
        _redPoint:setVisible(false)
        tabBtn:addChild(_redPoint, 1)
        cell._redPoint = _redPoint
        _redPoint:setAnchorPoint(1, 1)

		if self._activityIndex == _index then
			tabBtn:setSelected( true )
			cell:setLocalZOrder( 1 )
			self._activityCell = cell
			_redPoint:setPosition(tabBtn:getContentSize().width - 5, tabBtn:getContentSize().height - 5)
		else
			cell:setLocalZOrder( 0 )
			_redPoint:setPosition(tabBtn:getContentSize().width - 8, tabBtn:getContentSize().height - 5)
		end
		
        -- 刷新红点
        self:freshRed( cell, self._openStatus[_index].id )

        return cell
    end
    local function numberOfCellsInTableView()
    	return table.nums(self._openStatus)
    end
    tabTableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tabTableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tabTableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    tabBg:addChild(tabTableview)
    self._tabTableview = tabTableview
end

function ActivityPop:createActivity( _index, _cell )
	if #self._openStatus == 0 then
		return
	end
	-- 先设置为选中
	if self._activityCell then
		self._activityCell:setLocalZOrder( 0 )
		self._activityCell._tabBtn:setSelected( false )
		self._activityCell._redPoint:setPosition(self._activityCell._tabBtn:getContentSize().width - 8, self._activityCell._tabBtn:getContentSize().height - 5)
	end
	if _cell then
		_cell:setLocalZOrder( 1 )
		_cell._tabBtn:setSelected( true )
		_cell._redPoint:setPosition(_cell._tabBtn:getContentSize().width - 5, _cell._tabBtn:getContentSize().height - 5)
	else
		_cell = self._tabTableview:cellAtIndex(_index - 1)
	end
    -- 活动id
    local _data = self._openStatus[_index] or {}
    local _id = _data.id
	self:freshRed( _cell, _id, true )
    -- 活动数据
	if _data.op then
		local _params
		if _data.id == 9 then
			_params = {type=5001}
		end
		-- 请求后端
		zc.sendHttp({
			apiName = _data.op,
			params = _params,
			-- 成功回调
			successCallback = function(backData)
				if self._activityLayer then
			        self._activityLayer:removeFromParent()
			    end
			    backData.activityName = _data.name
			    backData.activityType = self._activityType
			    local _layer = requires(_data.file):create( backData )
			    _layer:setPosition( self._rightPos )
			    self._bg:addChild( _layer )
				self._activityLayer = _layer
				self._activityIndex = _index
				self._activityCell = _cell
				-- 创建的时候需要刷新tab
				if not self._tabInit then
					self._tabTableview:reloadData()
					self._tabInit = true
				end
	        end,
	        -- 失败回调
	        failCallback = function()
				if self._activityCell then
					self._activityCell:setLocalZOrder( 1 )
					self._activityCell._tabBtn:setSelected( true )
				end
				if _cell then
					_cell:setLocalZOrder( 0 )
					_cell._tabBtn:setSelected( false )
				end
	        end,
	        -- 错误码回调
	        errorCallback = function(errorCode, errorMsg)
				if self._activityCell then
					self._activityCell:setLocalZOrder( 1 )
					self._activityCell._tabBtn:setSelected( true )
				end
				if _cell then
					_cell:setLocalZOrder( 0 )
					_cell._tabBtn:setSelected( false )
				end
	        	if self._tabInit then
		        	if tonumber( errorCode ) == 341 then
		        		-- 活动未开放
		        		table.remove( self._openStatus, _index )
		        	else
                        zc.tipInfo(LANGUAGE_GETERRORTIP(errorMsg))
		        	end
	        		-- 点击tab的回调，需要提示错误信息
	        		self._tabTableview:reloadDataAndScrollToCurrentCell()
	        	else
	        		-- 初始化创建，不需要提示错误信息，直接移除
	        		table.remove( self._openStatus, _index )
	        		self:createInitTab()
	        	end
	        end,
        })
	else
		if self._activityLayer then
	        self._activityLayer:removeFromParent()
	    end
	    local _layer = requires(_data.file):create({activityType = self._activityType})
	    _layer:setPosition( self._rightPos )
	    self._bg:addChild( _layer )
		self._activityLayer = _layer
		self._activityIndex = _index
		self._activityCell = _cell
		-- 创建的时候需要刷新tab
		if not self._tabInit then
			self._tabTableview:reloadData()
			self._tabInit = true
		end
	end
end
-- 创建初始的活动
function ActivityPop:createInitTab()
	-- 活动界面
    self:createActivity( self._activityIndex )
end

-- 刷新红点
function ActivityPop:freshRed( cell, id, setTrue , idx)
	if tolua.isnull( cell ) then
		return
	end
	if idx and idx == 1 then
		self.finallRedStatus = false
	end

	if id == 2 then
		-- 竞速
		local _status = PlayerData._activitySpeedStatus
		cell._redPoint:setVisible( _status )

	elseif id == 11 then
		-- 领取体力
		local _status = false
		if PlayerData._activityFoodStatus == 2 or PlayerData._activityFoodStatus == 3 then
			_status = true
		end
		cell._redPoint:setVisible( _status )

	elseif id == 7 then
		cell._redPoint:setVisible( PlayerData:getRedState(5) == 1 )
	elseif id == 8 then
		local _status
		local _status_1
		if PlayerData:getRedState(6) == 0 then
			_status = false
		else
			_status = true
		end
		cell._redPoint:setVisible(_status)
	elseif id == 9 then
		cell._redPoint:setVisible( PlayerData:getRedState(7) == 1 )
	elseif id == 15 then
		cell._redPoint:setVisible( PlayerData:getRedState(8) == 1 )
	elseif id == 21 then
		cell._redPoint:setVisible( PlayerData:getRedState(9) == 1 )
	elseif id == 8 then -- 成长基金
		local _status
		local _status_1
		if PlayerData:getRedState(6) == 0 then
			_status = false
		else
			_status = true
		end
		cell._redPoint:setVisible(_status)
	elseif id == 30 then -- 等级礼包
		local _status
		if PlayerData:getRedState(13) == 0 then
			_status = false
		else
			_status = true
		end
		cell._redPoint:setVisible(_status)
	elseif id == 31 then -- 登录奖励
		local _status = PlayerData:getRedState(16)
		local isShow = false
		if _status == false then
			isShow = false
		else
			if _status == 0 then
				isShow = false
			else
				isShow = true
			end
		end
		cell._redPoint:setVisible(isShow)
	elseif id == 32 then -- 每日充值
		local _status = PlayerData:getRedState(18)
		local isShow = false
		if _status == false then
			isShow = false
		else
			if _status == 0 then
				isShow = false
			else
				isShow = true
			end
		end
		cell._redPoint:setVisible(isShow)
	else
		local _setTrue = setTrue
		if _setTrue == nil and not self._tabInit and cell._index == self._activityIndex then
			_setTrue = true
		end
		if _setTrue then	
			PlayerData.activityReds[id] = true
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
		end
		local _status = not PlayerData.activityReds[id]
		cell._redPoint:setVisible( _status )
	end

	if cell._redPoint:isVisible() then
		self.finallRedStatus = true
	end
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity", status = self.finallRedStatus}})
end


return ActivityPop