--[[
	奖励兑换
]]

local DaiChongZhi = class("DaiChongZhi", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(975,490)
	return layer
end)

function DaiChongZhi:create( params )
	return DaiChongZhi.new( params )
end

function DaiChongZhi:ctor( params )
	self._size = self:getContentSize()
	self:initData( params )
	self:initUI()
	self:initProcess()
	self:refresData()
	self:refresReward()
	self:refresUI()
	self:initTableview()
end

function DaiChongZhi:initData( params )
	-- dump(params)
	local list = params.list or {}
	self.list = list
	self.ValueMax = 0-- 开几天
	for k,v in pairs(list) do
		self.ValueMax = self.ValueMax + 1
	end
	self.isOne = self.ValueMax -- 适配用
	self.endTime = params.endTime or os.time()
	self._timer = nil
end

function DaiChongZhi:onExit()
	if self._timer then
		scheduler.unscheduleGlobal( self._timer )
		self._timer = nil
	end
end

function DaiChongZhi:refresData(sign)
	self.currentnum = 0
	self.dayData = {}
	self.weaponData = {}

	for k,v in pairs(self.list) do
		local single_saleData = gameData.getDataFromCacheWithPrimaryKey("dailyRecharge",v.id)
		single_saleData.status = tonumber(v.status)
		table.insert(self.dayData,single_saleData)
		if tonumber(v.status) == 0 or tonumber(v.status) == 1 then
			self.currentnum = tonumber(k)
		end
		self.boxId = single_saleData.boxId

		local show1 = single_saleData.show1
		local groupId = string.split(show1 or "",",")
		for k,v in pairs(groupId) do
			table.insert(self.weaponData,v)
		end
	end
	table.sort(self.dayData,function (a,b)
		return tonumber(a.id) < tonumber(b.id)
	end)
	if not sign then
		self.id = self.dayData[1].id
		for k,v in pairs(self.dayData) do
			if tonumber(v.status) == 0 then
				self.id = tonumber(v.id)
				break
			end
		end
		local st = 0
		for k,v in pairs(self.dayData) do
			if tonumber(v.status) == 1 then
				st = st + 1
			end
		end
		-- 0 可领 1已领 2未达成
		if st == self.isOne then
			self.id = self.dayData[self.isOne].id
		end
	end
end

function DaiChongZhi:initUI()
	-- 台子
	local bgtai = zc.createSprite("res/Main/activity/dayChongzhi/icon_taizi.png")
	bgtai:setPosition(300,self._size.height - 150)
	self:addChild(bgtai)
	-- 转光特效
	local zhaunguan = zc.createSprite("res/Main/activity/dayChongzhi/zhuanguang.png")
	zhaunguan:setPosition(bgtai:getContentSize().width/2,bgtai:getContentSize().height/2)
	bgtai:addChild(zhaunguan)
	zhaunguan:runAction(
	    CCRepeatForever:create(
	        -- cc.Sequence:create(
	            cc.RotateBy:create(3, 360)
	            )
	        -- )
	    )
	-- 右上
	local renyi = zc.createSprite('res/Main/activity/dayChongzhi/renyiyuanbao.png')
	renyi:setPosition(self._size.width/2 + 165,self._size.height - 105)
	self:addChild(renyi,20)
	-- 几天
	self.daySprite = zc.createSprite("res/Main/activity/dayChongzhi/icon_3tian.png")
	self.daySprite:setPosition(renyi:getContentSize().width/2 - 45,renyi:getContentSize().height/2 - 23)
	renyi:addChild(self.daySprite)
	-- 送什么（兵器或者勾玉）
	self.bingqi = zc.createSprite("res/Main/activity/dayChongzhi/bingqi.png")
	self.bingqi:setPosition(self._size.width/2 + 235,self._size.height - 130)
	self:addChild(self.bingqi)
	-- 左侧累计
	local gantanhao = zc.createSprite("res/Main/activity/rechargeReward/tanhao.png")
	gantanhao:setPosition(zhaunguan:getPositionX() -  15,zhaunguan:getPositionY() + 50)
	self:addChild(gantanhao)
	
    local currentbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    currentbg:setContentSize(320, 30)
    currentbg:setAnchorPoint(0, 0.5)
    currentbg:setPosition(gantanhao:getPositionX() + gantanhao:getContentSize().width/2, gantanhao:getPositionY())
    self:addChild(currentbg)

    self.currentbgsize = currentbg:getContentSize()

    local leiji = zc.createLabel({
    	text = zc.lang("recharge_count"),
    	fontSize = 20,
    	ap = cc.p(0,0.5),
    	color = cc.c3b(221,210,176),
    	pos = cc.p(10,self.currentbgsize.height/2),
    })

    currentbg:addChild(leiji)
    self.leiji = leiji

    self.TypeLabel = zc.createLabel({
    	text = LANGUAGE_get_advance_color_text(5),
    	fontSize = 19,
    	ap = cc.p(0,0.5),
    	color = cc.c3b(246,0,215),
    	pos = cc.p(leiji:getPositionX() + leiji:getContentSize().width + 5,self.currentbgsize.height/2),
    })
    currentbg:addChild(self.TypeLabel)

    self.TypeName = zc.createLabel({
    	text = "礼包",
    	fontSize = 20,
    	ap = cc.p(0,0.5),
    	color = cc.c3b(221,210,176),
    	pos = cc.p(self.TypeLabel:getPositionX() + self.TypeLabel:getContentSize().width + 5,self.currentbgsize.height/2),
    })
    currentbg:addChild(self.TypeName)
    -- 右中侧背景
    local rightbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	rightbg:setContentSize(300, 150)
    rightbg:setPosition(self._size.width - 325,self._size.height/2)
    self:addChild(rightbg)

    local _Left = zc.createSprite( "res/Main/activity/dayChongzhi/lace.png" )
    _Left:setAnchorPoint( 0, 0.5 )
    _Left:setPosition( 65, rightbg:getContentSize().height - 20 )
    rightbg:addChild( _Left,20)
    _Left:setVisible(true)

    local dayReward = zc.createSprite("res/Main/activity/dayChongzhi/dayreward.png")
    dayReward:setPosition(_Left:getPositionX() + _Left:getContentSize().width + 45,_Left:getPositionY())
    rightbg:addChild(dayReward)

    local _Right = zc.createSprite( "res/Main/activity/dayChongzhi/lace.png" )
    _Right:setAnchorPoint( 0, 0.5 )
    _Right:setPosition( dayReward:getPositionX() + dayReward:getContentSize().width/2 + 10, dayReward:getPositionY())
    _Right:setFlippedX( true )
    _Right:setVisible(true)

    rightbg:addChild(_Right,20)

    -- 奖励
    local pos = {cc.p(70,75),cc.p(150,75),cc.p(230,75)}
    for i = 1, 3 do
    	local _icon = zc.createIconByData({
				 data = {
		            mainType = 1,
		            type = 1, 
		            id = 1,
		        },
		        scale = 0.55,
		        pos = pos[i],
		        showCount = true
			})
		_icon:setTouchEndedShowTip()
		rightbg:addChild(_icon)
		self["_icon"..i] = _icon
    end

    local btn = zc.createCommomBtn({
    	tag = 1,
    	fontSize = 20,
    	text = zc.lang("fetch_2"),
    	needEnableWhenMoving = true,
    	needSwallow = false,
    	scale = 0.7,
    	pos = cc.p(rightbg:getContentSize().width/2, 5),
    	endCallback = function()
	    	
    	end,
	})
	rightbg:addChild(btn)
	self.btn = btn

	self.yilingqu = zc.createSprite("res/Main/activity/monthSign/fetched.png")
	self.yilingqu:setPosition(btn:getPositionX(),btn:getPositionY())
	self.yilingqu:setScale(0.7)
	rightbg:addChild(self.yilingqu)
	self:initTime()
end

function DaiChongZhi:initTime()
	local currentbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    currentbg:setContentSize(280, 30)
    currentbg:setPosition(cc.p(self._size.width/2 + 200,self._size.height - 40))
    self:addChild(currentbg)

    local size = currentbg:getContentSize()

	local lable = zc.createLabel({
		text = zc.lang("activityend")..":",
		ap = cc.p(0,0.5),
		pos = cc.p(10,size.height/2),
		fontSize = 20,
		outLine = true,
		pixel = 2,
		color = cc.c3b(236,176,176),
	})
	currentbg:addChild(lable)
	self.timeLabel = zc.createLabel({
		ap = cc.p(0,0.5),
		pos = cc.p(lable:getPositionX()+lable:getContentSize().width,size.height/2),
		fontSize = 20,
		outLine = true,
		pixel = 2,
		color = cc.c3b(255,242,202),
	})
	currentbg:addChild(self.timeLabel)

	local time_distance = self.endTime - PlayerData:getTssTime()
	local _oneDay = 60*60*24
	local _day = math.modf(time_distance/_oneDay)

	print("getTssTime:",PlayerData:getTssTime(),"time_distance:",time_distance,"_day:",_day)
	if _day > 1 then
		self.timeLabel:setString(_day .. zc.lang("date_day"))
		lable:setPositionX(80)
		self.timeLabel:setPositionX(lable:getPositionX() + lable:getContentSize().width)
	else
		lable:setPositionX(50)
		self.timeLabel:setPositionX(lable:getPositionX() + lable:getContentSize().width)
		local str = zc.getNewCdStringWithNumber( time_distance )
		self.timeLabel:setString(str)
	end
	self._timer = scheduler.scheduleGlobal(function()
		time_distance = ( time_distance - 1 )
		local _day = math.modf(time_distance/_oneDay)
		if _day > 1 then
			if self.timeLabel then
				self.timeLabel:setString(_day .. zc.lang("date_day"))
			end
		else
			if time_distance > 0 then
				local str = zc.getNewCdStringWithNumber( time_distance )
				if self.timeLabel then
					self.timeLabel:setString(str)
				end
			else
				self._timer:unscheduleGlobal()
				self._timer = nil
				if self.timeLabel then
					self.timeLabel:setVisible(false)
				end
				if lable then
					lable:setVisible(false)
				end
			end
		end
	end, 1)
end

function DaiChongZhi:refresUI()
	-- 每天的奖励
	for i = 1, self.isOne do
		local data = self.dayData[i]
		if data then
			-- dump(data)
			if self["item"..i] then
				local reward = data.show
				local str = string.split(reward or "","|")
				zc.updateIconByData(self["item"..i], {
					data = {
						mainType = str[1],
						type = str[2],
						id = str[2],
					}
				})
				if i ~= self.isOne then
					self["item"..i]:setTouchEndedShowTip()
				end
			end
			
		end
		if i <= (self.currentnum) then
			if self["process"..i] then
				self["process"..i]:setTexture('res/Main/activity/rechargeReward/progress_mid.png')
			end
		else
			if self["process"..i] then
				self["process"..i]:setTexture('res/Main/activity/rechargeReward/progress_mid_bg.png')
			end
		end
	end
	-- 每期送什么，多少天
	if self.isOne == 3 then
		self.daySprite:setTexture("res/Main/activity/dayChongzhi/icon_3tian.png")
		self.bingqi:setTexture("res/Main/activity/dayChongzhi/bingqi.png")
	elseif self.isOne == 4 then
		self.daySprite:setTexture("res/Main/activity/dayChongzhi/icon_4tian.png")
		self.bingqi:setTexture("res/Main/activity/dayChongzhi/gouyu.png")
	end
	-- 充值多少天送什么东西
	if self.isOne == 3 then
		local str = zc.lang("recharge_count").."三"..zc.lang("date_day")..zc.lang("presented")
		self.leiji:setString(str)
		self.TypeLabel:setPositionX(self.leiji:getPositionX() + self.leiji:getContentSize().width + 2)
		local text = zc.lang("smithy")..zc.lang("libao")
		self.TypeName:setString(text)
		self.TypeName:setPositionX(self.TypeLabel:getPositionX() + self.TypeLabel:getContentSize().width + 2)
	elseif self.isOne == 4 then
		local str = zc.lang("recharge_count").."四"..zc.lang("date_day")..zc.lang("presented")..zc.lang("gouyu")..zc.lang("libao")
		self.leiji:setString(str)
		self.leiji:setPositionX(40)
		self.TypeLabel:setString("")
		self.TypeName:setString("")
	end

	-- 领取奖励
	self.btn:setTouchEndedCall(function ( ... )
		for i = 1,self.isOne do
			local data = self.dayData[i]
			if data then
				if data.status == 0 then
					dump(data,"--------")
					zc.sendHttp({
			    		apiName = "DayChongzhi_Get",
			    		params = {id = (data.id)},
			    		successCallback = function( net_data )
			    			-- dump(net_data)
			    			net_data.noAnimation = true
			    			PlayerData:updataData(net_data)
			    			zc.createShowReward(net_data)
			    			for k,v in pairs(self.dayData) do
			    				if tonumber(v.id) == tonumber(data.id) then
			    					self.dayData[k].status = 1
			    					local index
			    					if k + 1 >= #self.dayData then
			    						index = #self.dayData
			    					else
			    						index = k + 1
			    					end

			    					self.id = self.dayData[index].id
			    					print("self.id::",self.id,"index::",index)
			    					for i,f in pairs(self.list) do
			    						if tonumber(v.id) == tonumber(f.id) then
			    							self.list[i].status = 1
			    						end
			    					end
			    				end
			    			end
			    			self:refresData(true)
			    			self:refresReward()
			    			local state = 0
			    			for k,v in pairs(self.dayData) do
			    				state = state + tonumber(v.status)
			    			end
			    			print("state:::",state)
			    			if state ~= 0 then
			    				PlayerData:updateRedDotData(18,0)
			    				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 32}})
			    			end
			    		end
					})
					break
				end
			end
		end
	end)
end

function DaiChongZhi:refresReward( ... )
	-- 0可领 1已领 2未达成
	for i = 1, self.isOne do
		local data = self.dayData[i]
		if data and tonumber(data.id) == tonumber(self.id) then
			local reward = data.reward
			local str = string.split(reward or "",",")
			print("self.id:::",self.id)
			-- dump(str,"str")
			for j = 1,3 do
				if self["_icon"..j] then
					local _data_re = string.split(str[j] or "","|")
					-- dump(_data_re,"_data_re")
					zc.updateIconByData(self["_icon"..j],{
						data = {
							mainType = _data_re[1],
							type = _data_re[2],
							id = tonumber(_data_re[2]),
							num = _data_re[3]
						},
						showCount = true,
					})
					self["_icon"..j]:setTouchEndedShowTip()
				end
			end
			if data.status == 0 then
				self.btn:setEnable(true)
				self.yilingqu:setVisible(false)
				self.btn:setVisible(true)
			elseif data.status == 1 then 
				self.btn:setEnable(false)
				self.btn:setVisible(true)
				self.yilingqu:setTexture("res/Main/activity/monthSign/fetched.png")
				self.yilingqu:setVisible(false)
				self.yilingqu:setScale(0.7)
				self.yilingqu:setPosition(self.btn:getPositionX(),self.btn:getPositionY())

			elseif data.status == 2 then 
				self.btn:setEnable(false)
				self.btn:setVisible(false)
				self.yilingqu:setVisible(true)
				self.yilingqu:setTexture("res/Main/activity/fightingRank/unGet.png")
				self.yilingqu:setScale(0.9)
				self.yilingqu:setPosition(self.btn:getPositionX(),self.btn:getPositionY() + 15)
			end
		end
		if data.status == 1 then
			if self["processyilingqu"..i] then
				self["processyilingqu"..i]:setVisible(true)
			end
		else
			if self["processyilingqu"..i] then
				self["processyilingqu"..i]:setVisible(false)
			end
		end
	end
end

function DaiChongZhi:initProcess()
	local bg = zc.createSprite("res/Main/activity/dayChongzhi/icon_diwen.png")
	bg:setPosition(self._size.width/2 + 13,95)
	self:addChild(bg)

	local rewardsp = zc.createSprite("res/Main/activity/dayChongzhi/czreward.png")
	rewardsp:setPosition(30,bg:getContentSize().height/2 - 5)
	bg:addChild(rewardsp)

    local begainPos = 70
    local distance = 175
    if self.isOne == 3 then -- 3. tian
    	begainPos = 40
		distance = 165
	elseif self.isOne == 4 then -- 4 tian 
		begainPos = -50
		distance = 165
    end

    for i = 1,self.isOne do
        local currentbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	    currentbg:setContentSize(80, 80)
	    currentbg:setPosition(cc.p(begainPos + distance*i, bg:getContentSize().height/2))
	    bg:addChild(currentbg)
		
	    local item = zc.createIconByData({
				 data = {
		            mainType = 1,
		            type = 1, 
		            id = 1,
		        },
		        scale = 0.6,
		        pos = cc.p(currentbg:getPositionX(),currentbg:getPositionY()),
		        showCount = true
			})
	    if i ~= self.isOne then
			item:setTouchEndedShowTip()
		else
			self.boxbtn = zc.createPushButton({
				touchSize = item:getContentSize(),
		        pos = cc.p(item:getPositionX(),item:getPositionY()),
		        endCallback = function()
		        	local data = gameData.getDataFromCacheWithPrimaryKey("treasure",self.boxId)
		        	zc.createSourcePop("rewardPreview", "src/layer/task/RewardPreviewPop.lua",{award = data.items })
		        end
			})
			bg:addChild(self.boxbtn)
		end
		self["item"..i] = item
		bg:addChild(item,10)

		local processyilingqu = zc.createSprite("res/Main/activity/monthSign/fetched.png")
		processyilingqu:setPosition(item:getPositionX(),item:getPositionY())
		bg:addChild(processyilingqu,11)
		processyilingqu:setVisible(false)
		processyilingqu:setScale(0.6)
		self["processyilingqu"..i] = processyilingqu

		if i ~= self.isOne then
			local process = zc.createSprite("res/Main/activity/rechargeReward/progress_mid_bg.png")
			process:setAnchorPoint(0,0.5)
			process:setPosition(currentbg:getPositionX() + 20,currentbg:getPositionY())
			bg:addChild(process)
			self["process"..i] = process
		end

        --活跃度
        local sp = zc.createSprite("res/Main/activity/dayChongzhi/di.png")
        sp:setPosition(begainPos + distance*i,10)
        bg:addChild(sp)
        local _task_activity_label = zc.createLabel({
            text = i..zc.lang("date_day"),
            fontSize = 16,
            ap = cc.p(0.5, 0),
            pos = cc.p(sp:getContentSize().width/2,sp:getContentSize().height/2 - 10),
            outLine = true,
        })
        sp:addChild(_task_activity_label)  
    end
end
function DaiChongZhi:initTableview()
	self._tableviewSize = cc.size(200,240)
	local tableview = zc.ZCTableView:create(self._tableviewSize)
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    tableview:setPosition( cc.p(200, 220))
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 200
    local cellHeight = 240
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellWidth, cellHeight)
        end
        self:updateCell( cell, index + 1 )
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self.weaponData
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    self:addChild(tableview)
    self._tableview = tableview
    
    tableview:reloadData()
    local sp = ccui.Scale9Sprite:create(cc.size(1,1,10,10),"res/Main/activity/unsele.png")
    sp:setContentSize(self._tableviewSize)
    local btn1 = zc.createPushButton({
    	-- normalNode = sp,
		touchSize = self._tableviewSize,
        pos = cc.p(tableview:getPositionX() + self._tableviewSize.width/2,tableview:getPositionY() + self._tableviewSize.height/2),
        endCallback = function()
        	return
        end
	})
	self:addChild(btn1)

	self._leftBtn = zc.createPushButton({
    	normalFile = "res/Main/arena/hallFame/arrow_up.png",
    	selectedFile = "res/Main/arena/hallFame/arrow_down.png",
    	pos = cc.p(170,360),
    	endCallback = function()
    		local page = tableview:getCurrentPage()
    		tableview:scrollToCell(page - 1)
    		if page == 1 then
    			self._leftBtn:setVisible(false)
    		else
    			self._leftBtn:setVisible(true)
    		end
    		self._rightBtn:setVisible(true)
    	end,
    })
    self._leftBtn:setVisible(false)
    self:addChild(self._leftBtn)
    local _node1 = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    _node1:setFlippedX(true)
    local _node2 = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _node2:setFlippedX(true)

    self._rightBtn = zc.createPushButton({
    	normalNode = _node1,
    	selectedNode = _node2,
    	pos = cc.p(440, 360),
    	endCallback = function()
    		local currpage = tableview:getCurrentPage()
    		tableview:scrollToCell(currpage + 1)
    		if currpage == #self.weaponData - 2 then
    			self._rightBtn:setVisible(false)
    		else
    			self._rightBtn:setVisible(true)
    		end
    		self._leftBtn:setVisible(true)
    	end,
    })
    self:addChild(self._rightBtn)
end
function DaiChongZhi:buildCell( cell, cellWidth, cellHeight)
	local bg =  zc.createSprite("res/Main/weapon/weaponImage/69.png")
	bg:setPosition( cellWidth/2,cellHeight/2)
	cell:addChild( bg )
	cell.bg = bg
end

function DaiChongZhi:updateCell( cell, index )
	local id = self.weaponData[index]
	if not id then return end
	local data
	local iconId
	if self.isOne == 3 then
		data = gameData.getDataFromCacheWithPrimaryKey("weapon",id)
		cell.bg:setTexture("res/Main/weapon/weaponImage/"..data.iconId..".png")
	elseif self.isOne == 4 then
		data = gameData.getDataFromCacheWithPrimaryKey("gem",id)
		cell.bg:setTexture("res/Main/gem/gemIcon/"..data.icon..".png")
	end
	if tonumber(data.iconId) == 72 then
		cell.bg:setScaleX(0.75)
	else
		cell.bg:setScale(1)
	end
	
end
return DaiChongZhi