local RewardLevel = class("RewardLevel", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function RewardLevel:create( params )
	return RewardLevel.new( params )
end

function RewardLevel:ctor( params )
    self._activityType = params.activityType
	self:initData( params )
	self:initUI()
    self:initTableivew()
    self:initButtom()
end

function RewardLevel:initData( params )
    -- dump(params)
	local _tasks = params.task or {}
    self._activityName = params.activityName or ""
    self.activityType = params.activityType
    local data = gameData.getDataFromCache("lvlreward_table")
	self._datas = {}

	for k,v in pairs(params.list or {}) do
        for f,g in pairs(data) do
            if tonumber(k) == tonumber(g.lvl) then
                g.status = v.status
                table.insert(self._datas, g)
            end
        end		
	end
    
    self:sortData()
	self._size = self:getContentSize()

    self.total_can_get = 0
    for k,v in pairs(self._datas) do
        if tonumber(v.status) == 1 then
            self.total_can_get = self.total_can_get + 1
        end
    end
end

function RewardLevel:sortData()
    -- 0是未完成 1是已完成未领取 2是已领取
    self.achievementData = {}
    local list1 = {}
    local list2 = {}
    local list3 = {}
    for k,v in pairs(self._datas) do
        if v.status == 0 then
            table.insert(list1,v)
        elseif v.status == 1 then
            table.insert(list2,v)
        elseif v.status == 2 then
            table.insert(list3,v)
        end
    end
    table.sort(list1,function (a,b)
        return a.id < b.id
    end)
    table.sort(list2,function (a,b)
        return a.id < b.id
    end)
    table.sort(list3,function (a,b)
        return a.id < b.id
    end)
    for k,v in pairs(list2) do
        table.insert(self.achievementData,v)
    end
    for k,v in pairs(list1) do
        table.insert(self.achievementData,v)
    end
    for k,v in pairs(list3) do
        table.insert(self.achievementData,v)
    end
    -- dump(self.achievementData,"test")
end

function RewardLevel:initUI()
    local leftpos
    print("self,activityType:::",self.activityType)
    if self.activityType == 2 then
        leftpos = cc.p(-40,self._size.height + 15)
    else
        leftpos = cc.p(90,self._size.height + 3)
    end

	local _tipDi = zc.createSprite("res/Main/activity/hotPacks/itemBg.png")
	_tipDi:setAnchorPoint(0.5, 1)
	_tipDi:setPosition(leftpos)

	local _leftBt = zc.createSprite("res/Main/activity/hotPacks/bj_3.png")
    _leftBt:setAnchorPoint(0.5, 1)
    _leftBt:setPosition(_tipDi:getPositionX(), _tipDi:getPositionY() - _tipDi:getContentSize().height*0.5)
    self:addChild(_leftBt)
	self:addChild(_tipDi)
	local _leftHeada = zc.createSprite("res/Main/activity/hotPacks/lb_105.png")
    _leftHeada:setPosition(_tipDi:getPositionX(), _leftBt:getPositionY() - 3)
    self:addChild(_leftHeada)

    local _w, _h = 44, 150
    local _titleDi = ccui.Scale9Sprite:create(cc.rect(2, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _titleDi:setContentSize(_w, _h)
    _titleDi:setAnchorPoint(1, 0.5)
    _titleDi:setPosition(_leftBt:getContentSize().width*0.5 + 5, _leftBt:getContentSize().height*0.5 + 28)
    _leftBt:addChild(_titleDi)

    local _labelTitle = zc.createLabel({
    	text = self._activityName,
    	fontSize = 26,
    	outLine = true,
    	pixel = 2,
    	color = cc.c3b(240, 232, 168),
    	width = 40,
    	pos = cc.p(_w*0.5 + 5, _h*0.5)
	})
    _labelTitle:setLineSpacing(-2)
	_titleDi:addChild(_labelTitle)

    local levelLabel = zc.createLabel({
        text = zc.lang("levelLabel1"),
        fontSize = 19,
        outLine = true,
        pixel = 2,
        width = 5,
        ap = cc.p(0,1),
        color = cc.c3b(251, 165, 186),
    })
    levelLabel:setLineSpacing(-5)
    levelLabel:setPosition(_leftBt:getContentSize().width/2 + 23,_leftBt:getContentSize().height/2 + 102)
    _leftBt:addChild(levelLabel)

    local levelLabel2 = zc.createLabel({
        text = zc.lang("levelLabel2"),
        fontSize = 19,
        outLine = true,
        pixel = 2,
        width = 5,
        ap = cc.p(0,1),
        color = cc.c3b(251, 165, 186),
    })
    levelLabel2:setLineSpacing(-6)
    levelLabel2:setPosition(_leftBt:getContentSize().width/2 + 23,_leftBt:getContentSize().height/2)
    _leftBt:addChild(levelLabel2)

end

function RewardLevel:initTableivew( ... )
    local tableSize = cc.size(560,400)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition(160,62)
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = 560
    local _cellHeight = 150
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildRightCell(cell,cellIndex + 1,_cellHeight,_cellWidth)
        end
        self:updateRightCell(cell, cellIndex + 1,_cellHeight,_cellWidth)
        return cell
    end
    local _num = #self.achievementData
    local function numberOfCellsInTableView()
        return _num
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self:addChild( tableView )
    tableView:reloadData()

    self.right_tableView = tableView
end

function RewardLevel:buildRightCell( cell,cellIndex,_cellHeight,_cellWidth )
    -- bg
    cell._item_bg = ccui.Scale9Sprite:create(cc.rect(20,20,150,150),"res/Main/activity/cell_bg_2.png")
    cell._item_bg:setContentSize(560,150)
    cell._item_bg:setPosition(_cellWidth/2,_cellHeight/2)

    cell:addChild(cell._item_bg)

    local size = cell._item_bg:getContentSize()

    local img = zc.createSprite("res/Main/activity/dekaron/titleTip.png")
    img:setPosition(147,cell._item_bg:getContentSize().height - 24)
    cell._item_bg:addChild(img)

    local posList = {
        cc.p(60,size.height/2 - 8),cc.p(150,size.height/2 - 8),
        cc.p(240,size.height/2 - 8),cc.p(330,size.height/2 - 8)
    }
    for i = 1,4 do
        local _item = zc.createIconByData({
            data = {
                mainType = 1,
                type = 1,
                id = 1,
                num = 1,
            },
            showCount = true,
            pos = posList[i],
        })  
        _item:setScale(0.6)
        cell._item_bg:addChild(_item)
        cell["_item"..i] = _item
    end

    --描述
    cell._task_desc_label = zc.createLabel({
        text = zc.lang("level_achieve"),
        fontSize = 21,
        ap = cc.p(0, 0.5),
        color = cc.c3b(251,239,196),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(20,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label)
    -- level
    cell._task_desc_label_level = zc.createLabel({
        text = "20",
        fontSize = 25,
        ap = cc.p(0, 0.5),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(cell._task_desc_label:getPositionX() + cell._task_desc_label:getContentSize().width,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label_level)
    -- ji
    cell._task_desc_label_ji = zc.createLabel({
        text = zc.lang("level_1"),
        fontSize = 21,
        ap = cc.p(0, 0.5),
        color = cc.c3b(251,239,196),
        outLine = true,
        pixel = 1.6,
        pos = cc.p(cell._task_desc_label_level:getPositionX() + cell._task_desc_label_level:getContentSize().width,img:getContentSize().height/2 + 2),
    })
    img:addChild(cell._task_desc_label_ji)

    -- 前往
    cell._task_goto = zc.createCommomBtn({
        tag = 3,
        ap = cc.p(0.5,0.5),
        pos = cc.p(size.width - 100, size.height/2 - 5),
        fontSize = 28,
        scale = 0.7,
        text = zc.lang("qianwang_2"),
    })
    cell:addChild(cell._task_goto)

    cell.yilingqu = zc.createSprite("res/Main/activity/monthSign/fetched.png")
    cell.yilingqu:setPosition(cell._task_goto:getPositionX(),cell._task_goto:getPositionY())
    cell:addChild(cell.yilingqu)

     --完成度数据
    cell._completionDegree_label = zc.createLabel({
        text = "10/",
        fontSize = 24,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(size.width - 100, size.height/2 + 35),
        outLine = true,
        pixel = 1.3,
        color = display.COLOR_GREEN,
        color2 = cc.c3b( 87, 0, 0 ),
    })
    cell._item_bg:addChild(cell._completionDegree_label)
end
function RewardLevel:updateRightCell(cell,cellIndex,_cellHeight,_cellWidth )
    local data = self.achievementData[cellIndex]
    if not data then return end

    local status = tonumber(data.status ) or 0
    -- 0是未完成 1是已完成未领取 2是已领取
    if status == 0 then
        local text = zc.lang("qianwang_2") 
        cell._task_goto:setText(text)
        cell.yilingqu:setVisible(false)
        cell._task_goto:setVisible(true)
        cell._completionDegree_label:setVisible(true)
    elseif status == 1 then
        local text = zc.lang("fetch_2")
        cell._task_goto:setText(text)
        cell.yilingqu:setVisible(false)
        cell._task_goto:setVisible(true)
        cell._completionDegree_label:setVisible(true)
    elseif status == 2 then
        cell._task_goto:setVisible(false)
        cell.yilingqu:setVisible(true)
        cell._completionDegree_label:setVisible(false)
    end
    -- 进度
    local level = tonumber(PlayerData.info.level)
    local targetlevel = data.lvl or 1
    local str = level.."/"..targetlevel
    cell._completionDegree_label:setString(str)
    cell._completionDegree_label:setColor(level < targetlevel and display.COLOR_RED or display.COLOR_GREEN)
    -- 等级
    local str_nus = tostring(data.lvl or 1)
    cell._task_desc_label_level:setString(str_nus)
    -- 奖励
    local rewardData = data.reward
    local list = string.split(rewardData,",")
    -- dump(list)
    for i = 1,4 do
        if list[i] then
            local _cont = string.split(list[i],"|")
            zc.updateIconByData(cell["_item"..i],{
                data = {
                    mainType = _cont[1],
                    type = _cont[2],
                    id = _cont[2],
                    num = _cont[3],
                },
                showCount = true,
            })
            cell["_item"..i]:setTouchEndedShowTip()
            cell["_item"..i]:setVisible(true)
        else
            cell["_item"..i]:setVisible(false)
        end
    end
    cell._task_goto:setTouchEndedCall(function()
        -- 0是未完成 1是已完成未领取 2是已领取
        if status == 0 then
            LayerManager.backToMainCity(false)
            zc.createChapter()
        elseif status == 1 then
            zc.sendHttp({
                apiName = "ReardLevel_Get",
                params = {level = data.lvl},
                successCallback = function( net_data )
                    net_data.noAnimation = true
                    PlayerData:updataData(net_data)
                    zc.createShowReward(net_data)
                    for k,v in pairs(self._datas) do
                        if tonumber(v.lvl) == tonumber(data.lvl) then
                            v.status = 2
                        end
                    end
                    self:sortData()
                    self.right_tableView:reloadData()
                    self.total_can_get = self.total_can_get - 1
                    if self.total_can_get == 0 then
                        print("你特么的给我消失.....1")
                        PlayerData:updateRedDotData(13,0)
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 30}})
                    end
                end
            })
        end
    end)
end
function RewardLevel:initButtom( ... )
    -- bottom
    local _file = "res/Main/role/trinket/sellDi.png"
    local _rect = cc.rect(20, 10, 549, 71)
    local bottom = ccui.Scale9Sprite:create(_rect, _file)
    bottom:setContentSize(724, 67)
    bottom:setAnchorPoint(0.5, 0)
    bottom:setPosition(self._size.width*0.5 + 5, -5)
    self:addChild( bottom )
    local bottomSize = bottom:getContentSize()
    -- 提示
    local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    timeBg:setContentSize(320, 30)
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(20, bottomSize.height*0.5)
    bottom:addChild(timeBg)
    -- 当前等级
    local currentbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    currentbg:setContentSize(170, 30)
    currentbg:setAnchorPoint(0, 0.5)
    currentbg:setPosition(bottomSize.width - 190, bottomSize.height*0.5)
    bottom:addChild(currentbg)

    local tanhao = zc.createSprite("res/Main/activity/rechargeReward/tanhao.png")
    tanhao:setAnchorPoint(0,0.5)
    tanhao:setPosition(5,15)
    timeBg:addChild(tanhao)
    -- 达到指定等级就可领取相应奖励
    local timeTip = zc.createLabel({
        text = zc.lang("getReward"),
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = cc.p(tanhao:getPositionX() + 29, timeBg:getContentSize().height*0.5),
        color = cc.c3b(255,241,202),
    })
    timeBg:addChild(timeTip)

    -- 当前等级
    local curr = zc.createLabel({
        text = zc.lang("curr_level")..":",
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = cc.p(5, currentbg:getContentSize().height*0.5),
        color = cc.c3b(208,189,139),
    })
    currentbg:addChild(curr)
    -- 当前等级num
    local curr_num = zc.createLabel({
        text = PlayerData.info.level,
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(curr:getPositionX() + curr:getContentSize().width + 5, currentbg:getContentSize().height*0.5),
    })
    currentbg:addChild(curr_num)
    -- ji
    local curr_ji = zc.createLabel({
        text = zc.lang('level_1'),
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = cc.p(currentbg:getContentSize().width - 30, currentbg:getContentSize().height*0.5),
        color = cc.c3b(208,189,139),
    })
    currentbg:addChild(curr_ji)
end

return RewardLevel