--[[
类型3道具的多选1弹窗
2017-02-21
BagChoosePop.lua
]]

local BagChoosePop = class("BagChoosePop",function()
	return ZCPopLayer:create()
end);

function BagChoosePop:create(data)
    local _pop = BagChoosePop.new(data)
    _pop:show()
    return _pop
end

function BagChoosePop:ctor( data )
    self:initData(data)
	self:initUI()
end

function BagChoosePop:initData( data )
    self._info = data.info--物品信息
    self._items = {}
    self._db = gameData.getDataFromCacheWithPrimaryKey("treasure", self._info.itemId)
    self._callback = data.callback 

    local _tmpInfos = string.split(self._db.items, ",")
    for i=1,#_tmpInfos do
        local _tmpInfo = string.split(_tmpInfos[i], "|")
        table.insert(self._items, _tmpInfo)
    end

end

function BagChoosePop:initUI()
      
    local _width = #self._items == 4 and 627 or 487
    local _height = 490
    local _bgSp = zc.createNormalPop({
        tag = 2,
        width = _width,
        height = _height,
        titleSrc = "res/Main/common/tipTitle/xuanzejiangli.png"
    })
    self:addContent(_bgSp)

    local backButton = zc.createBackButton({
        pos = cc.p(_width - 10, _height - 30),
        listener = function () 
            self:hide()
        end,
    })
    _bgSp:addChild(backButton, 5)

    -- bottom
    local _diHeight = 83
    local _bottom = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    _bottom:setContentSize(_width, _diHeight)
    _bottom:setAnchorPoint(0, 0)
    _bottom:setPosition(-2, 0) 
    _bgSp:addChild(_bottom, 1)

    local _chooseBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_width*0.5, _diHeight*0.5), 
        text = zc.lang("confirm2"),
        endCallback = function() 
            if self._callback then
                self._callback(1, self._selectedIdx)
            end
            self:hide()
        end
    })
    _bottom:addChild(_chooseBtn)

    -- middle
    local _middleWidth = _width - 36
    local _middleHeight = 310
    local _middle = zc.createGeneralPopScale({
        tag = 3,
        width = _middleWidth,
        height = _middleHeight,
    })
    _middle:setAnchorPoint(0.5, 0)
    _middle:setPosition(_width*0.5, _diHeight - 10)
    _bgSp:addChild(_middle)

    local _richLabel = zc.createRichLabel({
        text = LANGUAGE_BAG_CHOOSE_TIP(#self._items),
        fontSize = 24,
        color = cc.c3b(154, 137, 108),
    })
    _richLabel:setPosition(_middleWidth*0.5, _middleHeight - 27)
    _middle:addChild(_richLabel)

    local _cellWidth, _cellHeight = 140, 240

    local function _doSelected( idx )
        if self._selectedIdx then
            local _tmpCell = self._items[self._selectedIdx].cell
            _tmpCell:setEnable(true)
            _tmpCell.selectedNode:setVisible(false)
            _tmpCell.unCbtn:setVisible(true)
            _tmpCell.cBtn:setVisible(false)
        end

        self._selectedIdx = idx

        local _tmpCell = self._items[self._selectedIdx].cell
        _tmpCell:setEnable(false)
        _tmpCell.selectedNode:setVisible(true)
        _tmpCell.unCbtn:setVisible(false)
        _tmpCell.cBtn:setVisible(true)
    end

    local _startX = _middleWidth*0.5
    local _partWidth = _cellWidth
    if #self._items == 2 then
        _partWidth = 180
        _startX = _startX - _partWidth*0.5
    elseif #self._items == 3 then
        _partWidth = 146
        _startX = _startX - _partWidth
    elseif #self._items == 4 then
        _partWidth = 146
        _startX = _startX - _partWidth*1.5
    end

    for i=1, #self._items do
        local _cell = zc.createPushButton({
            normalNode = zc.createScale9Sprite({
                rect = cc.rect(15, 15, 70, 70),
                file = "res/Main/home/avator_bg.png",
                size = cc.size(_cellWidth, _cellHeight),
            }),
            noScaleAction = true,
            pos = cc.p(_startX + (i - 1)*_partWidth, _middleHeight*0.5 - 20),
            endCallback = function()
                _doSelected(i)
            end
        })
        _middle:addChild(_cell)
        self._items[i].cell = _cell

        local _item, _info = zc.createIconByData({
            data = {
                mainType = self._items[i][1],
                type = self._items[i][2], 
                id = self._items[i][2],
            },
        })
        _item:setScale(0.8)
        _item:setPosition(_cellWidth*0.5, _cellHeight - 65)
        _cell:addChild(_item, 1)

        local _selectedNode = ccui.Scale9Sprite:create(cc.rect(15, 15, 60, 60), "res/Main/common/popBg/di_2.png")
        _selectedNode:setContentSize(_cellWidth, _cellHeight)
        _selectedNode:setPosition(_cellWidth*0.5, _cellHeight*0.5)
        _cell:addChild(_selectedNode)
        _cell.selectedNode = _selectedNode
        _selectedNode:setVisible(false)

        local _itemDi = zc.createGeneralPopScale({
            tag = 3,
            width = 105,
            height = 105,
        })
        _itemDi:setPosition(_item:getPosition())
        _selectedNode:addChild(_itemDi)

        local _nameW, _nameH = _cellWidth - 30, 33
        local _nameDi = zc.getScaleNode("res/Main/common/popBg/di_properties.png", cc.size(_nameW, _nameH))
        _nameDi:setPosition(_cellWidth*0.5, _cellHeight*0.5 - 20)
        _cell:addChild(_nameDi, 1)

        local _nameTTF = zc.createLabel({
            text = _info.name,
            fontSize = 22,
            pos = cc.p(_nameW*0.5, _nameH*0.5)
        })
        _nameDi:addChild(_nameTTF, 1)

        local _unCbtn = zc.createSprite("res/Main/bag/unChoose.png")
        _unCbtn:setPosition(_cellWidth*0.5, 50)
        _cell:addChild(_unCbtn, 1)
        _cell.unCbtn = _unCbtn

        local _cBtn = zc.createSprite("res/Main/bag/choose.png")
        _cBtn:setPosition(_unCbtn:getPosition())
        _cell:addChild(_cBtn, 1)
        _cBtn:setVisible(false)
        _cell.cBtn = _cBtn
    end
    _doSelected(1)


    do return end
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2, zc.height/2),
    })
    self:addContent(bg)

    local title = zc.getTipPopTitle( "wupinchushou" )
    title:setPosition( bg:getContentSize().width/2, bg:getContentSize().height - 30 )
    bg:addChild(title,2)
    
    local _bgSize = bg:getContentSize()
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)


    --道具
	local item = nil
    if tonumber(self._info["mainType"]) == zc.mainTypeWeapon then 
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = self._info["weaponId"],
                -- num = 1,
                quality = self._info["color"],
            }, 
        })
    else
        item = zc.createIconByData({
            data = {
                mainType = self._info["mainType"],
                type = 1, 
                id = self._info["itemId"],
                -- num = self._info["num"],
                quality = self._info["color"],
            }, 
        })
    end
    item:setPosition(contentBg:getContentSize().width*0.5, 145)
    item:setScale(0.75)
    contentBg:addChild(item)
   
    local name = zc.createLabel({
    	text = self._info["name"],
    	fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(contentBg:getContentSize().width*0.5, 80),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(name)
    local num = zc.createLabel({
    	text = zc.lang("curr_have")..":",
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, 170),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
    	text = self._info["num"],
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, 170),
        outLine = true,
        color =display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    self._num2 = num2
    
    local addBg = zc.createScale9Sprite({
        size = cc.size(360, 65),
        rect = cc.rect(50, 50, 1, 1),
        file = "res/Main/common/img_empty.png",
        pos = cc.p(contentBg:getContentSize().width/2, 40),
    })
    contentBg:addChild(addBg)
    --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Min",
        endCallback = function()
            self:setMinNum(1)
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)
    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Max",
        endCallback = function()
            self:setMaxNum(self._maxNum)
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
            size = cc.size(120, 40),
            file = "res/Main/bag/new/bag_text_bg_s.png",
            pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
        })
    addBg:addChild(numBg)
    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    
    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 60), 
        text = self._rightBtnText,
        endCallback = function () 
            if self._rightFunc then 
                local newinfo = table.copy(self._info)
                newinfo["sellnum"] = self._useNum
                self._maxNum = self._maxNum - self._useNum
                if tonumber(self._maxNum) <= 0 then 
                    self._num:setText(0)
                    self._sell_label:setText(0)
                    self._rightFunc(self._useNum) 
                    self:hide()
                else
                    self._num:setText(1)
                    local _str_num = self._info["price"]
                    self._sell_label:setText(_str_num)
                    self._num2:setText(self._maxNum)
                    self._rightFunc(self._useNum) 
                end
            end
        end,
    })
    bg:addChild(useBtn)

    local sellImg = zc.getSprite({
        src = "res/Main/common/common_icon_money.png",
        pos = cc.p(useBtn:getPositionX() - useBtn:getContentSize().width*0.5 + 30, useBtn:getPositionY() + useBtn:getContentSize().height*0.5 + 20),
        scale = 0.9
    })
    bg:addChild(sellImg)
    local sell2 = zc.createLabel({
        text = self._info["price"],
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(sellImg:getPositionX() + sellImg:getContentSize().width*0.5 + 5, sellImg:getPositionY()),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild(sell2)
    self._sell_label = sell2

end
function BagChoosePop:addNum(addnum)
    self._useNum = self._useNum + addnum
    if self._useNum >= tonumber(self._maxNum) then 
        self._useNum = self._maxNum
    elseif self._useNum <= 1 then
        self._useNum = 1
    end
    self._num:setText(self._useNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
function BagChoosePop:setMaxNum(maxNum)
    self._useNum = maxNum
    self._num:setText(maxNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
function BagChoosePop:setMinNum(minNum)
    self._useNum = minNum
    self._num:setText(minNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
return BagChoosePop