--[[
    FileName: WeaponSynthesisPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local WeaponSynthesisPop = class( "WeaponSynthesisPop", function ()
    return ZCPopLayer:create()
end)
function WeaponSynthesisPop:create(params)
    return WeaponSynthesisPop.new(params)
end
function WeaponSynthesisPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:createHeadItemList()
    self:show()
end
function WeaponSynthesisPop:initData(params)
    local params = params or {}
    if params.isBagItem then
        self._isBagItem = true
        self._callback = params.callback
        self._params = params
        local itemInfo = gameData.getDataFromCacheWithPrimaryKey("item", params["itemId"] )
        self._itemInfo = itemInfo
        self._itemList = {}
        local targetInfo = gameData.getDataFromCacheWithPrimaryKey("item", zc.cardExtractPopId )
        local targetId = targetInfo["id"]
        self._targetId = targetId
        self._itemList[1] = {
            itemType = zc.mainTypeProp,
            itemId = targetId,
        }
        self._itemList[2] = {
            itemType = zc.mainTypeProp,
            itemId = itemInfo["id"],
        }   
    else  
        self._callback = params.callback
        self._params = params
        local itemInfo = gameData.getDataFromCacheWithPrimaryKey("item", params["itemId"] )
        self._itemInfo = itemInfo
        self._itemList = {}
        local weaponInfo = gameData.getDataFromCache("synth_weapon", {stuffId=params["itemId"]} )
        local weaponId = weaponInfo["id"]
        self._weaponId = weaponId
        self._itemList[1] = {
            itemType = zc.mainTypeWeapon,
            itemId = weaponId,
        }
        self._itemList[2] = {
            itemType = zc.mainTypeProp,
            itemId = itemInfo["id"],
        }
    end
end
function WeaponSynthesisPop:initUI()
    local _height = 495
    local _middlHeight = 316
    if self._isBagItem then
        _height = _height - 40
        _middlHeight = _middlHeight - 40
    end
    local popBg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        showSide = false,
        height = _height+31,
        width = 377,
        bianZOrder = 0
    })
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    self._popSize = cc.size(377,_height)

    -- local headInfoBg = zc.getScaleNode("res/Main/common/common_up_bg.png", cc.size(360, 130))
    local headInfoBg = zc.createSprite()
    headInfoBg:setContentSize( cc.size(360, 130) )
    headInfoBg:setAnchorPoint(cc.p(0.5, 1))
    headInfoBg:setPosition(cc.p(self._popSize.width/2-2, self._popSize.height-40))
    popBg:addChild(headInfoBg, 100)
    self._headInfoBg = headInfoBg

    local middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 350,
        height = _middlHeight,
    })
    middleBg:setAnchorPoint(cc.p(0.5, 0))
    middleBg:setPosition(cc.p(self._popSize.width/2-2, 15))
    popBg:addChild(middleBg)
    self._middleBg = middleBg

end
function WeaponSynthesisPop:createHeadItemList(_is_one_key)
    if self._headInfoBg then
        self._headInfoBg:removeAllChildren()
    end
    local headSize = self._headInfoBg:getContentSize()
    for i = 1,#self._itemList do
        local _v = self._itemList[i]

        if i == 1 then
            local _mainHeroBg = cc.Sprite:create( "res/Main/role/fetter/heroBg.png" )
            _mainHeroBg:setPosition( 50, headSize.height/2 )
            self._headInfoBg:addChild( _mainHeroBg )
            _mainHeroBg:setScale(0.6)
        elseif i > 1 then
            local rightArrow = zc.createSprite("res/Main/common/arrow_right.png")
             rightArrow:setAnchorPoint(0.5, 0.5)
             rightArrow:setPosition(50+(i-1)*120-60, headSize.height/2)
             self._headInfoBg:addChild(rightArrow) 
             rightArrow:setScale(0.5)
        end
        local item = zc.createIconByData({
            data = {
                mainType = _v.itemType,
                type = _v.itemId,
                id = _v.itemId,
                quality = 1,
            }, 
            listener = function()
                if not self._isBagItem then
                    if i == 1 then
                        self._mySysBg:setVisible(true)
                        if self._myTable then
                            self._myTable:setVisible(false)
                        end
                        if self._backBtn then
                            self._backBtn:setVisible(true)
                        end
                    elseif i == 2 then
                        if not self._myTable then
                            self:jump()
                        else
                            self._mySysBg:setVisible(false)
                            self._myTable:setVisible(true)
                            if self._backBtn then
                                self._backBtn:setVisible(false)
                            end
                        end
                    end
                end
            end,
            pos = cc.p(50+(i-1)*120, headSize.height/2), 
        })
        item:setScale(86/120)
        self._headInfoBg:addChild(item)

        if i == #self._itemList then
            local downArrow = zc.createSprite("res/Main/common/arrow_right.png")
            downArrow:setAnchorPoint(0.5, 0.5)
            downArrow:setPosition(item:getPositionX(), item:getPositionY()-50)
            self._headInfoBg:addChild(downArrow) 
            downArrow:setRotation(90)
            downArrow:setScale(0.5)
            local params = {id=_v["itemId"],itemType=_v["itemType"],sysNum=_v["sysNum"],needNum=_v["needNum"],costNum=_v["costNum"],_IS_ONE_KEY=_is_one_key}
            self:initSysthesisInfo(params)
            
        end
    end
end

function WeaponSynthesisPop:initSysthesisInfo(params)

    if not self._mySysBg then
        local sysSize = cc.size(self._middleBg:getContentSize().width-22, 192)
        local mySysBg = zc.createGeneralPopScale({
            tag = 2,
            width = sysSize.width,
            height = 192,
        })
        mySysBg:setAnchorPoint(cc.p(0.5, 1))
        mySysBg:setPosition(cc.p(self._middleBg:getContentSize().width/2, self._middleBg:getContentSize().height-8))
        self._middleBg:addChild(mySysBg)
        self._mySysBg = mySysBg

    end
    local mySysBg = self._mySysBg
    local mySysSize = cc.size(self._middleBg:getContentSize().width-22, 192)

    local nameLab = zc.createLabel({
        text = self._itemInfo["name"],
        outLine = true,
        fontSize = 18,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(mySysSize.width/2, mySysSize.height-21),
        color = zc.getColorByQuality(self._itemInfo["color"]),
    })
    mySysBg:addChild(nameLab)

    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, nameLab:getContentSize().height/2 )
    nameLab:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(nameLab:getContentSize().width+2, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    nameLab:addChild(lace_right)

    --目标物品
    local itemBg = zc.createSprite("res/Main/common/item_bg.png")
    itemBg:setPosition(mySysSize.width/2, mySysSize.height-95)
    mySysBg:addChild(itemBg, 1)
    itemBg:setScale(106/108)
    --目标物品
    local item = zc.createIconByData({
        data = {
            mainType =  zc.mainTypeProp,
            type = self._itemInfo["id"], 
            id = self._itemInfo["id"],
            quality = 1,
        }, 
        pos = cc.p(mySysSize.width/2, mySysSize.height-95)
    })
    item:setScale(98/125)  
    mySysBg:addChild(item, 1)
    self._item = item

    local costInfo
    if not self._isBagItem then
        costInfo = gameData.getDataFromCacheWithPrimaryKey("synth_weapon", self._weaponId)
    else
        costInfo = gameData.getDataFromCacheWithPrimaryKey("synth_item", self._targetId)
    end

    local costItemsmNum = zc.createLabel({
        text = "",
        fontSize = 24,
        ap = cc.p(1, 0.5),
        pos = cc.p(item:getContentSize().width-10, 17),
        outLine = true,
        color = display.COLOR_WHITE,
        pixel = 1.3,
    })
    costItemsmNum:setName("costItemsmNum")
    item:addChild(costItemsmNum)
    self._costItemsmNum = costItemsmNum

    --aq获取
    if not self._isBagItem then
        local scaleSize = cc.size(90, 50)
        -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
        local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
        local getBtn = zc.createPushButton({
            normalNode = myScale9,
            needSwallow = false,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(mySysSize.width/2, 25),
            endCallback = function() end,
        })
        mySysBg:addChild(getBtn)
        getBtn:setTouchEndedCall(function()
            --跳转武器副本
            self:jump()
        end)
        local getLab = zc.createLabel({
            text = zc.lang("to_get"),
            outLine = true,
            fontSize = 24,
            ap = cc.p(0, 0.5),
            pos = cc.p(0, getBtn:getContentSize().height/2 ),
            color = display.COLOR_BTNFONTYELLOW,
            pixel = 1.3
        })
        getBtn:addChild(getLab)
        local getLabLine = zc.createLabel({
            text = "______", 
            stroke = true,
            fontSize = 24,
            ap = cc.p(0, 0.5),
            pos = cc.p(0, getLab:getPositionY()-3),
            color = display.COLOR_BTNFONTYELLOW,
            pixel = 1.3
        })
        getBtn:addChild(getLabLine)
        local getArrow = zc.createSprite("res/Main/synthesis/getImg.png")
        getArrow:setAnchorPoint(0, 0.5)
        getArrow:setPosition(getLab:getPositionX()+getLab:getContentSize().width, getLab:getPositionY()-1)
        getBtn:addChild(getArrow)
        self._getBtn = getBtn
    end

    --消耗的物质
    local _consumeResLab = zc.createLabel({
        text = zc.lang("compound_cost") .. "：",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(mySysSize.width/2 , -24),
        pixel = 1.3
    })
    mySysBg:addChild(_consumeResLab)
    local costResInfo = string.split(costInfo["cost"], ",")
    local _consumeRes = {}
    for i = 1, table.nums(costResInfo) do
        local costRes = string.split(costResInfo[i], "|")
        if costRes[1] and costRes[2] then
            local idx = #_consumeRes + 1
            _consumeRes[idx] = {}
            _consumeRes[idx].itemType = costRes[1]
            _consumeRes[idx].id = costRes[2]
            _consumeRes[idx].type = costRes[2]
            _consumeRes[idx].num = costRes[3]
        end
    end
    self._resCostInfo = _consumeRes
    self._resItemList = {}
    local _consumeList = {}
    for i = 1, #_consumeRes do
        local _v = _consumeRes[i]
        local _resImg = zc.createSprite(zc.getImgByType(_v["id"]))
        _resImg:setAnchorPoint(0, 0.5)
        _resImg:setPosition(_consumeResLab:getPositionX()+_consumeResLab:getContentSize().width/2, _consumeResLab:getPositionY() )
        mySysBg:addChild(_resImg)
        _consumeList[#_consumeList+1] = _resImg

        local _resNum = zc.createLabel({
            text = _v["num"],
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(_resImg:getPositionX()+_resImg:getContentSize().width, _resImg:getPositionY()),
            color = _color,
            pixel = 1.3
        })
        mySysBg:addChild(_resNum)
        _consumeList[#_consumeList+1] = _resNum
        self._resItemList[#self._resItemList+1] = _resNum
    end
    local _allWidth = 0
    for i = 1, #_consumeList do
        _allWidth = _allWidth + _consumeList[i]:getContentSize().width
    end
    _consumeResLab:setPositionX(mySysSize.width/2-_allWidth/2)
    for i = 1, #_consumeList do
        if i == 1 then
            _consumeList[i]:setPositionX(_consumeResLab:getPositionX()+_consumeResLab:getContentSize().width/2)
        else
            _consumeList[i]:setPositionX(_consumeList[i-1]:getPositionX()+_consumeList[i-1]:getContentSize().width)
        end
    end
    if not next(_consumeList) then
        _consumeResLab:setVisible(false)
    end

    if self._isBagItem then
        self:refreshBagItemCostInfo()
    else
        self:refreshCostInfo()
    end
    self:setTouchState(touchParams)
end
function WeaponSynthesisPop:refreshBagItemCostInfo()
    self._itemEnougth = true
    self._resEnougth = true

    local sysInfo = gameData.getDataFromCacheWithPrimaryKey("synth_item", self._targetId)
    local stuff1 = sysInfo["stuff1"] or ""
    local costInfo = string.split(stuff1, "|")
    --花费道具
    local _ownNum = 0
    local _ownNumStr = ""
    local _color = display.COLOR_WHITE
    local _consumeNum = tonumber(costInfo[3]) or 1
    local bagInfo = PlayerData:getBagInfoByID(self._itemInfo["id"]) or {}
    _ownNum = bagInfo["num"] or 0
    _ownNumStr = _ownNum.."/".._consumeNum
    if _consumeNum <= 0 then
        _ownNumStr = _ownNum
    end
    if tonumber(_ownNum) < tonumber(_consumeNum) then
        _color = display.COLOR_RED
        self._itemEnougth = false
    end
    self._itemNeedNum = tonumber(_consumeNum) - tonumber(_ownNum)
    self._costItemsmNum:setText(_ownNumStr)
    self._costItemsmNum:setColor(_color)
    --花费资源
    for i = 1, #self._resCostInfo do
        local _v = self._resCostInfo[i]
        local _ownNum = PlayerData:getResourcesInfoById(_v["id"]) or 0
        local _color = display.COLOR_WHITE
        if tonumber(_v["num"]) > _ownNum then
            _color = display.COLOR_RED
            self._resEnougth = false
        end
        self._resItemList[i]:setColor(_color)
    end

    if not self._resEnougth or not self._itemEnougth then
        if self._backBtn then
            self._backBtn:setEnable(false)
        end
    end
end
--刷新合成花费
function WeaponSynthesisPop:refreshCostInfo()
    self._itemEnougth = true
    self._resEnougth = true

    local costInfo = gameData.getDataFromCacheWithPrimaryKey("synth_weapon", self._weaponId)
    --花费道具
    local _ownNum = 0
    local _ownNumStr = ""
    local _color = display.COLOR_WHITE
    local _consumeNum = tonumber(costInfo["num"]) or 1
    local bagInfo = PlayerData:getBagInfoByID(self._itemInfo["id"]) or {}
    _ownNum = bagInfo["num"] or 0
    _ownNumStr = _ownNum.."/".._consumeNum
    if _consumeNum <= 0 then
        _ownNumStr = _ownNum
    end
    if tonumber(_ownNum) < tonumber(_consumeNum) then
        _color = display.COLOR_RED
        self._itemEnougth = false
    end
    self._itemNeedNum = tonumber(_consumeNum) - tonumber(_ownNum)
    self._costItemsmNum:setText(_ownNumStr)
    self._costItemsmNum:setColor(_color)
    --花费资源
    for i = 1, #self._resCostInfo do
        local _v = self._resCostInfo[i]
        local _ownNum = PlayerData:getResourcesInfoById(_v["id"]) or 0
        local _color = display.COLOR_WHITE
        if tonumber(_v["num"]) > _ownNum then
            _color = display.COLOR_RED
            self._resEnougth = false
        end
        self._resItemList[i]:setColor(_color)
    end
    if self._itemEnougth then
        self._getBtn:setVisible(false)
    else
        self._getBtn:setVisible(true)
    end
    if not self._resEnougth or not self._itemEnougth then
        if self._backBtn then
            self._backBtn:setEnable(false)
        end
    end
end
function WeaponSynthesisPop:setTouchState()
    local backBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("smith_synthesis"),
        needSwallow = false,
        endCallback = function()
            if self._isBagItem then
                local _spine = zc.createSpine({
                    -- fileName = "jiban",
                    -- actName = "open",
                    fileName = "qianghua_jinjie",
                    actName = "animation2",
                    loop = false,
                    needInit = false,
                    autoRemove = true,
                })
                _spine:setScale(3.1)
                _spine:setPosition(self._item:getContentSize().width/2-2,self._item:getContentSize().height/2)
                self._item:addChild(_spine)
                local canSynthesisTable  = PlayerData:canSynthesis(self._targetId)
                local trsSynthInfo = PlayerData:canAKeySynthesis(canSynthesisTable, 1, {})
                trsSynthInfo = zc.jsonencode(trsSynthInfo)
                zc.sendHttp({
                    apiName = "Bag_synthItem",
                    params = {synthInfo = trsSynthInfo},
                    successCallback = function (data)
                        self._didSynthItem = true
                        LayerManager.addShieldLayout(nil, 0.3)
                        -- zc.tipInfo("合成成功！")
                        -- data.noAnimation = true
                        PlayerData:updataData(data)
                        self:refreshBagItemCostInfo()
                    end,
                })
            else
                zc.sendHttp({
                    apiName = "Weapon_synthesis",
                    params = {weaponId=self._weaponId},
                    successCallback = function (net_data)
                        self._didSynthItem = true
                        PlayerData:updataData(net_data)
                        PlayerData:addWeapon(net_data["weaponInfo"])
                        if zc.getPop("makeGodWeapon") == nil then 
                            musicManager.playEffect(zc.effect.zhaomu)
                            zc.createPop("makeGodWeapon", {info = PlayerData:getWeaponInfoInfoById(net_data["weaponInfo"]["id"]),onlyShow=true})
                        end
                        self:refreshCostInfo()
                    end
                })
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(self._popSize.width/2, 50)
    })
    self._popBg:addChild(backBtn)
    self._backBtn = backBtn
    if not self._resEnougth or not self._itemEnougth then
        backBtn:setEnable(false)
    end
end

--跳转(武器副本没有数据，得从后端拉)
function WeaponSynthesisPop:jump()
    local source = self._itemInfo.source or ""
    local sourceInfo = string.split(source, ",")
    local sourceTable = {} --武器副本的
    local copySourceTable = {} --普通副本的
    for i = 1, #sourceInfo do
        local _str = sourceInfo[i]
        local _strTa = string.split(_str,"|")
        if _strTa[1] and tonumber(_strTa[1]) == 9 then --武器副本的
            local idx = #sourceTable+1
            sourceTable[idx] = {}
            sourceTable[idx].id = tonumber(_strTa[2])
            sourceTable[idx].copyState = 9
        elseif _strTa[1] and tonumber(_strTa[1]) == 3 then --普通副本的
            copySourceTable[#copySourceTable+1] = tonumber(_strTa[2])
        elseif _strTa[1] and tonumber(_strTa[1]) == 2 then --多人副本掉落
            if not self._challengeBuilding then
                self._challengeBuilding = PlayerData:getHouseInfoByHouseId(15) or {}
            end
            local idx = #sourceTable+1
            sourceTable[idx] = {}
            sourceTable[idx].id = tonumber(_strTa[2])
            sourceTable[idx].copyState = 2
            sourceTable[idx].icon = "12"
            sourceTable[idx].status = false
            local _myLevel = tonumber(self._challengeBuilding.level)
            local tollgateTeamData = gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", _strTa[2]) or {}
            sourceTable[idx].name = tollgateTeamData["name"] or zc.lang("multi_copy")
            if _myLevel and tollgateTeamData then
                if tollgateTeamData.houseLevel and _myLevel >= tonumber(tollgateTeamData.houseLevel) then
                    sourceTable[idx].status = true
                end
            end
        end
    end
    self._dropList = sourceTable
    if next(copySourceTable) then
        local tollgateList = PlayerData:getCopyInfo()
        -- 副本类型
        self._nationData = tollgateList[1] or {}
        for i = 1, #copySourceTable do
            self:buildCopyInfo(copySourceTable[i])
        end
    end
    local _flag = zc.getFunctionStatus(32) --武器副本开启
    if _flag then
            self._mySysBg:setVisible(false)
            self._record = {}
            self._dropNum = table.nums(self._dropList)
            self:initTable()
    else
        self._mySysBg:setVisible(false)
        self._record = {}
        self._dropNum = table.nums(self._dropList)
        self:initTable()
    end
end
function WeaponSynthesisPop:buildCopyInfo(_tollid)
    local _tollid = tonumber(_tollid)
    -- 章节
    local tollgeteInfo = gameData.getDataFromCacheWithPrimaryKey("tollgate", _tollid)

    if tollgeteInfo and tollgeteInfo.chapterId then
        local chapterId = tonumber( tollgeteInfo.chapterId )
        local chapterData = self._nationData[chapterId] or {}
        -- 关卡
        local tollgateData = {}
        for k, w in ipairs( chapterData["tollgates"] or {} ) do
            if tonumber( w.tollgateId ) == _tollid then
                tollgateData = w
                break
            end
        end
        -- 状态
        local status = tonumber( tollgateData["status"] ) or 0
        local star   = tonumber( tollgateData["star"] ) or 0
        local data = {
            id = tollgeteInfo.id,
            icon = tollgeteInfo.icon,
            name = tollgeteInfo.name,
            chapterId = tollgeteInfo.chapterId,
            nationId = nationId,
            dropType = 0,
            star = star,
        }
        if status == 2 then
            -- 已通关
            data.status = true
        else
            -- 未通关
            data.status = false
        end
        self._dropList[#self._dropList + 1] = data
    end
end
function WeaponSynthesisPop:initTable()
    if self._backBtn then
        self._backBtn:setVisible(false)
    end

    local tableSize = cc.size(self._middleBg:getContentSize().width-10, 310)
    local myTableBg = self._middleBg

    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-10, 306))
    myTable:setPosition(5,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    myTableBg:addChild(myTable)
    self._myTable = myTable
    local function cellSizeForTable(table,idx)
        return 85, tableSize.width
    end
    local function numberOfCellsInTableView(table)
        return self._dropNum
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width, 80))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()
end

function WeaponSynthesisPop:updateCell(cell, nowIdx)
    local cellData = self._dropList[nowIdx]
    local cellSize = cell:getContentSize()
    local cellBg = zc.getScaleNode("res/Main/common/common_inner22.png", cc.size(cellSize.width,cellSize.height-5))
    cellBg:setPosition(cc.p(cellSize.width/2, cellSize.height/2))
    cell:addChild(cellBg)

    -- 图标
    local iconPath = ""
    local iconBgPath = ""
    local titleName = ""
    local tollgateName = ""
    local _scale = 1.0
    if cellData.copyState and cellData.copyState == 9 then
        local chapterData = gameData.getDataFromCacheWithPrimaryKey("weapon_tollgate_chapter",cellData.id ) or {}
        iconPath = "res/Main/hero/head/hero_head_"..tostring(chapterData["icon"])..".png"
        iconBgPath = "res/Main/hero/hero_item4.png"
        titleName = zc.lang("weapon_copy")
        tollgateName = chapterData["name"]
        _scale = 1.3
    elseif cellData.copyState and cellData.copyState == 2 then
        iconPath = "res/Main/copy/"..cellData.icon..".png"
        titleName = zc.lang("multi_copy")
        tollgateName = cellData.name
        _scale = 0.63
    else
        iconPath = "res/Main/copy/"..cellData.icon..".png"
        titleName = zc.lang("noraml_chapter")
        tollgateName = cellData.name
    end
    local iconbg = zc.createSprite(iconBgPath)
    iconbg:setPosition(45, cellBg:getContentSize().height/2)
    iconbg:setScale(70/125)
    cellBg:addChild(iconbg)
    local icon = zc.createSprite(iconPath)
    icon:setPosition(cc.p(iconbg:getContentSize().width/2, iconbg:getContentSize().height/2))
    icon:setScale(_scale)
    iconbg:addChild(icon)

    -- 副本名字
    local nation = zc.createLabel({
        text = titleName,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(cellSize.width/2-30, 55),
        color = display.COLOR_YELLOW,
        outLine = true,
    })
    cellBg:addChild( nation )
    -- 关卡名字
    local tollgate = zc.createLabel({
        text = tollgateName,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(cellSize.width/2-30, 25),
        color = display.COLOR_WHITE,
        outLine = true,
    })
    cellBg:addChild( tollgate)
    --前往按钮
    local _isOpen = false
    if cellData.copyState and cellData.copyState == 9 then
        _isOpen = true
    elseif cellData.copyState and cellData.copyState == 2 then
        if cellData.status then
            _isOpen = true
        end
    else
        if cellData.status then
            _isOpen = true
        end
    end

    if _isOpen then
        local goBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/btn_sec_u.png",
            selectedFile = "res/Main/common/button/btn_sec_d.png",
            pos = cc.p(275, cellSize.height/2-5), 
            anchor = cc.p(0.5, 0.5),
            needEnableWhenMoving = true,
            needSwallow = false,
            fontSize = 30,
            scale = 0.6,
            outLine = true,
            text = zc.lang("qianwang_2"),
            color2 = cc.c3b(76, 18, 18),
            endCallback = function()
                -- 前往副本的回调
                if cellData.copyState and cellData.copyState == 9 then
                    self:goDrop(cellData.id)
                elseif cellData.copyState and cellData.copyState == 2 then
                    zc.createMultiCopyMainScene(cellData.id)
                else
                    self:goCopy(cellData)
                end
            end
        })
        cellBg:addChild(goBtn)
    else
        local goBtn = zc.createPushButton({
            touchSize = cc.size( 150, 70 ),
            pos = cc.p(270, cellSize.height/2-5), 
            needEnableWhenMoving = true,
            needSwallow = false,
            fontSize = 20,
            text = LANGUAGE_TOLLGATEHERO.not_open,
            outLine = true,
            fontColor = display.COLOR_RED,
            endCallback = function()
                zc.tipInfo(zc.lang("tips_checkpoint_not_open") .. "！")
            end
        })
        cellBg:addChild(goBtn)
    end
end
function WeaponSynthesisPop:goCopy(data)
    -- 副本掉落
    local dropInfo = {
        mainType = self._itemList[2].itemType,
        itemId = self._itemList[2].itemId,
        needNum = self._itemNeedNum,
        name = self._itemInfo.name,
    }
    LayerManager.removeLayout(true)
    --如果可以直接扫荡，直接去扫荡
    if data["star"] and tonumber(data["star"]) >= 3 then
        --从后端获取怪物和掉落物品
        zc.sendHttp({
            apiName = "Tollgate_getTollInfo",
            params = {id=data.id},
            successCallback = function (net_data)
                local _tollid = data.id
                local _tollData = PlayerData:getCurTollGateData(_tollid)
                zc.createSourcePop("Copysweep", "src/layer/chapter/CopysweepPop.lua", {
                    enemyData = _tollData,
                    dropInfo = net_data.dropInfo,
                    tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", _tollData.tollgateId),
                    dropNeedItem = dropInfo,
                    nationId = 1,
                })
            end,
        })
    else
        zc.createTollgateLayer({
            nationId = data.nationId,
            tollgateId = data.chapterId,
            enemyid = data.id,
            dropInfo = dropInfo,
        })
    end
end

function WeaponSynthesisPop:goDrop(_id)
    self:hide()
    zc.createWeaponCopy(_id)
end

function WeaponSynthesisPop:onCleanup()
    if self._callback then
        local _flag = self._backBtn:isEnable()
        if not self._didSynthItem then
            _flag = true
        end
        self._callback(_flag)
    end
end


return WeaponSynthesisPop