-- 
local fazheng = class("fazheng", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function fazheng:create(params)
	return fazheng.new(params)
end

function fazheng:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 6
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	end
	return count
end

function fazheng:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local flag = true
	if skillType == BATTLE_SKILL_TYPE.ATK  then
		for k,hero in pairs(hurtTargets) do
			print("法正。。。。。。")
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "fazheng", actName = "atk_01", loop = true})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_02")
				self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "fazheng", actName = "atk0_01", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	zc.battle.doShockAndFlash(evt)
            	if self:isAttackEvent(evt, skillType)then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    -- armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
		    --目标位置
			local endPos 			= point
		    _arrow:setPosition(endPos)
			-- _arrow:runAction(cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(function()
			-- 	armature:getAnimation():play("atk3_02")
			-- end)))

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then

		local _playName = "atk3_01" 
		local _evt = evt
		if _evt == "do_atk3_hit2" then
			_playName = "atk3_02"
		end

		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "fazheng", actName = _playName, loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	zc.battle.doShockAndFlash(evt)
            	if self:isAttackEvent(evt,_evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})

		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature

		    if _playName == "atk3_02" then
		    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    	armature:setPosition(ccp(armature:getPositionX(), armature:getPositionY() + 10))
		    else
		    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    end

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function fazheng:showDefenseEffect(params)
	local skillType 	= params.skillType
	local hero 			= params.hero

	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function fazheng:isAttackEvent(evt, _evt)
	local attackEvt = false

	if _evt == "do_atk3_hit2" then
		if evt == "do_atk3_hit" then
		else
			if string.find(evt,"hit") then
				attackEvt = true
			end
		end
	else
		if string.find(evt,"hit") then
			attackEvt = true
		end
	end

	return attackEvt
end


-- function fazheng:isSkillEventAllDone(skillType,evt)
-- 	local ret = true
-- 	-- if skillType == 3 then
-- 	-- 	if not string.find(evt,"hit3") then
-- 	-- 		ret = false
-- 	--     end 
-- 	-- end
-- 	return ret
-- end

function fazheng:shouldMoveAttack(atkName)
	local ret = false
	-- if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
	-- 	ret = false
	-- end
	return ret
end


return fazheng