--  Created by zhangchao on 16-03-29.

local fuyongmoushi = class("fuyongmoushi", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function fuyongmoushi:create(params)
	return fuyongmoushi.new(params)
end


function fuyongmoushi:shouldMoveAttack(atkName)
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		return true
	end
	return false
end

function fuyongmoushi:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 7
	end
	return count
end

function fuyongmoushi:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end

function fuyongmoushi:getAttackPoint(skillType,targetHero)
	if skillType ~= BATTLE_SKILL_TYPE.SUPER then
		return self:getAttackNormalPoint(skillType,targetHero)
	end
	local _x = -80
    local rect 			= BATTLE_BONE_NAME.RECT_SUPER
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5,6}) then
			_position = 5
		else
			_position = 8
		end
    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end

function fuyongmoushi:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "fuyongmoushi"
		local _actName  = "eff_zidan"

		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "eff_shouji" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("eff_shouji")
				armature:setScaleX(math.abs(armature:getScaleX()))
				if self:getSide() == BATTLE_SIDE.RIGHT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    			self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		local _fileName = "fuyongmoushi"
		local _actName  = "eff_atk0_jineng"

		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "eff_atk0_jineng" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if k == 1 then
					self:doHurt(params)
				end
            end})
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 2},
			})
		end
	else
		self:doHurt(params)
	end
end

return fuyongmoushi




