--  Created by zhangchao on 16-06-29.
local guojia = class("guojia", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function guojia:create(params)
	return guojia.new(params)
end

local csbs = nil
function guojia:ctor(params)
	csbs = {"guojia_atk","guojia_fit2"}
	self:preloadCsbs(csbs)
	self._fit2SkillId = 342
end

function guojia:getCsbFiles()
	return csbs
end

function guojia:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 6
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		if self._specialStatus then
			count = 0
		else
			count = 6
		end
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 3 or 6
	end
	return count
end

function guojia:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "cybejing",
		skeletonActName = "guojia",
		name = "guojia",
		-- 合体技特效
		fileName = "guojia_fit2",
		actName = "Fit2",
	}
	if self._isFit2 then
		fitSrc.fileName = "guojia_Fit0_A2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function guojia:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget

	local tmp_side 	= self:getSide()
	local diffx = -300
	if tmp_side == BATTLE_SIDE.LEFT then
		tmp_side = BATTLE_SIDE.RIGHT
	else
		tmp_side = BATTLE_SIDE.LEFT
		diffx = 300
	end
	local position = 5
	if firstTarget then
		position = firstTarget:getBattlePosition()
	end
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	pos.x 			= pos.x + diffx
	-- pos.y 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5}).y
	armature:setPosition(pos)
	if self:getSide() == BATTLE_SIDE.LEFT then
		armature:setScaleX(-1 * armature:getScaleX())
	end
end

function guojia:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local pos
	if skillType ~= 3 then
	    local runningScene 		= cc.Director:getInstance():getRunningScene()
		local y 				= targetHero:getPositionY()
		local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		-- dump(denfenser_point,"denfenser_point")
		local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
		local x 				= denfenser_point.x - attackerMidBox.width / 2
		if self:getSide() == BATTLE_SIDE.RIGHT then
			x 					= denfenser_point.x + attackerMidBox.width / 2
		end
		pos 				= cc.p(x,y)
	--[[大招单独处理]]
	else
	    local tmp_side 	= self:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	    local x 		= cc.Director:getInstance():getWinSize().width / 2
	    
	    local diff_x 	= 100
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	diff_x 		= -100
	    end
	    pos.x 			= x + diff_x
	end
	return pos
end

function guojia:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit" then
			for k,hero in pairs(hurtTargets) do
				local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
				local _arrow = zc.battle.createBattleEffect({fileName = "guojia_atk" , actName = "atk" , moveCallback = function (armatureBack,movementType,movementID)
	            	if movementType == ccs.MovementEventType.complete and (movementID == "atk_1" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
                    		end,
                    		function ()
	                            print("armatureBack已被删除")
	                        end
                        )
	                end
	            end})
			    _arrow:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
				--起始位置
				local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
				--目标位置
				local endPos 			= point
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - _targetSlot.y;
				local deltaX = endPos.x - _targetSlot.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
				end
				local pos_delta = cc.pGetDistance(endPos, _targetSlot)
				local dt = zc.getDynamicTime(pos_delta, 3000)
				_arrow:runAction(
					cc.Sequence:create(
						cc.MoveTo:create(dt,endPos),
						cc.CallFunc:create(function()
							_arrow:getAnimation():play("atk_1", -1, 0)
							self:doHurt(params)
						end)
		    		)
	    		)
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = self:getLocalZOrder() + 1},
				})
			end
		else
			self:doHurt(params)
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		if evt == "do_atk0_hit" then
			for k,hero in pairs(hurtTargets) do
				local _effect = zc.battle.createBattleEffect({fileName = "guojia_atk" , actName = "atk0" , moveCallback = function (armatureBack,movementType,movementID)
	            	if movementType == ccs.MovementEventType.complete and (movementID == "atk0" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
                    		end,
                    		function ()
	                            print("armatureBack已被删除")
	                        end
                        )
	                end
	            end})
			    _effect:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _effect, zorder = hero:getLocalZOrder() + 1},
				})
			end
			self:doHurt(params)
		else
			for k,hero in pairs(hurtTargets) do
				local _effect = zc.battle.createBattleEffect({fileName = "guojia_atk" , actName = "atk0_1" , moveCallback = function (armatureBack,movementType,movementID)
	            	if movementType == ccs.MovementEventType.complete and (movementID == "atk0_1" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
                    		end,
                    		function ()
	                            print("armatureBack已被删除")
	                        end
                        )
	                end
	            end})
			    _effect:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _effect, zorder = hero:getLocalZOrder() + 1},
				})
			end
			self:doHurt(params)
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		self:setLocalZOrder( 2000 )
		self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function guojia:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	elseif atkName == BATTLE_ANIMATION_ACTION.FIT_START then
		ret = false
	end
	return ret
end

function guojia:playAction(actName,loop)
	local nowAnim, nowAnimType = self:getNowAnimationName()
	
	if self:isAlive() == false then
		-- print("正在播放"..tostring(nowAnim).."--actName="..tostring(actName))
		return
	end
	if actName == nowAnim then
		local _flag = true
		if actName == BATTLE_ANIMATION_ACTION.SUPER and nowAnimType then
			local processInfo = self:getSelectedTargets(actName)
			if processInfo and nowAnimType ~= BATTLE_ANIMATION_ACTION.ATK4_END then
				_flag = false
			elseif not processInfo and nowAnimType == BATTLE_ANIMATION_ACTION.ATK4_END then
				_flag = false
			end
		end
		if _flag then
			return
		end
	end
	
	--如果正在执行攻击技能，则代表被打断
	--[[如果被识破，且这时候死亡，则会先调用受击动作，紧接着播放死亡动作]]
	if not self._specialStatus then
		if nowAnim == self:_getAtkNameBySkillType(BATTLE_SKILL_TYPE.ATK) or nowAnim == self:_getAtkNameBySkillType(BATTLE_SKILL_TYPE.ATK0) or nowAnim == self:_getAtkNameBySkillType(BATTLE_SKILL_TYPE.SUPER) then
		-- if nowAnim == BATTLE_ANIMATION_ACTION.ATTACK or nowAnim == BATTLE_ANIMATION_ACTION.SUPER or nowAnim == BATTLE_ANIMATION_ACTION.ATK0 then
			if actName == BATTLE_ANIMATION_ACTION.DEFENSE then
				print(self:getHeroName().."的动作"..nowAnim.."被打断了")
				if not self._interrupted then
					self._interrupted = true
					performWithDelay(self,function( ... )
						if self:isAlive() == true then
							self._interrupted = false
		    				self:willNextStep()
						end
					end,0.5 * 2)
				end
			end
		end
	end

	--[[--如果为空，则默认不循环]]
	if loop == nil or tostring(loop) == "false" then
		loop = 0
	elseif tostring(loop) == "true" or tonumber(loop) > 0 then
		loop = 1
	end
	if actName == BATTLE_ANIMATION_ACTION.SUPER then
		-- 大招分两个阶段，聚气和攻击
		local _flag = true
		local processInfo = self:getSelectedTargets(actName)
		if processInfo and processInfo.process then
			local process = processInfo.process
			for k, process_item in pairs( process ) do
				local action_type = tonumber(process_item[1])
				if action_type == 5 then
					-- 放技能
					local skill_cover_targets = process_item[7]
					if table.nums( skill_cover_targets ) == 0 then
						-- 蓄力
						_flag = false
					end
				end
			end
		end
		if _flag then
			-- 攻击
			self._specialStatus = false
			self._armatureAnimation:play(BATTLE_ANIMATION_ACTION.ATK4_END,-1,loop)
		else
			-- 聚气
			self._specialStatus = true
			self:_doAnimationEvent("hit")
			self._armatureAnimation:play(BATTLE_ANIMATION_ACTION.ATK4_START,-1,loop)
			performWithDelay(self,function( ... )
				if self:isAlive() == true then
					self._backed = true
					self:setLocalZOrder(self:getInitialZOrder())
					zc.dispatchEvent({ name = EVENT_NAME_BATTLE_STEP_NEXT})
				end
			end,0.5 * 2)
		end
	elseif actName == BATTLE_ANIMATION_ACTION.DEFENSE then
		if not self._specialStatus then
			self._armatureAnimation:play(actName,-1,loop)
		end
	else
		self._armatureAnimation:play(actName,-1,loop)
	end
end

function guojia:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE) 
end

function guojia:getNowAnimationName()
	local name = self._armatureAnimation:getCurrentMovementID()
	local _type = name
	if name == BATTLE_ANIMATION_ACTION.ATK4_START or name == BATTLE_ANIMATION_ACTION.ATK4_IDLE or name == BATTLE_ANIMATION_ACTION.ATK4_END then
		name = BATTLE_ANIMATION_ACTION.SUPER
	elseif name == BATTLE_ANIMATION_ACTION.IDLE and self._specialStatus then
		name = BATTLE_ANIMATION_ACTION.SUPER
	else
		_type = nil
	end
	return name, _type
end


function guojia:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget

    local director = cc.Director:getInstance()
    local winSize = director:getWinSize()
    local winWidth = winSize.width
    local winHeight = winSize.height
	if skillType == BATTLE_SKILL_TYPE.SUPER and self._specialStatus then--3.士气技能 大招
		self:setLocalZOrder( 2000 )
		local _effect = zc.battle.createBattleEffect({fileName = "guojia_fit2" , actName = "Fit2"})
        local _posX = zc.width/2 + 100
        if self:getSide() == BATTLE_SIDE.LEFT then
	    	_effect:setScaleX(-1 * _effect:getScaleX())
	    	_posX = zc.width/2 - 100
	    end
	    _effect:setPosition( _posX, zc.height/2 - 100 )
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = _effect, zorder = 1000},
		})
    end
end

function guojia:doFitSkillHitEff(params)
	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})

	    if self:getSide() == BATTLE_SIDE.RIGHT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    end
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)

		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})

	    armature_fit2:setPosition(_pos)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return guojia