--  Created by zhangchao on 16-06-29.
local hfs = class("hfs", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function hfs:create(params)
	return hfs.new(params)
end

local csbs = nil
function hfs:ctor(params)
	csbs = {"hps_atk", "hps_atk_1"}
	self:preloadCsbs(csbs)
end

function hfs:getCsbFiles()
	return csbs
end

function hfs:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 5
	end
	return count
end

function hfs:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	if skillType == BATTLE_SKILL_TYPE.SUPER then--3.士气技能 大招
	    local armature_1 = zc.battle.createBattleEffect({fileName = "hps_atk" , actName = "atk3", autoRemove = true})
	    local director = cc.Director:getInstance()
	    local winSize = director:getWinSize()
	    local winWidth = winSize.width
	    local winHeight = winSize.height
	    armature_1:setPosition( winWidth/2, winHeight/2 )
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_1:setScaleX(-1 * armature_1:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_1, zorder = firstTarget:getLocalZOrder() + 1},
		})

		local armature_2 = zc.battle.createBattleEffect({fileName = "hps_atk_1" , actName = "atk3", autoRemove = true})
		local posX 	= firstTarget:getPositionX()
	    local tmp_side = firstTarget:getSide()
	    local posY = zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2}).y
	    armature_2:setPosition( posX, posY )
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_2:setScaleX(-1 * armature_2:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_2, zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end

function hfs:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit1" then
			for k,hero in pairs(hurtTargets) do
				local _arrow = zc.battle.createBattleEffect({fileName = "hps_atk_1", actName = "atk", autoRemove = true})
	            if self:getSide() == BATTLE_SIDE.LEFT then
			    	_arrow:setScaleX(-1 * _arrow:getScaleX())
			    end
			    _arrow:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
				hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
			end
			self:doHurt(params)
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		if string.find( evt, "hit" ) then
			for k,hero in pairs(hurtTargets) do
				hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
			end
			self:doHurt(params)
		end
	end
end

function hfs:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end

function hfs:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    if skillType == BATTLE_SKILL_TYPE.ATK then
    	
	else
		self:showCommonDefenseEffect(params)
	end
end


return hfs