-- 华佗

local huatuo = class("huatuo", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function huatuo:create(params)
	return huatuo.new(params)
end

function huatuo:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 1
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	end
	return count
end

function huatuo:getAttackPoint(skillType, targetHero)
	if skillType ~= 2 then
		return cc.p(0, 0)
	end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	local _position = targetHero:getBattlePosition()
	local _pos_ = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position})
	y = _pos_.y
	denfenser_point.x = _pos_.x
	local attackerMidBox	= self:getBoneBoundingBoxByName(BATTLE_BONE_NAME.RECT_ATK0)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x, y)
	return pos
end

function huatuo:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local firstTarget = params.firstTarget


	if skillType == BATTLE_SKILL_TYPE.SUPER then
		dump(params)
	end

	if skillType == BATTLE_SKILL_TYPE.SUPER then
		if table.nums(hurtTargets) == 0 then
			table.insert(hurtTargets, firstTarget)
		end 

		for k,hero in pairs(hurtTargets) do

			if self:isAttackEvent(evt) and hero == hurtTargets[1] then
        		params.evt = evt
				self:doHurt(params)
        	end
			
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "huatuo", actName = "atk3_shangceng", moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})

		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end

		    local armature_2 = zc.battle.createBattleEffect({fileName = "huatuo", actName = "atk3_xiaceng", moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})

		    armature_2:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature_2:setScaleX(-1 * armature_2:getScaleX())
		    end

		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature_2, zorder = hero:getLocalZOrder() + 1},
			})
			
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function huatuo:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		ret = true
	end

	return ret
end

function huatuo:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero

	if skillType == 2 then
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end


return huatuo