--  Created by zhangchao on 16-03-29.
local lvbu = class("lvbu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function lvbu:create(params)
	local _lvbu = lvbu.new(params)
	_lvbu._fit2SkillId = 340
	return _lvbu
end

local csbs = nil
function lvbu:ctor(params)
	csbs = {"lvbu_atk"}
	self:preloadCsbs(csbs)
end

function lvbu:getCsbFiles()
	return csbs
end

function lvbu:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end
			local weaponId = self:getWeaponId()
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end

function lvbu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 2
	elseif skillType == 3 then
		count = 5
	elseif skillType == 4 then
		count = 6
	end
	return count
end

function lvbu:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.FIT_START then
		ret = false
	end
	return ret
end

function lvbu:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= self:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6})
	end
	return pos
end

function lvbu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		if evt == "do_atk3_hit" then
			for k,hero in pairs(hurtTargets) do
				local point = hero:getInitialPoint()
				-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
				hero:setLocalZOrder( self:getLocalZOrder() + 2 )
				local _shadow = hero:getArmature():getBone(hero:getResourceId().."_shadow")
				if not tolua.isnull( _shadow ) then
					-- _shadow:getDisplayManager():setVisible( false )
					local _posX, _posY = _shadow:getPosition()
					_posX, _posY = 0, 0
					_shadow:stopAllActions()
					_shadow:runAction(
						cc.Spawn:create(
							cc.EaseExponentialOut:create( cc.MoveTo:create(0.35, cc.p(_posX, _posY - 100)) ),
							cc.ScaleTo:create( 0.35, 0.9 )
						)
					)
				else
					print("~~~~~~~~~~~~~~~~~~~~~"..hero:getResourceId().."_shadow not exist")
				end
				hero:runAction(
					cc.EaseExponentialOut:create( cc.MoveTo:create(0.35, cc.p(point.x, point.y + 100)) )
				)
			end
		elseif evt == "do_atk3_hit2" then
			for k,hero in pairs(hurtTargets) do
				local point = hero:getInitialPoint()
				-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
				local _shadow = hero:getArmature():getBone(hero:getResourceId().."_shadow")
				if not tolua.isnull( _shadow ) then
					-- _shadow:getDisplayManager():setVisible( false )
					local _posX, _posY = _shadow:getPosition()
					_posX, _posY = 0, 0
					_shadow:stopAllActions()
					_shadow:runAction(
						cc.Spawn:create(
							cc.EaseExponentialIn:create( cc.MoveTo:create(0.3, cc.p(_posX, _posY)) ),
							cc.ScaleTo:create( 0.3, 1 )
						)
					)
				else
					print("~~~~~~~~~~~~~~~~~~~~~"..hero:getResourceId().."_shadow not exist")
				end
				hero:runAction(
					cc.Sequence:create(
						cc.EaseExponentialIn:create( cc.MoveTo:create(0.3, cc.p(point.x, point.y)) ),
						cc.CallFunc:create(function()
							hero:setLocalZOrder( hero:getInitialZOrder() )
						end)
					)
				)
			end
		end
	end

	if skillType == BATTLE_SKILL_TYPE.FIT then
		self:doHurt(params)
	else
		if evt and string.find(evt,"hit") then
			for k,hero in pairs(hurtTargets) do
				local armature = zc.battle.createBattleEffect({
					fileName = "lvbu_atk",
					actName = "atk",
					autoRemove = true,
	            })
				armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 1},
				})
			end
			self:doHurt(params)
		end
	end
end

function lvbu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "lbbejing",
		skeletonActName = "lvbu",
		name = "lvbu",
		-- 合体技特效
		fileName = "lvbu_fit2",
		actName = "Fit2",
	}
	if self._isFit2 then
		fitSrc.fileName = "lvbu_fit_A2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function lvbu:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget

    local tmp_side 	= self:getSide()
    if tmp_side == BATTLE_SIDE.LEFT then
    	tmp_side = BATTLE_SIDE.RIGHT
    else
    	tmp_side = BATTLE_SIDE.LEFT
    end
    local position = 5
    if firstTarget then
    	position = firstTarget:getBattlePosition()
    end
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = position})
	pos.y 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5}).y
    armature:setPosition(pos)
    if self:getSide() == BATTLE_SIDE.RIGHT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end

function lvbu:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function lvbu:doFitSkillHitEff(params)
	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			if not tolua.isnull(fit_bg) then
				fit_bg:removeFromParent()
			end
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
		end})

	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    end
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)

		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})
    	_pos.y = _pos.y + 80
	    armature_fit2:setPosition(_pos)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})


		local armature_fit3 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = "Fit3", completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})
	    armature_fit3:setPosition(_pos)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit3:setScaleX(-1 * armature_fit3:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit3 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return lvbu




