--  Created by zhangchao on 17-05-09.
local zhangliao_s = class("zhangliao_s", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhangliao_s:create(params)
	return zhangliao_s.new(params)
end

function zhangliao_s:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,4,7}) then
			_position = 4
		elseif inArray(_position, {2,5,8}) then
			_position = 5
		else
			_position = 6
		end
    	local _pos_ = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position})
		y = _pos_.y
		denfenser_point.x = _pos_.x
	end
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x, y)
	return pos
end

function zhangliao_s:showDefenseEffect(params)
	local skillType 	= params.skillType
	local hero 			= params.hero
    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function zhangliao_s:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 7
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 6
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = 6
	end
	return count
end

function zhangliao_s:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "bejing",
		skeletonActName = "zhangliao",
		name = "zhangliao",
		heroActName = "idle",
		
		-- 合体技特效
		fileName = "zhangliao_Fit0",
		actName = "Fit0",
	}
	return fitSrc
end

-- function zhangliao_s:isSkillEventAllDone(skillType,evt)
-- 	local ret = true
-- 	-- if skillType == 3 then
-- 	-- 	if not string.find(evt,"hit3") then
-- 	-- 		ret = false
-- 	--     end 
-- 	-- end
-- 	return ret
-- end

function zhangliao_s:doFitSkillHitEff(params)
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})

	    if self:getSide() == BATTLE_SIDE.RIGHT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    end
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)

		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,4,7}) then
			_position = 4
		elseif inArray(_position, {2,5,8}) then
			_position = 5
		else
			_position = 6
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})

	    armature_fit2:setPosition(_pos)

	    armature_fit2:setScale(1.2)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return zhangliao_s