--[[
布阵选择 
wcc
2015-11-18
"emBattle",--阵法信息表
"consume_price",--消费表
"formation_level",--阵法升级表
]]
local BuzhenSelectPop = class("BuzhenSelectPop",function()
    return ZCPopLayer:create()
end)

function BuzhenSelectPop:create(data)
	return BuzhenSelectPop.new(data)
end
function BuzhenSelectPop:onCleanup()
    if self._endcallback then
        self._endcallback()
    end
end

function BuzhenSelectPop:ctor(data)
    self._isRemoveLayout = true --从layermanager自动删除
    self:initData(data)
	self:initUI(data)
    self:show()
end

function BuzhenSelectPop:initData(data)
    self._curMatrix = data.curMatrix--选中的阵位
    self._matrixType = data._type or 1
    -- dump(self._curMatrix, "self._curMatrix ======== ")
    self._useMatrixId = data.useMatrixId--开启的阵容
    self._nineHeroString = data.nineHeroString
    self._callback = data.callback
    self._endcallback = data.endcallback
    self._handFlag = data.handFlag
    self._parent = data.parent
    self.formationlevelDB = gameData.getDataFromCache("formation_level", {formationId = self._curMatrix["formationId"]})
    if table.nums(self.formationlevelDB) < 1 and next(self.formationlevelDB) ~= nil then
        self.formationlevelDB = {self.formationlevelDB}
    end
    self.consumepriceDB = gameData.getDataFromCache("consume_price", {type = 1})
    if table.nums(self.consumepriceDB) < 1 and next(self.consumepriceDB) ~= nil then
        self.consumepriceDB = {self.consumepriceDB}
    end
    --阵位解锁
    self._levelToPos = {}
    for i = 1, table.nums(self.formationlevelDB) do
        if i == 1 then
            self._levelToPos[1] = {}
            self._levelToPos[1].needLevel = i
            self._levelToPos[1].map = self.formationlevelDB[i].map 
        else
            if self.formationlevelDB[i].map ~= self._levelToPos[#self._levelToPos].map then
                local idx = #self._levelToPos+1
                self._levelToPos[idx] = {} 
                self._levelToPos[idx].needLevel = i
                self._levelToPos[idx].map = self.formationlevelDB[i].map 
            end
        end
    end

    local alreadyOpen = {}
    for i = 1, #self._levelToPos do
        local posTa = string.split(self._levelToPos[i].map, "|")
        self._levelToPos[i].open = {}

        for j=1, #posTa do
            if not alreadyOpen[tonumber(posTa[j])] then
                alreadyOpen[tonumber(posTa[j])] = "open"
                self._levelToPos[i].open[#self._levelToPos[i].open+1] = posTa[j]
            end
        end
    end
    

    --判断开启不  等级限制  VIP限制
    local isopen = 0
    if tonumber(PlayerData.info.vip) >= tonumber(self._curMatrix["needVip"])
        and tonumber(PlayerData.info.level) >= tonumber(self._curMatrix["needLevel"])  then
        isopen = 1
    end
    self._curMatrix["open"] = isopen
end
function BuzhenSelectPop:initUI(data)
    local bg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        showSide = false,
        height = 480,
        bianZOrder = 0
    })
    bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(bg)
    self.bg = bg
    local _bgSize = bg:getContentSize()
    local close = zc.createBackButton({
        pos = cc.p(_bgSize.width-10, _bgSize.height-10),
        listener = function () 
            self:hide()
        end,
    })
    bg:addChild(close)
    self._close_btn = close

    local _itemBg = zc.createGeneralPopScale()
    _itemBg:setAnchorPoint(0.5, 1)
    _itemBg:setPosition(_bgSize.width*0.5, _bgSize.height - 50)
    bg:addChild(_itemBg)

    local _itemBgSize = _itemBg:getContentSize()

    local _bgFlower = zc.getSprite({
        src = "res/Main/common/popBg/bgFlower.png",
        pos = cc.p(70, _itemBgSize.height*0.5),
        scale = 0.7,
    })
    _itemBg:addChild(_bgFlower)
	
    local itemMatrix = self:initMatrixItem(self._curMatrix)
    itemMatrix:setScale(0.95)
    itemMatrix:setPosition(_bgFlower:getPosition())
    _itemBg:addChild(itemMatrix)

    -- name
    local nameBg = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(230, 100),
    })
    _itemBg:addChild(nameBg)

    local _label = zc.createRichLabel({
        text = zc.lang("matrix"),
        fontSize = 20,
        anchor = cc.p(0, 0.5),
        pos = cc.p(15, nameBg:getContentSize().height*0.5),
    })
    _label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
    nameBg:addChild(_label)

    local name = zc.createLabel({
        text = self._curMatrix.name,
        pos = cc.p(nameBg:getContentSize().width - 5, nameBg:getContentSize().height*0.5),
        ap = cc.p(1, 0.5),
        fontSize = 20,
        color = display.COLOR_GREEN,
        outLine = true,
    })
    nameBg:addChild(name)

    -- level
    local levelBg = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(230, 60),
    })
    _itemBg:addChild(levelBg)

    local _label = zc.createRichLabel({
        text = zc.lang("level"),
        fontSize = 20,
        anchor = cc.p(0, 0.5),
        pos = cc.p(15, nameBg:getContentSize().height*0.5),
    })
    _label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
    levelBg:addChild(_label)

    local level = zc.createLabel({
        text = zc.getLevelTipShow() .. self._curMatrix.level,
        pos = cc.p(levelBg:getContentSize().width - 5, levelBg:getContentSize().height*0.5),
        ap = cc.p(1, 0.5),
        fontSize = 18,
        color = display.COLOR_GREEN,
        outLine = true,
    })
    levelBg:addChild(level)
    self._level = level

    local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        height = 250,
    })
    _bottomBg:setAnchorPoint(0.5, 0)
    _bottomBg:setPosition(_bgSize.width*0.5, 15)
    bg:addChild(_bottomBg)

    local _bottomBgSize = _bottomBg:getContentSize()

    local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = 325,
        height = 130,
    })
    _attrBg:setAnchorPoint(0.5, 1)
    _attrBg:setPosition(_bottomBgSize.width*0.5, _bottomBgSize.height - 10)
    _bottomBg:addChild(_attrBg)
    self._attrBg = _attrBg

	--阵法属性
	self:initArrLayer(self._curMatrix)

	--启用按钮
    local _partW = 85
    local openBtn
    openBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("enable_matrix"),
        touchScale = 0.9,
        pos = cc.p(_bottomBgSize.width - _partW, 40),
        endCallback = function()
            if tonumber(self._curMatrix["open"]) == 1 then 
                --启用之前，先保存之前的阵法
                local infoData = data["useMatrixId"]..":"..self._nineHeroString
                zc.sendHttp({
                    apiName = "Formation_saveFormation",
                    params = {enableId = self._curMatrix.formationId, info = infoData,type=self._matrixType},
                    successCallback = function (data)
                        if tonumber(self._matrixType) == 1 then --如果是普通阵法就保存, 如果是演武榜阵法就临时保存
                            PlayerData:setFormationsInfo( data.formations )
                        end
                        if self._callback then
                            self._callback(data.formations, self._curMatrix.formationId)
                        end
                        self:hide()
                    end,
                })
            end 
        end
    })
    _bottomBg:addChild(openBtn)

    if tonumber(self._useMatrixId) ==  tonumber(self._curMatrix.formationId) 
        or tonumber(self._curMatrix["open"]) == 0 then 

        openBtn:setEnable(false)

        local cannotOpenText = ""
        local _vip = tonumber(PlayerData:getBaseInfoByTag("vip")) or 0
        local _needVip = tonumber(self._curMatrix["needVip"]) or 0
        if _vip < _needVip then 
            cannotOpenText = zc.lang("need_vip").. _needVip .. zc.lang("level_1")
        end
        local _needLevel = tonumber(self._curMatrix["needLevel"]) or 0
        if PlayerData:getUserLevel() < _needLevel then
            cannotOpenText = zc.lang("need_lord_level") .. zc.getLevelTipShow() .. _needLevel
        end
        local levelUp = zc.createLabel({
            text = cannotOpenText,
            pos = cc.p(openBtn:getContentSize().width/2, openBtn:getContentSize().height),
            ap = cc.p(0.5, 0),
            fontSize = 18,
            outLine = true,
        })
        openBtn:addChild(levelUp)
	end
    self._openBtn = openBtn
    
    --升级阵法
    local trainBtn
    trainBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("upgrade"),
        pos = cc.p(_partW, openBtn:getPositionY()),
        touchScale = 0.9,
        endCallback = function()
            if self._guideHand then
                self._guideHand:removeFromParent()
                self._guideHand = nil
            end
            --判断玩家等级
            local needUserLevel = nil
            for i=1,#self.formationlevelDB do 
                if tonumber(self._curMatrix.level) + 1 == tonumber(self.formationlevelDB[i].level) then 
                    needUserLevel = tonumber(self.formationlevelDB[i].needLevel) 
                    break
                end
            end
            if needUserLevel == nil then
                zc.tipInfo(zc.lang("tips_matrix_full_level"))
                return
            end
            if needUserLevel ~= nil and tonumber(needUserLevel) > tonumber(PlayerData.info.level) then
                zc.tipInfo(zc.lang("tips_need_player")..needUserLevel..zc.lang("level_1"))
                return
            end
            zc.sendHttp({
                apiName = "Formation_upgrade",
                params = {id = self._curMatrix.formationId },
                successCallback = function (data)
                    ---新手引导
                    self:guideFunc()
                    local upLevel = tonumber(data["level"])
                    PlayerData:updataData( data )
                    PlayerData:updateFormationsInfoById(data["id"], {level = upLevel})
                    self._curMatrix.level = upLevel
                    self._level:setText( zc.getLevelTipShow() .. upLevel )
                    --能继续升级
                    local needLevelTable = self:getLordLevelByFormationLevel(self._curMatrix.formationId, self._curMatrix.level)
                    if needLevelTable.nextLevel and tonumber(PlayerData.info.level) >= needLevelTable.nextLevel then
                        --needLevel
                        if tonumber(PlayerData.info.level) < needLevelTable.needLevel then
                            self._levelUp3:setVisible(true)
                            self._levelUp3:setText(zc.lang("need_lord_level") .. zc.getLevelTipShow() .. needLevelTable.needLevel)
                            self._levelCostImg:setVisible(false)
                            self._levelCost:setVisible(false)
                        end
                    else
                    end
                    self:initArrLayer(self._curMatrix)
                    --消耗
                    self._levelCost:setText(self:getLevelUpCost(upLevel)["price"])
                    local _needLevel = tonumber(needLevelTable.needLevel) or 0
                    if PlayerData:getUserLevel() < _needLevel then
                        trainBtn:setEnable(false)
                    end
                    zc.tipInfo(zc.lang("upgrade_success") .. "！")
                    --升级完，修改阵法的开启阵位
                    if self._parent then
                        self._parent:levelUpRefresh(self._curMatrix.formationId, upLevel)
                    end
                end,
            })
        end
    })
    _bottomBg:addChild(trainBtn)

    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2011 or _currentGID == GuideKey.KEY_12812 then
        self._trainBtn = trainBtn
    end
    if self._handFlag then
        self._handBtn = trainBtn
    end

    --
    --升级消耗元宝
    local costInfo = self:getLevelUpCost(self._curMatrix.level)
    local levelCostImg = zc.getSprite({
        src = zc.getImgByType(costInfo.type),
        pos = cc.p(trainBtn:getPositionX(), trainBtn:getPositionY()+45)
    })
    levelCostImg:setScale(0.8)
    _bottomBg:addChild(levelCostImg)
    local levelCost2 =  zc.createLabel({
        text = costInfo["price"],
        pos = cc.p(trainBtn:getPositionX(), levelCostImg:getPositionY()),
        ap = cc.p(0, 0.5),
        fontSize = 18,
        outLine = true,
    })
    _bottomBg:addChild(levelCost2)
    self._levelCostImg  =levelCostImg
    self._levelCost = levelCost2
    
    levelCostImg:setPositionX(trainBtn:getPositionX()-levelCost2:getContentSize().width/2)
    levelCost2:setPositionX(levelCostImg:getPositionX()+levelCostImg:getContentSize().width/2)

    local levelUp3 = zc.createLabel({
        text = "",
        pos = cc.p(trainBtn:getPositionX(), levelCostImg:getPositionY()),
        fontSize = 18,
        color = display.COLOR_RED,
        outLine = true,
    })
    _bottomBg:addChild(levelUp3)
    self._levelUp3 = levelUp3
    --能继续升级
    local needLevelTable = self:getLordLevelByFormationLevel(self._curMatrix.formationId, self._curMatrix.level)
    if needLevelTable.nextLevel then
        if tonumber(PlayerData.info.level) < needLevelTable.needLevel then
            levelUp3:setText(zc.lang("need_lord_level") .. zc.getLevelTipShow() .. needLevelTable.needLevel)
        else
            levelUp3:setText("")
        end
    end

    local needLevelTable = self:getLordLevelByFormationLevel(self._curMatrix.formationId, self._curMatrix.level)
    if needLevelTable.nextLevel and tonumber(PlayerData.info.level) >= needLevelTable.needLevel then
	   levelUp3:setVisible(false)
        if tonumber(self._curMatrix["open"]) == 0 then 
            trainBtn:setEnable(false)
        end
    else --不能升级
        trainBtn:setEnable(false)
        levelCostImg:setVisible(false)
        levelCost2:setVisible(false)
        self._trainBtn = nil
        self:guideFunc()
	end
end
function BuzhenSelectPop:initArrLayer(datainfo)
    local _bg = self._attrBg
    _bg:removeAllChildren()
    local _size = _bg:getContentSize()
    
    local zfAttTable = self:getMatrixInDB(datainfo, datainfo.level)
    local heroAttTable = self:getMatrixOneAttAddDB(datainfo.formationId, datainfo.level)
    -- local layerHeight = 30*(#zfAttTable)

    --是否有特殊信息
    local _height = 22
    local _height2 = 85
    local surperInfo = self:getSurper(datainfo, datainfo.level)
    if surperInfo ~= "" then
        -- layerHeight = layerHeight + 30
        _height = 56
        _height2 = 50
    end

    local _titleLab = zc.createLabel({
        text = zc.lang("levelup_effect"),
        fontSize = 20,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_size.width*0.5, _size.height - _height),
    })
    _bg:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _bg:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _bg:addChild(_titleRightSp)

    local _width = _size.width - 10
    local layerHeight = _titleLab:getPositionY() - 15

    local oneH = layerHeight-15
    for i=1,#zfAttTable do 
        local xiaoguo1 = zc.createLabel({
            text = zfAttTable[i].attname .. ":",
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(5, oneH),
            outLine = true,
            color = cc.c3b(194, 175, 122),
        })
        _bg:addChild(xiaoguo1)
        local curEff = tonumber(zfAttTable[i].startatt) + (tonumber(self._curMatrix.level)-1)*tonumber(zfAttTable[i].addatt)
        local xiaoguo2 = zc.createLabel({
            text = "+"..zc.getAttributeNumById(zfAttTable[i]["id"], curEff),
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(xiaoguo1:getPositionX()+xiaoguo1:getContentSize().width, oneH),
            outLine = true,
        })
        _bg:addChild(xiaoguo2)

        local needLevelTable = self:getLordLevelByFormationLevel(self._curMatrix.formationId, self._curMatrix.level)
        if needLevelTable.nextLevel  and tonumber(PlayerData.info.level) >= needLevelTable.nextLevel then
	        local str = "+"..zc.getAttributeNumById(zfAttTable[i]["id"], curEff+tonumber(zfAttTable[i].addatt))
            local xiaoguo3 = zc.createLabel({
	            text = str,
	            fontSize = 18,
	            ap = cc.p(1, 0.5),
	            pos = cc.p(_width - 5, oneH),
	            outLine = true,
	            color = display.COLOR_GREEN,
	        })
	        _bg:addChild(xiaoguo3)
	    end
        oneH = oneH - 25
    end

    if surperInfo ~= "" then
        local _supterDi = zc.getScaleNode(
            "res/Main/common/popBg/di_properties.png",
            cc.size(260, 32)
        )
        _supterDi:setPosition(_size.width*0.5, _size.height - 25)
        _bg:addChild(_supterDi)
        local _diSize = _supterDi:getContentSize()
        cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
        local _tip = zc.getSprite({
            src = "home_icon_info.png",
            plist = true,
            pos = cc.p(15, _diSize.height*0.5),
            scale = 0.5
        })
        _supterDi:addChild(_tip)
        local supter = zc.createLabel({
            text = surperInfo,
            outLine = true,
            fontSize = 20,
            pos = cc.p(_diSize.width*0.5, _diSize.height*0.5),
            color = display.COLOR_RED,
            pixel = 1.3
        })
        _supterDi:addChild(supter)
    end
end
function BuzhenSelectPop:getSurper(data, level)
    local level = tonumber(level) or 1
    local str = ""
    for i=1,#self._levelToPos do
        if tonumber(self._levelToPos[i].needLevel) > level then
            local needLevel = self._levelToPos[i].needLevel
            str = zc.lang("matrix") .. needLevel .. zc.lang("level_unlock")
            for j = 1, #self._levelToPos[i].open do
                if j == 1  then
                    str = str..self._levelToPos[i].open[j]
                else
                    str = str .. "、" ..self._levelToPos[i].open[j]
                end
            end
            str = str .. zc.lang("number_position")
            return str
        end
    end
    return str
end
function BuzhenSelectPop:initMatrixItem(info)

    local scaleSize = cc.size(100, 100)
    local itemMatrix = zc.getScaleNode("res/Main/research/bingfa/info_scale.png", scaleSize)

    local heiBg = zc.getScaleNode("res/Main/research/qunxiong/word_bg2.png", cc.size(98, 98))
    heiBg:setPosition(cc.p(scaleSize.width/2, scaleSize.height/2))
    itemMatrix:addChild(heiBg)

    local _needVip = 2
    local _isOpen = false
    local _qiYong = "noSelected"
    if info["needVip"] and tonumber(info["needVip"]) > 0 then
        _needVip = 1
    end
    if info["open"] and tonumber(info["open"]) == 1 then
        _isOpen = true
    end
    if info["status"] and tonumber(info["status"]) == 1 then
        _qiYong = "selected"
    end

    local imgPath = {
        [1] = { --需要vip的
            selected = {
                bgImg = "res/Main/matrix/select_bg.png",
                posHave = "res/Main/matrix/liang_lan.png",
                posNo = "res/Main/matrix/an_lan.png",
            },
            noSelected = {
                bgImg = "res/Main/matrix/weixuan_lan.png",
                posHave = "res/Main/matrix/an_lan_block.png",
                posNo = "res/Main/matrix/an_lan.png",    
            }
        },
        [2] = { --不需要vip的
            selected = {
                bgImg = "res/Main/matrix/select_bg.png",
                posHave = "res/Main/matrix/liang_huang.png",
                posNo = "res/Main/matrix/an_hui.png",
            },
            noSelected = {
                bgImg = "res/Main/matrix/weixuan_hui.png",
                posHave = "res/Main/matrix/an_hui_block.png",
                posNo = "res/Main/matrix/an_hui.png",    
            }
        },
    }
    
    local imgTable = imgPath[_needVip][_qiYong]
    local bgImg = zc.createSprite(imgTable["bgImg"])
    bgImg:setAnchorPoint(0.5, 0.5)
    bgImg:setPosition(itemMatrix:getContentSize().width/2, itemMatrix:getContentSize().height/2)
    itemMatrix:addChild(bgImg)
    bgImg:setName("blockBgImg")

    local mapInfo = string.split(info["map"],"|")
    local map = {}
    for i = 1,#mapInfo do
        map[tonumber(mapInfo[i])] = "true"
    end
    local itemWidth = itemMatrix:getContentSize().width
    local itemHeight = itemMatrix:getContentSize().height
    for i = 1, 9 do
        local posx = itemWidth - 25 - math.floor((i-1)/3) * 25
        local posy = itemHeight - 25 - (i - math.floor((i-1)/3) * 3 - 1) * 25
        if map[i] then
            local posHave = zc.createSprite(imgTable["posHave"])
            posHave:setAnchorPoint(0.5, 0.5)
            posHave:setPosition(posx, posy)
            itemMatrix:addChild(posHave)
        else
            local posNo = zc.createSprite(imgTable["posNo"])
            posNo:setAnchorPoint(0.5, 0.5)
            posNo:setPosition(posx, posy)
            itemMatrix:addChild(posNo)
        end
    end

    if not _isOpen then
        local mask = zc.createSprite("res/Main/matrix/mask.png")
        mask:setAnchorPoint(0.5, 0.5)
        mask:setPosition(itemWidth/2, itemHeight/2)
        itemMatrix:addChild(mask)
    end



    do return itemMatrix end


    local open = info["open"]
    local pointimg = "res/Main/matrixBattle/dot_"..open..".png"
    -- if color and tonumber(color) == 2 then
    --     pointimg = "res/Main/matrix/matrix_redpoint.png"
    -- end



    local itemBg = zc.getSprite({
        src = "res/Main/role/starup/iconBg.png",
        pos = cc.p(scaleSize.width/2, scaleSize.height/2),
    })
    itemMatrix:addChild(itemBg)
    itemBg:setScale(97/138)

	local array = string.split(self._curMatrix.map,"|")
    local posList = {
        cc.p(78, 78),cc.p(78, 58),cc.p(78, 38),
        cc.p(58, 78),cc.p(58, 58),cc.p(58, 38),
        cc.p(38, 78),cc.p(38, 58),cc.p(38, 38),
    }
    for i=1,#array do 
        local location = tonumber(array[i])
        local pointImg = zc.getSprite({
            src = pointimg,
            pos = posList[location],
        })
        itemMatrix:addChild(pointImg, 2)
    end
    
    --连线
    local liehangArray = {
        {1,1},{1,2},{1,3},
        {2,1},{2,2},{2,3},
        {3,1},{3,2},{3,3},
    } 
    local lineTable = {}
    for i=1,#array do 
        local location = tonumber(array[i])
        for j=i+1,#array do
            local locationj = tonumber(array[j])
            if (math.abs(liehangArray[location][1] - liehangArray[locationj][1]) == 0 and math.abs(liehangArray[location][2] - liehangArray[locationj][2]) == 1) then
                lineTable[#lineTable + 1] = {x = location, y = locationj, img = 1}
            elseif (math.abs(liehangArray[location][1] - liehangArray[locationj][1]) == 1 and math.abs(liehangArray[location][2] - liehangArray[locationj][2]) == 0) then 
                lineTable[#lineTable + 1] = {x = location, y = locationj, img = 2}
            elseif (math.abs(liehangArray[location][1] - liehangArray[locationj][1]) == 1 and math.abs(liehangArray[location][2] - liehangArray[locationj][2]) == 1) then   
                if (liehangArray[location][1] - liehangArray[locationj][1]) + (liehangArray[location][2] - liehangArray[locationj][2]) == 0 then 
                    lineTable[#lineTable + 1] = {x = location, y = locationj, img = 3}
                else
                    lineTable[#lineTable + 1] = {x = location, y = locationj, img = 4}
                end
            end
        end
    end

    local lineSrc = "res/Main/matrixBattle/line_"..open.."_"
    
    for i, v in ipairs( lineTable ) do
        local anchor = cc.p(1, 1)
        local path = 1
        local rotate = 0
        if v.img == 1 then
            -- |
            anchor = cc.p(0.5, 1)
            path = 1
            rotate = 0
        elseif v.img == 2 then
            -- -
            anchor = cc.p(0.5, 1)--cc.p(1, 0.5)
            path = 1
            rotate = 90
        elseif v.img == 3 then
            -- \
            anchor = cc.p(1, 0)
            path = 2
            rotate = 0
        elseif v.img == 4 then
            -- /
            anchor = cc.p(0, 1)--cc.p(1, 1)
            path = 2
            rotate = 90
        end
        local lineImg = cc.Sprite:create( lineSrc .. path ..".png" )
        lineImg:setRotation( rotate )
        lineImg:setAnchorPoint( anchor )
        lineImg:setPosition( posList[v.x] )
        lineImg:setScale(0.4)
        itemMatrix:addChild(lineImg, 1)
    end
end

--返回  0_10_0_0_0_0_0_0_0
function BuzhenSelectPop:changeNineHeroString()
    local nineHeroArray = string.split(self._nineHeroString, "_")
    local newNineHeroArray = {}
    for i=1,#nineHeroArray do 
    	if tonumber(nineHeroArray[i]) ~= 0 then 
    		newNineHeroArray[#newNineHeroArray+1] = nineHeroArray[i]
    	end
    end
    local newMatrixDB = PlayerData:getFormationsInfoByFormationId( self._curMatrix.formationId )
    local newMatrixDBMap = string.split(newMatrixDB["map"], "|")
    local newArray = {}
    for i=1,9 do 
    	newArray[i] = {}
    	newArray[i]["open"] = 0
    	newArray[i]["heroID"] = "0"
    	for j=1,#newMatrixDBMap do
    		if i == tonumber(newMatrixDBMap[j]) then 
    			newArray[i]["open"] = 1
    			break
    		end
    	end
    end
    local nineHeroArrayPos = 1
	for i=1,#newArray do
		if newArray[i]["open"] == 1 and nineHeroArrayPos <= #newNineHeroArray then 
			newArray[i]["heroID"] = newNineHeroArray[nineHeroArrayPos]
			nineHeroArrayPos = nineHeroArrayPos + 1
		end
	end
    local heroString = ""
    for i=1,8 do
        heroString = heroString..newArray[i]["heroID"].."_"
    end
    heroString = heroString..tostring(newArray[9]["heroID"])
    return heroString
end
--等级 全体加成
function BuzhenSelectPop:getMatrixInDB(formationInfo, level)
	local level = tonumber(level)
    local attTable = {}

    for j=1,4 do 
        if formationInfo["effect"..j] ~= "" and formationInfo["effect"..j] ~= nil then 
            local _isBase = false
            if formationInfo["effectLayer"..j] and (tonumber(formationInfo["effectLayer"..j])==1 or tonumber(formationInfo["effectLayer"..j])==2) then
                _isBase = true
            end
            local _target = nil
            if formationInfo["effectTarget"..j] and type(formationInfo["effectTarget"..j]) == "number" then
                _target = formationInfo["effectTarget"..j]
            end
            
            local array = string.split(formationInfo["effect"..j],"|")
            local newindex = #attTable+1
            attTable[newindex] = {}
            local effectStr = LANGUAGE_getAttributeTextById(array[1], _isBase)
            if _target then
                effectStr = LANGUAGE_getTargetTextById(_target)..effectStr
            end
            attTable[newindex].attname = effectStr
            attTable[newindex].startatt = tonumber(array[2])
            attTable[newindex].addatt = tonumber(array[3])
            attTable[newindex].id = tonumber(array[1])
        end
    end
    return attTable
end
--等级 某一人加成
function BuzhenSelectPop:getMatrixOneAttAddDB(formationId, level)
    level = tonumber(level)
    local nextlevel = level + 1
    level =  math.floor(level/5)*5
    if level == 0 then 
        level = 1
    end
    local attTable = {}
    for j=1, 9 do 
        if self.formationlevelDB[1]["location"..j] ~= "" and tonumber(self.formationlevelDB[1]["location"..j]) ~= 0 then 
            local array = string.split(self.formationlevelDB[1]["location"..j],"|")

            local newindex = #attTable+1
            attTable[newindex] = {}
            attTable[newindex].attname = j..zc.lang("number_position")..zc.getEquipAttriNameByEffectType(array[1], true, true)
            attTable[newindex].curadd = tonumber(array[2])*100
            if self.formationlevelDB[2] and self.formationlevelDB[2]["location"..j] ~= "" and tonumber(self.formationlevelDB[2]["location"..j]) ~= 0 then 
            	local array1 = string.split(self.formationlevelDB[2]["location"..j],"|")
            	attTable[newindex].nextadd = tonumber(array1[2])*100
            end
        end
    end
    return attTable
end
--判断阵法某一等级 需要的主公等级
--是否还有下一级
function BuzhenSelectPop:getLordLevelByFormationLevel(formationId, level)
    local needLevelAndNext = {}
    for i=1,#self.formationlevelDB do 
        if tonumber(self.formationlevelDB[i].level) == tonumber(level)+1 then 
            needLevelAndNext.needLevel = tonumber(self.formationlevelDB[i].needLevel)
            needLevelAndNext.nextLevel = tonumber(level)+1
            break
        end
    end
    return needLevelAndNext
end
function BuzhenSelectPop:getLevelUpCost(level)
	level = tonumber(level)
    local upCost = {}
	if level >= #self.consumepriceDB then
        upCost.price = 0 
		return upCost
	else
        upCost = self.consumepriceDB[level]
        return upCost
	end
end

function BuzhenSelectPop:onEnter()
    --新手引导
    performWithDelay(self, function ()
        if self._trainBtn and self._trainBtn:isEnable() then
            zc.addGuideBtn(self._trainBtn)
        end
        if self._handBtn then
            self._guideHand = zc.createSpine({
                fileName = "shou",
                actName = "shou",
                scale = 0.8
            })
            -- self._guideHand:setScaleX(-1)
            local _btn = self._handBtn
            self._guideHand:setPosition(cc.pMul(cc.pFromSize(_btn:getContentSize()), 0.5))
            _btn:addChild(self._guideHand, 10)
            performWithDelay(self._guideHand, function()
                self._guideHand:removeFromParent()
                self._guideHand = nil
            end, 4)
        end
    end,0.3)
end


--新手引导
function BuzhenSelectPop:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2011 or _currentGID == GuideKey.KEY_12812 then
        getGuideManager():guideOver()
        getGuideManager():setNextGID(_currentGID)
        self:addGuide_1()
    end
end

--新手引导
function BuzhenSelectPop:addGuide_1()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_2012 or _currentGID == GuideKey.KEY_12813 then
        self:getContainerLayer():setTouchEndedCallback(function() end)
        local _btn = self._close_btn
        getGuideManager():addMaskLayer()
        performWithDelay(self, function ()
            getGuideManager():setObjTarget(_btn)
            getGuideManager():startGuide()
            getGuideManager():removeMaskLayer()
        end,0.3)
        _btn:setTouchEndedCall(function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_2012 or _currentGID == GuideKey.KEY_12813 then
                getGuideManager():setNextGID(_currentGID)
                LayerManager.removeLayout(true)
                local _Buzhen = zc.getPop("Buzhen")
                if _Buzhen then
                    _Buzhen:addGuide_1()
                end
            end
        end)
    end
end

return BuzhenSelectPop

