--[[
FileName 		ChapterBuyPop.lua --精英购买次数
ProjectName		HJ2
    
Created by wangming on 16-07-05

]]

local ChapterBuyPop = class("ChapterBuyPop", function()
	return ZCPopLayer:create()
end)

function ChapterBuyPop:create( params )
	local _pop = ChapterBuyPop.new(params)
	_pop:show()
	return _pop
end

function ChapterBuyPop:ctor( params )
    local _info = PlayerData:getEliteBuyInfo()
    self._buyType = params.buyType or 37
    self._nowHave = params.nowHave or _info.challengeTimes
    self._useNum = 0
    self._nowBuyCount = params.nowBuyTimes or _info.buyTollgateChallenge
    self._cost = 0
    self._callBack = params.callBack


    self._containerLayer:setTouchEndedCallback(function() 
        self:hide({noAction=true})
    end)
    self:initUI()
    -- self:addNum(1)
end

function ChapterBuyPop:initUI()
	local _bg = zc.createSprite("res/Main/common/popBg/popup_Bg_blue.png")
    _bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(_bg)
    local _bgSize = _bg:getContentSize()

    local titleLab = zc.getTipPopTitle( "goumai" )
    titleLab:setPosition( _bgSize.width*0.5, _bgSize.height - 30 )
    _bg:addChild(titleLab, 2)

    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)    
    _bg:addChild(contentBg)

    local contentBgSize = contentBg:getContentSize()

    local backButton = zc.createBackButton({
        pos = cc.p(_bg:getContentSize().width - 10, _bg:getContentSize().height - 10),
        listener = function()
            self:hide({noAction = true})
        end,
    })
    _bg:addChild(backButton)

    local _str = zc.lang("elite_chapter_challenge_times")
    if self._buyType == 61 then
        _str = zc.lang("grab_food_times")
    end
    local name = zc.createLabel({
        text = _str,
        fontSize = 28,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(contentBgSize.width*0.5, contentBgSize.height*0.5),
        outLine = true,
    })
    contentBg:addChild(name)

    local num = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, contentBgSize.height - 30),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
        text = self._nowHave,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, num:getPositionY()),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    
    local addBg = cc.Node:create()
    addBg:setContentSize(360, 65)
    addBg:setAnchorPoint(0.5, 0.5)
    addBg:setPosition(contentBgSize.width/2, 30)
    contentBg:addChild(addBg)

    -- --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "-10",
        endCallback = function()
            self:addNum(-10) 
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)
    -- --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "+10",
        endCallback = function()
            self:addNum(10) 
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
        size = cc.size(120, 40),
        file = "res/Main/bag/new/bag_text_bg_s.png",
        pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
    })
    addBg:addChild(numBg)

    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    
    local sellImg = zc.getSprite({
        src = zc.getImgByType(zc.dataTypeGold),
        ap = cc.p(1, 0.5),
        pos = cc.p(_bgSize.width*0.5, 105),
        scale = 0.9
    })
    _bg:addChild(sellImg)
    local sellNum1 = zc.createLabel({
        text = 0,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgSize.width*0.5, 105),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    _bg:addChild(sellNum1)
    self._sell_label = sellNum1

    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_bgSize.width/2, 60), 
        text = zc.lang("buy2"),
        endCallback = function ()
            if tonumber(self._useNum) <= 0 then
                return
            end
            if self._cost > PlayerData:getResourcesInfoById(zc.dataTypeGold) then
                zc.tipInfo(zc.lang("tips_gold_deficiency"))
                return
            end
            if self._buyType == 37 then
                zc.sendHttp({
                    apiName = "Tollgate_buyEliteTime",
                    params = {num = self._useNum},
                    successCallback = function(data)
                        PlayerData:updataData(data)
                        if self._callBack then
                            self._callBack()
                        end
                        self:hide({noAction=true})
                    end,
                })
            elseif self._buyType == 61 then
                zc.sendHttp({
                    apiName = "GrabFood_buyTimes",
                    params = {times = self._useNum},
                    successCallback = function(data)
                        PlayerData:updataData(data)
                        if self._callBack then
                            self._callBack({
                                buyTimes = self._useNum,
                                times = data.times
                            })
                        end
                        self:hide({noAction=true})
                    end,
                })
            end
        end,
    })
    _bg:addChild(useBtn)
end

function ChapterBuyPop:_getConsumeData( count )
    local _datas = gameData.getDataFromCache("consume_price", {type = self._buyType})
    local _subType = 0
    if count > #_datas then
        _subType = #_datas
    else
        _subType = count
    end
    return gameData.getDataFromCache("consume_price", {type = self._buyType, subtype = _subType})
end

function ChapterBuyPop:addNum( num )
    
    local _num = self._useNum + num
    if _num < 0 then
        _num = 0
    end

    if _num == self._useNum then
        return
    end
    self._num:setText(_num)

    local _cost = self._cost
    local _count = self._nowBuyCount
    
    local _plus = num > 0 and 1 or -1

    
    while self._useNum ~= _num do
        self._useNum = self._useNum + _plus
        local _consumeData = {}
        if _plus < 0 then
            _consumeData = self:_getConsumeData(_count)
        end
        _count = _count + _plus
        if _plus > 0 then
            _consumeData = self:_getConsumeData(_count)
        end
        _cost = _cost + _plus*(tonumber(_consumeData.price) or 0)    
    end
    self._sell_label:setText(_cost)
    self._useNum = _num
    self._cost = _cost
    self._nowBuyCount = _count
end


return ChapterBuyPop