--[[
-- 聊天界面
-- @author lph
-- Creation  2015-1-15
]]
--flags  1 世界 2 国家 3 私聊 4 系统 5战报 6 客服 100 多人副本内聊天

local ChatPanelPop = class("ChatPanelPop",function ()
	return zc.createNormalDialog({
        showBack = false
    })
end)

function ChatPanelPop:create(data)
    return ChatPanelPop.new(data)
end

function ChatPanelPop:ctor(data)
    self.curText = nil
    if data then
        self._isClose = data.isClose == nil and false or data.isClose
        self._curChannel = data.channel or 1
        self._toUserId = tonumber( data.toUserId )
        self._toUserName = data.toUserName or ""
        self._toUserGodName = data.toGodName or 0
    else
        self._curChannel = 1
    end
    self:initUI()
end

function ChatPanelPop:toChatWithUser( data )
    if data then
        self._isClose = data.isClose == nil and false or data.isClose
        self._curChannel = data.channel or 1
        self._toUserId = tonumber( data.toUserId )
        self._toUserName = data.toUserName or ""
        self._toUserGodName = data.toGodName or 0
    end
    self:selectChatChannel(self._curChannel)
end

function ChatPanelPop:initUI()
    --频道
	self.tabChatPanel = {
        {tag = 1, text = zc.lang("chat_world"), name = "world"},  
        {tag = 5, text = zc.lang("chat_system"), name = "system"}, 
        {tag = 2, text = zc.lang("chat_country"), name = "country"},
        {tag = 3, text = zc.lang("chat_private"), name = "private"},
        -- {tag = 5, text = zc.lang("chat_battleField","战报"), name = "battleField"},
        {tag = 6, text = zc.lang("chat_customerService"), name = "customerService"},
        {tag = 4, text = zc.lang("chat_private"), name = "private"},
    }

	self.curChatList = getNetManager():getRequestCenter():getAllChatData()
    -- self._key = 0
    self:initChatBox()
    self:selectChatChannel(self._curChannel)
end

function ChatPanelPop:setShow(isShow)
    local _isShow = isShow == nil and isShow or false
    if self:isVisible() == isShow then
        return
    end
    local textureCache = cc.Director:getInstance():getTextureCache()
            
    if isShow then
        self:setVisible(true)
        local _bg = self._chat_input_Bg:getChildByName("bgImg")
        if _bg then
           _bg:setTexture("res/Main/common/popBg/bgWhite.png")
        end
        self._chat_normal_input_bg:setTexture("res/Main/chat/chat_normal_input_bg.png")
        if self._chat_private_input_Bg then
            self._chat_private_input_Bg:setTexture("res/Main/chat/chat_private_input_bg.png")
        end
    else
        self:setVisible(false)
        local _bg = self._chat_input_Bg:getChildByName("bgImg")
        if _bg then
           _bg:setTexture(nil)
        end
        if self._chat_private_input_Bg then
            self._chat_private_input_Bg:setTexture(nil)
        end
        self._chat_normal_input_bg:setTexture(nil)
        textureCache:removeTextureForKey("res/Main/common/popBg/bgWhite.png")
        textureCache:removeTextureForKey("res/Main/chat/chat_normal_input_bg.png")
        textureCache:removeTextureForKey("res/Main/chat/chat_private_input_bg.png")
    end
end

--更新聊天内容
function ChatPanelPop:updateTableView()
    self.curChatList = getNetManager():getRequestCenter():getAllChatData()
    self:updateTableViewContentOffset(self._curChannel)
end

--弹出聊天框
function ChatPanelPop:initChatBox()
    self._curChannelTem = 1
    local chat_input_Bg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/common/popBg/bgWhite.png",
        height = 550,
    })
    chat_input_Bg:setPosition(zc.width/2, zc.height/2)
    self:addChild(chat_input_Bg) 
    --标题
    local chat_title = zc.getSprite({
        src = "res/Main/chat/chat_title.png",
        pos = cc.p(-30, chat_input_Bg:getBoundingBox().height),
        ap = cc.p(0,0.5)
    })
    chat_input_Bg:addChild(chat_title, 5)
    --关闭按钮
    local closeButton = zc.createTopBackButton({
        listener = function () 
            LayerManager.removeLayout(nil, nil, false)
        end,
    })
    self:addChild(closeButton, 6)

    --普通输入背景
    local chat_normal_input_bg = zc.getSprite({
        src = "res/Main/chat/chat_normal_input_bg.png",
        ap = cc.p(0, 0),
        pos = cc.p(155, 10)
    })
    chat_input_Bg:addChild(chat_normal_input_bg)
    self._chat_normal_input_bg = chat_normal_input_bg
    
    local inputBoxSize = cc.size(400, 35) 
    local inputBox = ccui.EditBox:create(inputBoxSize, "res/Main/common/img_empty.png") 
    inputBox:setContentSize(cc.size(400, 40) )
    inputBox:setName("inputBox")
    inputBox:setFontSize(22)
    inputBox:setAnchorPoint(0, 0.5)
    inputBox:setPlaceHolder(zc.lang("max_enter_tips"))
    inputBox:setPlaceholderFontColor(cc.c3b(105,94,79))
    inputBox:setPlaceholderFont(zc.getFont(1), 22 )
    inputBox:setMaxLength(50) 
    inputBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    inputBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    inputBox:setPosition(242, 47)  
    chat_input_Bg:addChild(inputBox,2)

    --EditBox事件检测
    local handler = function(event,pSender)
        if event == "began" then
        end
        if event == "return" then
            local str = inputBox:getText()
            self:setCurText(str)
        end
        if event == "ended" then
            local str = inputBox:getText()
            self:setCurText(str)
        end
        if event == "changed" then
            local str = inputBox:getText()
            self:setCurText(str)
        end
    end
    inputBox:registerScriptEditBoxHandler(handler)

    --语音聊天
    local _voiceButton = zc.createPushButton({
        normalFile = "res/Main/chat/chat_voice_btn.png",
        selectedFile = "res/Main/chat/chat_voice_btn.png",
        disableFile = "res/Main/chat/chat_voice_btn.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
        end,
        pos = cc.p(190, inputBox:getPositionY()),
    })
    chat_input_Bg:addChild(_voiceButton, 2)

    local function _chooseEmojCall( name )
        local _text = "{ani=" .. name .. "}"
        local _countryId = 0
        if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 and PlayerData:getBaseInfoByTag("countryName") == ""  then 
            --没有国家
            _countryId = 0
        else
            _countryId = tonumber(PlayerData:getBaseInfoByTag("countryId"))
        end
        local _data = {toUserId = self._toUserId, countryId = _countryId}
        getNetManager():getRequestCenter():sendWords(self._curChannel,_text,_data)
    end
    --表情
    local _expressionButton = zc.createPushButton({
        normalFile = "res/Main/chat/chat_expression_btn_u.png",
        endCallback = function () 
            local _pos = inputBox:getParent():convertToWorldSpace(cc.p(inputBox:getPosition()))
            zc.createSourcePop("EmojSelectPop","src/layer/chat/EmojSelectPop.lua", {
                pos = cc.p(_pos.x + inputBoxSize.width*0.5 - 5, _pos.y + inputBoxSize.height*0.5 + 10),
                ap = cc.p(0.5, 0),
                callback = _chooseEmojCall,
            })
        end,
        pos = cc.p(680, _voiceButton:getPositionY()),
    })
    chat_input_Bg:addChild(_expressionButton, 2)

    --发送聊天
    local sendButton = zc.createPushButton({
        normalFile = "res/Main/common/button/btn_sec_u.png",
        selectedFile = "res/Main/common/button/btn_sec_d.png",
        text = zc.lang("send2"),
        fontSize = 30,
        scale = 0.7,
        outLine = true,
        color2 = cc.c3b(76, 18, 18),
        endCallback = function () 
            if self._curChannel == 1 then
                local _mVip = tonumber(PlayerData.info.vip) or 0
                if _mVip < 1 then
                    zc.tipInfo(zc.lang("tips_send_words"))
                    return
                end
            end
            local _text = self:getCurText() --inputBox:getText()
            if _text ~= "" then 
                local _countryId = 0
                if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 and PlayerData:getBaseInfoByTag("countryName") == ""  then 
                    --没有国家
                    _countryId = 0
                else
                    _countryId = tonumber(PlayerData:getBaseInfoByTag("countryId"))
                end
                local _data = {toUserId = self._toUserId, countryId = _countryId}
                getNetManager():getRequestCenter():sendWords(self._curChannel,_text,_data)
            end
            inputBox:setText("")
            self:setCurText("")
        end,
        pos = cc.p(780, _expressionButton:getPositionY()),
    })
    chat_input_Bg:addChild(sendButton, 2)

    
    --左侧标签按钮
    self._chatTagBtns = {}
    -- self._chatBtnTitles = {}

    for i=1, 5 do
        local src_title = self.tabChatPanel[i].text
        self._chatTagBtns[i] = zc.createTypeBtn({
            btnText = src_title,
            endCallback = function () 
                self:selectChatChannel(self.tabChatPanel[i].tag)
            end,
            pos = cc.p(85, 495-i*68),
        })
        chat_input_Bg:addChild(self._chatTagBtns[i])
    end
    self._chat_input_Bg = chat_input_Bg
    self._chatTagBtns[1]:setSelected(true)
    self.curChatChannelList = getNetManager():getRequestCenter():getWorldChatData()
    -- dump(self.curChatChannelList, "---self.curChatChannelList---")
    self:initChatChannelTableView()
    self:updateTableViewContentOffset(1) 
end

--选择聊天频道
function ChatPanelPop:selectChatChannel(tag)
    if self._curChannelTem == tag then return end
    if tag == 3 then
        self:initPrivateChatView()
    else
        if self._chat_private_input_Bg then
            self._chat_private_input_Bg:setVisible(false)
        end
        if self._chat_normal_input_bg then
            self._chat_normal_input_bg:setVisible(true)
        end
    end
    self._curChannelTem = tag

    for i=1, 5 do
        if self.tabChatPanel[i].tag == tag then 
            self._chatTagBtns[i]:setSelected(true)
        else
            self._chatTagBtns[i]:setSelected(false)
        end
    end
    
    --更新数据
    self._curChannel = tag
    self:updateTableViewContentOffset(tag)
    
end
--聊天列表刷新
function ChatPanelPop:updateTableViewContentOffset(tag)
    -- self.curChatChannelList = {}
    if tag == 1 then     --世界
        self.curChatChannelList = getNetManager():getRequestCenter():getWorldChatData()
    elseif tag == 2 then --国家
        self.curChatChannelList = getNetManager():getRequestCenter():getCountryChatData()
        -- dump(self.curChatChannelList, "---self.curChatChannelList---")
    elseif tag == 3 then --私聊
        self.curChatChannelList = getNetManager():getRequestCenter():getPrivateChatData()
    elseif tag == 4 then --系统
        -- self.curChatChannelList = getNetManager():getRequestCenter():getPrivateChatData()
    elseif tag == 5 then --战报
        self.curChatChannelList = getNetManager():getRequestCenter():getBattleFieldChatData()
    elseif tag == 6 then --客服
        -- print("----客服-----------------------------")
        -- self.curChatChannelList = getNetManager():getRequestCenter():getPrivateChatData()

        zc.enterCustomerServiceCenter()
        self:selectChatChannel(1)
    end
    -- dump( self.curChatChannelList, "===============================self.curChatChannelList222" )
    if tag == 3 then
        -- 私聊
        if self._ChatPrivateTableView then
            self:buildPrivateChatData()
            self:refreshPrivateState(function()
                self._friendTable:reloadData()
                self._friendTable:scrollToLastCell()
                self:updatePrivateView()
            end)
        end
    else       
        if self._ChatTableView then
            self._ChatTableView:reloadData()
            local _count = #self.curChatChannelList
            local _offSet = self._ChatTableView:getContentOffset()
            local _offSetY = 0
            for i=1, #self.curChatChannelList do
                local _h = self:getChatNormalCellSize(i - 1)
                _offSetY = _offSetY + _h
            end
            _offSetY = self._ChatTableView:getViewSize().height - _offSetY
            print("----self._ChatTableView----",_offSetY)
            if _offSetY <= 0 then
                self._ChatTableView:setContentOffset(cc.p(0, 0))
            else
                self._ChatTableView:setContentOffset(cc.p(0, _offSetY))
            end
        end
    end
end

function ChatPanelPop:getChatNormalCellSize( idx )
    local chatData = self.curChatChannelList[idx + 1]
    if chatData then 
        local __chatFlags = tonumber(chatData.flags) or 1 
        if (__chatFlags == 1 or __chatFlags == 2) and type(chatData.text) ~= "table" then
            local _data = self:getObjTable(chatData.text)
            local _aniFlag = false
            for k,v in pairs(_data) do
                if type(v) == "table" then
                    if v.type == "ani" then
                        _aniFlag = true
                    end
                end
            end
            if _aniFlag then
                return 110, 680
            end
            return 100, 680
        else
            return 50, 680
        end
    end
    return 50, 680
end

--聊天框聊天列表
function ChatPanelPop:initChatChannelTableView() 
    local _ChatTableView = zc.ZCTableView:create(cc.size(690, 360))
    _ChatTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _ChatTableView:setPosition(cc.p(10, 85))
    _ChatTableView:setDelegate()
    _ChatTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    self._underLineH = -3
    local function cellSizeForTable(table, idx)
        return self:getChatNormalCellSize(idx)
    end
    local function tableCellAtIndex(table, idx) 
        local cellIndex = idx + 1
        local cell = _ChatTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            -- self:buildCell_(cell, cellIndex)
        end
        cell:removeAllChildren()
        cell._height, cell._width = cellSizeForTable(table, idx)
        -- 更新界面
        self:updateCell_(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return table.nums(self.curChatChannelList) 
    end
    _ChatTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _ChatTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _ChatTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._chat_normal_input_bg:addChild(_ChatTableView)
    self._ChatTableView = _ChatTableView
    -- self._ChatTableView:reloadData()
end

function ChatPanelPop:updateCell_(cell, cellIndex)
    local chatData = self.curChatChannelList[cellIndex]
    if not chatData then 
        return
    end

    local __chatFlags = tonumber(chatData.flags) or 1
    if (__chatFlags == 1 or __chatFlags == 2) and type(chatData.text) ~= "table" then
        local _flag = false
        if tonumber(chatData.userId) == tonumber(GAMEUID) then
            _flag = true
        end

        local _iconDi = zc.createSprite(string.format("res/Main/hero/hero_item%s.png", _flag and "3" or "4"))
        local _iconId = tonumber(chatData.iconId) or 1
        local _iconImg = zc.createSprite(string.format("res/Main/hero/head/hero_head_10%s.png", tostring(_iconId)))
        _iconImg:setScale(1.3)
        _iconImg:setPosition(_iconDi:getContentSize().width*0.5, _iconDi:getContentSize().height*0.5)
        _iconDi:addChild(_iconImg)
        local headIcon = zc.createPushButton({
            normalNode = _iconDi,
            scale = 0.5,
            needSwallow = false,
            needEnableWhenMoving = true,
            endCallback = function()
                if tonumber(chatData.userId) == tonumber(GAMEUID) then
                    return
                end
                zc.createOtherPlayerSelect(chatData.userId)
            end
        })
        cell:addChild(headIcon)
        local _jiao = zc.createSprite(string.format("res/Main/hero/jiao_%d.png", _flag and "3" or "4"))
        _jiao:setAnchorPoint(0, 0)
        _jiao:setPosition(1, 1)
        headIcon:addChild(_jiao)
        local _level = tonumber(chatData.level) or 1
        local _levelLabel = zc.createLabel({
            text =  "Lv." .. _level,
            fontSize = 22,
            ap = cc.p(0, 0),
            pos = cc.p(3, 3),
            outLine = true,
        })
        headIcon:addChild(_levelLabel)

        local _startX = headIcon:getBoundingBox().width
        headIcon:setPosition(_startX*0.5, cell._height - headIcon:getBoundingBox().height*0.5 - 5)
        if _flag then
            headIcon:setPositionX(cell._width - _startX*0.5)
        end

        local _data = self:getObjTable(chatData.text)
        local _string, _aniFlag = "", false
        for k,v in pairs(_data) do
            if type(v) == "table" then
                if v.type == "ani" then
                    _aniFlag = true
                    --表情
                    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/chat/emoj.plist", "res/Main/chat/emoj.pvr.ccz")
                    local expression = zc.getSprite({
                        src = tostring(v.aniId),
                        plist = true,
                        scale = 0.85,
                        pos = cc.p(_startX + 20, 4),
                        ap = cc.p(0, 0)
                    })
                    -- expression:setScale(0.9)
                    cell:addChild(expression, 1)

                    if _flag then
                        expression:setAnchorPoint(1, 0)
                        expression:setPositionX(cell._width - _startX - 20)
                    end
                end
            elseif type(v) == "string" then
                _string = string.trim(v)
            end
        end

        local _infoLab = zc.createLabel({
            text = _string,
            fontSize = 20,
            ap = cc.p(0, 1),
            color = cc.c3b(125, 78, 57),
        })
        cell:addChild(_infoLab, 1)

        local _width = _infoLab:getContentSize().width
        
        local _maxWidth = cell._width - 100 - 35
        local _limitWidth = 120
        local _lineFlag = 1
        if _width > _maxWidth then
            _width = _maxWidth
            _lineFlag = 2
        end
        if _aniFlag then
            _width = _limitWidth
            _lineFlag = 3
            _infoLab:setVisible(false)
        end

        local _sizeH = 67
        if _lineFlag == 2 then
            _sizeH = 93
        elseif _lineFlag == 3 then
            _sizeH = 105
        end
        local _size = cc.size(_width + 35, _sizeH)
        local _tmpY = (cell._height - _size.height)*0.5 - 5
        local _pY = cell._height*0.5 + _tmpY
        if _lineFlag == 2 then
            _pY = _pY + _tmpY + 14
        elseif _lineFlag == 3 then
            _pY = _pY + _tmpY + 21
        end
        _infoLab:setPositionY(_pY)


        local _di = zc.createScale9Sprite({
            file = "res/Main/chat/normalChatDi.png", 
            rect = cc.rect(23, 67 - 19, 15, 10),
            size = _size,
            ap = cc.p(0, 0.5),
            pos = cc.p(_startX, cell._height*0.5 + _tmpY)
        })
        cell:addChild(_di)

        local _pX = _startX + 20
        if _flag then
            _pX = cell._width - _startX - _size.width + 10
            _di:setScaleX(-1)
            _di:setPositionX(cell._width - _startX)
        end
        _infoLab:setPositionX(_pX)

        local _data = gameData.getDataFromCacheWithPrimaryKey("title", chatData.godName)
        _god_name = _data.name or ""

        local _data = gameData.getDataFromCacheWithPrimaryKey("title", chatData.godName)
        local _god_name = _data.name or ""
        local _godLevel = tonumber(_data.level) or 3
        _godLevel = _godLevel < 1 and 1 or _godLevel
        _godLevel = _godLevel > 3 and 3 or _godLevel

        local _godX, _godY, _tmpWidth = _pX, _pY + 18, 0
        local _godDi = nil
        if _god_name ~= "" then
            _godDi = zc.createSprite("res/Main/chat/titleDi_" .. _godLevel ..  ".png")
            _godDi:setAnchorPoint(0, 0.5)
            _godDi:setPosition(_pX - 15, _pY + 26)
            cell:addChild(_godDi)
            local _god_name_label = zc.createLabel({
                text = _god_name,
                fontSize = 20,
                ap = cc.p(0.5, 0),
                pos = cc.p(92, 5),
                color = cc.c3b(255, 234, 0),
            })
            _godDi:addChild(_god_name_label)
            _godX = _godDi:getPositionX() + _godDi:getContentSize().width + 5
            _godY = _godDi:getPositionY() - 7
            _tmpWidth = _tmpWidth + _godDi:getContentSize().width
        end
        local _nameLab =  zc.createLabel({
            text = chatData.userName,
            fontSize = 16,
            ap = cc.p(0, 0.5),
            color = cc.c3b(115, 85, 65),
            pos = cc.p(_godX, _godY),
        })
        cell:addChild(_nameLab)
        _tmpWidth = _tmpWidth + _nameLab:getContentSize().width + 5
        if _aniFlag then
            _tmpWidth = _tmpWidth < _limitWidth and _limitWidth or _tmpWidth
        else
            local _infoWidth = _infoLab:getContentSize().width
            _tmpWidth = _tmpWidth < _infoWidth and _infoWidth or _tmpWidth
            _tmpWidth = _tmpWidth > _maxWidth and _maxWidth or _tmpWidth
        end
        _size.width = _tmpWidth + 35
        _di:setContentSize(_size)
        if _flag then
            _pX = cell._width - _startX - _size.width + 10 
            _godX = _pX
            if _godDi then 
                _godDi:setPositionX(_pX - 15)
                _godX = _godDi:getPositionX() + _godDi:getContentSize().width + 5
            end
            _nameLab:setPositionX(_godX)
        end
        _infoLab:setPositionX(_pX)
        _infoLab:setWidth(_tmpWidth)
    else
        local _file = "res/Main/chat/reportFlag.png"
        if __chatFlags == 4 then
            _file = "res/Main/chat/systemFlag.png"
        elseif __chatFlags == 1 then
            _file = "res/Main/chat/teamFlag1.png"
        elseif __chatFlags == 2 then
            _file = "res/Main/chat/teamFlag.png"
        end
        local _size = cc.size(cell._width - 5, 43)
        local _di = zc.createScale9Sprite({
            file = _file, 
            rect = cc.rect(73, 15, 23, 13),
            size = _size,
            ap = cc.p(0, 0.5),
            pos = cc.p(5, cell._height*0.5)
        })
        cell:addChild(_di)
        local _partX = 72

        local _data
        if (__chatFlags == 1 or __chatFlags == 2) and type(chatData.text) == "table" then
            _data = {}
            if chatData.text._tag then
                local _text = chatData.text.info
                table.insert(_data, _text)
            else
                --多人fb
                local _text = ""
                if chatData.text.teamId then
                    if chatData.text.info then
                        _text = chatData.text.info
                    end
                end
                table.insert(_data, _text)
            end
        elseif __chatFlags == 4 then
            _data = {chatData.text}
        elseif __chatFlags == 5 and type(chatData.text) == "table" then
            _data = {}
            local _text = ""
            for k,v in pairs(chatData.text) do
                if v.type == 1 then
                    local _name = ""
                    if tonumber(k) ~= 1 then
                        if tonumber(GAMEUID) == tonumber(v.id) then
                            _name = zc.lang("chat_you")
                        else
                            _name = v.name or ""
                        end
                    end
                    _text = _text .. _name
                elseif v.type == 2 then
                    _text = _text .. v.text
                end        
            end
            table.insert(_data,_text)
        else
            _data = self:getObjTable(chatData.text)
        end
        
        for k,v in pairs(_data) do
            if v then
                if __chatFlags == 4 then --
                    local _chat_desc_label = zc.createRichLabel({
                        text = " " .. v,
                        fontSize = 20,
                        anchor = cc.p(0, 0.5),
                        pos = cc.p(_partX + 3, _size.height*0.5 + 3),
                        color = cc.c3b(125, 78, 57),
                    })
                    cell:addChild(_chat_desc_label)
                elseif type(v) == "string" then
                    local _user_name = chatData.userName or ""
                    if tonumber(GAMEUID) == tonumber(chatData.userId) then
                        _user_name = zc.lang("chat_you") 
                    end
                    local _color = cc.c3b(78, 78, 124)
                    local _nameLab = ZCLabel:createWithParams({
                        text = _user_name,
                        ttf = zc.getFont(1),
                        fontSize = 18,
                        anchor = cc.p(0, 0.5),
                        pos = cc.p(_partX, _size.height*0.5),
                        color = _color,
                    })
                    _di:addChild(_nameLab)

                    _nameLab:setTouchEndedCallback(function()
                        if tonumber(chatData.userId) == tonumber(GAMEUID) then
                            return
                        end
                        zc.createOtherPlayerSelect(chatData.userId)
                    end)
                    local _line_1 = cc.DrawNode:create()
                    _line_1:drawLine(
                        cc.p(0, self._underLineH), 
                        cc.p(_nameLab:getContentSize().width, self._underLineH), 
                        cc.c4f(_color.r/255, _color.g/255, _color.b/255, 1))
                    _line_1:setPositionY(2)
                    _nameLab:addChild(_line_1, -1)

                    v = string.trim(v)
                    local _infoLab = ZCLabel:createWithParams({
                        text = " " .. v .. " ",
                        ttf = zc.getFont(1),
                        fontSize = 20,
                        anchor = cc.p(0, 0.5),
                        pos = cc.p(_nameLab:getPositionX() + _nameLab:getContentSize().width, _size.height*0.5),
                        color = cc.c3b(125, 78, 57),
                    })
                    _di:addChild(_infoLab)

                    local _str = zc.lang("add_team")
                    if __chatFlags == 5 then
                        _str = zc.lang("view_playback")
                    end
                    _color = cc.c3b(202, 63, 63)
                    local _touchLab = ZCLabel:createWithParams({
                        text = _str,
                        ttf = zc.getFont(1),
                        fontSize = 18,
                        anchor = cc.p(0, 0.5),
                        pos = cc.p(_infoLab:getPositionX() + _infoLab:getContentSize().width, _size.height*0.5),
                        color = _color,
                    })  
                    _di:addChild(_touchLab)

                    _touchLab:setTouchEndedCallback(function()
                        if __chatFlags == 5 then
                            self:onClickBattlefield(chatData)
                        else
                            self:onClickAddItemMenu(chatData)
                        end
                    end)
                    local _line_1 = cc.DrawNode:create()
                    _line_1:drawLine(
                        cc.p(0, self._underLineH), 
                        cc.p(_touchLab:getContentSize().width, self._underLineH), 
                        cc.c4f(_color.r/255, _color.g/255, _color.b/255, 1))
                    _line_1:setPositionY(2)
                    _touchLab:addChild(_line_1, -1)
                end
            end
        end
    end
end

--选择玩家名称响应
function ChatPanelPop:onClickUserName(chatData,flag)
    -- dump(chatData, "chatData ========= ")
    local _name = ""
    if flag then
        print("------chatData.userName------",chatData.toUserName)
        self._toUserId = chatData.toUserId
        _name = chatData.toUserName or ""
    else
        print("------chatData.userName------",chatData.userName)
        self._toUserId = chatData.userId
        _name = chatData.userName or ""
    end
    if tonumber(self._toUserId) == tonumber(GAMEUID) then
        return
    end
    self._toUserName = _name
    self._toUserGodName = chatData.godName or ""
    zc.createOtherPlayerSelect(self._toUserId)
end
--选择战报回放
function ChatPanelPop:onClickBattlefield(chatData)
    --战报测试
    -- dump(chatData,"--------chatData--------")
    local _warKey = nil
    if type(chatData.text) == "table" and tonumber(chatData.flags) == 5 then
        for k,v in pairs(chatData.text) do
            if v.type == 3 then
                _warKey = v.key
            end        
        end
    else 
        local _data = self:getObjTable(chatData.text)
        -- dump(_data, "====_data_data=====")
        for k,v in pairs(_data) do
            if type(v) == "table" then
                if v.type == "key" then
                    _warKey = v.warKey
                end
            end
        end
    end
    -- print("---_warKey----",_warKey)
    zc.createBattleByWarKey(_warKey)
end

--多人fb加入队伍
function ChatPanelPop:onClickAddItemMenu(chatData)
    if type(chatData.text) == "table" then
        if chatData.text._tag then
            zc.jionCountryMineTeam(chatData)
        else 
            local _teamId = chatData.text.teamId
            local _tollgateId = chatData.text.tollgateId
            -- print("--1111---",_teamId,_tollgateId)
            --跳转多人fb
            local function _CallBack()
                -- if self._isClose then
                    LayerManager.removeLayout(nil, nil, false)
                -- else
                --     self:setShow(false)
                -- end
            end
            zc.joinOneMultiCopyTeam( _teamId, _tollgateId,_CallBack)
        end
    end
end

function ChatPanelPop:setCurText(strText)
    self.curText = strText

end

function ChatPanelPop:getCurText()
    return self.curText
end

function ChatPanelPop:addAni(aniData)
    local placeSign = self:createObjStr("ani",aniData) --aniData动画的编号 
    local tempStr=self.curText..placeSign
    -- print("----tempStr----",tempStr)
    self:setCurText(tempStr) 
end

function ChatPanelPop:createObjStr(type,obj)
    local tempStr = nil
    if type == "ani" then
        tempStr = "{ani="..obj.."}"
    end
    return tempStr
end




-----------------字符串内容处理-----------------
function ChatPanelPop:getObjTable(msgContent)
    -- print("getObjTable is called")
    -- msgContent = "今天晚上打副本吧,我昨天获得了一个不错的物品{key=003} "  
    -- msgContent = "今天晚上打副本吧{{ani=52} 我昨天获{得了一个不错的物品{item=003} 我想把它}送给{name=胖墩},然后回家了"    
    local itemList  = {}

    if msgContent == nil or msgContent == nil then
        return itemList
    end

    itemList = self:callBackSplitItem(msgContent,"{","}")
    -- dump(itemList, "---itemList---")
    for skey,svalue in pairs(itemList) do
        if type(svalue) == "string" and svalue ~= "" then
            local splitArry = self:SplitItem(svalue,"=")
            -- local splitArry = self:SplitItem_1(svalue,"=")
            if table.maxn(splitArry) == 2 then
                local key = splitArry[1]
                local value =splitArry[2]
                local obj = {} --换成对象实体 ani  item  name
                if key == "ani" then
                    obj.type = "ani"
                    obj.aniId = value
                elseif key == "key" then
                    obj.type = "key"
                    obj.warKey = value
                end
                itemList[skey] = obj
            else
                --local tempValue = "{"..svalue.."}"
                --itemList[skey] = tempValue
            end
        end
    end
    -- dump(itemList, "---itemList---")
    return itemList
end

--将字符串分割成需要的格式
function ChatPanelPop:callBackSplitItem(szFullString,szSeparator1,szSeparator2)
    local result = {}

    local resultTable = {}
    local resultList = self:SplitItem(szFullString,szSeparator1)
    for k,v in pairs(resultList) do
        local resArry = self:SplitItem(v,szSeparator2)
        
        table.insert(resultTable,resArry)

    end

    for key,value in pairs(resultTable) do
        if  value~=nil and type(value) == "table" then
            for skey,svalue in pairs(value) do
                if svalue ~= "" then
                    table.insert(result,svalue)
                end
            end
        end
    end
    return result
end

function ChatPanelPop:SplitItem(szFullString, szSeparator)  
    -- print("--szFullString---",szFullString)
    local nFindStartIndex = 1  
    local nSplitIndex = 1  
    local nSplitArray = {}  
    xpcall(function()
        while true do  
           local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
           -- print("Split",nFindLastIndex)  
           if not nFindLastIndex then  
                table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, string.len(szFullString)) )
                break  
            end
            table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)  )
            nFindStartIndex = nFindLastIndex + string.len(szSeparator)  
            nSplitIndex = nSplitIndex + 1  
        end
    end, function() end)
    return nSplitArray  
end

function ChatPanelPop:SplitItem_1(szFullString, szSeparator)  
    -- print("--szFullString---",szFullString)
    local nFindStartIndex = 1  
    local nFindLastIndex = 1
    local nSplitIndex = 1  
    local nSplitArray = {}  

    local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
    -- print("---nFindLastIndex--",nFindLastIndex,szSeparator)
    if nFindLastIndex then  
        -- print("----",string.sub(szFullString, nFindStartIndex, nFindLastIndex-1))
        table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, nFindLastIndex-1))
        -- print("----",string.sub(szFullString, nFindLastIndex,string.len(szFullString)))
        table.insert(nSplitArray,string.sub(szFullString, nFindLastIndex,string.len(szFullString))) 
    end
    -- dump(nSplitArray, "---nSplitArray---")
    return nSplitArray  
end

--弹出聊天私聊界面
function ChatPanelPop:initPrivateChatView()
    self._chat_normal_input_bg:setVisible(false)
    local chat_private_input_Bg = zc.getSprite({
        src = "res/Main/chat/chat_private_input_bg.png",
        pos = cc.p(150, 10),
        ap = cc.p(0, 0)
    })
    self._chat_input_Bg:addChild(chat_private_input_Bg)
    self._chat_private_input_Bg = chat_private_input_Bg
    local _toUserName = ""
    if self._toUserName then
        _toUserName = self._toUserName or ""
    end
    --私聊对象
    local _toUserName_label = zc.createLabel({
        text = _toUserName,
        fontSize = 22,
        ap = cc.p(0.5, 1),
        outLine = true,
        pixel = 1.5,
        pos = cc.p(460, chat_private_input_Bg:getBoundingBox().height-3),
        color = cc.c3b(255, 237, 86)
    })
    chat_private_input_Bg:addChild(_toUserName_label)
    self._chat_private_input_Bg = chat_private_input_Bg
    self._toUserName_label = _toUserName_label
    self:initChatPrivateChannelTableView()
    --好友列表
    -- self._friendData = PlayerData:getFriendInfo().friends
    -- dump(self._friendData, "---self._friendData--")
    self._friendData = {}
    self._privateIndex = 1
    self:initFriendListView()
end

function ChatPanelPop:buildPrivateChatData()
    self._privateChatData = {}
    self._friendData = {}
    local myUserId = tonumber( PlayerData.info.userId )
    -- dump( self.curChatChannelList, "self.curChatChannelList" )
    for i, v in ipairs( self.curChatChannelList ) do
        local id = 0
        local name = ""
        local iconId = 1
        local _god_name = ""
        if myUserId == tonumber( v.userId ) then
            id = tonumber( v.toUserId )
            name = v.toUserName or ""
            _god_name = v.toGoldName
        else
            id = tonumber( v.userId )
            name = v.userName or ""
            _god_name = v.godName
        end
        if self._privateChatData[id] then
            self._privateChatData[id][#self._privateChatData[id] + 1] = v
        else
            self._privateChatData[id] = { v }
            self._friendData[#self._friendData + 1] = {
                userId = id,
                userName = name,
                iconId = iconId,
                online = 0,
                godName = _god_name
            }
        end
    end
    if self._toUserId then
        if self._privateChatData[self._toUserId] then
            -- 已经聊过天了，查找聊天记录，跳到对应人
            for i, v in ipairs( self._friendData ) do
                if v.userId == self._toUserId then
                    self._privateIndex = i
                    break
                end
            end
        else
            -- 没聊过天，在最后添加
            self._privateChatData[self._toUserId] = {}
            self._friendData[#self._friendData + 1] = {
                userId = self._toUserId,
                userName = self._toUserName,
                iconId = 1,
                online = 0,
                godName = self._toUserGodName
            }
            self._privateIndex = #self._friendData
        end
    else
        self._privateIndex = #self._friendData
    end
    -- dump( self._privateChatData, "self._privateChatData" )
    -- dump( self._friendData, "self._friendData" )
end

function ChatPanelPop:initFriendListView()
    local _tableSize = cc.size(250, 370)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(0, 80)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._chat_private_input_Bg:addChild(_tableView)
    self._friendTable = _tableView

    local _cellSize = cc.size(250, 100)

    local function numberOfCellsInTableView( table )
        return #self._friendData
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height , _cellSize.width
    end
    local function tableTouchEnded(table, cell)
        
    end
    local function tableCellAtIndex( table, index )
        local cell = table:dequeueCell()
        if cell then
            cell:removeAllChildren()
        else
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end

        local _selectedDi = zc.getScaleNode("res/Main/chat/scale9_bg.png", cc.size(_cellSize.width - 30, _cellSize.height))
        _selectedDi:setAnchorPoint(0, 0)
        _selectedDi:setPosition(5, 0)
        cell:addChild(_selectedDi)
        _selectedDi:setVisible(false)
        cell.selectedDi = _selectedDi

        local _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 0), _cellSize.width, _cellSize.height)
        cell:addChild(_di) 
        self:createOneCell(_di, index)
        return cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableView:registerScriptHandler(tableTouchEnded,zctech.TABLEVIEW_TOUCH_ENDED)
    -- _tableView:reloadData()
end

function ChatPanelPop:createOneCell( cell, index )
    local _friendData = self._friendData[index+1]
    if _friendData then
        local _node = cc.Node:create()
        _node:setContentSize(cell:getContentSize())
        local _di = zc.createPushButton({
            normalNode = _node,
            anchor = cc.p(0, 0),
            needSwallow = false,
            needEnableWhenMoving = true,
            endCallback = function()
                self:updatePrivateView(index+1)
            end
        })
        cell:addChild(_di)
        --头像
        local headIcon = zc.createPlayerHead({iconId=_friendData.iconId})
        headIcon:setPosition(cc.p(52, 50))
        headIcon:setScale(0.95)
        cell:addChild(headIcon)
        -- dump(_friendData, "wm----_friendData : ")
        local _data = gameData.getDataFromCacheWithPrimaryKey("title", _friendData.godName)
        local _god_name = _data.name or ""
        local _godLevel = _data.level or 3
        _godLevel = _godLevel < 1 and 1 or _godLevel
        _godLevel = _godLevel > 3 and 3 or _godLevel
        local _partY = 20
        if _god_name ~= "" then 
            local _godDi = zc.getSprite({
                src = "res/Main/chat/titleDi_" .. _godLevel .. ".png",
                ap = cc.p(0, 0.5),
                pos = cc.p(95, 78),
                scale = 0.85,
            })
            cell:addChild(_godDi)
            --玩家名称
            local _god_name_label = ZCLabel:createWithParams({
                text = _god_name,
                ttf = zc.getFont(1),
                fontSize = 20,
                anchor = cc.p(0.5, 0),
                pos = cc.p(92, 5),
                color = cc.c3b(255, 234, 0)
            })
            _godDi:addChild(_god_name_label)
            _partY = 0
        end

        local _name_label = zc.createLabel({
            text = _friendData.userName,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            outLine = true,
            pos = cc.p(100, 49 + _partY),
        })
        cell:addChild(_name_label) 
        local _text = zc.lang("on_line")
        local _color = display.COLOR_GREEN
        if tonumber(_friendData.online) == 0 then
            _text = zc.lang("off_line")
            _color = display.COLOR_GRAY
        else 
            _text = zc.lang("on_line")
            _color = display.COLOR_GREEN
        end
        local _line_label = zc.createLabel({
            text = _text,
            fontSize = 18,
            ap = cc.p(0,0.5),
            outLine = true,
            pos = cc.p(100, 25 + _partY*0.5),
            color = _color,
        })
        cell:addChild(_line_label) 
        headIcon:setTouchEndedCall(function()
            zc.createOtherPlayerSelect(_friendData.userId)
        end)
    end
end

function ChatPanelPop:updatePrivateView(index)
    local _idx = tonumber(index) or self._privateIndex
    local _friendData = self._friendData[index]
    local _friendCell = self._friendTable:cellAtIndex(self._privateIndex - 1)
    if _friendCell then
        _friendCell.selectedDi:setVisible(false)
    end
    local _toUserName = ""
    if _friendData then
        _toUserName = _friendData.userName
        self._toUserId = _friendData.userId
        self._toUserGodName = _friendData.godName
    end
    self._toUserName_label:setText(_toUserName)
    self._privateIndex = _idx
    local _friendCell = self._friendTable:cellAtIndex(self._privateIndex - 1)
    if _friendCell then
        _friendCell.selectedDi:setVisible(true)
    end
    self._ChatPrivateTableView:reloadData()
    self._ChatPrivateTableView:scrollToLastCell()
end

-- 私聊
function ChatPanelPop:initChatPrivateChannelTableView()
    local _ChatPrivateTableView = zc.ZCTableView:create(cc.size(475, 340))
    _ChatPrivateTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _ChatPrivateTableView:setPosition(cc.p(235, 80))
    _ChatPrivateTableView:setDelegate()
    _ChatPrivateTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function tableCellTouched(table, cell)
        --print("cell touched at index: " .. cell:getIdx())
    end
    local function cellSizeForTable(table, idx) 
        return 100, 450
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = _ChatPrivateTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildPrivateCell_(cell, cellIndex)
        end
        -- 更新界面
        self:updatePrivateCell_(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        if #self._friendData == 0 then
            -- 没有聊天信息
            return 0
        else
            local userId = self._friendData[self._privateIndex].userId
            return #self._privateChatData[userId]
        end
    end
    _ChatPrivateTableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    _ChatPrivateTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _ChatPrivateTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _ChatPrivateTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._chat_private_input_Bg:addChild(_ChatPrivateTableView)
    self._ChatPrivateTableView = _ChatPrivateTableView
end

function ChatPanelPop:buildPrivateCell_( cell, cellIndex )
    cell.item = cc.Node:create()
    cell.item:setPosition(cc.p(405, 50))
    cell:addChild(cell.item)
end

function ChatPanelPop:updatePrivateCell_(cell, cellIndex)
    local _friendData = self._friendData[self._privateIndex]
    local userId = _friendData.userId
    local allChatData = self._privateChatData[userId]
    local chatData = allChatData[cellIndex]
    if chatData then 
        self:analysisChatContent_private(cell, chatData)
        if not self._toUserId then
            self._toUserId = chatData.userId
            self._toUserName = chatData.userName or ""
            self._toUserGodName = chatData.godName or ""
            if self._toUserName then
                self._toUserName_label:setText(self._toUserName)
            end
        end
        if cell.item then
            local _id = _friendData.iconId
            if chatData.userId == tonumber(GAMEUID) then
                _id = PlayerData.info.iconId
            end
            cell.item:removeAllChildren()
            local headIcon = zc.createPlayerHead({iconId=_id})
            headIcon:setScale(0.95)
            cell.item:addChild(headIcon)
        end
    end 
end

--处理聊天内容显示
function ChatPanelPop:analysisChatContent_private(cell, chatData)
    if cell._layout then cell._layout:removeSelf() cell._layout = nil end
    cell._layout = cc.Node:create()
    cell._layout:setContentSize(cc.size(cell:getContentSize().width, cell:getContentSize().height))
    cell._layout:setPosition(0, 0)
    cell:addChild(cell._layout)  
    cell._chat_private_item_bg = zc.createScale9Sprite({
        file = "res/Main/chat/chat_private_item_bg.png",
        rect = cc.rect(5, 5, 50, 5),
        size = cc.size(346, 85),
        pos = cc.p(180, 50),
    })
    cell._layout:addChild(cell._chat_private_item_bg)
    -- local _color = display.COLOR_BLACK
    local _color = cc.c3b(76, 18, 18)
    if tonumber(chatData.userId) ~= tonumber(GAMEUID) then
        cell._chat_private_item_bg:setScaleX(-1)
        cell.item:setPosition(cc.p(50,50))
        cell._chat_private_item_bg:setPosition(273, 50)
        _color = cc.c3b(76, 18, 18)
    else
        cell._chat_private_item_bg:setScaleX(1)
        cell.item:setPosition(cc.p(405,50))
        cell._chat_private_item_bg:setPosition(180, 50)
    end
    -- local _data = chatData
    local _data = self:getObjTable(chatData.text)
    -- dump(_data)
    if tonumber(chatData.flags) == 5 then --战报
        for k,v in pairs(_data) do
            if type(v) == "table" then
                if v.type == "key" then
                    table.remove(_data,k)
                end
            end
        end
    end
    posx = 0
    local _temp_posx = posx
    local _fontNum = 0
    local _fontNum_temp = 0
    local _index = 0
    local _tmpH = 0
    local posy = 70*0.5 + _tmpH
    local resultText1 = ""
    local resultText2 = ""
    local _temp_label = zc.createRichLabel({
        text = "",
        fontSize = 22,
        anchor = cc.p(0, 1),
        pos = cc.p(8 , cell._chat_private_item_bg:getContentSize().height - 4),
        color = _color,
    })   
    _temp_label:setDimensions(cc.size(320, 100))

    local _addWidth = 0
    for k,v in pairs(_data) do
        if type(v) == "string" then
            _temp_label:setString(v)
            cell._chat_private_item_bg:addChild(_temp_label, 1)
            if cell._chat_private_item_bg:getScaleX() < 0 then
                _temp_label:setScaleX(-1)
                _temp_label:setPositionX(cell._chat_private_item_bg:getContentSize().width - 24)
            end
        elseif type(v) == "table" then
            if v.type == "ani" then
                cell._chat_private_item_bg:setVisible(false)
                --表情
                cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/chat/emoj.plist", "res/Main/chat/emoj.pvr.ccz")
                posy = 55
                if tonumber(chatData.userId) ~= tonumber(GAMEUID) then
                    posx = 142
                else
                    posx = 310
                end
                local expression = zc.getSprite({
                    src = tostring(v.aniId),
                    plist = true,
                    pos = cc.p(posx, posy),
                })
                cell._layout:addChild(expression,1)
            end
        end
    end
end

-- 请求私聊列表的在线数据和icon
function ChatPanelPop:refreshPrivateState(_callback)
    if not self._friendData or #self._friendData == 0 then
        return
    end
    local _targetUserId = ""
    for i, v in ipairs( self._friendData ) do
        if i == 1 then
            _targetUserId = tostring( v.userId )
        else
            _targetUserId = _targetUserId.."|"..tostring( v.userId )
        end
    end
    zc.sendHttp({
        apiName = "User_getUserOnline",
        params = {targetUserId=_targetUserId},
        successCallback = function (data)
            for k, v in pairs(data) do
                for i, u in ipairs( self._friendData ) do
                    if tonumber( k ) == tonumber( u.userId ) then
                        u.iconId = tonumber(v.iconId)
                        u.online = v.isOnline
                    end
                end    
            end
            if _callback then
                _callback()
            end
        end,
    })
end


return ChatPanelPop