--[[
	FileName: GrabMineInfoPop.lua
	Author: andong
	Date: 2016-12-06
	Purpose: 国家抢矿信息界面
]]
local GrabMineInfoPop = class( "GrabMineInfoPop", function ()
    -- return ZCPopLayer:create({opacityValue=150})
    return ZCPopLayer:create({opacityValue=150})
end)
function GrabMineInfoPop:create(parmas)
	return GrabMineInfoPop.new(parmas)
end
function GrabMineInfoPop:ctor(parmas)
	self:initData(parmas)
	self:initUI()
	self:show(false)
end

function GrabMineInfoPop:initData(parmas)
    local parmas = parmas or {}
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    if parmas.goBattle then
        self._goBattle = parmas.goBattle
    end

    self._isOnlyShow = parmas.onlyShow or false --只是显示，没有按钮点击交互
    self._areaIndex = tonumber(parmas.area) --区域id
    self._mineId = tonumber(parmas.mineId)  --矿id
    --拿当前矿的数据方法（1：遍历所有矿查找、2参数传递）
    -- 1
    local _allMineInfo = PlayerData:getCountryMineData() or {}
    local mineInfo = _allMineInfo[self._areaIndex] or {}
    local mineList = mineInfo.mineList or {}
    self._data = {}
    for i = 1, #mineList do
        local v = mineList[i]
        if v and v.countryMineId and tonumber(v.countryMineId) == tonumber(self._mineId) then
            self._data = v
            break
        end
    end
    -- 2 (这里可能没有数据，玩家从主城界面直接进入抢夺队伍，现在的解决办法是去拉一次抢矿数据)
    if not next(self._data) then
        self._data = parmas.data or {}
        zc.sendHttp({
            apiName = "CountryMine_main",
            successCallback = function (net_data)
                PlayerData:initCountryMineData(net_data)
                for k, v in pairs(net_data) do
                    if v and type(v) == "table" and next(v) then
                        for m,n in pairs(v) do
                            if m and tonumber(m) and tonumber(m) == self._mineId then
                                self._data = n
                                if not tolua.isnull(self) then
                                    self:refreshUIInfo()
                                end
                                break
                            end                     
                        end
                    end
                end
            end
        })
    end
    dump(self._data, " wm---test : ")
    self._maxMemberNum = 3 --驻守成员最大数量 
    self._userId = tonumber(PlayerData.info.userId)

    local _staticdata = gameData.getDataFromCacheWithPrimaryKey("mine", self._mineId) or {}
    self._staticMineData = _staticdata
    self._tag = tonumber(_staticdata.grade) or 1

    --是不是自己的国家占领的矿
    self._countryInfo = PlayerData:getCountryInfo() or {}
    self._countryName = self._countryInfo.name or ""
    self._countryId = tostring(self._countryInfo.id) or ""

    --
    self:refreshNowState()
    self:getRewardList()
    
end
function GrabMineInfoPop:getRewardList()
    local rewardList = {}
    local _levyHouseInfo = PlayerData:getHouseInfoByHouseId(16)
    local _levyProfit = gameData.getDataFromCacheWithPrimaryKey("houseEffect_leyv", _levyHouseInfo["level"]) --等级与收益
    for i = 1, 3 do
        if self._staticMineData["resourceOutput"..i] and self._staticMineData["resourceOutput"..i] ~= "" then
            local rewardT = string.split(self._staticMineData["resourceOutput"..i], "|")
            if rewardT[1] and rewardT[2] and rewardT[3] then
                local _num = rewardT[3]
                if i == 1 then --奖励1 ，根据策划的需求，系数*征收(对应类型)的基础值/100
                    local _profitTypeList = {[2]=1,[9]=2,[10]=3}
                    local _profitType = _profitTypeList[tonumber(rewardT[2])] or 1
                    _num = math.floor((tonumber(_levyProfit["awards".._profitType]) or 1) * (tonumber(_num) or 1)/100)
                end
                local _index = #rewardList + 1
                rewardList[_index] = {}
                rewardList[_index].itemType = rewardT[1]
                rewardList[_index].itemId = rewardT[2]
                rewardList[_index].num = zc.getWan( _num )
                rewardList[_index]._getType = i --奖励类型（1个人，2...，3国家）
                rewardList[_index].tipStr = zc.lang("reward_after_clearing") --奖励类型（1个人，2...，3国家）
                rewardList[_index].color  = cc.c3b(203,183,123)
            end
        end
    end
    --额外的奖励（抢占/驻守）
    local extraRewardStr = ""
    local tipStr = zc.lang("may_reward_after_clearing")
    if self._rightState.state == 1 then
        extraRewardStr = self._staticMineData["seizeReward"] or ""
    else
        extraRewardStr = self._staticMineData["grabReward"] or ""
        tipStr = zc.lang("may_reward_after_seize")
    end
    local extraRewardList = string.split(extraRewardStr, ",")
    for i = 1, #extraRewardList do
        local extraReward = string.split(extraRewardList[i], "|")
        if extraReward and extraReward[1] and extraReward[2] then
            local _index = #rewardList + 1
            rewardList[_index] = {}
            rewardList[_index].itemType = extraReward[1]
            rewardList[_index].itemId = extraReward[2]
            rewardList[_index].num = zc.getWan( extraReward[3] ) 
            rewardList[_index]._getType = 2 --奖励类型（1个人，2...，3国家）
            rewardList[_index].tipStr = tipStr --奖励类型（1个人，2...，3国家）
        end
    end
    self._rewardList = rewardList
    self._rewardNum = table.nums(self._rewardList)
end
-- 刷新当前界面信息
function GrabMineInfoPop:refreshNowState()

    --是否已经有人驻守
    self._hasOccupy = 1 --(1:没有人，2:已经驻守)
    if self:isOccupy(self._data) then
        self._hasOccupy = 2
    end

    self._isOwnCountry = false
    -- if tostring(self._data["countryName"]) == self._countryName then
    if tostring(self._data["countryId"]) == self._countryId then
        self._isOwnCountry = true
    end

    --当前右按钮的状态 state（1：驻守、2：掠夺）,canTouch是否可点击
    self._rightState = { state = 1, canTouch = true, }
    if not self._isOwnCountry and self._hasOccupy == 2 then --如果不是自己的国家，被别的国家占领了，可以抢
        self._rightState.state = 2
        self._rightState.canTouch = true
    elseif self._isOwnCountry and (self._teamIsFull or self._isInTheTeam) then --如是是自己的国家，但是队伍已经满了(或者自己在队伍中)，不能再驻守
        self._rightState.state = 1
        self._rightState.canTouch = false
    end

    --当前左按钮的状态（1：自己不在队伍中、2自己在队伍中(在队伍中可放弃占领)）
    self._leftState = 1
    if self._isInTheTeam then
        self._leftState = 2
    end

end

--判断是否占领
function GrabMineInfoPop:isOccupy(_data)
    if not _data then
        return false
    end
    local _isOccupy = false
    self._isInTheTeam = false --自己有没有在队伍中
    self._teamIsFull = true  --队伍是否已经满员
    for i = 1, 3 do
        if _data["userId"..i] and tonumber(_data["userId"..i]) and tonumber(_data["userId"..i]) > 0 then
            _isOccupy = true
            if tonumber(_data["userId"..i]) == self._userId then
                self._isInTheTeam = true
            end
        else
            self._teamIsFull = false
        end
    end
    return _isOccupy
end

function GrabMineInfoPop:initUI(params)

	local titleSrc = "res/Main/country/grabMine/mine_name_"..self._staticMineData.grade..".png"
    if not zc.checkFileExist(titleSrc) then
        titleSrc = "res/Main/country/grabMine/mine_name_1.png"
    end

    local addHeight = 0
    if self._rewardNum == 3 then --如果有3个奖励要拉长
        addHeight = 32
    end
    local popHeight = 521 + addHeight
    local _middleBgHeight = 319 + addHeight
    if self._isOnlyShow then
        popHeight = popHeight - 65
        _middleBgHeight = _middleBgHeight-65
    end
    local popBg = zc.createNormalPop({
        tag = 1,
        titleSrc = titleSrc,
        showSide = false,
        height = popHeight+31,
        width = 409,
        bianZOrder = 0
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)
    local popSize = cc.size(409, popHeight)
    self._popSize = popSize

    --关闭按钮
    local close = zc.createBackButton({
        pos = cc.p( popSize.width-10  , popSize.height), 
        listener = function()
            self:hide()
        end,
    })
    popBg:addChild( close )

    local headBg = zc.createGeneralPopScale({
    	width = 384,
    })
    headBg:setAnchorPoint(0.5, 1)
    headBg:setPosition(popSize.width*0.5, popSize.height - 50)
    popBg:addChild(headBg)

    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 381,
        height = _middleBgHeight,
    })
    _middleBg:setAnchorPoint(cc.p(0.5, 0))
    _middleBg:setPosition(cc.p(popSize.width/2, 15))
    popBg:addChild(_middleBg)
    self._middleBg = _middleBg


    local headSize = headBg:getContentSize()
    local _bgFlower = zc.getSprite({
        src = "res/Main/common/popBg/bgFlower.png",
        pos = cc.p(70, headSize.height*0.5),
        scale = 0.7,
    })
    headBg:addChild(_bgFlower)

    local _scaleList = {
        [1] = {_scale = 1.2, justX = 8},
        [2] = {_scale = 1.2, justX = 7},
        [3] = {_scale = 1, justX = 9},
        [4] = {_scale = 0.8, justX = 0},
    }
    local mineImg = zc.createSprite("res/Main/country/grabMine/building_"..self._tag..".png")
    mineImg:setScale(_scaleList[self._tag]._scale or 1)
    mineImg:setAnchorPoint(0.5, 0.5)
    mineImg:setPosition(_bgFlower:getContentSize().width/2+(_scaleList[self._tag].justX or 0), _bgFlower:getContentSize().height/2)
    _bgFlower:addChild(mineImg)


    local nameBg1 = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(260, headSize.height/4*3-10),
    })
    headBg:addChild(nameBg1)
    local nameBg2 = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(260, headSize.height/4+10),
    })
    headBg:addChild(nameBg2)

    local nameDesc = zc.createLabel({
        text = zc.lang("seize_country") .. "：",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(7,nameBg1:getContentSize().height/2),
        color = cc.c3b(203,183,123),
    })
    nameBg1:addChild(nameDesc)

    local ownerName = zc.createLabel({
        text = zc.lang("un_seize"),
        fontSize = 18,
        ap = cc.p(1, 0.5),
        pos = cc.p(nameBg1:getContentSize().width-7,nameBg1:getContentSize().height/2),
    })
    nameBg1:addChild(ownerName)

    self._ownerName = ownerName

    local timeDesc = zc.createLabel({
        text = zc.lang("clearing_count_time") .. "：",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(7,nameBg2:getContentSize().height/2),
        color = cc.c3b(203,183,123),
    })
    nameBg2:addChild(timeDesc)
    local timeLab = zc.createLabel({
        text = "00:00:00",
        fontSize = 18,
        ap = cc.p(1, 0.5),
        pos = cc.p(nameBg2:getContentSize().width-7, nameBg2:getContentSize().height/2),
        color = display.COLOR_RED,
    })
    nameBg2:addChild(timeLab)
    self._timeLab = timeLab

    local GrabMineMapFirstLayer = zc.getScene("GrabMineMapFirstLayer")
    if GrabMineMapFirstLayer then
        local _timeList = GrabMineMapFirstLayer:getTimeList() or {}
        for i = 1, #_timeList do
            local v = _timeList[i]
            if v and v.grade and v.lastTime and v.grade == self._tag then
                timeLab:setString(zc.getTimeHMS(v.lastTime))
                break
            end
        end
    end

    
    --
    local infoBgSize = cc.size(_middleBg:getContentSize().width-22,231+addHeight)

    local infoBg = zc.createGeneralPopScale({
        tag = 2,
        width = infoBgSize.width,
        height = infoBgSize.height,
    })
    infoBg:setAnchorPoint(cc.p(0.5, 1))
    infoBg:setPosition(cc.p(_middleBg:getContentSize().width/2, _middleBg:getContentSize().height-8))
    _middleBg:addChild(infoBg)

    --成员
    local stuffTitle = zc.createSprite("res/Main/country/grabMine/garrison_member.png")
    stuffTitle:setAnchorPoint(0.5, 0.5)
    stuffTitle:setPosition(infoBgSize.width/2, infoBgSize.height-20)
    infoBg:addChild(stuffTitle)
    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, stuffTitle:getContentSize().height/2 )
    stuffTitle:addChild(lace_left)
    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(stuffTitle:getContentSize().width, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    stuffTitle:addChild(lace_right)

    local distance = 116
    local posList = zc.sortFromMiddle( cc.p(infoBgSize.width/2,infoBgSize.height-80), self._maxMemberNum , distance )

    self._inviteBtnList = {}
    for i = 1, self._maxMemberNum do
        local item_bg = zc.createSprite("res/Main/smithy/shenbing/item_bg.png")
        item_bg:setAnchorPoint(0.5, 0.5)
        item_bg:setPosition(posList[i])
        infoBg:addChild(item_bg)
        local itemBgSize = item_bg:getContentSize()

		local inviteBtn = zc.createPushButton({
			touchSize = cc.size(itemBgSize.width, itemBgSize.height),
			pos = cc.p(itemBgSize.width/2, itemBgSize.height/2),
			endCallback = function()
                if self._isOnlyShow then
                    return
                end
                zc.createGrabCountryList({_type = 1,mineId=self._data.countryArea,id=self._data.countryMineId})
            end
		})
		item_bg:addChild(inviteBtn)
		inviteBtn:setContentSize(itemBgSize)

		local canOccupy = zc.createSprite("res/Main/country/grabMine/tip_can_garrison.png")
		canOccupy:setPosition(itemBgSize.width/2, itemBgSize.height/2)
		item_bg:addChild(canOccupy)

        local _headIcon = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = 101,
                level = zc.getLevelTipShow().."10",
            }, 
            showLevel = true,
            mainRoleIcon = 1,
            pos = cc.p(itemBgSize.width/2, itemBgSize.height/2 ),
        })
        _headIcon:setScale(80 / 120)
        item_bg:addChild(_headIcon)
        _headIcon:setVisible(false)

        local _userName = zc.createLabel({
            fontSize = 14,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(itemBgSize.width/2, itemBgSize.height/2 - 55),
            color = cc.c3b(203,183,123),
        })
        item_bg:addChild(_userName)
        _userName:setVisible(false)
        

        self._inviteBtnList[i] = {}
        self._inviteBtnList[i]._btn = inviteBtn
        self._inviteBtnList[i]._canOccupy = canOccupy
        self._inviteBtnList[i]._headIcon = _headIcon
        self._inviteBtnList[i]._userName = _userName

    end

    --desc
    local descSize = cc.size(333, 64 + addHeight)
    local descBg = zc.getScaleNode("res/Main/role/common/name_bg.png", descSize)
    descBg:setAnchorPoint(0.5,0)
    descBg:setPosition(infoBgSize.width/2, 12)
    infoBg:addChild(descBg)

    local rewardNum = 2 --奖励个数
    local rewardList = self._rewardList

	local rewardNum = table.nums(rewardList) --奖励个数
	local itemDis = descSize.height/rewardNum
    for i = 1, rewardNum do
    	local posY = descSize.height-itemDis/2 - 2 - (i-1)*28

    	
    	local reward = rewardList[i]
        local rewardPath = ""

        -- dump(reward, "rewardreward-----------dump--------ad-------------" )
        local _scale = 0.85
        if tonumber(reward.itemType) == 1 then
            rewardPath = zc.getImgByType( reward.itemId )
        elseif tonumber(reward.itemType) == 4 then
            local _info = zc._getIconInfo({
                data = {
                    mainType = reward.itemType,
                    type = reward.itemId,
                    id = reward.itemId,
                    num = reward.num,
                }
            })
            -- dump(_info, "_info-----------dump--------ad-------------" )
            rewardPath = _info.img
            _scale = 0.35
        end

        local myLab = zc.createLabel({
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, posY),
            color = cc.c3b(203,183,123),
        })
        descBg:addChild(myLab)
	    local rewardImg = zc.createSprite( rewardPath )
	    rewardImg:setAnchorPoint(0, 0.5)
	    rewardImg:setPosition(230, posY )
	    descBg:addChild(rewardImg)
	    rewardImg:setScale(_scale)
	    local rewardNum = zc.createLabel({
	        text = reward.num,
	        fontSize = 18,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(270, posY ),
	        pixel = 2,
	    })
	    descBg:addChild(rewardNum)
        --
        local _str = ""
        if reward._getType == 1 then
            _str = zc.lang("for_member_reward_after_clearing")
        elseif reward._getType == 2 then
            _str = reward.tipStr
            myLab:setColor(reward.color or display.COLOR_RED)
        elseif reward._getType == 3 then
            _str = zc.lang("for_country_reward_after_clearing")
        end
        myLab:setString(_str)
    end


    if not self._isOnlyShow then
        local leftBtn = zc.createCommomBtn({
            tag = 2,
            text = "left",
            needSwallow = false,
            endCallback = function()
                if self._leftState == 2 then
                    --如果是队长，可以放弃队伍
                    zc.sendHttp({
                        apiName = "CountryMine_giveUp",
                        params = {mineId=self._data.countryArea,id=self._data.countryMineId},
                        successCallback = function (net_data)
                            PlayerData:setCountryOneMineInfo(self._data, net_data, true)
                            self:refreshUIInfo()
                        end
                    })
                elseif self._leftState == 1 then
                    self:hide()
                end
            end,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(_middleBg:getContentSize().width/2-98, 40)
        })
        _middleBg:addChild(leftBtn)
        self._leftBtn = leftBtn
        local rightBtn = zc.createCommomBtn({
            tag = 1,
            text = "right",
            needSwallow = false,
            endCallback = function()
                if self._rightState.state == 1 then --占领
                    zc.sendHttp({
                        apiName = "CountryMine_occupy",
                        params = {mineId=self._data.countryArea,id=self._data.countryMineId},
                        successCallback = function (net_data)
                            PlayerData:setCountryOneMineInfo(self._data, net_data, true)
                            self:refreshUIInfo()
                            if not self._teamIsFull then
                                zc.createGrabCountryList({_type = 1,mineId=self._data.countryArea,id=self._data.countryMineId})
                            end
                        end
                    })
                elseif self._rightState.state == 2 then --掠夺
                    local _fightTimes = PlayerData:getCountryMineFightTimes()
                    if _fightTimes.freeTimes <= 0 then
                        local function buyTime()
                            zc.sendHttp({
                                apiName = "CountryMine_buyFightTime",
                                successCallback = function (net_data)
                                    zc.tipInfo(zc.lang("tips_buy_success") .. "！")
                                    PlayerData:updataData( net_data )
                                    PlayerData:setCountryMineFightTimes({freeTimes=net_data.freeTimes,timesLimit=net_data.timesLimit})
                                end
                            })
                        end
                        local priceInfo = zc.getConsumePriceData( 50, _fightTimes.timesLimit+1 ) or {}
                        local price = priceInfo.price or 0
                        local comfirm = ZCConfirmDialog:createWithParams({
                            title = zc.lang("prompt"),
                            msg = LANGUAGE_SEIZE_BUYGOLD(price),
                            showDi = true,
                            rightCallback = function()
                                buyTime()
                            end
                        })
                        self:addChild(comfirm, 11)
                    else
                        zc.sendHttp({
                            apiName = "CountryMine_createTeam",
                            params = {mineId=self._data.countryArea,id=self._data.countryMineId},
                            successCallback = function (net_data)
                                local _recordMineData = self._data
                                if self._goBattle then
                                    self._goBattle()
                                end
                                zc.createGrabMineTeam( net_data,_recordMineData )
                            end
                        })
                    end 
                end
            end,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(_middleBg:getContentSize().width/2+98, 40)
        })
        _middleBg:addChild(rightBtn)
        self._rightBtn = rightBtn
    end

    self:refreshUIInfo()

end
function GrabMineInfoPop:doTimeAction(timeList)
    if not timeList or not self._timeLab then
        return
    end
    for i = 1, #timeList do
        local v = timeList[i]
        if v.lastTime and v.grade then
            if tonumber(v.grade) == self._tag then
                if not tolua.isnull(self._timeLab) then
                    local _timeTss = v.lastTime
                    if _timeTss < 0 then
                        _timeTss = 0
                    end
                    self._timeLab:setString(zc.getTimeHMS(_timeTss))
                end
                break
            end
        end
    end

end
function GrabMineInfoPop:refreshTwoButton()
    if self._isOnlyShow then
        return
    end
    local _rightText = zc.lang("defend_2")
    if self._rightState.state == 1 then
    elseif self._rightState.state == 2 then
        _rightText = zc.lang("seize_2")
    end
    local _leftText = zc.lang("cancel2")
    if self._leftState == 1 then
    elseif self._leftState == 2 then
        _leftText = zc.lang("give_up_2")
    end

    if self._rightState.canTouch then
        self._rightBtn:setEnable(true)
    else
        self._rightBtn:setEnable(false)
    end
    self._rightBtn:setString(_rightText)
    self._leftBtn:setString(_leftText)

end
function GrabMineInfoPop:refreshUIInfo()

    --先刷新数据状态
    self:refreshNowState()
    --刷新按钮状态
    self:refreshTwoButton()

    --
    for i = 1, self._maxMemberNum do
        local _inviteBtn = self._inviteBtnList[i]._btn
        local _canOccupy = self._inviteBtnList[i]._canOccupy
        _canOccupy:stopAllActions()
        local _headIcon = self._inviteBtnList[i]._headIcon
        local _userName = self._inviteBtnList[i]._userName
        local _userId = tonumber(self._data["userId"..i]) or 0

        if self._hasOccupy == 1 then --未被占领时
            _canOccupy:setTexture("res/Main/country/grabMine/tip_no_garrison.png")
            _canOccupy:setVisible(true)
            _inviteBtn:setVisible(false)
            _headIcon:setVisible(false)
            _userName:setVisible(false)

        else
            if _userId > 0 then
                _inviteBtn:setVisible(false)
                _canOccupy:setVisible(false)
                _headIcon:setVisible(true)
                _userName:setVisible(true)
                _userName:setString(self._data["userName"..i])
                local newParmas = {
                    data = {
                        mainType = zc.mainTypeSoldier,
                        type = 1,
                        id = 101,
                        level = zc.getLevelTipShow()..(self._data["level"..i] or "1"),
                    },
                    showLevel = true,
                    mainRoleIcon = self._data["iconId"..i] or 1,
                    listener = function ()
                    end
                }
                zc.updateIconByData(_headIcon,newParmas)
            else
                _canOccupy:setVisible(true)
                _headIcon:setVisible(false)
                _userName:setVisible(false)
            end

            if self._isInTheTeam then
                _canOccupy:setTexture("res/Main/country/grabMine/tip_can_invite.png")
                if _userId == 0 then
                    _inviteBtn:setVisible(true)
                end
            elseif self._isOwnCountry then
                _canOccupy:setTexture("res/Main/country/grabMine/tip_can_garrison.png")
                _inviteBtn:setVisible(false)
            else
                _canOccupy:setVisible(false)
                _inviteBtn:setVisible(false)
            end
        end
        if _canOccupy:isVisible() then
            _canOccupy:runAction(cc.RepeatForever:create(cc.Sequence:create(
                cc.FadeOut:create(1),
                cc.FadeIn:create(0.8)
            )))
        end
    end

    --未占领
    if self._hasOccupy == 1 then
        self._ownerName:setString(zc.lang("un_seize"))
    else --被占领
        self._ownerName:setString(self._data.countryName)
    end

end
function GrabMineInfoPop:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end
function GrabMineInfoPop:onEnter( ... ) --走这里：1是第一次、2是从战斗页面回来重新pushScene的时候
    if self._notInit then
        performWithDelay(self, function()
            if self._isInTheTeam then
                if self._teamIsFull then
                    self:hide()
                end
            else
                self:hide()
            end
            --有额外的奖励
            if PlayerData._robExtraResData and PlayerData._robExtraResData.clientItems then
                zc.createSourcePop("GrabMineExtraResPop", "src/layer/country/grabMine/GrabMineExtraResPop.lua", {})
            end
        end, 0.1)
    end
    self._notInit = true
end

return GrabMineInfoPop