--[[
	FileName: GrabMineMapFirstLayer.lua
	Author: andong
	Date: 2016-12-06
	Purpose: 国家抢矿主界面
]]
local GrabMineMapFirstLayer = class( "GrabMineMapFirstLayer", function ()
    return zc.createNormalDialog({
    	showFlower = false,
    })
end)
function GrabMineMapFirstLayer:create(parmas)
	return GrabMineMapFirstLayer.new(parmas)
end
function GrabMineMapFirstLayer:ctor(parmas)
	-- dump(parmas, "parmas=====")
	self:initData(parmas)
	self:initUI()
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_GRABMINE_REFRESHUI,
        callback = function()
        	self:refreshAllUI()
        end
    })
end
--刷新所有矿界面信息
function GrabMineMapFirstLayer:refreshAllUI()
	--刷新二级地图页面
	local GrabMineMapSecondLayer = zc.getScene("GrabMineMapSecondLayer")
	if GrabMineMapSecondLayer then
		GrabMineMapSecondLayer:refreshUIState()
	end
	--刷新信息页面
	local GrabMineInfoPop = zc.getPop("GrabMineInfoPop")
	if GrabMineInfoPop then
		GrabMineInfoPop:refreshUIInfo()
	end
	--刷新一级页面
	self:refreshMapUI()
end

function GrabMineMapFirstLayer:initData(parmas)
	local parmas = parmas or {}
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end

    local _mineInfo = PlayerData:getCountryMineData() or {}
    self._mineInfo = _mineInfo

    self._nowFightState = false

    self:initRewardTime()
end
--初始化奖励时间
function GrabMineMapFirstLayer:initRewardTime( )
   	local _tss = PlayerData:getTssTime()
    print("-----------log--------ad-------------tss ", _tss, os.date("%m月%d日%H时%M分",_tss ), os.date("%H:%M",_tss ))
    local nowYear = os.date("%Y",_tss ) --服务器现在的时间(小时)
    local nowMonth = os.date("%m",_tss ) --服务器现在的时间(小时)
    local nowDay = os.date("%d",_tss ) --服务器现在的时间(小时)
    local nowHour = os.date("%H",_tss ) --服务器现在的时间(小时)
    local nowMinute = os.date("%M",_tss ) --服务器现在的时间(分钟)

    self._todayTime = {
    	nowYear = nowYear,
    	nowMonth = nowMonth,
    	nowDay = nowDay,
    	nowHour = nowHour,
    	nowMinute = nowMinute,
	}

    --设置奖励时间
    local allMineStaticData = gameData.getDataFromCache("mine")
    local rewardTimeList =  {}
    local gradeRecord = {}
    for k,v in pairs(allMineStaticData) do
    	if v and v.timeType then
    		local timeType = tonumber(v.timeType) --奖励结算时间类型(1每天开始占矿后，每隔几个小时结算一次、2固定时间结算奖励)
    		local grade = tonumber(v.grade)

    		if not gradeRecord[grade] then
    			local _index = #rewardTimeList + 1
    			rewardTimeList[_index] = {}
    			rewardTimeList[_index].timeType = timeType
    			rewardTimeList[_index].openTime = v.openTime
    			rewardTimeList[_index].interval = v.time
    			rewardTimeList[_index].time = v.time
    			rewardTimeList[_index].name = v.name
    			rewardTimeList[_index].grade = v.grade --品级
    			rewardTimeList[_index].nowTimeTss = table.copy(_tss)

				local beganTime =  string.split(v.openTime, ":")
				local beganHour = tonumber(beganTime[1]) or 9
				local beganMinute = tonumber(beganTime[2]) or 30
	    		--开始时间
			    local beganTab = {year=nowYear, month=nowMonth, day=nowDay, hour=beganHour,min=beganMinute,sec=0,isdst=false}
			    local beganTss = os.time(beganTab)
    			rewardTimeList[_index].beganTss = beganTss

			    --结束时间
			    v.endTime = v.endTime or "21:30"
				local endTime =  string.split(v.endTime, ":")
				local endHour = tonumber(endTime[1]) or 21
				local endMinute = tonumber(endTime[2]) or 30
		    	local endTab = {year=nowYear, month=nowMonth, day=nowDay, hour=endHour,min=endMinute,sec=0,isdst=false}
			    local endTss = os.time(endTab)
    			rewardTimeList[_index].endTss = endTss

    			gradeRecord[grade] = true

    		end
    	end
    end

    table.sort(rewardTimeList,function(a,b)
    	return tonumber(a.grade) < tonumber(b.grade)
    end)

    self._allTimeList = rewardTimeList

    --刷新时间点
    self:refreshTimes()
    --定时器
    self:selfTimeSchedule()
end
function GrabMineMapFirstLayer:refreshTimes()
	self._settlementGrade = {} --当前结算奖励的品级
    --计算时间点
    local _allMinLastTime = 0
    self._startTss = 0 --未开启倒计时
    for i = 1, #self._allTimeList do
    	local v = self._allTimeList[i]
    	if v and v.openTime then
    		local timeType = tonumber(v.timeType) or 1
    		v.lastTime = 0
		    local _beganTss = v.beganTss or 0
		    local _endTss = v.endTss or 0

		    if v.nowTimeTss > _endTss then --结束
		    elseif v.nowTimeTss < _beganTss then --还未开启
		    	self._startTss = _beganTss - v.nowTimeTss
			else
	    		if timeType == 1 then
				    for j = 1, 10 do
				    	_beganTss = _beganTss + (tonumber(v.interval) or 1) * 60*60
				    	if _beganTss > v.nowTimeTss then
				    		v.lastTime = _beganTss - v.nowTimeTss
				    		break
				    	end
				    end
				elseif timeType == 2 then
					local _timeList = string.split(v.time, "|")
					for j = 1, #_timeList do
						local _getTime = string.split(_timeList[j], ":")
						local _getHourTime = tonumber(_getTime[1]) or 0
						local _getMinuteTime = tonumber(_getTime[2]) or 0
					    local getTab = {year=self._todayTime.nowYear, month=self._todayTime.nowMonth, day=self._todayTime.nowDay, hour=_getHourTime,min=_getMinuteTime,sec=0,isdst=false}
			    		local getTss = os.time(getTab) --返回两个时间之间的秒
				    	if getTss > v.nowTimeTss then
				    		v.lastTime = getTss - v.nowTimeTss
				    		break
				    	end
					end
				end
			end

			--test
			-- v.lastTime = 10 + (i-1)*60

			if _allMinLastTime == 0 then
				_allMinLastTime = v.lastTime
				self._settlementGrade[v.grade] = true
			else
				if v.lastTime < _allMinLastTime then
					_allMinLastTime = v.lastTime
					self._settlementGrade = {}
					self._settlementGrade[v.grade] = true
				elseif v.lastTime == _allMinLastTime then
					self._settlementGrade[v.grade] = true
				end
			end
    	end
    end

    -- dump(self._allTimeList, "self._allTimeList-----------dump--------ad-------------" )
    -- dump(self._settlementGrade, "self._settlementGrade-----------dump--------ad-------------" )
end
function GrabMineMapFirstLayer:selfTimeSchedule()
	local timeActionPoint = {[20]=1,[21]=1,[22]=1} --做spine动画的时间点
    local _minimumTime = 9999999999 --记录最小时间
    local _ishowReward = false
    local _selfOccupyId = 0
	self._timeScheduler = scheduler.scheduleGlobal(function()
		local _noReward = true --全部倒计时结束
		-- dump(self._allTimeList, "self._allTimeList-----------dump--------ad-------------" )
		-- print("-----------log--------ad-------------self._startTss ", self._startTss)
		if self._startTss > 0 then --还未开启
			_noReward = false
			self._startTss = self._startTss - 1
			if self._startTss == 0 then
				self:refreshTimes()
			end
		end
		for i = 1, #self._allTimeList do

			local v = self._allTimeList[i]
			v.nowTimeTss = v.nowTimeTss + 1

			if v and v.lastTime and v.lastTime > 0 then
				v.lastTime = v.lastTime - 1
				_noReward = false
				if v.lastTime < _minimumTime then
					_minimumTime = v.lastTime
				end
			end

		end
		--刷新倒计时
		local GrabMineMapSecondLayer = zc.getScene("GrabMineMapSecondLayer")
		if GrabMineMapSecondLayer then
			GrabMineMapSecondLayer:timeAction(self._allTimeList)
		end
		local GrabMineInfoPop = zc.getPop("GrabMineInfoPop")
		if GrabMineInfoPop then
			GrabMineInfoPop:doTimeAction(self._allTimeList)
		end
		local grabShowInfoPop = zc.getPop("grabShowInfoPop")
		if grabShowInfoPop then
			grabShowInfoPop:doTimeAction(self._allTimeList)
		end
		self:timeAction(self._allTimeList)
		if not self._nowFightState then
			--如果正在动画时间点内
	        if timeActionPoint[_minimumTime] then
	            if not self._timeShowLay then
	                self:createShowLay()
	                local _showLay = self._timeShowLay
	                _showLay:setOpacity(150)
	                if not self._daojishiSpine then
	                    local _daojishiSpine = zc.createSpine({
	                        fileName = "boss_laixi",
	                        actName = "dixi_open",
	                        loop = false,
	                        removeCallback = function() end
	                    })
	                    _daojishiSpine:setPosition(zc.width/2,zc.height/2)
	                    _daojishiSpine:setScale(1.5)
	                    _showLay:addChild(_daojishiSpine, 2)
	                    self._daojishiSpine = _daojishiSpine

	                    _daojishiSpine:registerSpineEventHandler( function ( event )
	                        if event.animation == "dixi_open" then
	                            _daojishiSpine:playAction("dixi_idle", true)
	                            _showLay:setOpacity(0)
	                            _daojishiSpine:runAction(cc.Sequence:create(
	                                cc.Spawn:create(
	                                    cc.ScaleTo:create(0.5, 0.73),
	                                    cc.MoveTo:create(0.5, cc.p(zc.width/2, zc.height-48))),
	                                cc.DelayTime:create(0.5),
	                                cc.CallFunc:create(function() 
	                                    self:beganCount(_minimumTime)
	                                end),
	                                -- cc.FadeOut:create(0.1),
	                                -- cc.DelayTime:create(0.1),
	                                cc.RemoveSelf:create(true)
	                            ))
	                        end
	                    end, sp.EventType.ANIMATION_COMPLETE)
	                end
	            else
		        	-- if tolua.isnull(self._fntTime) then
		        	-- 	self:beganCount(_minimumTime)
		        	-- end
	                if not tolua.isnull(self._fntTime) then
	                    self._fntTime:setString(_minimumTime)
	                end
	            end
	        elseif _minimumTime < 20 and _minimumTime > 0 then
	        	if tolua.isnull(self._fntTime) then
	        		self:beganCount(_minimumTime)
	        	end
	            if not tolua.isnull(self._fntTime) then
	                self._fntTime:setString(_minimumTime)
	            end
	        end
	    end

	    if _minimumTime == 1 then --(这里，放这个点是处理，奖励结算的误差)
    		local selfOccupyData = PlayerData:getSelfOccupyedMine() or {}
			_selfOccupyId = selfOccupyData[1] or 0
	    end
	    --处理
	    if _minimumTime == 0 then
            if not tolua.isnull(self._fntTime) then
                self._fntTime:setString(_minimumTime)
            end
            if not _ishowReward then
            	local _getReardGradList = table.copy(self._settlementGrade)
            	self:refreshTimes()
	        	_ishowReward = true
	        	--
	            local nowLayer = zc.getScene("GrabMineMapSecondLayer")
	            if not nowLayer then
	            	nowLayer = self
	            end
	        	nowLayer:getJingBiAction(_getReardGradList)
    			local _runningScene = cc.Director:getInstance():getRunningScene()

    			--奖励结算（倒计时前后端有一点点误差，在结算的时候，后端先把矿给清理了，自己占领的就没了，就弹不了奖励框）
		        performWithDelay(_runningScene, function()
		        	if tolua.isnull(self) then
		        		return
		        	end
		            self:deleteShowLay()
		            --重置状态
		            _minimumTime = 9999999999
		            self._daojishiSpine = nil
		            _ishowReward = false
		            --弹出结算奖励

		            local nowLayer = zc.getScene("GrabMineMapSecondLayer")
		            if not nowLayer then
		            	nowLayer = self
		            end
		            if not nowLayer:getChildByName("nowRewardPop") then
						if _selfOccupyId > 0 then
							
							local reward = self:getSelfOccupyReward(_getReardGradList, _selfOccupyId)
							if next(reward) then
		 		            	-- nowLayer:getChildByName("nowRewardPop"):removeFromParent()
				            	local scaleSize = cc.size(200, 200)
				            	local contentNode = zc.createSprite()
				            	contentNode:setContentSize( scaleSize )

							    -- 提示
							    local _tipBg = cc.Sprite:create( "res/Main/country/countryDart/resultBg.png" )
							    _tipBg:setPosition( scaleSize.width/2, scaleSize.height - 25 )
								contentNode:addChild( _tipBg )
								local _tipSp = cc.Sprite:create( "res/Main/wushenTower/item.png" )
								_tipSp:setPosition( 50, _tipBg:getContentSize().height/2 )
								_tipBg:addChild( _tipSp )
				            	local tipLaba = zc.createLabel({
				            	    text = zc.lang("congratulations_to_get_reward") .. "：",
				            	    fontSize = 20,
				            	    ap = cc.p(0, 0.5),
				            	    pos = cc.p(80, _tipBg:getContentSize().height/2),
				            	    color = cc.c3b(255,220,106),
				            	})
				            	_tipBg:addChild(tipLaba)
				            	
				            	local _pos = zc.sortFromMiddle( cc.p(scaleSize.width/2, scaleSize.height/2-40), #reward, 140 )
				            	for i = 1, #reward do
		            				local item = zc.createIconByData({
								        data = {
								            mainType = reward[i]["itemType"],
								            type = reward[i]["itemId"],
								            id = reward[i]["itemId"],
								            num = reward[i]["num"],
								        }, 
								        showCount = true,
								        showDetailPop = true,
								        pos = cc.p(scaleSize.width/2, scaleSize.height/2-40),
								        pos = _pos[i],
								    })
								    item:setScale(0.8)
								    contentNode:addChild(item)
				            	end

					            local comfirm = ZCConfirmDialog:createWithParams({
					                title = zc.lang("prompt"),
					                msg = "",
					                contentNode = contentNode,
					                showDi = false,
					                leftVisible = false,
					            })
					            comfirm:setName("nowRewardPop")
					            nowLayer:addChild(comfirm, 11)
					            comfirm.containerBg:setTexture("res/Main/tollgateHero/tollgateBg_2.png")
					        end
					        --恢复状态
					        _selfOccupyId = 0 
				        end
		            end

		        end, 1)
			end
	    end
		if _noReward then
			self:stopMyTimer()
		end
	end,1)
end

--弹银币动画
function GrabMineMapFirstLayer:getJingBiAction(_gradeList)
	local _gradeList = _gradeList or {}
	for k, v in pairs(self._allButtonList) do
		for m, n in pairs(v) do
			if n and n._btn and n._typeInfo then
				local _btn = n._btn
				local _typeInfo = n._typeInfo
				--结算类型
				if _typeInfo.tag and _gradeList[_typeInfo.tag] then
				    local jingbi = zc.createSpine({
				        fileName = "jingbi",
				        actName = "animation",
				        loop = false,
				        needInit = false,
				        removeCallback = function() end,
				        autoRemove = true,
				    })
				    jingbi:setScale(self._iconScale*0.7)
				    local jingbiPos
				    if n.jingbiPos then
				    	jingbiPos = n.jingbiPos
				    else
        				jingbiPos = _btn:convertToWorldSpace(cc.p(_btn:getContentSize().width/2,_btn:getContentSize().height/2))
        				n.jingbiPos = jingbiPos
        			end
				    jingbi:setPosition(jingbiPos)
				    self:addChild(jingbi, 3)
				end
			end
		end
	end
end

function GrabMineMapFirstLayer:createShowLay()
    local _runningScene = cc.Director:getInstance():getRunningScene()
    if _runningScene:getChildByName("_timeShowLay") then
    	_runningScene:getChildByName("_timeShowLay"):removeFromParent()
    end
    local _showLay = cc.LayerColor:create(cc.c4b(0, 0, 0, 200), zc.width, zc.height)
    _runningScene:addChild(_showLay, 1)
    _showLay:setName("_timeShowLay") 
    self._timeShowLay = _showLay
end
function GrabMineMapFirstLayer:deleteShowLay()
    if not tolua.isnull(self._timeShowLay) then
        self._timeShowLay:removeFromParent()
        self._timeShowLay = nil
    end
end
--如果是进入战斗页面，则不显示倒计时
function GrabMineMapFirstLayer:setNowFightState(_state)
	self._nowFightState = _state
end
function GrabMineMapFirstLayer:beganCount(_minimumTime)
	local _showLay = self._timeShowLay
	if tolua.isnull(_showLay) then
		self:createShowLay()
	end
	_showLay = self._timeShowLay
    _showLay:setOpacity(0)
    local redScreen = zc.getScaleNode("res/Main/country/grabMine/redScreen.png", cc.size(zc.width, zc.height))
    redScreen:setAnchorPoint( 0.5, 0.5 )
    redScreen:setPosition(zc.width/2, zc.height/2)
    _showLay:addChild(redScreen)
    redScreen:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.FadeIn:create(0.5),
        cc.FadeOut:create(0.8)
    )))
    local daojishiBg = zc.createSprite("res/Main/country/grabMine/daojishiBg.png")
    daojishiBg:setAnchorPoint(0.5, 0.5)
    daojishiBg:setPosition(zc.width/2+30, zc.height -60)
    _showLay:addChild(daojishiBg)
    -- daojishiBg:setScale(1.5)
    local _chapterNum = zc.createFntLabel({
        fnt = "res/Main/chapterMain/chapterBigNum.fnt",
        text = _minimumTime,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(daojishiBg:getContentSize().width*0.5-20,daojishiBg:getContentSize().height/2+15),
        addwidth = -10,
    })
    daojishiBg:addChild(_chapterNum, 1)
    self._fntTime = _chapterNum
end
function GrabMineMapFirstLayer:stopMyTimer()
	if self._timeScheduler then
		scheduler.unscheduleGlobal( self._timeScheduler )
	end
	self._timeScheduler = nil
end
function GrabMineMapFirstLayer:getTimeList()
	return self._allTimeList
end
function GrabMineMapFirstLayer:getSelfOccupyReward(_gradeList, _id)
    local rewardList = {}
    local _levyHouseInfo = PlayerData:getHouseInfoByHouseId(16)
    local _levyProfit = gameData.getDataFromCacheWithPrimaryKey("houseEffect_leyv", _levyHouseInfo["level"]) --等级与收益
    local _staticMineData = gameData.getDataFromCacheWithPrimaryKey("mine", _id) or {}
    local _occupuGrad = tonumber(_staticMineData["grade"]) or 0
    if not _gradeList[_occupuGrad] then
    	return rewardList
    end
    for i = 1, 3 do
        if _staticMineData["resourceOutput"..i] and _staticMineData["resourceOutput"..i] ~= "" then
            local rewardT = string.split(_staticMineData["resourceOutput"..i], "|")
            if rewardT[1] and rewardT[2] and rewardT[3] then
                local _num = rewardT[3]
                local _index = #rewardList + 1
                rewardList[_index] = {}
                rewardList[_index].itemType = rewardT[1]
                rewardList[_index].itemId = rewardT[2]
                rewardList[_index].num = zc.getWan( _num )
                rewardList[_index]._getType = i --奖励类型（1个人，2...，3国家）
            end
        end
    end


    if PlayerData._occupyExtraResData and PlayerData._occupyExtraResData.have then
    	local nowTime = os.time()
    	local getTime = PlayerData._occupyExtraResData.time
    	if nowTime - getTime < 600 then --十分钟内
		    local extraReward = string.split(tostring(_staticMineData["seizeReward"]), "|")
		    if extraReward and extraReward[1] and extraReward[2] then
		        local _index = #rewardList + 1
		        rewardList[_index] = {}
		        rewardList[_index].itemType = extraReward[1]
		        rewardList[_index].itemId = extraReward[2]
		        rewardList[_index].num = zc.getWan( extraReward[3] ) 
		        rewardList[_index]._getType = 2 --奖励类型（1个人，2...，3国家）
		    end
		end
	    --重置数据
	    PlayerData:setOccupyExtraResData()
    end
    return rewardList
end

function GrabMineMapFirstLayer:initUI(params)
	local mine_bg_all = zc.createSprite("res/Main/country/grabMine/mine_bg_all.jpg")
	mine_bg_all:setAnchorPoint(0.5, 0.5)
	mine_bg_all:setPosition(zc.width/2, zc.height/2)
	self:addChild(mine_bg_all)

	self:initCommonUIINfo()

	self:initBuildingAndLines()

	--刷新
	self:refreshMapUI()
end
function GrabMineMapFirstLayer:refreshMapUI()
	self:refreshBuildingButton()
	self:refreshLines()
end
function GrabMineMapFirstLayer:initCommonUIINfo()

    local commonIconBg = zc.createSprite()
    commonIconBg:setContentSize(zc.width,zc.height)
    commonIconBg:setPosition(zc.width/2,zc.height/2)
    self:addChild(commonIconBg, 4)

	local title = zc.createSprite("res/Main/country/grabMine/title.png")
	title:setAnchorPoint(0, 1)
	title:setPosition(0, zc.height)
	self:addChild(title, 10)

    --添加云动画
    zc.getYunDongTai(nil,2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp )
            self:addChild( armDown )
            armUp:setPositionY(zc.height-40)
            armDown:setPositionY(40)
        end
    end)

    self._bottomButtonLay = requires("src/layer/mainCity/MainBottomBtnsLayer.lua"):create({
        isBack = true,
        -- needToDefault = true,
        showList = {jiaose="1",beibao="1",guojia="1",bingqi="1",buzhen="1"},
    })
    self:addChild(self._bottomButtonLay, 4)

    -- 聊天
    self._chatLayer = requires("src/layer/chat/ChatLeadTipsPop.lua").create()
    self._chatLayer:setPosition( 0, 0 )
    commonIconBg:addChild( self._chatLayer )

    local countTimeBg = zc.createPushButton({
        normalFile = "res/Main/country/grabMine/getBg.png",
        needSwallow = true,
        noScaleAction = true,
    })
    countTimeBg:setAnchorPoint(0, 0.5)
    countTimeBg:setPosition(0, zc.height/2+40)
    commonIconBg:addChild(countTimeBg, 4)
    self._countTimeBg = countTimeBg
    self._countTimeBgIsOpen = true

    local timeList = self:getTimeList()
    for i = 1, #timeList do
        local v = timeList[i]
        local mienNameLab = zc.createLabel({
            text = v.name,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(42, countTimeBg:getContentSize().height - 33 - (i-1)*75),
            color = zc.getColorByQuality( i+1 ),
        })
        countTimeBg:addChild(mienNameLab)
        local timeLab = zc.createLabel({
            text = zc.getTimeHMS(v.lastTime),
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(42, countTimeBg:getContentSize().height- 60 - (i-1)*75),
            color = zc.getColorByQuality( i+1 ),
        })
        countTimeBg:addChild(timeLab)
        countTimeBg["timeLab"..i] = timeLab
    end

    local function moveCountTimeBg()
        self:openAttribute()
        if self._arrowBtn then
            local _normal = self._arrowBtn._arrowImg
            if self._countTimeBgIsOpen then
                _normal:setRotation( 0 )
            else
                _normal:setRotation( 180 )
            end
        end
    end

    local scaleSize = cc.size(60, 200)
    local myScale9 = zc.createSprite()
    myScale9:setContentSize( scaleSize )
    local arrowImg = zc.createSprite("res/Main/country/grabMine/getArrow.png")
    arrowImg:setPosition(scaleSize.width/2, scaleSize.height-30)
    myScale9:addChild(arrowImg)
    local arrowBtn = zc.createPushButton({
        normalNode = myScale9,
        pos = cc.p(173, 182),
        endCallback = function()
            moveCountTimeBg()
        end
    })
    countTimeBg:addChild(arrowBtn)
    arrowBtn._arrowImg = arrowImg
    self._arrowBtn = arrowBtn

    --test
    -- moveCountTimeBg()
    arrowImg:setRotation( 180 )
    self._countTimeBg:setPositionX( self._countTimeBg:getPositionX() - 150 )
    self._countTimeBgIsOpen = false

    --开启时间
    local _tipBg = cc.Sprite:create( "res/Main/country/countryDart/timeBg.png" )
    _tipBg:setAnchorPoint( 0, 0.5 )
    _tipBg:setPosition( 350, zc.height - 50 )
    commonIconBg:addChild( _tipBg, 1 )
    local _tipSp = cc.Sprite:create( "res/Main/wushenTower/item.png" )
    _tipSp:setPosition( 50, 18 )
    _tipBg:addChild( _tipSp )
    local openTimeStr = "9:30-21:30"
    local _tipLabel = zc.createRichLabel({
        text = "[color=ffe6e0a3]每日功能开启时间：[/color][color=ffff3644]"..openTimeStr.."[/color]",
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 70, 18 ),
    })
    _tipBg:addChild( _tipLabel )
    _tipLabel:setAnchorPoint( 0, 0.5 )

end
function GrabMineMapFirstLayer:timeAction( timeList )
    if not timeList then
        return
    end
    for i = 1, #timeList do
        local v = timeList[i]
        if v.lastTime then
            local timeLab = self._countTimeBg["timeLab"..i]
            if not tolua.isnull(timeLab) then
                local _timeTss = v.lastTime
                if _timeTss < 0 then
                    _timeTss = 0
                end
                timeLab:setString(zc.getTimeHMS(_timeTss))
            end
        end
    end
end
--打开属性加成显示
function GrabMineMapFirstLayer:openAttribute()
    if self._attributeIsMoving then
        return
    end
    self._attributeIsMoving = true
    local direction = 1
    if self._countTimeBgIsOpen then
        self._countTimeBgIsOpen = false
        direction = -1
    else
        self._countTimeBgIsOpen = true
    end
    local _arr = {}
    local _per = 150/19
    for i = 1, 19 do
        _arr[#_arr+1] = cc.MoveBy:create(0.01, cc.p(direction*_per, 0))
    end
    _arr[#_arr+1] = cc.CallFunc:create(function() self._attributeIsMoving = false end)
    self._countTimeBg:runAction(cc.Sequence:create(_arr))
end

function GrabMineMapFirstLayer:updateChatPanelView(chanel)
    if self._chatLayer then
        self._chatLayer:updateTableView()
    end
end

function GrabMineMapFirstLayer:initBuildingAndLines()
	--线层
	local lineLayer = zc.createSprite()
	lineLayer:setAnchorPoint(0.5, 0.5)
	lineLayer:setContentSize(1136, 640)
	lineLayer:setPosition(zc.width/2, zc.height/2)
	self:addChild(lineLayer)
	self._lineLayer = lineLayer

	self:initLines()

	--建筑层
	local buildingLayer = zc.createSprite()
	buildingLayer:setAnchorPoint(0.5, 0.5)
	buildingLayer:setContentSize(1136, 640)
	buildingLayer:setPosition(zc.width/2, zc.height/2)
	self:addChild(buildingLayer)
	self._buildingLayer = buildingLayer

	self:initBuilding()
end

function GrabMineMapFirstLayer:initLines()

	self._iconScale = 0.5

	local lineBg = self._lineLayer
	local lineNums = 20

	local linePos = {
		["gebi"] = {
			{pos=cc.p(406, 351),actId=4},
			{pos=cc.p(473, 378),actId=5},
		},
		["xueshan"] = {
			{pos=cc.p(535, 364),actId=4},
			{pos=cc.p(583, 347),actId=5},
		},
		["huoshan"] = {
			{pos=cc.p(441, 288),actId=4},
			{pos=cc.p(491, 285),actId=5},
		},
		["zhaoze"] = {
			{pos=cc.p(553, 279),actId=4},
			{pos=cc.p(605, 283),actId=5},
		},
	}

	--from占领的地方，to可以去占领的地方
	local _conditionList = {
		["1_gebi_"] = {from=6,to={[33]=33}},
		["2_gebi_"] = {from=7,to={[33]=33,[34]=34}},
		["3_gebi_"] = {from=8,to={[34]=34}},
		["4_gebi_"] = {from=33,to={[41]=41}},
		["5_gebi_"] = {from=34,to={[41]=41}},
		["1_xueshan_"] = {from=14,to={[35]=35}},
		["2_xueshan_"] = {from=15,to={[35]=35,[36]=36}},
		["3_xueshan_"] = {from=16,to={[36]=36}},
		["4_xueshan_"] = {from=35,to={[41]=41}},
		["5_xueshan_"] = {from=36,to={[41]=41}},
		["1_huoshan_"] = {from=22,to={[37]=37}},
		["2_huoshan_"] = {from=23,to={[37]=37,[38]=38}},
		["3_huoshan_"] = {from=24,to={[38]=38}},
		["4_huoshan_"] = {from=37,to={[41]=41}},
		["5_huoshan_"] = {from=38,to={[41]=41}},
		["1_zhaoze_"] = {from=30,to={[39]=39}},
		["2_zhaoze_"] = {from=31,to={[39]=39,[40]=40}},
		["3_zhaoze_"] = {from=32,to={[40]=40}},
		["4_zhaoze_"] = {from=39,to={[41]=41}},
		["5_zhaoze_"] = {from=40,to={[41]=41}},
	}


	self._areaSpineName = {
		"gebi",
		"xueshan",
		"huoshan",
		"zhaoze",
	}

	--路线动画
	self._lineSpineList = {}

    for i = 1, #self._areaSpineName do
    	local _area = self._areaSpineName[i]
    	local _linePos = linePos[_area]
    	-- for j = 1, 5 do
    	for j = 1, #_linePos do
    		local _lineInfo = _linePos[j]
    		local _actName = _lineInfo.actId.."_".._area.."_"
		    local _lineSpine = zc.createSpine({
		        fileName = "kuangqu",
		        actName = _actName.."stop",
		        loop = true,
		        removeCallback = function() end
		    })
		    _lineSpine:setPosition(_lineInfo.pos)
		    lineBg:addChild(_lineSpine)
		    _lineSpine:setScale(self._iconScale)

		    local _index = #self._lineSpineList + 1
		    self._lineSpineList[_index] = {}
		    self._lineSpineList[_index]._spine = _lineSpine
		    self._lineSpineList[_index]._actNamePrefix = _actName
		    self._lineSpineList[_index]._oldState = "stop"
		    self._lineSpineList[_index]._condition = _conditionList[_actName]
		end
    end

end

--获取区域坐标
function GrabMineMapFirstLayer:gerAreaBuildingPos(_area)
	local _area = tonumber(_area) or 1

    self._flagJustPos = {
        [1] = cc.p(22,7),
        [2] = cc.p(21,4),
        [3] = cc.p(28,4),
        [4] = cc.p(52,-8),
    }
    self._eff_kuangInfo = {
        [1] = {scale=1.2,justx=-4,justy=-4},
        [2] = {scale=1.3,justx=-2,justy=-8},    
        [3] = {scale=1.7,justx=-6,justy=-8},    
        [4] = {scale=2.2,justx=-2,justy=-17},   
    }
	--对应区域1、2、3、4、5(左上、右上、左下、右下、中间)
	local _areaPosList = {
		[1] = {
			{pos=cc.p(115, 399),tag=1, area=1,id=1},
			{pos=cc.p(179, 488),tag=1, area=1,id=4},
			{pos=cc.p(247, 463),tag=1, area=1,id=2},
			{pos=cc.p(286, 514),tag=1, area=1,id=5, zorder=0},
			{pos=cc.p(404, 512),tag=1, area=1,id=3, zorder=0},
			{pos=cc.p(214, 411),tag=2, area=1,id=6},
			{pos=cc.p(341, 478),tag=2, area=1,id=7},
			{pos=cc.p(464, 491),tag=2, area=1,id=8},
		},
		[2] = {
			{pos=cc.p(747, 531),tag=1, area=2,id=13},
			{pos=cc.p(801, 460),tag=1, area=2,id=9},
			{pos=cc.p(883, 469),tag=1, area=2,id=11},
			{pos=cc.p(985, 479),tag=1, area=2,id=12},
			{pos=cc.p(988, 396),tag=1, area=2,id=10},
			{pos=cc.p(636, 499),tag=2, area=2,id=14},
			{pos=cc.p(700, 455),tag=2, area=2,id=15},
			{pos=cc.p(833, 397),tag=2, area=2,id=16},
		},
		[3] = {
			{pos=cc.p( 89, 185),tag=1, area=3,id=17},
			{pos=cc.p(147, 136),tag=1, area=3,id=18},
			{pos=cc.p(183, 183),tag=1, area=3,id=19},
			{pos=cc.p(226, 118),tag=1, area=3,id=20},
			{pos=cc.p(347, 104),tag=1, area=3,id=21},
			{pos=cc.p(243, 251),tag=2, area=3,id=22},
			{pos=cc.p(324, 187),tag=2, area=3,id=23},
			{pos=cc.p(418, 146),tag=2, area=3,id=24},
		},
		[4] = {
			{pos=cc.p(631, 131),tag=1, area=4,id=25},
			{pos=cc.p(747, 147),tag=1, area=4,id=26},
			{pos=cc.p(773, 202),tag=1, area=4,id=27},
			{pos=cc.p(875, 246),tag=1, area=4,id=28},
			{pos=cc.p(915, 190),tag=1, area=4,id=29},
			{pos=cc.p(580, 175),tag=2, area=4,id=30},
			{pos=cc.p(668, 198),tag=2, area=4,id=31},
			{pos=cc.p(791, 263),tag=2, area=4,id=32},
		},
		[5] = {
			{pos=cc.p(683, 372),tag=3, area=5,id=36},
			{pos=cc.p(586, 412),tag=3, area=5,id=35},
			{pos=cc.p(336, 394),tag=3, area=5,id=33},
			{pos=cc.p(454, 415),tag=3, area=5,id=34},
			{pos=cc.p(609, 244),tag=3, area=5,id=39},
			{pos=cc.p(701, 262),tag=3, area=5,id=40},
			{pos=cc.p(391, 278),tag=3, area=5,id=37},
			{pos=cc.p(475, 256),tag=3, area=5,id=38},
		},
	}
	return _areaPosList[_area]
end
--初始化建筑
function GrabMineMapFirstLayer:initBuilding()
	local areaNums = 5 -- 区域数量
	self._allButtonList = {}
	--普通建筑
	for i = 1, areaNums do
		local _areaTypeInfo = self:gerAreaBuildingPos(i)
		for j = 1, #_areaTypeInfo do
			local typeInfo = _areaTypeInfo[j]
			self:createBuildButton(typeInfo)
		end
	end
	--中心建筑
	local centerTypeInfo = {pos=cc.p(527, 340),area=5,tag=4,id=41}
	self:createBuildButton(centerTypeInfo)

end
function GrabMineMapFirstLayer:createBuildButton(typeInfo)
	local buildingBg = self._buildingLayer

	local _path = "res/Main/country/grabMine/building_"..typeInfo.tag..".png"
	typeInfo.path = _path
	local building = zc.createSprite(_path)
	building:setScale(self._iconScale)

	local myLab = zc.createLabel({
	    text = typeInfo.id ,
	    outLine = true,
	    fontSize = 40,
	    pos = cc.p(building:getContentSize().width/2, building:getContentSize().height/2),
	    color = display.COLOR_RED,
	})
	-- building:addChild(myLab)

	typeInfo.zorder = typeInfo.zorder and typeInfo.zorder or 1
    local buildingButton = self:getBuildingButton(building, typeInfo)
	buildingBg:addChild(buildingButton, typeInfo.zorder )


	--按区域记录按钮
	local _area = tonumber(typeInfo.area) or 1
	local _btnId = tonumber(typeInfo.id) or 1
	if not self._allButtonList[_area] then
		self._allButtonList[_area] = {}
	end
	self._allButtonList[_area][_btnId] = {}
	self._allButtonList[_area][_btnId]._btn = buildingButton
	self._allButtonList[_area][_btnId]._typeInfo = typeInfo
end
function GrabMineMapFirstLayer:getBuildingButton(_node, _info)

	local test = false

	if not test then
		local buildingButton = zc.createPushButton({
		    normalNode = _node,
		    pos = _info.pos,
		    needSwallow = true,
		    endCallback = function()
				local _area = tonumber(_info.area) or 1
				zc.createSourceScene("GrabMineMapSecondLayer", "src/layer/country/grabMine/GrabMineMapSecondLayer.lua", {area=_area})
		    end
		})

	    local _flag = zc.createSprite("res/Main/country/grabMine/occupyFlag_red.png")
	    _flag:setAnchorPoint(0.5, 0.5)
	    _flag:setPosition(_info.pos.x + self._flagJustPos[_info.tag].x, _info.pos.y + self._flagJustPos[_info.tag].y)
	    -- _node:addChild(_flag)
	    _flag:setScale(self._iconScale)
	    self._buildingLayer:addChild(_flag, _info.zorder + 1)
	    buildingButton._flag = _flag

	    local _flagName = zc.createLabel({
	        text = "",
	        outLine = true,
	        fontSize = 28,
	        ap = cc.p(0, 0.5),
	        pos = cc.p(_flag:getContentSize().width/2-15, _flag:getContentSize().height - 40),
	        color = display.COLOR_WHITE,
	        color2 = display.COLOR_BLACK,
	        align = kCCTextAlignmentCenter,
	        pixel = 1.3
	    })
	    _flag:addChild(_flagName)
	    buildingButton._flagName = _flagName
  
		return buildingButton

	else
		if not self._buildingList then
			self._buildingList = {}
		end
		if not self._buildingList[_info.area] then
			self._buildingList[_info.area] = {}
		end
		-- --test
		local buildingBtn = ccui.ImageView:create(_info.path)
		buildingBtn:setAnchorPoint(cc.p(0.5, 0.5))
		buildingBtn:setPosition(_info.pos)
		self._buildingList[_info.area][#self._buildingList[_info.area]+1] = buildingBtn
		buildingBtn:setScale(self._iconScale)
	    buildingBtn:setTouchEnabled(true)
	    buildingBtn:addTouchEventListener(function ( sender, eventType )
	        if eventType == ccui.TouchEventType.began then
	            self._partPoint = sender:getTouchBeganPosition()
	            buildingBtn:setLocalZOrder(4)
	            return true
	        elseif eventType == ccui.TouchEventType.moved then 
	            local _movePoint = sender:getTouchMovePosition()
	            local _pos = cc.pSub(_movePoint, self._partPoint)
	            _pos = cc.pAdd(_pos, cc.p(buildingBtn:getPosition()))
	            self._partPoint = _movePoint
	            buildingBtn:setPosition(_pos.x, _pos.y)
	        else
	        	local pos = sender:getTouchEndPosition()
	    		-- print("sender end pos -----------log--------ad-------------".."cc.p("..pos.x..", "..pos.y..")")
	        	for m = 1, #self._buildingList[_info.area] do
	        		local _b = self._buildingList[_info.area][m]
	        		local pos = cc.p( math.floor(_b:getPositionX()), math.floor(_b:getPositionY()) )
	        		-- print("all end pos -----------log--------ad-------------  "..m.."  cc.p("..pos.x..", "..pos.y..")")
	        	end
	        end
	    end)
		local myLab = zc.createLabel({
		    text = _info.id,
		    stroke = true,
		    fontSize = 18,
		    pos = cc.p(buildingBtn:getContentSize().width/2, buildingBtn:getContentSize().height/2),
		})
		buildingBtn:addChild(myLab)

		return buildingBtn
	end
end

--判断是否有人占领
function GrabMineMapFirstLayer:isOccupy(_data)
    if not _data then
        return false
    end
    for i = 1, 3 do
        if _data["userId"..i] and tonumber(_data["userId"..i]) and tonumber(_data["userId"..i]) > 0 then
            return true
        end
    end
    return false
end

--刷新建筑
function GrabMineMapFirstLayer:refreshBuildingButton()
	local selfCountryOccupy = PlayerData:getSelfCountryOccupy()
	local selfOccupyData = PlayerData:getSelfOccupyedMine() or {}
	local selfOccupyId = selfOccupyData[1] or 0
	for i = 1, #self._mineInfo do
		local _areaData = self._mineInfo[i] or {}  --区域数据
		local _mineList = _areaData.mineList or {} --区域矿
		local _areaButtonList = self._allButtonList[i] or {} --区域建筑
		for j = 1, #_mineList do
			local _mineInfo = _mineList[j]
			local _buildingInfo = _areaButtonList[tonumber(_mineInfo.countryMineId)]
			if _buildingInfo and _buildingInfo._btn and _buildingInfo._typeInfo then
				local isOccupy = self:isOccupy(_mineInfo)
				local _buildingBtn = _buildingInfo._btn
				local _typeInfo = _buildingInfo._typeInfo
				local _normal = _buildingBtn:getStateNormal()
				_buildingBtn:stopAllActions()
				--如果被占领
				if isOccupy then
					_buildingBtn._flag:setVisible(true)
					local strName = _mineInfo.countryName
					strName = string.sub(strName,1,3)
					_buildingBtn._flagName:setString(strName)
                	local _flagNameWidth =  _buildingBtn._flagName:getContentSize().width or 0 --以汉字做为标准(宽度32)
                	_buildingBtn._flagName:setPositionX(_buildingBtn._flag:getContentSize().width/2-15 - (_flagNameWidth-32)/2)
					if selfCountryOccupy[_typeInfo.id] then
						_buildingBtn._flag:setTexture("res/Main/country/grabMine/occupyFlag_blue.png")
					else
						_buildingBtn._flag:setTexture("res/Main/country/grabMine/occupyFlag_red.png")
					end
				else
					_buildingBtn._flag:setVisible(false)
				end
				--如果是自己占领的矿
				if selfOccupyId ~= 0 then
					if _typeInfo.id == selfOccupyId then
	                    local eff_kuang = self._buildingLayer:getChildByName("self_eff_kuang")
                    	if not eff_kuang then
		                    eff_kuang = zc.createSpine({
		                        fileName = "eff_kuang",
		                        actName = "animation",
		                        loop = true,
		                        removeCallback = function() end
		                    })
	                    	eff_kuang:setName("self_eff_kuang")
		                    self._buildingLayer:addChild(eff_kuang,  _typeInfo.zorder-1)
		                end
	                    local _scale = self._eff_kuangInfo[_typeInfo.tag].scale or 1
	                    local _jsutX = self._eff_kuangInfo[_typeInfo.tag].justx or 0
	                    local _justY = self._eff_kuangInfo[_typeInfo.tag].justy or 0
	                    eff_kuang:setPosition(_typeInfo.pos.x+_jsutX, _typeInfo.pos.y+_justY)
	                    eff_kuang:setScale(_scale*self._iconScale)
	                    eff_kuang:setLocalZOrder(_typeInfo.zorder-1)
					end
				end
			end
		end
	end
    if not selfOccupyId or selfOccupyId == 0 then
        local self_eff_kuang = self._buildingLayer:getChildByName("self_eff_kuang")
        if self_eff_kuang then
            self_eff_kuang:removeFromParent()
        end
    end
end
--刷新路线
function GrabMineMapFirstLayer:refreshLines()
	--自己国家占领的矿
	local selfCountryOccupy = PlayerData:getSelfCountryOccupy()
	for i = 1, #self._lineSpineList do
	    local _lineSpine = self._lineSpineList[i]._spine
	    local _actName = self._lineSpineList[i]._actNamePrefix
	    local _oldState = self._lineSpineList[i]._oldState
	    local _condition = self._lineSpineList[i]._condition

	    local _from = _condition.from or {} --由什么而亮
	    local _to = _condition.to or {} 

	    if selfCountryOccupy[_from] then --如果已经占领这个地方
	    	local endAct = "start"
	    	local _countryOccupyState = true
	    	for k,v in pairs(_to) do
	    		if v and type(v) == "number" then
	    			if not selfCountryOccupy[v] then
	    				_countryOccupyState = false
	    				break
	    			end
	    		end
	    	end
	    	if _countryOccupyState then
	    		endAct = "open"
	    	end
	    	if _oldState == "stop" then
	    		_lineSpine:playAction(_actName.."idle", false)
	    		self._lineSpineList[i]._oldState = "idle"
				_lineSpine:registerSpineEventHandler( function ( event )
					if event.animation == _actName.."idle" then
						_lineSpine:playAction(_actName..endAct, true)
						self._lineSpineList[i]._oldState = endAct
					end
				end, sp.EventType.ANIMATION_COMPLETE)
			else
				_lineSpine:playAction(_actName..endAct, true)
				self._lineSpineList[i]._oldState = endAct
	    	end
	    else
			_lineSpine:playAction(_actName.."stop", true)
			self._lineSpineList[i]._oldState = "stop"
	    end
	end
end
function GrabMineMapFirstLayer:onCleanup()
    self:stopMyTimer()
    self:deleteShowLay()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_GRABMINE_REFRESHUI)
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end
function GrabMineMapFirstLayer:onEnter( ... )
	if self._notInit then
		--刷新
    	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_GRABMINE_REFRESHUI})
	end
	self._notInit = true
end

return GrabMineMapFirstLayer