-- FileName: LimitChallengeCopy.lua
-- Author: wangming
-- Date: 2016-09-26
-- Purpose: 新主线章节列表界面  fbid 1.速度副本、2.生存副本、3.强攻副本、4.极限挑战
--[[TODO List]]

local LimitChallengeCopy = class("LimitChallengeCopy", function()
	return zc.createNormalDialog({
		src = "res/Main/limitChallengeCopy/bg.jpg",
        showYun = true,
        yunTag = 1,
        yunZorder = {1, -1},
        yunOffY = {50, 0},
	})
end)

function LimitChallengeCopy:create( params )
	return LimitChallengeCopy.new(params)
end

function LimitChallengeCopy:onEnter()
    self:addGuide()
	if not self._haveInit then
		self._haveInit = true
		return
	end
    performWithDelay(self, function( ... )
        zc.sendHttp({
            apiName = "LimitChallenge_main",
            successCallback = function (result)
                if tolua.isnull(self) then
                    return
                end
                self._infos = result.tollgateInfo
                self._record = result.record or {}
                self:freshNowSelected()
            end,
        }) 
    end, 0.01)
end

function LimitChallengeCopy:ctor( params )
    self._needUnlock = false
    self._needIntegral = 0
	self._infos = params.tollgateInfo or {}
    self._record = params.record or {}
    self._nowIdx = 2
    if params.goIdx then
        self._nowIdx = tonumber(params.goIdx) or 2
        if not inArray(self._nowIdx, {1,2,3,4}) then
            self._nowIdx = 2
        end
    end
    --title
    local _titleBg = zc.getSprite({
        src = "res/Main/chapterMain/infoTitle.png",
        ap = cc.p(0.5, 1),
        pos = cc.p(zc.width*0.25, zc.height),
    })
    self:addChild(_titleBg, 4)

    local _titleLab = zc.createLabel({
        text = "",
        fontSize = 20,
        outLine = true,
        pos = cc.p(_titleBg:getContentSize().width*0.5, _titleBg:getContentSize().height*0.5 + 5),
    })
    _titleBg:addChild(_titleLab)  
	self._titleLab = _titleLab 

    --底部
    local _bottomDiImg = zc.getSprite({
    	src = "res/Main/levy/bg_down.jpg",
    	pos = cc.p(zc.width*0.5, 25),
    })
    self:addChild(_bottomDiImg, 2)
    local _bottomDiSize = cc.size(zc.width, _bottomDiImg:getContentSize().height*0.5 + _bottomDiImg:getPositionY())
    local _bottomDi = cc.Node:create()
    self:addChild(_bottomDi, 2)


    local _tipTypeDi = zc.getSprite({
    	pos = cc.p(130, _bottomDiSize.height + 60)
	})
	_bottomDi:addChild(_tipTypeDi)
	self._tipTypeDi = _tipTypeDi
    local _tipInfoDi = zc.getSprite({
    	src = "res/Main/limitChallengeCopy/tipNumDi.png",
    	pos = cc.p(130, _bottomDiSize.height + 25)
	})
	_bottomDi:addChild(_tipInfoDi)
	local _tipInfoLabel = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        text = 1,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_tipInfoDi:getContentSize().width*0.5, _tipInfoDi:getContentSize().height*0.5 - 3),
        addwidth = -5,
    })
    _tipInfoDi:addChild(_tipInfoLabel, 10)
    self._tipInfoLabel = _tipInfoLabel

    local _tipTitleDi = zc.getSprite({
    	src = "res/Main/limitChallengeCopy/tipDi.png",
    	pos = cc.p(130, _bottomDiSize.height*0.5)
	})
	_bottomDi:addChild(_tipTitleDi)

	local _tipTitleLab = zc.createLabel({
		text = zc.lang("tactical_analysis"),
		fontSize = 18,
		width = 20,
		pos = cc.p(_tipTitleDi:getPosition()),
		color = cc.c3b(197, 181, 150),
	})
	_bottomDi:addChild(_tipTitleLab)

	local _tipDiSize = cc.size(410, 80)
    local _tipDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _tipDiSize)
    _tipDi:setAnchorPoint(0, 0.5)
    _tipDi:setPosition(_tipTitleDi:getPositionX() + 30, _bottomDiSize.height*0.5)
    _bottomDi:addChild(_tipDi)
       
    local _tipLab = zc.createLabel({
		fontSize = 18,
		width = _tipDiSize.width - 6,
		ap = cc.p(0.5, 1),
		pos = cc.p(_tipDiSize.width*0.5, _tipDiSize.height - 5),
	})
	_tipDi:addChild(_tipLab)   
	self._tipLab = _tipLab 

	local _rewardTip = zc.getSprite({
    	src = "res/Main/limitChallengeCopy/rewardTip.png",
    	pos = cc.p(_tipDi:getPositionX() + _tipDiSize.width + 50, _bottomDiSize.height*0.5)
	})
	_bottomDi:addChild(_rewardTip)
	self._rewardTip = _rewardTip

	local _challengeBtn = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("challenge_2"),
		pos = cc.p(_bottomDiSize.width - 180, _bottomDiSize.height*0.5 + 10),
		endCallback = function()
            if self._needUnlock then
                zc.sendHttp({    
                    apiName = "LimitChallenge_unlock",
                    params = {tollgateId = self._tollgateId, type = self._nowIdx},
                    successCallback = function (result)
                        if tolua.isnull(self) then
                            return
                        end
                        PlayerData:updataData(result)
                        self._infos = result.tollgateInfo or {}
                        self._record = result.record or {}
                        self._needUnlock = false
                        self._unLockTip:setVisible(false)
                        zc.tipInfo(zc.lang("tips_unlock_success"))
                        if self._challengeBtn.eff then
                            self._challengeBtn.eff:playAction("animation2")
                            self._challengeBtn.eff:registerSpineEventHandler( function ( event )
                                local name  = event.animation
                                if name == "animation2" then
                                    performWithDelay(self._challengeBtn.eff, function()
                                        self._challengeBtn.eff:removeFromParent()
                                        self._challengeBtn.eff = nil
                                    end, 0.01)
                                end
                            end, sp.EventType.ANIMATION_COMPLETE)
                        end
                    end,
                })
                return
            end
			local _enemyGroup = gameData.getDataFromCache("specialTollgateGroup", {tollgateId = self._tollgateDb.id})
            local _enemysData = {
	            tollgateId = self._tollgateDb.id,
            	enemys = {}
            }
            for i = 1, 9 do
                local _npcId = tonumber(_enemyGroup["location" .. i]) or 0
                if _npcId ~= 0 then
                    _enemysData.enemys[i] = gameData.getDataFromCacheWithPrimaryKey("specialTollgateNpc", _npcId)
                else
                	_enemysData.enemys[i] = {}
                end
            end
            local _params = {
                battleType = BattleType.LimitChallenge, 
                enemys = _enemysData, 
                tollgateId = self._tollgateDb.id,
                tollgateType = self._tollgateDb.fbId,
                fightScene = 1,
                isFirstFight = true,
            }
			zc.createMatrixBattle(_params)
		end
	})
	_bottomDi:addChild(_challengeBtn)
	self._challengeBtn = _challengeBtn

    local _allOverImg = zc.getSprite({
        src = "res/Main/limitChallengeCopy/allOver.png",
        pos = cc.p(_challengeBtn:getPositionX(), _bottomDiSize.height*0.5)
    })
    _bottomDi:addChild(_allOverImg)
    _allOverImg:setVisible(false)
    self._allOverImg = _allOverImg
	
	local _unLockTip = zc.createLabel({
		text = "",
		fontSize = 20,
		pos = cc.p(_challengeBtn:getPositionX(), _challengeBtn:getPositionY() - 50),
		color = cc.c3b(197, 181, 150),
	})
	_bottomDi:addChild(_unLockTip)
	self._unLockTip = _unLockTip

     local _inkBottom = zc.createSprite("res/Main/role/common/ink_bottom.png")
    _inkBottom:setAnchorPoint(0, 1)
    _inkBottom:setPosition(-370, zc.height)
    self:addChild(_inkBottom)

	local _heroPic = zc.createSprite()
    _heroPic:setPosition(zc.width*0.25, zc.height*0.5)
    self:addChild(_heroPic)
	self._heroPic = _heroPic

    local _inkTop = zc.createSprite("res/Main/role/common/ink_top.png")
    _inkTop:setAnchorPoint(0, 0)
    self:addChild(_inkTop)

    --上部
 	local _upDiSize = cc.size(zc.width, zc.height - _bottomDiSize.height)
    local _upDi = cc.Node:create()
    _upDi:setPosition(0, _bottomDiSize.height)
    self:addChild(_upDi, 1)

    local _cloud = zc.getSprite({
    	src = "res/Main/limitChallengeCopy/cloud.png",
    	pos = cc.p(_upDiSize.width*0.5 - 20, _upDiSize.height*0.5),
    	ap = cc.p(0, 0.5),
    })
    _upDi:addChild(_cloud, -1)

    local _partWidth = 140
    self._btns = {}

    local _speedBtn = zc.createPushButton({
    	normalFile = "res/Main/limitChallengeCopy/speedBtn.png",
        selectedFile = "res/Main/limitChallengeCopy/speedBtn_d.png",
    	pos = cc.p(_upDiSize.width*0.75, _upDiSize.height*0.5 - 170),
    	endCallback = function()
    		self:freshNowSelected(1)
    	end
	})
    _speedBtn.normalFile = "res/Main/limitChallengeCopy/speedBtn.png"
    _speedBtn.selectedFile = "res/Main/limitChallengeCopy/speedBtn_d.png"
    _upDi:addChild(_speedBtn, 1)
    table.insert(self._btns, _speedBtn)

    local _survivalBtn = zc.createPushButton({
    	normalFile = "res/Main/limitChallengeCopy/survivalBtn.png",
        selectedFile = "res/Main/limitChallengeCopy/survivalBtn_d.png",
    	pos = cc.p(_upDiSize.width*0.75 - _partWidth, _upDiSize.height*0.5 - 60),
    	endCallback = function()
    		self:freshNowSelected(2)
    	end
	})
    _survivalBtn.normalFile = "res/Main/limitChallengeCopy/survivalBtn.png"
    _survivalBtn.selectedFile = "res/Main/limitChallengeCopy/survivalBtn_d.png"
    _upDi:addChild(_survivalBtn, 1)
    table.insert(self._btns, _survivalBtn)

    local _attackBtn = zc.createPushButton({
    	normalFile = "res/Main/limitChallengeCopy/attackBtn.png",
        selectedFile = "res/Main/limitChallengeCopy/attackBtn_d.png",
    	pos = cc.p(_upDiSize.width*0.75 + _partWidth, _survivalBtn:getPositionY()),
    	endCallback = function()
    		self:freshNowSelected(3)
    	end
	})
    _attackBtn.normalFile = "res/Main/limitChallengeCopy/attackBtn.png"
    _attackBtn.selectedFile = "res/Main/limitChallengeCopy/attackBtn_d.png"
    _upDi:addChild(_attackBtn, 1)
    table.insert(self._btns, _attackBtn)

    local _node = zc.createSprite()
    _node:setContentSize(_attackBtn:getContentSize())
    local _limitBtn = zc.createPushButton({
    	normalNode = _node,
    	pos = cc.p(_upDiSize.width*0.75, _upDiSize.height*0.5 + 100),
    	endCallback = function()
    		self:freshNowSelected(4)
    	end
	})
    _upDi:addChild(_limitBtn)
    local _eff = zc.getSpine("jixiantiaozhan")
    _eff:playAction("animation", true)
    _eff:registerSpineEventHandler( function ( event )
        if event.animation == "animation2" then
            _eff:playAction("animation3", true)
        end
    end, sp.EventType.ANIMATION_COMPLETE)
    _eff:setPosition(_limitBtn:getContentSize().width*0.5, _limitBtn:getContentSize().height*0.5)
    _limitBtn:addChild(_eff)
    _limitBtn.texiao = _eff
    table.insert(self._btns, _limitBtn)



	self:freshNowSelected()
end

-- 1.速度副本、2.生存副本、3.强攻副本、4.极限挑战
function LimitChallengeCopy:freshNowSelected( idx )
	local _idx = tonumber(idx) or self._nowIdx
	self._nowIdx = _idx

	for i,v in ipairs(self._btns) do
		if i == _idx then
            if i ~= 4 then
                v:getStateSelected():setTexture(v.selectedFile)
            elseif v.texiao then
                v.texiao:playAction("animation2")
            end
            v:setSelected(true)
			v:setEnable(false)
            if not v.eff and i ~= 4 then
                v.eff = zc.getSpine("speedsudu")
                v.eff:playAction("animation", true)
                v:getParent():addChild(v.eff, -1)
                v.eff:setPosition(v:getPosition())
            end
		else
            if i ~= 4 then
                v:getStateSelected():setTexture(v.normalFile)
            elseif v.texiao then
                v.texiao:playAction("animation", true)
            end
            v:setSelected(false)
			v:setEnable(true)
            if v.eff then
                v.eff:removeFromParent()
                v.eff = nil
            end
		end
	end
	local _haveAllOver = false
	local _tollgateId = tonumber(self._infos["maxTollgate" .. _idx]) or 0
	if _tollgateId == 0 then
		_tollgateId = _idx*10000 + 1
	else
		local _tempDb = gameData.getDataFromCacheWithPrimaryKey("specialTollgate", _tollgateId + 1)
		if next(_tempDb) ~= nil then
			_tollgateId = _tollgateId + 1
		else
			_haveAllOver = true
		end
	end
    self._tollgateId = _tollgateId
	local _tollgateDb = gameData.getDataFromCacheWithPrimaryKey("specialTollgate", _tollgateId)
	local _tollIdx = _tollgateId%10000
	self._tollgateDb = _tollgateDb

	self._titleLab:setString(zc.lang("num_di") .. _tollIdx .. zc.lang("num_guan")) 
	self._tipLab:setString(tostring(_tollgateDb.tacticsDesc))
	local _needIntegral = tonumber(_tollgateDb.needIntegral) or 0
    self._needIntegral = _needIntegral
    if self._challengeBtn.eff then
        self._challengeBtn.eff:removeFromParent()
        self._challengeBtn.eff = nil
    end

    self._unLockTip:setVisible(true)
    self._challengeBtn:setVisible(true)
    self._needUnlock = false
	if _needIntegral > 0 then
		self._unLockTip:setVisible(true)
		self._unLockTip:setString(zc.lang("unlock_need_score") .. " " .. _needIntegral)
		local _nowHave = tonumber(PlayerData:getResourcesInfoById(zc.dataSpecialPoint)) or 0
        self._challengeBtn:setEnable(_nowHave >= _needIntegral)
        self._needUnlock = true
        local _table = self._record["4"] or {}
        for k,v in pairs(_table) do
            if tonumber(k) == self._tollgateId then
                if v.u == 1 then
                    self._needUnlock = false
                    break
                end
            end
        end
        if self._needUnlock then
            local _eff = zc.createSpine({
                fileName = "shengsuotielian",
                actName = "animation",
                loop = true,
            })
            _eff:setPosition(self._challengeBtn:getContentSize().width*0.5, self._challengeBtn:getContentSize().height*0.5)
            self._challengeBtn:addChild(_eff)
            self._challengeBtn.eff = _eff
        else
            self._challengeBtn:setEnable(true)
            self._unLockTip:setVisible(false)
        end
	else
		self._unLockTip:setVisible(false)
		self._challengeBtn:setEnable(true)
	end
	if _haveAllOver then
		self._unLockTip:setVisible(false)
		self._challengeBtn:setVisible(false)
        self._allOverImg:setVisible(true)
    else
        self._allOverImg:setVisible(false)
	end


    local _heroImg = "res/Main/hero/body/"..tostring(_tollgateDb.card)..".png"
    if not zc.checkFileExist(_heroImg) then
        _heroImg = "res/Main/hero/body/1.png"
    end
    self._heroPic:setTexture(_heroImg)

    self._rewardTip:removeAllChildren()

    local _specialDrop = _tollgateDb.specialDrop or ""
    local _dropIds = string.split(tostring(_specialDrop), ",")
    local _startX = 80
    for i=1, 2 do
    	local _dropData = gameData.getDataFromCacheWithPrimaryKey("drop_award", _dropIds[i])
    	if _dropData and next(_dropData) ~= nil then	
    		local _icon = zc.createIconByData({
    			data = {
	                mainType = _dropData.itemType,
	                type = _dropData.itemId, 
	                id = _dropData.itemId,
	                num = _dropData.itemNum,
	    		},
	    		showDetailPop = true,
	    		pos = cc.p(_startX, self._rewardTip:getContentSize().height*0.5)
			})
			_icon:setScale(0.65)
			self._rewardTip:addChild(_icon)
			_startX = _startX + 110
    	end
    end
    
    local _num = tonumber(_tollgateDb.speed) or 0
    local _src = "res/Main/limitChallengeCopy/tipSpeed.png"
    if _num == 0 then
    	_num = tonumber(_tollgateDb.fight) or 0
    	_src = "res/Main/limitChallengeCopy/tipFight.png"
    end
    self._tipTypeDi:setTexture(_src)
    self._tipInfoLabel:setString(_num)

end

function LimitChallengeCopy:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_13903 then
        zc.setGuideFuncNextStep(_currentGID, false)
        self:addGuide()
    elseif _currentGID == GuideKey.KEY_13904 then
        local function _callBack()
            getGuideManager():setFuncGuideOver()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

return LimitChallengeCopy