--[[
-- 主城界面
-- @author wangming
-- Creation  2016-08-08
]]
local MainCityLayer = class("MainCityLayer", function ()
    return ZCDialog:create()
end)

function MainCityLayer:create(data)
    local _packageId = zc.getChannelPackageId()
    if APPSTORE_REVIEW and (_packageId == 2 or _packageId == 10 ) then -- 以前用的是5，现在改为用2  _packageId == 10 or _packageId == 2
        IS_REVIEW_MAINCITY = false
        ISSHOW_GUIDE = false
    else
        IS_REVIEW_MAINCITY = false
        ISSHOW_GUIDE = true
    end

    ----------------准备新手引导步骤--------------------
    GuideTollgateKey = {}
    local _data = gameData.getAllDataWithNoClone("functions")
    for k,v in pairs(_data) do
        if tonumber(v.tollgateId) ~= 1001001 
          and v.functionId ~= 10
          and v.functionId ~= 9
          and v.functionId ~= 44
          and v.functionId ~= 37 then
            GuideTollgateKey[k] = tonumber(v.tollgateId) or 0
        end
    end
    getGuideManager():preGuideStep()
    ------------------------------------------------
	local mainCity = MainCityLayer.new()
	return mainCity
end

function MainCityLayer:ctor()
    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
	self.houseList = {}
    self._bubbleList = {}
    self._uiZorder = 10
    zc.loginSuccessCallback(true)
    
    --地图容器
    self:initUI()
    self:createScrollView()
    self:createFarm()

    local _house = self:getHouseByHouseId(1)
    if _house then
        self:moveHouseInMyVision(_house, true)
    end
    
    --响应android 返回事件
    local androidComfirm       = nil
    local function onrelease(code, event)
       if code == cc.KeyCode.KEY_BACK then
            if not androidComfirm then
                local _scene = cc.Director:getInstance():getRunningScene()
                local _notice = _scene:getChildByName("NoticePop")
                if _notice then
                    _notice:removeFromParent()
                end
                androidComfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    rightText = zc.lang("quit_2"),
                    showDi = true,
                    msg = zc.lang("tips_sure_to_quit"),
                    closeCallback = function()
                        androidComfirm = nil
                    end,
                    rightCallback = function()
                        zc.doSdkExit(function()
                            cc.Director:getInstance():endToLua()
                            comfirm = nil
                        end)
                    end
                })  
                androidComfirm:setName("BackKeyPop")
                _scene:addChild(androidComfirm, 999999999)
            else
                androidComfirm:removeFromParent()
                androidComfirm = nil
            end
        elseif code == cc.KeyCode.KEY_HOME then
            
        end
    end
    local listener = cc.EventListenerKeyboard:create()
    listener:registerScriptHandler(onrelease, cc.Handler.EVENT_KEYBOARD_RELEASED)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)

    -- add小喇叭
    local node = cc.Director:getInstance():getNotificationNode()
    local announce = ZCMarqueeNode:createWithParams({
        pos = cc.p(260, winSize.height - 60),
        anchor = cc.p(0, 1),
    })
    announce:setName("announcement")
    node:addChild(announce)
    local _datas = PlayerData:getArenaChampionInfo()
    if table.nums(_datas) > 0 then
        for k,v in pairs(_datas) do
            if string.len(v) > 0 then
                ZCMarqueeNode:insertAData(tostring(v))
            end
        end
    end
    announce:run()

    self._haveSend = false
    zc.removeEventListener("EVENT_NAME_COME_TO_FOREGROUND")
    zc.addEventListener({name = "EVENT_NAME_COME_TO_FOREGROUND" , callback = function(event)
        print("EVENT_NAME_COME_TO_FOREGROUND")
        --解析本地Manifest文件,检查更新
        if tolua.isnull(self) or self._haveSend then
            return
        end
        self._haveSend = true
        local params = {
            succCall = function( data )
                LayerManager.backToMainCity(false)
                print("从后台回来检查到需要异步更新EVENT_NAME_COME_TO_FOREGROUND")
                helper.reloadAllFile()
                requires("src/main.lua")
            end, 
            failCall = function()
                if CHECK_UPDATA and CHECK_TABLE_UPDATA then
                    requires("src/TableLoadingLayer.lua"):create({
                        successCallback = function()
                            local tipPop = ZCConfirmDialog:createWithParams({
                                title = zc.lang("prompt"),
                                showDi = true,
                                leftVisible = false,
                                msg = zc.lang("tips_relogin"),
                                rightCallback = function()
                                    zc.goReturnLogin()
                                end
                            })
                            tipPop:setName("reloginTip")
                            local _root = LayerManager.getCurRootLayer()
                            _root:addChild(tipPop, 200000)
                            if tipPop._containerLayer then
                                tipPop._containerLayer:setTouchEndedCallback(function()
                                end)
                            end
                            if tipPop._close_btn then
                                tipPop._close_btn:setVisible( false )
                            end
                        end,
                        failedCallback = function()
                            self._haveSend = false
                        end
                    })
                else
                    self._haveSend = false
                end
            end
        }
        local manifest = zc.checkUpdate(params)
    end})

    self:tempFreshSevenDayRed()
    self:tempFreshActivityFoodRed()

    -- self:checkBuildGuide()
end

function MainCityLayer:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE)
    zc.removeEventListener(CUSTOM_EVENT.EVENT_NAME_COME_TO_FOREGROUND)
    zc.removeEventListener(CUSTOM_EVENT.EVENT_TARGET_REDPOINT)
end

function MainCityLayer:onExit()
    if self._timer then
        scheduler.unscheduleGlobal( self._timer )
        self._timer = nil
    end
end

function MainCityLayer:onEnter()
    if not self:isVisible() then
        return
    end
    -- 引导的时候将这个目标按钮和副本（主线按钮）屏蔽掉了，每次进入mainCity设置一下
    if self._icon then
        self._icon:setEnable(true)
    end
    if self._bottomButtonLay._fubenButton and self._bottomButtonLay._fubenButton._btn then
        self._bottomButtonLay._fubenButton._btn:setEnable(true)
    end
    if self._guideHand then
        self._guideHand:setVisible(false)
    end

    if self._hasShowNotice then
        helper.releaseSpineCaches()
        helper.collectMemory()
        if self.scollView then
            self.scollView:onEnter()
        end
        if self._farm then
            self._farm:onEnter()
        end
        if self._bottomButtonLay then
            self._bottomButtonLay:checkOpen()
        end
    end    
    local _flag = self:check3006Guide()
    --任务是否开启
    self:checkTaskOpen()
    
    local _lay = getGuideManager():getMaskLayer()
    local _topLay = LayerManager.getTopInfoLayer()
    _topLay:addChild(_lay, 1000)
    performWithDelay(_lay, function()
        -- self:checkSpBuildGuide()
        self:guideFunc()

        self:checkRedAndBubble(_flag)
        -- 招募积累，马超参上弹出页
        if not self._hasShowNotice then
            if not APP_REVIEW and not APPSTORE_REVIEW and getGuideManager():guideIsOver() then
                zc.createNoticePop({
                    callBack = function()
                        zc.createRecruitAccumulationPop({
                            callback = function()
                                self:checkNewFuncGuide()
                                self:checkShowFuben()
                                self:checkShowFengce()
                            end
                        })
                    end
                })
            end
            self._hasShowNotice = true
            PlayerData:freshMainBubbleShow()
        else
            self:freshBubbleInfo()
            self:checkShowFuben()
            self:checkShowFengce()
        end
    end, 0.1)

    performWithDelay(_lay, function()
        if not tolua.isnull(_lay) then
            _lay:removeFromParent()
            _lay = nil
        end
    end, 0.3)

    --检查即将开放
    self:checkUpcomingOpen()

    if not self._farm:isFarmShow() then
        musicManager.playMusic(zc.bgm.city, true)
    end
    self._timer = nil
    local sign,time_distance = PlayerData:getActiveEntrance2()
    local function setActivity()
        local _btnScale = 0.9
        local _posX = 0
        for i, v in ipairs( self._activityIcon ) do
            local _flag = v.flag
            if _flag == self._acttiveFlag.limitTimeHot then
                v:setVisible(false)
            end
            if v:isVisible() then
                v:setPositionX( _posX )
                _posX = _posX - 100*_btnScale
            end
        end
    end
    print("sign:",sign,"time_distance-----",time_distance)
    if sign then
        if time_distance then
            self._timer = scheduler.scheduleGlobal(function()
                time_distance = ( time_distance - 1 )
                if time_distance <= 0 then
                    scheduler.unscheduleGlobal( self._timer )
                    self._timer = nil
                    setActivity()
                end
                -- print("time_distance:",time_distance)
                for i, v in ipairs( self._activityIcon ) do
                    local _flag = v.flag
                    if _flag == self._acttiveFlag.limitTimeHot then
                        local jjg = tonumber(PlayerData:getRedState(15))
                        local dc = tonumber(PlayerData:getRedState(11))
                        -- print("jjg:",jjg,"dc:",dc)
                        local statusjjg = true
                        local statusdc = true
                        if not jjg or jjg == false or jjg == 0 then
                            statusjjg = false
                        end
                        if not jjg or jjg == false or jjg == 0 then
                            statusdc = false
                        end

                        if statusdc == false and statusjjg == false then
                            v._redDot:setVisible(false)
                        else
                            v._redDot:setVisible(true)
                        end
                    end
                end

            end, 1)
        end
    else
        if self._timer then
            scheduler.unscheduleGlobal( self._timer )
            self._timer = nil
        end
        setActivity()
    end
    local function createIcon( ... )
        if not self._icon then
            -- 目标按钮
            local targetNode = cc.Node:create()
            self:addChild(targetNode, 100)
            targetNode:setPosition(zc.width/2, zc.height - 150)
            self.targetNode = targetNode
            local normalImage = zc.createSprite("res/Main/target/mubiaogongneng.png")
            normalImage:setScale(0.7)
            self._icon = zc.createPushButton({
                normalNode = zc.createSprite(),
                ap = cc.p(0.5, 0),
                btnEff = zc.effect.btnOpen,
                scale = 1,
                touchSize = normalImage:getContentSize(),
                pos = cc.p(0,0),
                endCallback = function ( ... )
                    local guideHead = self.targetNode:getChildByTag(100)
                    print("guideHead ",guideHead)
                    if guideHead then
                        self.targetNode:removeChildByTag(100)
                    end
                     zc.createSourceScene("MainCityTargetLayer", "src/layer/mainCity/MainCityTargetLayer.lua")
                end,
            })
            self._icon:setContentSize(normalImage:getContentSize())
            targetNode:addChild(self._icon)

            local _btnbg = zc.getSprite({
                src = "bottomDi.png",
                plist = true,
                pos = cc.p(self._icon:getContentSize().width*0.5 - 5, self._icon:getContentSize().height*0.5 - 5),
                scale = 1.2,
            })
            self._icon:addChild(_btnbg)

            local _spine = zc.getSpine("mubiaogongneng")
            _spine:playAction("animation", true)
            _spine:setScale(0.75)
            _spine:setPosition(self._icon:getContentSize().width*0.5, self._icon:getContentSize().height*0.5)
            self._icon:addChild( _spine )
            local _di = zc.getSprite({
                src = "btnNameDi.png",
                plist = true,
                scale = 1.2,
                -- pos = cc.p(_btn:getContentSize().width*0.5, 10),
            })
            -- local _di = zc.createSpriteWithFrameName("activityNameDi.png")
            _di:setAnchorPoint(0.5, 0)
            _di:setPosition(self._icon:getContentSize().width*0.5, -2)
            self._icon:addChild(_di)
            local _lab = zc.createLabel({
                text = zc.lang("target"),
                fontSize = 22,
                outLine = true,
                pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5),
            })
            _di:addChild(_lab)

            local _redDot = cc.Sprite:create( "res/Main/common/common_red_point.png" )
            _redDot:setAnchorPoint( 1, 1 )
            _redDot:setPosition( self._icon:getContentSize().width - 7  , self._icon:getContentSize().height - 20)
            _redDot:setVisible( false )
            self._icon:addChild( _redDot )
            self._icon._redDot = _redDot

            local targetNodeSize = targetNode:getContentSize()
            local posX = targetNode:getPositionX()
            local posY = targetNode:getPositionY()

            local scaleTo =  CCScaleTo:create(0.7, 0.75)
            local moveTo = CCMoveBy:create(0.7, ccp(zc.width - posX - targetNodeSize.width - 53,- posY - targetNodeSize.height + 255))
            local spwan = CCSpawn:create(scaleTo,moveTo)
            local callBack = CCCallFunc:create(function ( ... )
                local id1 = PlayerData:getFuncGuideInfo(1000000)
                local id2 = PlayerData:getFuncGuideInfo(2000000)
                if PlayerData.taskId then
                    if tonumber(PlayerData.taskId) == 1 then
                        if not id1 then --  没有走
                            getGuideManager():sendFuncGuideTrigger(1000000)
                            local _guideHand = zc.createSpine({
                                fileName = "shou",
                                actName = "shou",
                            })
                            _guideHand:setPosition(cc.pMul(cc.pFromSize(self.targetNode:getContentSize()), 0.5))
                            self.targetNode:addChild(_guideHand,100,100)
                        end
                    elseif tonumber(PlayerData.taskId) == 2 then
                        if not id2 then --  没有走
                            getGuideManager():sendFuncGuideTrigger(2000000)
                            local _guideHand = zc.createSpine({
                                fileName = "shou",
                                actName = "shou",
                            })
                            _guideHand:setPosition(cc.pMul(cc.pFromSize(self.targetNode:getContentSize()), 0.5))
                            self.targetNode:addChild(_guideHand,100,100)
                        end
                    end
                end
            end)
            local sqe =  CCSequence:create(spwan, callBack)
            targetNode:runAction(sqe)
        end
    end
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_TARGET_REDPOINT,
        callback = function(data)
            dump(data.data, "---EVENT_TARGET_REDPOINT--")
            if tolua.isnull(self) then
                return
            end
            local sign = tonumber(data.data.sign)
            print("sign -------",sign)
            PlayerData.targetFromSever = sign
        end
    })

    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_FOODSRED,
        callback = function(data)
            self:refreshNewactivityRed()
        end
    })

    local _currentGID = getGuideManager():getCurrentGID()
    print("_currentGID:",_currentGID,PlayerData.targetFromSever)
    if _currentGID == 1 then -- =1表示引导结束
        if PlayerData.targetFromSever then -- 登录游戏时判断
            if tonumber(PlayerData.targetFromSever) == 0 then -- 显示按钮
                if not self._icon then
                    createIcon()
                end
                self._icon:setVisible(true)
                self._icon._redDot:setVisible(false)
            elseif tonumber(PlayerData.targetFromSever) == 1 then -- 显示按钮 和红点
                if not self._icon then
                    createIcon()
                end
                self._icon._redDot:setVisible(true)
                self._icon:setVisible(true)
            elseif tonumber(PlayerData.targetFromSever) == 2 then -- 关闭按钮
                if self._icon then
                    self._icon:setVisible(false)
                    self._icon = nil
                end
            end
        end
    end
end

function MainCityLayer:checkShowFengce( )
    -- 封测充值弹出页
    if self._isOpenFengce and not self._showFengce then
        zc.createNoticePop({
            callBack = function()
                zc.createFengcePop()
            end
        })
        self._showFengce = true
    end
end

function MainCityLayer:checkUpcomingOpen()
    local nextInfo = zc.getNextOpenFuncInfoNew()
    if nextInfo and nextInfo.icon then
        if self._upcomingOpenBtn then
            if self._upcomingOpenBtn._nextFuncId == nextInfo.functionId then
                return
            end
            self._upcomingOpenBtn:removeFromParent()
            self._upcomingOpenBtn = nil
        end
        local _bottomBg = zc.getSprite({
            src = "bottomDi.png",
            plist = true,
            scale = 0.9,
        })
        local _normal = zc.createSprite("res/Main/common/common_icon_"..nextInfo.icon..".png")
        _normal:setScale(0.6*0.9)
        _normal:setPosition(_bottomBg:getContentSize().width/2,_bottomBg:getContentSize().height/2)
        _bottomBg:addChild(_normal)
        local _btn = zc.createPushButton({
            normalNode = _bottomBg,
            scale = 0.9,
            pos = cc.p(60, 110),
            endCallback = function()
                zc.createSourcePop("UpcomingOpenPop", "src/layer/mainCity/UpcomingOpenPop.lua", {nextInfo=nextInfo})
            end,
        })
        self._chatUpNode:addChild(_btn)
        local upcoming = zc.createSprite("res/Main/common/upcomingOpen.png")
        upcoming:setPosition(_btn:getContentSize().width/2, 0)
        _btn:addChild(upcoming, 1)
        self._upcomingOpenBtn = _btn
        self._upcomingOpenBtn._nextFuncId = nextInfo.functionId
    else
        if self._upcomingOpenBtn then
            self._upcomingOpenBtn:removeFromParent()
            self._upcomingOpenBtn = nil
        end
    end
end
--创建界面元素
function MainCityLayer:initUI()
    self:createActivityNode()
    --底部按钮
    self._bottomButtonLay = requires("src/layer/mainCity/MainBottomBtnsLayer.lua"):create()
    self:addChild(self._bottomButtonLay, self._uiZorder)
    --添加锤子
    self:createHammerButton()
    --添加好友和邮件按钮
    self:createFriendAndMailButton()

    --添加红点气泡检测
    self:addMyEventListener()

    performWithDelay(self, function()
       for k,v in pairs(self._activityIcon) do
            if v.flag == self._acttiveFlag.activity then
                v._redDot:setVisible( true )
                break
            end
        end
    end, 0.5)
    
end

function MainCityLayer:createActivityNode()
    self._acttiveFlag = {
        fisrt_recharge = 1,
        recharge = 2,
        activity = 3,
        new_activity = 4,
        seven_day = 5,
        rank_list = 6,
        song_caohong = 7,
        limitTimeHot = 8,
    }
    local _activityTb = {
        {
            src = "res/Main/common/common_icon_huodong.png",
            btnEff = zc.effect.btnActive,
            listener = function()
                zc.createActivityPop()
            end,
            text = zc.lang("fuli"),
            flag = self._acttiveFlag.activity,
        },
        {
            src = "res/Main/common/common_icon_qiri.png",
            btnEff = zc.effect.btnActive,
            listener = function()
                zc.createSevenDayPop()
            end,
            text = zc.lang("sevenday_activity"),
            flag = self._acttiveFlag.seven_day,
        },
        {
            src = "res/Main/common/common_icon_rank.png",
            btnEff = zc.effect.btnOpen,
            listener = function()
                zc.createRankListPop()
            end,
            text = zc.lang("rank"),
            flag = self._acttiveFlag.rank_list,
        },
        {
            src = "res/Main/activity/secondDay/icon.png",
            srcScale = 1,
            btnEff = zc.effect.btnOpen,
            listener = function()
                zc.createSecondDayLayer()
            end,
            text = zc.lang("give_caohong"),
            flag = self._acttiveFlag.song_caohong,
        },
        {
            src = "res/Main/limittimehot/limittimehot.png",
            srcScale = 0.7,
            btnEff = zc.effect.btnOpen,
            listener = function()
                zc.sendHttp({
                    apiName = "Activity_open_info",
                    params ={ entrance = 2},
                    successCallback = function (net_data)
                        print("-----------限时热点-----")
                        PlayerData:setLimitActivityInfo(net_data)
                        local _params = params or {}
                        zc.createSourceScene("LimitTimeHot", "src/layer/activity/LimitTimeHot.lua",_params)
                    end
                })
            end,
            text = zc.lang("limitTimeHot"),
            flag = self._acttiveFlag.limitTimeHot,
        },
    }
    if not APP_REVIEW and APP_SERVER ~= 2 then
        _activityTb[#_activityTb + 1] = {
            srcScale = 1,
            btnEff = zc.effect.btnOpen,
            listener = function()
                zc.createRechargePop()
            end,
            text = zc.lang("recharge"),
            isChongzhi = true,
            flag = self._acttiveFlag.recharge,
        }
        _activityTb[#_activityTb + 1] = {
            srcScale = 1,
            btnEff = zc.effect.btnOpen,
            listener = function()
                zc.createActivityPop({idx = 9})
            end,
            text = zc.lang("fisrt_recharge"),
            isFisrtRecharge = true,
            flag = self._acttiveFlag.fisrt_recharge,
        }
        _activityTb[#_activityTb + 1] = {
            src = "res/Main/common/common_icon_xinfuhuodong.png",
            btnEff = zc.effect.btnActive,
            listener = function()
                zc.createActivityPop({sType = 1,entrance = 0})
            end,
            text = zc.lang("new_server_activity"),
            isXinfu = true,
            flag = self._acttiveFlag.new_activity,
        }
    end
    table.sort(_activityTb, function( a, b )
        return a.flag < b.flag
    end)
    self._activityIcon = {}
    local _activityNode = cc.Node:create()
    self:addChild(_activityNode, self._uiZorder)
    _activityNode:setPosition(zc.width - 65, zc.height - 95)
    self._activityNode = _activityNode
    local _btnScale = 0.9

    for i=1, #_activityTb do
        local _data = _activityTb[i]
        local _icon = zc.createPushButton({
            normalNode = zc.createSpriteWithFrameName("activityBtn.png"),
            ap = cc.p(0.5, 0),
            btnEff = _data.btnEff,
            scale = 0.85*_btnScale,
            pos = cc.p(-(i - 1)*100*_btnScale, 0),
            endCallback = _data.listener,
        })
        _activityNode:addChild(_icon)
        _icon.flag = _data.flag
        self._activityIcon[i] = _icon
        local _sp = zc.getSprite({
            src = _data.src,
            scale = _data.srcScale or 0.6*_btnScale,
            pos = cc.p(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5),
        })
        _icon:addChild(_sp)
        if _data.isChongzhi then
            _icon.isChongzhi = _data.isChongzhi

            local _spine = zc.getSpine("chongzhi")
            _spine:playAction("chongzhi2", true)
            _spine:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5)
            _icon:addChild( _spine )
            local _spine = zc.getSpine("chongzhi")
            _spine:playAction("chongzhi1", true)
            _spine:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5)
            _icon:addChild( _spine )
        end
        if _data.isFisrtRecharge then
            _icon.isFisrtRecharge = _data.isFisrtRecharge

            local _spine = zc.getSpine("shouchong")
            _spine:playAction("animation", true)
            _spine:setPosition(_icon:getContentSize().width*0.5, 15)
            _icon:addChild( _spine )
        end
   
        local _di = zc.createSpriteWithFrameName("activityNameDi.png")
        _di:setAnchorPoint(0.5, 0)
        _di:setPosition(_icon:getContentSize().width*0.5, 0)
        _icon:addChild(_di)
        local _lab = zc.createLabel({
            text = _data.text,
            fontSize = 22,
            outLine = true,
            pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5),
        })
        _di:addChild(_lab)
        -- 添加红点
        local _redDot = cc.Sprite:create( "res/Main/common/common_red_point.png" )
        _redDot:setAnchorPoint( 1, 1 )
        _redDot:setPosition( _icon:getContentSize().width + 5, _icon:getContentSize().height )
        _redDot:setVisible( false )
        _icon:addChild( _redDot )
        _icon._redDot = _redDot

        if i == 1 or i == 2 then
            local _spine = zc.getSpine("huodongtubiao")
            _spine:playAction("animation", true)
            _spine:setScale( 1.2 )
            _spine:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5)
            _icon:addChild( _spine )
        end
    end
    self:refreshActivityBtn()
end

--刷新新手活动红点
function MainCityLayer:refreshNewactivityRed()
    for i, v in ipairs( self._activityIcon ) do
        local _flag = v.flag
        if _flag == self._acttiveFlag.new_activity then
            v._redDot:setVisible( PlayerData:getRedState(4) == 1 or PlayerData:getRedState(18) == 1 or PlayerData:getRedState(5) == 1)
        elseif _flag == self._acttiveFlag.seven_day then
            v._redDot:setVisible( PlayerData:getRedState(17) == 1 )
        end
    end
end


-- 刷新活动按钮显示
function MainCityLayer:refreshActivityBtn()
    local _sevenDayStatus = PlayerData:getSevenDayStatus() --7日状态
    local _fisrtRechargeShowFlag = PlayerData:getFirstRechargeShowFlag()--首充状态
    local _newFuActiveFlag = PlayerData:checkKaiFuActivityShowFlag() -- 开服活动状态
    local _secondDayStatus = PlayerData:getSecondDaySignStatus() -- 送曹洪状态
    local _activeEntranceState = PlayerData:getActiveEntrance2()
    local _btnScale = 0.9
    local _posX = 0
    print("_activeEntranceState:",_activeEntranceState)

    for i, v in ipairs( self._activityIcon ) do
        local _flag = v.flag
        if _flag == self._acttiveFlag.fisrt_recharge then
            v:setVisible(_fisrtRechargeShowFlag)
        elseif _flag == self._acttiveFlag.new_activity then
            v:setVisible(_newFuActiveFlag)
            v._redDot:setVisible( PlayerData:getRedState(4) == 1 )
        elseif _flag == self._acttiveFlag.seven_day then
            v:setVisible(_sevenDayStatus == 1)
        elseif _flag == self._acttiveFlag.song_caohong then
            v:setVisible(_secondDayStatus ~= 2)
        elseif _flag == self._acttiveFlag.limitTimeHot then
            v:setVisible(_activeEntranceState)
            local jjg = tonumber(PlayerData:getRedState(15))
            local dc = tonumber(PlayerData:getRedState(11))
            print("refreshActivityBtn::",jjg,dc)
            local statusjjg = true
            local statusdc = true
            if not jjg or jjg == false or jjg == 0 then
                statusjjg = false
            end
            if not jjg or jjg == false or jjg == 0 then
                statusdc = false
            end

            if statusdc == false and statusjjg == false then
                v._redDot:setVisible(false)
            else
                v._redDot:setVisible(true)
            end
        end
        if v:isVisible() then
            v:setPositionX( _posX )
            _posX = _posX - 100*_btnScale
        end
    end
end

--创建scollview
function MainCityLayer:createScrollView()
    local _touchedTarget, _isFarm, _isGrab
    local function _runClickAction( target, onlyStop )
        _touchedTarget = target
        if not target then
            return
        end
        if target._scaleAction then
            target:stopAction(target._scaleAction)
        end
        target._scaleAction = nil
        -- target:setScale(1.0)
        if onlyStop then
            target:setScale(0.9)
            target._scaleAction = cc.Sequence:create(
                cc.ScaleTo:create(0.05, 0.9),
                cc.ScaleTo:create(0.05, 1.1),
                cc.ScaleTo:create(0.05, 0.95),
                cc.ScaleTo:create(0.1, 1.0),
                cc.CallFunc:create(function()
                    target._scaleAction = nil
                end)
            )
            target:runAction(target._scaleAction)
        else
            target:setScale(1.0)
            target._scaleAction = cc.Sequence:create(
                cc.ScaleTo:create(0.05, 0.9),
                cc.CallFunc:create(function()
                    target._scaleAction = nil
                end)
            )
            target:runAction(target._scaleAction)
        end
    end
    local function _beganCall( pos )
        _touchedTarget = nil
        _isFarm = false
        _isGrab = false
        local _currentGID = getGuideManager():getCurrentGID()
        if inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_TIEJIANGPU) then
            local _house = self:getHouseByHouseId(11)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_12102 then
            local _house = self:getHouseByHouseId(1)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_12210 then
            local _house = self:getHouseByHouseId(13)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_12704 then
            local _house = self:getHouseByHouseId(8)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_13010 
          or _currentGID == GuideKey.KEY_12803 
          or _currentGID == GuideKey.KEY_14402 then
            local _house = self:getHouseByHouseId(9)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_TONGQUETAI) then
            local _house = self:getHouseByHouseId(10)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_12002 or _currentGID == GuideKey.KEY_12504 then
            local _house = self:getHouseByHouseId(14)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_TIAOZHAN) then
            local _house = self:getHouseByHouseId(15)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_6007 then
            local _house = self:getHouseByHouseId(16)
            if zc.isTouchContainsPoint(_house, pos) then
                _runClickAction(_house)
            end
            return
        elseif _currentGID == GuideKey.KEY_14602 then
            if self._grabBtn and zc.isTouchContainsPoint(self._grabBtn.touchNode, pos) then
                self._grabBtn:setScale(0.9)
                _runClickAction(self._grabBtn)
                _isGrab = true
            end
            return
        elseif not inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_FARM) then
            for k,v in pairs(self.houseList) do
                if zc.isTouchContainsPoint(v, pos) then
                    _runClickAction(v)
                    return
                end
            end
        end
        if zc.isTouchContainsPoint(self._farmBtn.touchNode, pos) then
            self._farmBtn:setScale(0.9)
            _runClickAction(self._farmBtn)
            _isFarm = true
        elseif self._grabBtn and self._grabBtn._house_name_bg:isVisible() and zc.isTouchContainsPoint(self._grabBtn.touchNode, pos) then
            self._grabBtn:setScale(0.9)
            _runClickAction(self._grabBtn)
            _isGrab = true
        end
    end
    local function _endedCall( pos, isClick )
        if _touchedTarget then
            _runClickAction(_touchedTarget, true)
            if isClick then
                if self.scollView then
                    self.scollView:setCanScroll(true)
                end
                if _isFarm then
                    self:createFarm()
                elseif _isGrab then
                    zc.createGrabFoodMain()
                else
                    _touchedTarget:normalTouch()
                end
            end
        end
        _touchedTarget = nil
        _isFarm = false
        _isGrab = false
    end

    if IS_REVIEW_MAINCITY then
        local view = requires("src/layer/mainCity/MyFullScrollLayer.lua"):createOne()
        view:setClickBeganCallFunc(_beganCall)
        view:setClickEndedCallFunc(_endedCall)
        self:addChild(view)
        local pLay = cc.Node:create()
        pLay:setContentSize(cc.size(zc.width, zc.height))
        view:addBackLay(pLay, 1)

        local _bg = zc.createSprite("res/Main/home/tmp/bg.jpg")
        _bg:setPosition(zc.width*0.5, zc.height*0.5)
        pLay:addChild(_bg)

        local _info = {
            {
                x = 890, 
                y = 346,
                houseId = 12,
                pedestalId = 9,
            },
            {
                x = 710, 
                y = 193,
                houseId = 13,
                pedestalId = 10,
            },
            {
                x = 375, 
                y = 289,
                houseId = 16,
                pedestalId = 21,
            },
            {
                x = 570, 
                y = 340,
                houseId = 15,
                pedestalId = 20,
            },
            {
                x = 575, 
                y = 522,
                houseId = 4,
                pedestalId = 4,
            },
            {
                x = 194, 
                y = 183,
                houseId = 14,
                pedestalId = 11,
            },
            {
                x = 520, 
                y = 187,
                houseId = 9,
                pedestalId = 6,
            },
            {
                x = 690, 
                y = 449,
                houseId = 11,
                pedestalId = 8,
            },
            {
                x = 72, 
                y = 435,
                houseId = 8,
                pedestalId = 5,
            },
            {
                x = 375, 
                y = 485,
                houseId = 1,
                pedestalId = 1,
            },
            {
                x = 855, 
                y = 215,
                isFarm = true,
            },
        }

        local _spTable = {}
        for k,v in pairs(_info) do
            local _sp
            if v.isFarm then
                _sp = zc.getSprite({
                    src = "res/Main/home/tmp/farm.png",
                })
                local _nameBar = zc.getSprite({
                    src = "house_nameFarm.png",
                    plist = true,
                    pos = cc.p(25, _sp:getContentSize().height*0.5 + 50),
                })
                _sp:addChild(_nameBar, 3)
                _sp._house_name_bg = _nameBar
                self._farmBtn = _sp
                local _touchNode = cc.Node:create()
                _touchNode:setContentSize(_sp:getContentSize().width, _sp:getContentSize().height + 30)
                _sp:addChild(_touchNode)
                self._farmBtn.touchNode = _touchNode
            else
                v.par = self
                _sp = requires("src/layer/mainCity/HouseSpriteBase.lua"):create(v)
                table.insert(self.houseList, _sp)
                local _houseData = PlayerData:getHouseInfoByHouseId(v.houseId)
                if _houseData then
                    _sp:setHousesData(_houseData)
                end
            end
            table.insert(_spTable, _sp)
            _sp:setPosition(v.x, v.y)
        end
        
        table.sort(_spTable, function( a, b )
            return a:getPositionY() > b:getPositionY()
        end)
        for i=1, #_spTable do
            pLay:addChild(_spTable[i])
        end
    else
        local _datasInfo = requires("src/layer/mainCity/MainCityDatas.lua")
        local _widhts = _datasInfo.layBase.width
        local _normalWith = _datasInfo.layBase.normalWith
        local _totleWith = _normalWith
        local _totleHeight = 852
        local _idx = 1
        local _bounce = _datasInfo.layBase.bounce

        local view = requires("src/layer/mainCity/MyFullScrollLayer.lua"):createOne()
        view:setBounce(_bounce)
        view:setScrollAutoScale(3)
        self.scollView = view
        self:addChild(view)
        view:setClickBeganCallFunc(_beganCall)
        view:setClickEndedCallFunc(_endedCall)
        local _infos = _datasInfo.infos

        local _backLayData = {}
        for i=1, 6 do
            _totleWith = _widhts[i]
            local pLay = cc.Node:create()
            pLay:setContentSize(cc.size(_totleWith, _totleHeight))
            view:addBackLay(pLay, _idx)
            local _partW = _totleWith - _normalWith -- (i-1)*_part
            local _info = _infos[i]
            local pLenth = #_info
            local pDatas = {id = i}
            pDatas.data = {}
            for j=#_info, 1, -1 do
                local _data = _info[j]
                _data.plist = _data.plist == nil and true or _data.plist
                local _sp
                local _pos = cc.p(_data.x + _partW*0.5, _totleHeight -_data.y)
                if _data.isFarm or _data.isGrab then
                    _sp = zc.getSprite({
                        src = _data.src,
                        plist = _data.plist,
                    })
                    local _num = #pDatas.data + 1
                    _sp:setName("back_" .. _num)
                    pDatas.data[_num] = {
                        src = _data.src,
                        plist = _data.plist,
                        pos = _pos
                    }
                    local _nameBar = zc.getSprite({
                        src = _data.isFarm and "house_nameFarm.png" or "house_nameGrab.png",
                        plist = true,
                        pos = cc.p(25, _sp:getContentSize().height*0.5 + 50),
                    })
                    _sp:addChild(_nameBar, 3)
                    _sp._house_name_bg = _nameBar
                    local _touchNode = cc.Node:create()
                    _touchNode:setContentSize(_sp:getContentSize().width, _sp:getContentSize().height + 30)
                    _sp:addChild(_touchNode)

                    if _data.isFarm then
                        self._farmBtn = _sp
                        self._farmBtn.touchNode = _touchNode
                    else
                        self._grabBtn = _sp
                        self._grabBtn.touchNode = _touchNode
                        if not zc.getFunctionStatus(46, false) then
                            self._grabBtn._house_name_bg:setVisible(false)
                        end
                        _nameBar:setPositionX(75)
                    end
                elseif _data.houseId then
                    _data.par = self
                    _sp = requires("src/layer/mainCity/HouseSpriteBase.lua"):create(_data)
                    table.insert(self.houseList, _sp)
                    local _houseData = PlayerData:getHouseInfoByHouseId(_data.houseId)
                    if _houseData then
                        _sp:setHousesData(_houseData)
                    end
                elseif _data.actionName then
                    _sp = zc.createSpine({
                        fileName = _data.src,
                        actName = _data.actionName,
                    })
                else
                    _sp = zc.getSprite({
                        src = _data.src,
                        plist = _data.plist,
                    })
                    local _num = #pDatas.data + 1
                    _sp:setName("back_" .. _num)
                    pDatas.data[_num] = {
                        src = _data.src,
                        plist = _data.plist,
                        pos = _pos
                    }
                end
                _sp:setPosition(_pos)
                pLay:addChild(_sp)
            end
            _backLayData[#_backLayData + 1] = pDatas
            _idx = _idx + 1
            if i == 1 then
                local _armture = zc.createAnimationArmature({
                    fileName = "zcgy_taiyangguang",
                    loop = false,
                    actName = "zcgy_suoxiao",
                })
                _armture:setVisible(false)
                _armture:setPosition(1470, 725)
                pLay:addChild(_armture, 1)
                view._lightEff = _armture

                local particle = cc.ParticleSystemQuad:create("res/Main/home/zhuchengluohua.plist")
                particle:setPosition(120, _totleHeight -147)
                pLay:addChild(particle, 1)
            elseif i == 2 then
                view:setBirdsInfo(_datasInfo.birdsInfo, pLay)
            end
        end
        view:setBackLayData(_backLayData, "res/Main/home/homeBg.pvr.ccz", "res/Main/home/homeBg.plist")
    end
    table.sort(self.houseList, function( a, b )
        return a:getPositionY() < b:getPositionY()
    end)
end

function MainCityLayer:getHouseByHouseId(id)
    local function _do( tb )
        for k, v in pairs(tb) do
            if v:getHouseId() == id then
                return v
            end
        end
    end
    local _house = _do(self.houseList)
    if not _house then
        if self._farm and self._farm:isFarmShow() then
            _house = _do(self._farm.houseList)
        end
    end
    return _house
end

--建设建筑物
function MainCityLayer:addNewBuilding( houseData )
    local _pedestalId = tonumber(houseData.pedestalId)
    local function _do( tb )
        local _flag = false
        for k, v in pairs(tb) do
            if v:getPedestalId() == _pedestalId then
                local _tag = tonumber(houseData.houseId)
                if _tag == 6 or _tag == 7 then
                    _tag = _pedestalId
                elseif _tag == 13 then
                    _tag = 16
                end
                v:setHousesData(houseData)
                -- 商店气泡
                if _tag == 12 then
                    -- 建造商店
                    PlayerData._shopCanDoTime[1] = 0
                    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 12}})
                end
                if _tag == 13 then
                    -- 建造演武榜
                    PlayerData._shopCanDoTime[2] = 0
                    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 12}})
                end
                _flag = true
                break
            end
        end
        return _flag
    end
    if _do(self.houseList) then
        return
    end
    if self._farm and self._farm:isFarmShow() then
        _do(self._farm.houseList)
    end
end

--建筑移动位置计算
function MainCityLayer:moveHouseInMyVision(houseData, noAnimation, callback)
    if houseData.getHouseId then
        local _houseId = houseData:getHouseId()
        if _houseId == 0 or houseData:isResourcesBuild() then
            self:createFarm()
            if callback then
                callback()
            end
            return
        end
    end
    if not self.scollView then
        if callback then
            callback()
        end
        return
    end

    local pos1 = cc.p(houseData:getPosition())
    local pos2 = cc.p(self.scollView:getTopLay():getPosition())
        
    local dis = zc.width*0.5 - (pos1.x + pos2.x) 
    local pTime = (noAnimation == true) and 0 or 0.3
    self.scollView:setAutoMove(pTime, dis, callback, true)
end


--将建筑拉到视野内-flag true 为建造 false 为升级
function MainCityLayer:showHouseInMyVision(houseId, flag, isGuide)
    local _isGuide = isGuide == nil and false or isGuide 
    
    local topInfo = LayerManager.getTopInfoLayer()
    if _isGuide and topInfo then
        self._maskLayer_10 = getGuideManager():getMaskLayer()
        topInfo:addChild(self._maskLayer_10, 1000)
    end

    local _houseId = tonumber(houseId) or 0
    local houseData = nil
    local function _do( tb )
        for k,v in pairs(tb) do
            if _houseId == v:getHouseId() then
                if houseData then
                    if v._houseData and houseData._houseData.level < v._houseData.level then
                        houseData = v
                    end
                else
                    houseData = v
                end
                if not _isGuide then
                    break
                end
            end
        end
    end
    if _houseId == 6 or _houseId == 7 then
        self:createFarm()
        _do(self._farm.houseList)
    else
        self:removeFarm()
        _do(self.houseList)
    end
    if _houseId ~= 6 and _houseId ~= 7 then
        flag = false
    end

    if houseData and not flag then
        if not _isGuide then
            zc.showEntityTouchPop()
        end
        local function _callBack()
            if self._maskLayer_10 then
                self._maskLayer_10:removeFromParent()
                self._maskLayer_10 = nil
            end
            if houseData:judgeResourcesGain() then
                houseData:gainResource()
            end
            if _isGuide then
                local function _doNormalGuide()
                    local _currentGID = getGuideManager():getCurrentGID()
                    print("阿西吧".._currentGID)
                    if inArray(_currentGID, GuideGroup.CHOOSE_JIANZHU) then
                        -- if _currentGID == GuideKey.KEY_14903 then
                        --     print("GuideKey.KEY_14903 ")
                        --     getGuideManager():setTouchOffSet(ccp(0, 200))
                        -- end
                        getGuideManager():setObjTarget(houseData)
                        getGuideManager():startGuide()
                    elseif _currentGID == GuideKey.KEY_15103 then
                        zc.setGuideFuncNextStep(_currentGID)
                        getGuideManager():setObjTarget(houseData)
                        getGuideManager():startGuide()
                    end

                end
                if not self._funcOpenFlag then
                    _doNormalGuide()
                    return
                end

                self:doFuncGuideOpen(houseData, _doNormalGuide)
            else
                zc.showEntityTouchPop(houseData)
                if _houseId == 6 or _houseId == 7 then
                    houseData:addGuideShou()
                end
            end
        end
        if _isGuide and self.scollView then
            self.scollView:setCanScroll(false)
        end
        self:moveHouseInMyVision(houseData, _isGuide, _callBack)
        return
    end

    if _houseId == 6 or _houseId == 7 then
        if self._farm and self._farm:isFarmShow() then
            for k,v in pairs(self._farm.houseList) do
                if v:getHouseId() == 0 then
                    self:showChooseHouse_guide(v)
                    if not _isGuide then
                        v:addGuideShou()
                    end
                    break 
                end
            end
        end
    end

    --移除屏蔽
    if _isGuide and self._maskLayer_10 then
        self._maskLayer_10:removeFromParent()
        self._maskLayer_10 = nil
    end
end

--新手引导--显示当前底座可建设建筑
function MainCityLayer:showChooseHouse_guide( build )
    getGuideManager():addMaskLayer()
    local function _callback()
        getGuideManager():removeMaskLayer()
        local _currentGID = getGuideManager():getCurrentGID()
        if inArray(_currentGID, GuideGroup.CHOOSE_JIANZHU) then
            getGuideManager():setObjTarget(build)
            getGuideManager():startGuide()
        end
    end
    build:showButtonAction(0, nil, _callback)     
end

function MainCityLayer:createHammerButton()
    local _hammerNode = cc.Node:create()
    _hammerNode:setPosition(0, zc.height - 140)
    self:addChild(_hammerNode, self._uiZorder)
    self._hammerNode = _hammerNode
    local function _hammerShowHousePanel( checkID )
        local _checkID = tonumber(checkID) or 0
        if _checkID == 0 then
            return
        end
        local _house
        local function _do( tb )
            zc.showEntityTouchPop()
            for k,v in pairs(tb) do
                if v._houseData and _checkID == tonumber(v._houseData.id) then
                    _house = v
                end
            end
        end
        _do(self.houseList)
        if not _house and self._farm then
            _do(self._farm.houseList)
            if _house then
                self:createFarm()
            end
        end
        
        if _house then
            self:moveHouseInMyVision(_house, nil, function()
                zc.showEntityTouchPop(_house)
            end)
        end
    end

    local _hammer1 = zc.createPushButton({
        normalFile = "hammerTimeDi.png",
        plist = true,
        pos = cc.p(85, -25),
        endCallback = function()
            local _curBuildingInfo = PlayerData:getCurBuildingInfo()
            if not _curBuildingInfo then
                return
            end
            _hammerShowHousePanel(_curBuildingInfo.commonAssociateId)
        end
    })
    self._hammer1 = _hammer1
    _hammerNode:addChild(_hammer1)

    --加载动画
    local arm1 = zc.getSpine("hammer", 0.45)
    arm1:setPosition(35, 16)
    _hammer1:addChild(arm1)
    _hammer1._ani = arm1
    arm1:playAction("idle", true )

    local _label = zc.createLabel({
        text = "",
        fontSize = 18,
        outLine = true,
        pos = cc.p(95, _hammer1:getContentSize().height*0.5),
    })
    _hammer1._label = _label
    _hammer1:addChild(_label)

    local _hammer2 = zc.createPushButton({
        normalFile = "hammerTimeDi.png",
        plist = true,
        pos = cc.p(85, -75),
        endCallback = function()
            local _curBuildingInfo = PlayerData:getCurBuildingInfo()
            if not _curBuildingInfo then
                return
            end
            local _payEffectEndTime = tonumber(_curBuildingInfo.payEffectEndTime) or 0
            if _payEffectEndTime - PlayerData:getTime() > 0 then
                local _payAssociateId = tonumber(_curBuildingInfo.payAssociateId) or 0
                local _time = tonumber(_curBuildingInfo.payEffectEndTime) - PlayerData:getTime()
                if _payAssociateId ~= 0 and _time > 0 then
                    _hammerShowHousePanel(_payAssociateId)
                else
                    local _str_time = zc.timeToClock(_time, false)
                    if self._overplus_img then
                        self._overplusTimeLabel:setText(_str_time)
                    else
                        self._overplus_img = zc.createSprite("res/Main/multyCopy/talkBar.png")
                        self._overplus_img:setPosition(240, zc.height - 220)
                        self:addChild(self._overplus_img, self._uiZorder)
                        self._overplus_img:setScaleY(0.8)
                        self._overplus_img:setScaleX(-0.8)
                        self._overplus_img:setRotation(-11)
                        local _titleLabel = zc.createLabel({
                            text = zc.lang("overplus_time"),
                            fontSize = 22,
                            ap = cc.p(0.5,0.5),
                            pos = cc.p(106, 70),
                            stroke = true,
                        })
                        _titleLabel:setScaleX(-1)
                        _titleLabel:setRotation(-11)
                        self._overplus_img:addChild(_titleLabel)
                        --时间
                        self._overplusTimeLabel = zc.createLabel({
                            text = _str_time,
                            fontSize = 22,
                            ap = cc.p(0.5, 0.5),
                            pos = cc.p(104, 45),
                            stroke = true,
                            color = display.COLOR_RED,
                        })
                        self._overplusTimeLabel:setScaleX(-1)
                        self._overplusTimeLabel:setRotation(-11)
                        self._overplus_img:addChild(self._overplusTimeLabel)
                    end
                    if self._overplus_img._action then
                        self._overplus_img:stopAction(self._overplus_img._action)
                    end
                    self._overplus_img._action = performWithDelay(self._overplus_img,function ()
                        if self._overplus_img then
                            self._overplus_img:removeFromParent()
                            self._overplus_img = nil
                        end
                    end,3)
                end
            else
                zc.createBuyPop({
                    tip = zc.lang("tips_buy_payqueue"),
                    special = {
                        {begin = 7, length = 5}
                    },
                    consume = {
                        {type = 1, num = 250}
                    },
                    clickHide = true,
                    callback = function()
                        zc.sendHttp({
                            apiName = "House_buyQueue", 
                            successCallback = function(data) 
                                PlayerData:setPayEffectEndTime(data.effectEndTime)
                                PlayerData:updataData(data)
                                self:updateHammer()
                            end,
                        })
                    end
                })
            end
        end,
    })
    self._hammer2 = _hammer2
    _hammerNode:addChild(_hammer2)

    local arm2 = zc.getSpine("hammer", 0.45)
    arm2:setPosition(35, 16)
    _hammer2:addChild(arm2)
    _hammer2._ani = arm2

    local _label = zc.createLabel({
        text = "",
        fontSize = 18,
        outLine = true,
        pos = cc.p(95, _hammer2:getContentSize().height*0.5),
    })
    _hammer2._label = _label
    _hammer2:addChild(_label)

    self:updateHammer()
end

--公共的锤子清理初始化创建处理
function MainCityLayer:_cleanHammer( hammer, idx)
    if tolua.isnull(hammer) then
        return
    end

    local _ani = hammer._ani
    if idx == 1 then
        if hammer._status == 1 then
            return
        end
        hammer._label:setString(zc.lang("leisure"))
        hammer._label:setColor(display.COLOR_GREEN)
        hammer._status = 1
        _ani:playAction("stop", true)
    else
        local _curBuildingInfo = PlayerData:getCurBuildingInfo()
        if _curBuildingInfo and (tonumber(_curBuildingInfo.payEffectEndTime) - PlayerData:getTime() > 0) then
            if hammer._status == 1 then
                return
            end
            hammer._label:setString(zc.lang("leisure"))
            hammer._label:setColor(display.COLOR_GREEN)
            hammer._status = 1
            _ani:playAction("stop_1", true)
        else
            if hammer._status == 2 then
                return
            end
            hammer._label:setString(zc.lang("canbuy"))
            hammer._label:setColor(display.COLOR_GREEN)
            hammer._status = 2
            _ani:playAction("idle", true)
        end
    end
end

--公共的锤子计时初始化创建处理
function MainCityLayer:_createLabel(hammer, idx)
    if tolua.isnull(hammer) then
        return
    end
    if hammer._status == 3 then
        return
    end
    hammer._label:setColor(display.COLOR_RED)
    hammer._status = 3
    local _ani = hammer._ani
    if idx == 1 then
        _ani:playAction("start", true)
    else
        _ani:playAction("start_1", true)
    end
end

 --更新锤子计时
function MainCityLayer:updateHammer()
    local _curBuildingInfo = PlayerData:getCurBuildingInfo()
    if not _curBuildingInfo then
        self:_cleanHammer(self._hammer1, 1)
        self:_cleanHammer(self._hammer2, 2)
    end

    -----免费的锤子的计时处理
    if _curBuildingInfo.commonAssociateId ~= 0 then
        local function _updateHam1()
            local _time = tonumber(_curBuildingInfo.commonCdEndTime) - PlayerData:getTime()
            if _time > 0 then
                self:_createLabel(self._hammer1, 1)
                local _strTime = zc.timeToClock(_time, false)
                self._hammer1._label:setText(_strTime)
            else
                _curBuildingInfo.commonAssociateId = 0
                self:_cleanHammer(self._hammer1, 1)
            end
        end
        _updateHam1()
    else
        self:_cleanHammer(self._hammer1, 1)
    end
   
    -----购买的锤子的计时处理
    if _curBuildingInfo.payAssociateId ~= 0 then
        local function _updateHam2()
            local _time = tonumber(_curBuildingInfo.payCdEndTime) - PlayerData:getTime()
            if _time > 0 then
                self:_createLabel(self._hammer2, 2)
                local _strTime = zc.timeToClock(_time, false)
                self._hammer2._label:setText(_strTime)
            else
                _curBuildingInfo.payAssociateId = 0
                self:_cleanHammer(self._hammer2, 2)
            end
        end    
        _updateHam2()
    else
        self:_cleanHammer(self._hammer2, 2)
    end

    if self._hammer2._action2 then
        self._hammer2:stopAction(self._hammer2._action2)
        self._hammer2._action2 = nil
    end
    -----购买的锤子如果到期了就重新刷新下
    local _time = tonumber(_curBuildingInfo.payEffectEndTime) - PlayerData:getTime()
    if _time > 0 then
        self._hammer2._action2 = performWithDelay(self._hammer2, function()
            self:updateHammer()
        end, _time)
    end
end

function MainCityLayer:updateHammerTime(strTime, percent, tag)
    local _hammer = tag == 1 and self._hammer1 or self._hammer2

    if percent < 100 then
        self:_createLabel(_hammer, tag)
        _hammer._label:setText(strTime)
    else
        self:_cleanHammer(_hammer, tag)
    end

end

--好友和邮件按钮
function MainCityLayer:createFriendAndMailButton()
    --显示聊天
    _chatLayer = requires("src/layer/chat/ChatLeadTipsPop.lua").create(panel)
    _chatLayer:setPosition(0, 5)
    self:addChild(_chatLayer, self._uiZorder)
    self.chatLayer = _chatLayer
    local _chatUpNode = cc.Node:create()
    self._chatUpNode = _chatUpNode
    _chatUpNode:setPosition(0, _chatLayer:getContentSize().height)
    _chatLayer:addChild(_chatUpNode)

    local _taskLayer = requires("src/layer/task/TaskTipsPop.lua").create()
    _taskLayer:setPosition(5, _chatLayer:getContentSize().height + 5)
    _chatLayer:addChild(_taskLayer)
    self.taskLayer = _taskLayer

    local _datas = {
        {
            src = "res/Main/common/common_icon_mail.png",
            listener = function()
                zc.createEmailPop()
            end,
        },
        {
            src = "res/Main/common/common_icon_haoyou.png",
            listener = function()
                zc.createFriendScene()
            end,
        },
    }
    local _x = 35
    local _y = 30
    for i=1, #_datas do
        local _data = _datas[i]
        local _btn
        _btn = zc.createPushButton({
            normalFile = _data.src,
            pos = cc.p(_x + (i - 1)*60 , _y),
            scale = 0.9,
            endCallback = _data.listener
        })
        _chatUpNode:addChild(_btn, 1)

        local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
        _redPoint:setVisible(false)
        _btn:addChild(_redPoint)
        _btn._redPoint = _redPoint
        _redPoint:setAnchorPoint(0.5, 0.5)
        _redPoint:setPosition(_btn:getContentSize().width*_btn:getScale(), _btn:getContentSize().height*_btn:getScale())

        if i == 2 then
            self._friendBtn = _btn
        elseif i == 1 then
            self._mailBtn = _btn
        end
    end
end


--更新聊天内容
function MainCityLayer:updateChatPanelView(panel)
    if self.chatLayer then
        self.chatLayer:updateTableView()
    end
end


function MainCityLayer:removeFarm()
    if not self._farm then
        return
    end
    self._farm:setFarmShow(false)
    self._activityNode:setVisible(true)
    -- self._farm:removeFromParent()
    -- self._farm = nil
end

function MainCityLayer:createFarm()
    if not self._farm then
        self._farm = requires("src/layer/mainCity/MainFarmLayer.lua"):create(self)
        self:addChild(self._farm, 1)
        self._farm:setFarmShow(false)
        return
    end
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_FARM) then
        zc.setGuideFuncNextStep(_currentGID, false)
    end
    self._farm:setFarmShow(true)
    self._activityNode:setVisible(false)
end

--刷新任务
function MainCityLayer:updateTaskLeadTips(needGet)
    print("wm----updateTaskLeadTips : ", needGet)
    if needGet then
        zc.sendHttp({
            apiName = "Task_taskList", 
            successCallback = function (data) 
                if tolua.isnull(self) then
                    return
                end
                PlayerData:setTaskData(data)
                self.taskLayer:refresh()
                self._bottomButtonLay:freshTaskRed()
            end, 
            isSilent = true,
        })
    else
        self.taskLayer:refresh()
        self._bottomButtonLay:freshTaskRed()
    end
end

--任务开启
function MainCityLayer:checkTaskOpen()
    --功能开放 --任务 id 11
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID ~= GuideKey.KEY_OVER and _currentGID < GuideKey.KEY_6019 then
        self.taskLayer:setVisible(false)
        self._chatUpNode:setPositionY(self.chatLayer:getContentSize().height + 0)
    else
        local _flag = self.taskLayer:isVisible()
        self.taskLayer:setVisible(true)
        self._chatUpNode:setPositionY(self.chatLayer:getContentSize().height + 50)
        if not _flag then
            local _eff = zc.createSpine({
                fileName = "renwutexiao",
                actName = "renwutexiao",
                loop = false,
                autoRemove = true,
            })
            _eff:setPosition(self.taskLayer:getContentSize().width*0.5, self.taskLayer:getContentSize().height*0.5)
            self.taskLayer:addChild(_eff, 5)
        end
    end
    -- 判断封测充值是否已经开启
    for k,v in pairs(PlayerData:getActivityInfo()) do
        if tonumber(v.activeId) == 33 then
            self._isOpenFengce = true
            break
        end
    end
end


--[[
    0 Bubble_fight 切磋次数
    1 Bubble_challange 演武榜被打次数
    Bubble_worldBoss 世界boss开启气泡提示
    Bubble_help 押镖帮助
    Bubble_dart 押镖开始
    Bubble_gainResource 资源收集处理气泡
]]
function MainCityLayer:addBubble( data )
    -- dump(data, "-----------dump--------ad-------------" )
    local _data = data or {}
    local _tag = _data.sType or ""
    local _bubble = self:getBubble(_tag)
    if not _bubble then
        print("_tag : ", _tag)
        if _tag == "Bubble_worldBoss"
          or _tag == "Bubble_help"
          or _tag == "Bubble_dart"
          or _tag == "Bubble_invite_occupy"
          or _tag == "Bubble_invite_fight"
          or _tag == "Bubble_mine_wasChallenged" then
            local _flag = zc.getFunctionStatus(24)
            if not _flag then
                return
            end
            -- 没有国家
            if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == "" then 
                return 
            end
        end
        cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
        -- local _src = _tag == "Bubble_gainResource" and "Bubble_dart" or _tag
        local _imgTag = _tag
        if _tag == "Bubble_invite_occupy" or _tag == "Bubble_invite_fight" or _tag == "Bubble_mine_wasChallenged" then
            _imgTag = "Bubble_kuang"
        end
        _bubble = zc.createPushButton({
            normalFile = "main" .. _imgTag .. ".png",
            plist = true,
            pos = cc.p(-200, 200),
            btnEff = zc.effect.btnBubble,
            endCallback = function()
                if _tag == "Bubble_fight" then
                    zc.sendHttp({
                        apiName = "Mail_dealWithBubble",
                        params = {type=6},
                        successCallback = function( backData )
                            local _bubble = PlayerData:getMainBubble()
                            _bubble["1"] = 0
                            PlayerData:setMainBubble(_bubble)
                            local _datas = backData.mails
                            -- dump(_datas, "wm---Bubble_fight : ")
                            local _totle = table.nums(_datas)
                            if _totle > 0 then
                                local _nowIdx = 1
                                local _msg = _datas[_nowIdx].content
                                local _timeDate =  zc.timeToDate(_datas[_nowIdx].time)
                                local tipPop 
                                if tonumber(_timeDate.min) < 10 then
                                    _timeDate.min = "0" .. _timeDate.min
                                end
                                if tonumber(_timeDate.sec) < 10 then
                                    _timeDate.sec = "0" .. _timeDate.sec
                                end
                                local timeLabel = zc.createLabel({
                                    text = _timeDate.year..".".._timeDate.month..".".._timeDate.day .. "\t" .. _timeDate.hour .. ":" .. _timeDate.min .. ":" .. _timeDate.sec,
                                    outLine = true,
                                    fontSize = 18,
                                    ap = cc.p(1, 0),
                                    shadowSize = cc.size(1, -1),
                                })
                                tipPop = ZCConfirmDialog:createWithParams({
                                    title = zc.lang("prompt"),
                                    showDi = true,
                                    isHide = false,
                                    msg = _msg,
                                    leftText = zc.lang("see_fightreport"),
                                    rightText = _nowIdx == _totle and zc.lang("close2") or zc.lang("next_tiao"),
                                    leftCallback = function()
                                        local _warKeyParams = _datas[_nowIdx].params or {}
                                        local _warKey = _warKeyParams.warKey
                                        zc.createBattleByWarKey(_warKey)
                                    end,
                                    rightCallback = function()
                                        if _nowIdx < _totle then
                                            _nowIdx = _nowIdx + 1
                                            _msg = _datas[_nowIdx].content
                                            tipPop:setMsg(_msg)
                                            local _timeDate =  zc.timeToDate(_datas[_nowIdx].time)
                                            if tonumber(_timeDate.min) < 10 then
                                                _timeDate.min = "0" .. _timeDate.min
                                            end
                                            if tonumber(_timeDate.sec) < 10 then
                                                _timeDate.sec = "0" .. _timeDate.sec
                                            end
                                            timeLabel:setString(_timeDate.year..".".._timeDate.month..".".._timeDate.day .. "\t" .. _timeDate.hour .. ":" .. _timeDate.min .. ":" .. _timeDate.sec)
                                            if _nowIdx == _totle then
                                                tipPop:getRightButton():setText(zc.lang("close2"))
                                            end
                                        else
                                            tipPop:hide()
                                        end
                                    end
                                })
                                local _tmpBg = tipPop:getMiddleBg()
                                timeLabel:setPosition(_tmpBg:getContentSize().width - 2, 5)
                                _tmpBg:addChild(timeLabel)
                                self:addChild(tipPop, self._uiZorder + 1)
                            end
                            self:removeBubble(_tag)
                        end
                    })
                elseif _tag == "Bubble_challange" then
                    zc.sendHttp({
                        apiName = "Mail_dealWithBubble",
                        params = {type=5},
                        successCallback = function( backData )
                            local _bubble = PlayerData:getMainBubble()
                            _bubble["2"] = 0
                            PlayerData:setMainBubble(_bubble)
                            local _datas = backData.mails
                            local _totle = table.nums(_datas)
                            if _totle > 0 then
                                local tipPop = ZCConfirmDialog:createWithParams({
                                    title = zc.lang("prompt"),
                                    showDi = true,
                                    msg = _datas[_totle].content,
                                    leftText = zc.lang("check_2"),
                                    rightText = zc.lang("close2"),
                                    leftCallback = function()
                                        zc.createArenaRecordPop()
                                    end
                                })
                                self:addChild(tipPop, self._uiZorder + 1)
                            end
                            self:removeBubble(_tag)
                        end
                    })
                elseif _tag == "Bubble_worldBoss" then
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = zc.lang("tips_worldboss_iscoming"),
                        rightText = zc.lang("enter_2"),
                        rightCallback = function()
                            zc.createWorldBossLayer()
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_help" then
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = zc.lang("tips_dart_ask_for_help"),
                        rightText = zc.lang("enter_2"),
                        rightCallback = function()
                            zc.createCountryScene({goToTab=4})
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_dart" then
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = zc.lang("tips_dart_start"),
                        rightText = zc.lang("enter_2"),
                        rightCallback = function()
                            zc.createCountryDartMainLayer()
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_gainResource" then
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = zc.lang("tips_field_resourse_full"),
                        rightText = zc.lang("qianwang_2"),
                        rightCallback = function()
                            self:createFarm()
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_invite_occupy" then
                    local mineInfo = gameData.getDataFromCacheWithPrimaryKey("mine", data._info.id) or {}
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = "“"..data._info.userName.."”" .. zc.lang("invite_to_defend") .. "“"..mineInfo.name.."”" .. zc.lang("denfend_now") .. "？",
                        rightText = zc.lang("jieshou_2"),
                        leftText = zc.lang("jujue_2"),
                        rightCallback = function()
                            zc.jionCountryMineTeam({
                                text={
                                    _tag=1,
                                    _mineId = data._info.mineId,
                                    _id = data._info.id,
                                    _teamId = data._info.teamId,
                                }
                            })
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_invite_fight" then
                    local mineInfo = gameData.getDataFromCacheWithPrimaryKey("mine", data._info.mid) or {}
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = "“"..data._info.userName.."”" .. zc.lang("invite_to_seize") .. "“"..(mineInfo.name or "xxx").."”，" .. zc.lang("add_team") .. "！",
                        rightText = zc.lang("qianwang_2"),
                        leftText = zc.lang("jujue_2"),
                        rightCallback = function()
                            zc.jionCountryMineTeam({
                                text={
                                    _tag=2,
                                    _mineId = data._info.mineId,
                                    _id = data._info.mid,
                                    _teamId = data._info.teamId,
                                }
                            })
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                elseif _tag == "Bubble_mine_wasChallenged" then
                    zc.sendHttp({
                        apiName = "Mail_dealWithBubble",
                        params = {type=7},
                        successCallback = function( backData )
                            local _bubble = PlayerData:getMainBubble()
                            _bubble["3"] = 0
                            PlayerData:setMainBubble(_bubble)
                            local _datas = backData.mails
                            local _totle = table.nums(_datas)
                            if _totle > 0 then
                                local _nowIdx = 1
                                local tipPop
                                local _msg = _datas[_nowIdx].content
                                tipPop = ZCConfirmDialog:createWithParams({
                                    title = zc.lang("prompt"),
                                    showDi = true,
                                    isHide = false,
                                    msg = _msg,
                                    leftText = zc.lang("goto_rightnow"),
                                    rightText = _nowIdx == _totle and zc.lang("close2") or zc.lang("next_tiao"),
                                    leftCallback = function()
                                        tipPop:hide()
                                        zc.createCountryScene({toFun=6})
                                    end,
                                    rightCallback = function()
                                        if _nowIdx < _totle then
                                            _nowIdx = _nowIdx + 1
                                            _msg = _datas[_nowIdx].content
                                            tipPop:setMsg(_msg)
                                            if _nowIdx == _totle then
                                                tipPop:getRightButton():setText(zc.lang("close2"))
                                            end
                                        else
                                            tipPop:hide()
                                        end
                                    end
                                })
                                self:addChild(tipPop, self._uiZorder + 1)

                            end
                            self:removeBubble(_tag)
                        end
                    })
                elseif _tag == "Bubble_gidFight" then
                    local _showMsg = zc.lang("tip_bubble_godfight_canreward")
                    local _bubble = PlayerData:getDataBubble()
                    _bubble["5"] = 0
                    PlayerData:setDataBubble(_bubble)
                    local tipPop = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        showDi = true,
                        msg = _showMsg,
                        rightText = zc.lang("qianwang_2"),
                        rightCallback = function()
                            zc.createGodFightScene()
                        end
                    })
                    self:addChild(tipPop, self._uiZorder + 1)
                    self:removeBubble(_tag)
                end
            end
        })
        _bubble.tag = _tag
        self:addChild(_bubble, self._uiZorder)
        table.insert(self._bubbleList, _bubble)

        self:freshBubbleInfo()
    end
end

function MainCityLayer:removeBubble( tag )
    local _bubble, key = self:getBubble(tag)
    if not _bubble then
        return
    end
    table.remove(self._bubbleList, key)
    _bubble:removeFromParent()
    self:freshBubbleInfo()
end

function MainCityLayer:getBubble( tag )
    for k,v in pairs(self._bubbleList) do
        if v.tag == tag then
            return v, k
        end
    end
    return nil
end

function MainCityLayer:freshBubbleInfo()
    local _currentGID = getGuideManager():getCurrentGID()
    local _falg = _currentGID == GuideKey.KEY_OVER or _currentGID == 1
    local _partX = 90
    local _startX = zc.width*0.5 - (#self._bubbleList - 0.5) * _partX * 0.5
    for i=1, #self._bubbleList do
        local _bubble = self._bubbleList[i]
        if _bubble._fadeAction then
            _bubble:getStateNormal():stopAction(_bubble._fadeAction)
        end
        if _falg then
            _bubble:getStateNormal():setOpacity(255*0.35)
            _bubble._fadeAction = cc.RepeatForever:create(cc.Sequence:create(
                cc.FadeTo:create(1.5, 255),
                cc.DelayTime:create(0.2),
                cc.FadeTo:create(1.5, 255*0.35)
            ))
            _bubble:getStateNormal():runAction(_bubble._fadeAction)
            _bubble:setPositionX(_startX + (i - 1) * _partX)
        else
            _bubble:setVisible(false)
        end
    end
end

-------------------------红点、气泡-----------------------------------

--注册气泡红点事件
function MainCityLayer:addMyEventListener()
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE,
        callback = function(data)
            -- dump(data.data, "---EVENT_REDORBUBBLE_CHANGEEVENT_REDORBUBBLE_CHANGE--")
            if tolua.isnull(self) then
                return
            end
            if not data or not data.data then
                self:checkRedAndBubble()
            else
                local _tag = data.data.tag
                if _tag == "mail" then
                    self:freshMailRed()
                elseif _tag == "friend" then
                    self:freshFriendRed()
                elseif _tag == "task" then
                    self:updateTaskLeadTips()
                elseif _tag == "activity" then
                    self:freshActivityRed(data.data.status)
                elseif _tag == "sevenDay" then
                    self:freshSevenDayRed( data.data.status )
                elseif _tag == "activityShow" then
                    -- 刷新活动按钮显示
                    self:refreshActivityBtn()
                elseif _tag == "house" then
                    local _id = tonumber(data.data.id) or 0
                    if _id ~= 0 then
                        self:freshHouseBubble(_id)
                    end
                elseif _tag == "grabFood" then
                    if not self._grabBtn or not self._grabBtn._house_name_bg:isVisible() then
                        return
                    end
                    local _data = tonumber(data.data.bubbleData) or 0
                    local function _createBubble( actName )
                        local _btn = self._grabBtn._spBubble 
                        if _btn then
                            if _btn.tag ~= actName then
                                _btn.tag = actName
                                _btn._armature:playAction(actName, true)
                            end
                            return
                        end
                        local _size = self._grabBtn:getContentSize()
                        local _pos = cc.p(_size.width*0.5, _size.height + 15)
                        _btn = zc.createPushButton({
                            touchSize = cc.size(100, 40),
                            touchScale = 0.9,
                            scale = 0.8,
                            noScaleAction = true,
                            btnEff = zc.effect.btnBubble,
                            endCallback = function() 
                                zc.createGrabFoodMain()
                            end,
                        })
                        self._grabBtn:addChild(_btn, 3)
                        self._grabBtn._spBubble = _btn
                        --加载动画
                        local _armature = zc.createSpine({
                            fileName = "jianzhuqipao",
                            actName = "_actName",
                        })
                        _armature:setPositionY(-15)
                        _btn:addChild(_armature)
                        _btn._armature = _armature
                        _btn.tag = actName
                        _btn:setPosition(_pos)
                        _btn._armature:playAction(actName, true)
                    end
                    self._grabBtn:stopActionByTag(999)
                    if _data == 0 then
                        if self._grabBtn._spBubble then
                            self._grabBtn._spBubble:removeFromParent()
                            self._grabBtn._spBubble = nil
                        end
                    elseif _data == 1 then
                        _createBubble("ketuntian")
                    else
                        local _time = _data - PlayerData:getTime()
                        if _time <= 0 then
                            _createBubble("keshengji")
                        else
                            performWithDelay(self._grabBtn, function()
                                _createBubble("keshengji")
                            end, _time, 999)
                        end
                    end
                elseif _tag == "bubble" then
                    if data.data then
                        self:addBubble(data.data)
                    end
                elseif _tag == "limitTimeHot" then
                    for i, v in ipairs( self._activityIcon ) do
                        local _flag = v.flag
                        if _flag == self._acttiveFlag.limitTimeHot then
                            v._redDot:setVisible(false)
                        end
                    end
                end
            end
        end
    })
end

--红点气泡
function MainCityLayer:checkRedAndBubble(checkHouse) 
    -- print("----检测红点-----")
    -- 刷新气泡
    if checkHouse then
        for k,v in pairs(self.houseList) do
            v:checkHouseBubble()
        end
    end
    ------刷新红点-----
    --根据具体规则刷新红点
    -- 好友红点
    self:freshFriendRed()
    -- 邮件红点
    self:freshMailRed()
    
    self._bottomButtonLay:checkRedAndBubble()

    self:tempFreshActivitySpeedRed()
end

function MainCityLayer:freshHouseBubble( id )
    for k,v in pairs(self.houseList) do
        if v:getHouseId() == id then
            v:checkHouseBubble()
            break
        end
    end
end

-- 好友红点
function MainCityLayer:freshFriendRed()
    local _friendInfo = PlayerData:getFriendInfo()
    if _friendInfo then
        local _canRed = false
        if #_friendInfo.pendings > 0 then
            _canRed = true
        else 
            local _getNum = PlayerData:getFriendSendEnergyNum()
            if _getNum > 0 then
                _canRed = true
            end
        end
        if _canRed then
            self._friendBtn._redPoint:setVisible(true)
        else
            self._friendBtn._redPoint:setVisible(false)
        end
    else
        self._friendBtn._redPoint:setVisible(false)
    end
end

-- 邮件红点
function MainCityLayer:freshMailRed()
    local _email_num = PlayerData:getUnReadMailNum()
    if _email_num > 0 then
        self._mailBtn._redPoint:setVisible(true)
    else
        self._mailBtn._redPoint:setVisible(false)
    end
end

-- 活动红点
function MainCityLayer:freshActivityRed( _status )

    -- if PlayerData._activityFoodStatus == 2 or PlayerData._activityFoodStatus == 3 then
    --     _status = true
    -- elseif PlayerData._activitySpeedStatus then
    --     _status = true
    -- elseif table.nums(PlayerData.activityReds) > 0 then
    --     _status = true
    -- elseif conditions then
    --     --todo
    -- end
    
    for k,v in pairs(self._activityIcon) do
        if v.flag == self._acttiveFlag.activity then
            v._redDot:setVisible( _status )
            break
        end
    end
end

-- 七日活动红点
function MainCityLayer:freshSevenDayRed( status )
    for k,v in pairs(self._activityIcon) do
        if v.flag == self._acttiveFlag.seven_day then
            v._redDot:setVisible( status )
            break
        end
    end
end

-- 暂时刷新活动红点，领体力只需要请求一次
function MainCityLayer:tempFreshActivityFoodRed()
    PlayerData:setActivityFoodRedDot()
end
-- 暂时刷新活动红点，竞速需要每次刷新
function MainCityLayer:tempFreshActivitySpeedRed( data )
    -- 竞速
    if not PlayerData._activitySpeedStatus then
        PlayerData:setActivitySpeedRedDot()
    end
end

-- 暂时刷新七日活动红点，需要改成后端推送
function MainCityLayer:tempFreshSevenDayRed()
    local _status = PlayerData:getSevenDayStatus()
    if _status ~= 1 then
        return
    end
    zc.sendHttp({
        apiName = "SevenDay_main",
        successCallback = function(data)
            if tolua.isnull(self) then
                return
            end
            -- 今天第几天
            local _today = tonumber( data.time.day ) or 0
            for i, v in ipairs( data.taskList ) do
                local _status = tonumber( v.status ) or 1
                if _status == 2 then
                    local _list = gameData.getDataFromCacheWithPrimaryKey("sevenDay", v.taskId)
                    local _day = tonumber( _list.days ) or 1
                    local _type = tonumber( _list.type ) or 1
                    if _day <= _today and _type ~= 4 then
                        self:freshSevenDayRed( true )
                        return
                    end
                end
            end
        end,
    })
end

----------------新手引导的处理---------------

function MainCityLayer:checkSpBuildGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID ~= 1 
      and _currentGID ~= 13003 
      and _currentGID ~= 13008 
      and _currentGID ~= 13010 
      then
        return
    end
    local _flag = zc.getFunctionStatus(30, false)  --酒馆
    if not _flag then
        return
    end
    local _task = PlayerData:getTaskData()[2] or {}
    for k,v in pairs(_task) do
        if v.taskId == GuideTaskKey and v.status == 2 then
            getGuideManager():setCurrentGID(GuideKey.KEY_13003, true)
            return
        end
    end
    local _flag = PlayerData:getFuncGuideInfo(30)
    if _flag then
        return
    end
    getGuideManager():setCurrentGID(GuideKey.KEY_13010, true)
end

function MainCityLayer:checkShowFuben()
    if not tolua.isnull(self._guideHand) then
        self._guideHand:setVisible(false)
    else
        self._guideHand = nil
    end
    if not getGuideManager():guideIsOver() then
        if self._guideHand then
            self._guideHand:removeFromParent()
            self._guideHand = nil
        end
        return
    end
    local datas = PlayerData:getTaskData()[1] or {}
    for k,v in pairs(datas) do
        if v.taskId == GuideTask33Key then
            return
        end
    end
    if not self._buzhenHandFlag and not self._fubenHandFlag then
        local _data = PlayerData:getCopyInfoByChapterId(2) or {}
        local _inlog = tonumber(_data.inlog) or 0
        if _inlog ~= 0 then 
            if self._guideHand then
                self._guideHand:removeFromParent()
                self._guideHand = nil
            end
            return
        end
    end
    if not self._guideHand then
        self._guideHand = zc.createSpine({
            fileName = "shou",
            actName = "shou",
            scale = 0.8
        })
        local _btn = self._bottomButtonLay._fubenButton
        if self._buzhenHandFlag then
            _btn = self._bottomButtonLay._buzhenButton
        end
        self._guideHand:setPosition(cc.pMul(cc.pFromSize(_btn:getContentSize()), 0.5))
        _btn:addChild(self._guideHand, 10)
    end
    self._guideHand:stopAllActions()
    self._guideHand:setVisible(true)

    if self._fubenHandFlag then
        self._fubenHandFlag = false
        performWithDelay(self._guideHand, function()
            self._guideHand:removeFromParent()
            self._guideHand = nil
        end, 4)
    end
end

function MainCityLayer:setFubenHandFlag()
    self._fubenHandFlag = true
end

function MainCityLayer:setBuzhenHandFlag( flag )
    self._buzhenHandFlag = flag
end

function MainCityLayer:setFuncOpenFlag( funcData )
    self._funcOpenFlag = clone(funcData)
end

function MainCityLayer:doFuncGuideOpen( houseData, callback )
    local _guideFuncData = self._funcOpenFlag
    self._funcOpenFlag = nil
    local _topLay = LayerManager.getTopInfoLayer()
    local _lay = ZCDialog:create(100)
    _topLay:addChild(_lay, 100)
    local _light = zc.getSprite({
        src = "res/image/guide/funcLight.png",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
        -- scale = 0.5,
    })
    _lay:addChild(_light)
    _light:runAction(cc.RepeatForever:create(cc.RotateBy:create(1.5, 360)))
    local tipIcon = self._bottomButtonLay:createBottonBtn({
        src = "res/Main/common/common_icon_".._guideFuncData.icon..".png",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
        text = _guideFuncData.content,
        needAdd = false,
    })
    _lay:addChild(tipIcon)
    local _pos = cc.p(houseData:getPosition())
    _pos = houseData:getParent():convertToWorldSpace(_pos)
    tipIcon:runAction(cc.Sequence:create(
        cc.DelayTime:create(1),
        cc.CallFunc:create(function()
            _light:removeFromParent()
        end),
        cc.EaseOut:create(cc.Spawn:create(
            cc.MoveTo:create(0.5, _pos),
            cc.ScaleTo:create(0.5, 0.1)
        ), 3),
        cc.CallFunc:create(function()
            _lay:removeFromParent()
            if callback then
                callback()
            end
        end)
    ))
end

function MainCityLayer:check3006Guide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID ~= GuideKey.KEY_3006 then
        return true
    end
    local _topLay = LayerManager.getTopInfoLayer()
    _topLay:setVisible(false)
    self._activityNode:setVisible(false)
    self._hammerNode:setVisible(false)
    self._bottomButtonLay:setVisible(false)
    self.chatLayer:setVisible(false)
    self._farmBtn._house_name_bg:setVisible(false)
    if self._grabBtn then
        self._grabBtn._house_name_bg:setVisible(false)
    end
    for k,v in pairs(self.houseList) do
        if v._house_name_bg then
            v._house_name_bg:setVisible(false)
        end
        v:cleanSpBubble()
    end
    return false
end

--处理新开功能的老用户引导处理
function MainCityLayer:checkNewFuncGuide()
    if not getGuideManager():guideIsOver() then
        return
    end
    --只能保留一个，当前是47
    if not zc.getFunctionStatus(47, false) then
        return
    end
    if PlayerData:getFuncGuideInfo(47) then
        return
    end
    getGuideManager():setCurrentGID(GuideKey.KEY_14702)
    self:guideFunc()
    self:freshBubbleInfo()
end

--新手引导处理  showHouseInMyVision true 为建造 false 为升级
function MainCityLayer:guideFunc( stepId )
    local function setGId( id )
        local _id = tonumber(id)
        if not _id then
            return
        end
        getGuideManager():setCurrentGID(_id)
        zc.sendHttp({
            apiName = "User_setGuideSteps",
            params = {step = _id},
            successCallback = function (net_data)
                self._added = true
                self:guideFunc()
            end,
        })
        return true
    end
    if not self._added then
        if setGId(stepId) then
            return
        end
    end

    local topInfo = LayerManager.getTopInfoLayer()
    if topInfo then
        if not tolua.isnull(self._maskLayer_2) then
            self._maskLayer_2:removeFromParent()
            self._maskLayer_2 = nil
        end
        self._maskLayer_2 = getGuideManager():getMaskLayer()
        topInfo:addChild(self._maskLayer_2, 1000)
    end

    local function _getFlagGuide(_currentGID, _id1, _id2, _houseId)
        local _flag = _currentGID == _id1 and true or false
        if _flag then
            local _build = self:getHouseByHouseId(_houseId)
            if _build and _build._houseData then
                _flag = false
                getGuideManager():setCurrentGID(_id2)
            end
        end
        self:showHouseInMyVision(_houseId, _flag, true)
    end

    local _currentGID = getGuideManager():getCurrentGID()
    print("wm---guideFunc : ", _currentGID )
    if _currentGID == GuideKey.KEY_OVER then
        getGuideManager():guideOver()
    elseif _currentGID == GuideKey.KEY_1001 then
    elseif inArray(_currentGID, GuideGroup.BTN_FUBEN) then  --副本
        getGuideManager():setObjTarget(self._bottomButtonLay._fubenButton)
        getGuideManager():startGuide()
    elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_TIEJIANGPU) then
        self:showHouseInMyVision(11, false, true) 
    elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_TONGQUETAI) then
        self:showHouseInMyVision(10, false, true) 
    elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_JIUGUAN) then
        _getFlagGuide(_currentGID, GuideKey.KEY_13008, GuideKey.KEY_13010, 9)
    elseif inArray(_currentGID, GuideGroup.BTN_ROLE) then
        getGuideManager():setObjTarget(self._bottomButtonLay._soliderButton, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_6007 then
        self:showHouseInMyVision(16, false, true) 
    elseif inArray(_currentGID, GuideGroup.HOUSE_CHOOSE_FARM) then
        if self.scollView then 
            self.scollView:setCanScroll(false)
        end
        self:moveHouseInMyVision(self._farmBtn, true, function()
            getGuideManager():setObjTarget(self._farmBtn)
            getGuideManager():startGuide()
        end)
    elseif _currentGID == GuideKey.KEY_14602 then
        if self.scollView then 
            self.scollView:setCanScroll(false)
        end
        if self._grabBtn then
            self._grabBtn._house_name_bg:setVisible(true)
        end
        self:moveHouseInMyVision(self._grabBtn, true, function()
            self._icon:setEnable(false)
            self._bottomButtonLay._fubenButton._btn:setEnable(false)
            getGuideManager():setObjTarget(self._grabBtn, 0.8)
            getGuideManager():startGuide()
        end)
    elseif _currentGID == GuideKey.KEY_6021 then
        local _curTaskList = PlayerData:getTaskData()[1] or {}
        local _taskInfo = _curTaskList[1]
        if not _taskInfo or _taskInfo.status ~= 2 then
            getGuideManager():setCurrentGID(GuideKey.KEY_OVER, true)
        else
            getGuideManager():setObjTarget(self.taskLayer, 0.8)
            getGuideManager():startGuide()
        end
    elseif _currentGID == GuideKey.KEY_12002 then
        self:showHouseInMyVision(14, false, true) 
    elseif _currentGID == GuideKey.KEY_11602
      or _currentGID == GuideKey.KEY_11604 then
        _getFlagGuide(_currentGID, GuideKey.KEY_11602, GuideKey.KEY_11604, 15)
    elseif _currentGID == GuideKey.KEY_11904 then
        self:showHouseInMyVision(15, false, true) 
    elseif _currentGID == GuideKey.KEY_12102 then
        self:showHouseInMyVision(1, false, true) 
    elseif _currentGID == GuideKey.KEY_12210 then
        self:showHouseInMyVision(13, false, true) 
    elseif _currentGID == GuideKey.KEY_14502 then
        self:showHouseInMyVision(13, false, true) 
    elseif _currentGID == GuideKey.KEY_12302 then
        self:showHouseInMyVision(15, false, true) 
    elseif _currentGID == GuideKey.KEY_15003 then --英雄试炼
        self:showHouseInMyVision(15, false, true) 
    elseif _currentGID == GuideKey.KEY_14902 then --打造
        zc.setGuideFuncNextStep(_currentGID)
        self:showHouseInMyVision(11, false, true) 
    elseif _currentGID == GuideKey.KEY_12402 then
        local function _doNormalGuide()
            getGuideManager():setObjTarget(self._bottomButtonLay._countryButton, 0.8)
            getGuideManager():startGuide()
        end
        if self._funcOpenFlag then
            self:doFuncGuideOpen(self._bottomButtonLay._countryButton, _doNormalGuide)
        else
            _doNormalGuide()
        end
    elseif _currentGID == GuideKey.KEY_12502
      or _currentGID == GuideKey.KEY_12504 then
        _getFlagGuide(_currentGID, GuideKey.KEY_12502, GuideKey.KEY_12504, 14)
    elseif _currentGID == GuideKey.KEY_12602 then
        self:showHouseInMyVision(10, false, true) 
    elseif _currentGID == GuideKey.KEY_12702
      or _currentGID == GuideKey.KEY_12704 then
        _getFlagGuide(_currentGID, GuideKey.KEY_12702, GuideKey.KEY_12704, 8)
    elseif _currentGID == GuideKey.KEY_12803 then
        _getFlagGuide(_currentGID, GuideKey.KEY_12803, GuideKey.KEY_12803, 9)
    elseif _currentGID == GuideKey.KEY_14402 then
        _getFlagGuide(_currentGID, GuideKey.KEY_14402, GuideKey.KEY_14402, 9)
    elseif _currentGID == GuideKey.KEY_12815 then
        getGuideManager():setObjTarget(self._bottomButtonLay._taskButton, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12810 then
        getGuideManager():setObjTarget(self._bottomButtonLay._buzhenButton, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_13003 then
        getGuideManager():setObjTarget(self._bottomButtonLay._taskButton, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_13202 then
        self:showHouseInMyVision(15, false, true) 
    elseif _currentGID == GuideKey.KEY_13902 then
        self:showHouseInMyVision(15, false, true) 
    elseif inArray(_currentGID, GuideGroup.DUI_HUA) then
        if _currentGID == GuideKey.KEY_1001
          or _currentGID == GuideKey.KEY_6006
          or _currentGID == GuideKey.KEY_6019
          or _currentGID == GuideKey.KEY_11104
          or _currentGID == GuideKey.KEY_12307
          or _currentGID == GuideKey.KEY_13013
          or _currentGID == GuideKey.KEY_14401
          then
            local function _callBack()
                if _currentGID == GuideKey.KEY_6019 then
                    self:checkTaskOpen()
                    getGuideManager():getMaskLayer(LayerManager.getTopInfoLayer(), 1, function()
                        self:guideFunc()
                    end)
                else
                    self:guideFunc()
                end
            end
            getGuideManager():setHeroFuncCallBack(_callBack)
            getGuideManager():startGuide()
        elseif _currentGID == GuideKey.KEY_3006 then
            local topInfo = LayerManager.getTopInfoLayer()
            local __maskLay = getGuideManager():getMaskLayer()
            topInfo:addChild(__maskLay, 1000)
            performWithDelay(self, function() 
                local function __showStory()
                    __maskLay:removeFromParent()
                    local function _callBack()
                        self:guideFunc()
                    end
                    getGuideManager():setHeroFuncCallBack(_callBack)
                    getGuideManager():startGuide()
                end
                local function _doFadeIn( target, isLast )
                    if not target then
                        return
                    end
                    target:setVisible(true)
                    zc.doFuncForAllChild(target, function(child)
                        child:setOpacity(0)
                        if isLast and child == target then
                            child:runAction(cc.Sequence:create(
                                cc.FadeIn:create(1),
                                cc.DelayTime:create(0.2),
                                cc.CallFunc:create(__showStory)
                            ))
                        else
                            child:runAction(cc.FadeIn:create(1))
                        end
                    end)
                end

                local function _tmeFunc()
                    _doFadeIn(self.chatLayer)
                    _doFadeIn(self._bottomButtonLay)
                    _doFadeIn(self._hammerNode)
                    _doFadeIn(self._activityNode)
                    _doFadeIn(self._farmBtn._house_name_bg)
                    if self._grabBtn and zc.getFunctionStatus(46, false) then
                        _doFadeIn(self._grabBtn._house_name_bg)
                    end
                    for k,v in pairs(self.houseList) do
                        _doFadeIn(v._house_name_bg)
                        v:checkHouseBubble()
                    end
                    local topInfo = LayerManager.getTopInfoLayer()
                    _doFadeIn(topInfo, true)
                end
                if self.scollView then
                    self.scollView:setAutoMove(4.8, -2000, _tmeFunc)
                else
                    _tmeFunc()
                end
            end, 0.2)
            
        end
    elseif _currentGID == GuideKey.KEY_15102 then
        print("======GuideKey.KEY_15103")
        zc.setGuideFuncNextStep(_currentGID)
        self:showHouseInMyVision(11, false, true) 
    end
    if not tolua.isnull(self._maskLayer_2) then
        self._maskLayer_2:removeFromParent()
        self._maskLayer_2 = nil
    end
end

return MainCityLayer