--[[
    FileName: GeneralManualListLayer.lua
    Author: andong
    Date: 2017-01-05
    Purpose: 武将图鉴界面
]]
local GeneralManualListLayer = class( "GeneralManualListLayer", function ()
    local _sp = zc.createSprite()
    _sp:setContentSize(zc.width, 640)
    return _sp
end)
function GeneralManualListLayer:create(parmas)
    return self.new(parmas)
end
-- 2 1 3 4 掉落路径排序
function GeneralManualListLayer:ctor(parmas)
    -- dump(parmas, "GeneralManualListLayer parmas=====")
    self._scrollAnimation = {
        [1] = "qunxiongbingqitujian",
        [2] = "zhanshenmolu",
    }
    self:initData(parmas)
    self:initUI()
    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "cleanup" == event then
            self:onCleanup()
        elseif "exit" == event then
            -- self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function GeneralManualListLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    local static = gameData.getDataFromCache("hero_handbook_info")
    self._data = {}
    self._palceToData = {}
    self._mainIdToData = {}
    self._heroIdToData = {}
    local handbook = parmas.data or 1
    self._handbook = handbook
    for k,v in pairs(static) do
        if v and v.handbook and tonumber(v.handbook) ~= 5 then
            if tonumber(v.handbook) == handbook then
                self._data[#self._data+1] = v
                local _place = tonumber(v.place)
                self._palceToData[_place] = v
                local _mianId = tonumber(v.id)
                self._mainIdToData[_mianId] = v
                local _generalId = tonumber(v.generalid)
                self._heroIdToData[_generalId] = v
            end
        end
    end
    --
    self._parentCloseBtn = parmas.closeBtn
    self._parent = parmas.parent
    --
    if parmas.gotoHeroId then
        self._gotoHeroId = parmas.gotoHeroId
    end
    --
    self:refreshOwnHero()
end
--刷新自己的武将
function GeneralManualListLayer:refreshOwnHero()
    self._mainHeroId = tonumber( PlayerData.info.heroId ) or 0
    local ownHero = PlayerData:getGeneralInfo()

    local ownHeroList = {} --已经有的武将
    for k,v in pairs(ownHero) do
        if tonumber( v.id ) ~= self._mainHeroId then
            local heroId = tonumber(v.heroId)
            ownHeroList[heroId] = v
        end
    end
    self._ownHeroList = ownHeroList
    
end
function GeneralManualListLayer:initUI()
    -- local background = zc.createSprite("res/Main/pub/evaluate_bg.jpg")
    -- background:setPosition(cc.p(zc.width/2, zc.height/2))
    -- self:addChild(background)
    -- zc.setBgSize(background)
    --返回按钮
    -- local backButton = zc.createTopBackButton({
    --     pos = cc.p(zc.width - 60, zc.height - 40), 
    --     listener = function ()
    --         self:removeFromParent()
    --     end,
    -- })
    -- self:addChild(backButton, 100)
    -- self._backButton = backButton
    self._parentCloseBtn:setTouchEndedCall(function()
        self:removeFromParent()
    end)

    local scaleSize = cc.size(zc.width, 576)
    local _bgImg = zc.getScaleNode("res/Main/common/popBg/bg2.jpg", scaleSize)
    -- local _bgImg = zc.createSprite()
    -- _bgImg:setContentSize( scaleSize )
    _bgImg:setAnchorPoint( 0.5, 0.5 )
    _bgImg:setPosition( zc.width/2,  scaleSize.height/2 )
    self:addChild(_bgImg)

    local frameSize = cc.size(scaleSize.width+30, scaleSize.height+20)
    local frame = zc.getScaleNode("res/Main/common/frame.png", frameSize)
    frame:setAnchorPoint(0.5, 0.5)
    frame:setPosition(scaleSize.width/2, scaleSize.height/2 -2 )
    _bgImg:addChild(frame)
    -- frame:setFlippedY(true)

    -- 卷轴
    -- local fileName = self._scrollAnimation[self._handbook]
    -- if not fileName then
    --     fileName = "qunxiongbingqitujian"
    -- end
    -- local _armature = zc.createSpine({
    --     fileName = fileName,
    --     actName = "stop2",
    --     loop = true,
    --     needInit = false,
    -- })
    -- _armature:setAnchorPoint(0.5,0.5)
    -- _armature:setPosition(100-45, _bgImg:getPositionY() )
    -- self:addChild(_armature, 1)
    -- _armature:setScaleY(620/493)

    local scrollImg = zc.createSprite("res/Main/pub/manual/scroll_img_"..self._handbook..".png")
    scrollImg:setAnchorPoint(0, 0.5)
    scrollImg:setPosition(0, scaleSize.height/2 + 8 ) 
    _bgImg:addChild(scrollImg, 1)

    local scrollName = zc.createSprite("res/Main/pub/manual/scroll_name_"..self._handbook..".png")
    scrollName:setAnchorPoint(0.5, 0.5)
    scrollName:setPosition(50, 574)
    scrollImg:addChild(scrollName)

    local scrollSize = cc.size(scaleSize.width - 140, scaleSize.height)
    local dropScrollView = zc.createScrollview({
        size = scrollSize,
        innerSize = scrollSize,
        dir = ccui.ScrollViewDir.vertical,
        bar = false,
        bounceEnable = false,
    })
    _bgImg:addChild(dropScrollView)
    -- dropScrollView:ignoreAnchorPointForPosition(false)
    -- dropScrollView:setAnchorPoint(0.5, 0)
    dropScrollView:setPosition(140,0)
    self._dropScrollView = dropScrollView

    local posYList = {}
    for i = 1, 4 do
        posYList[i] = scrollSize.height - 74 - (i-1)* 143
        local cell_itemSize = cc.size(998, 140)
        local cell_itemBg = zc.getScaleNode("res/Main/pub/manual/cell_itemBg.png", cell_itemSize)
        cell_itemBg:setAnchorPoint( 0.5, 0.5 )
        cell_itemBg:setPosition(scrollSize.width/2, posYList[i])
        dropScrollView:addChild(cell_itemBg)
    end

    self._generalSpriteList = {}

    self._consumeNumLabs = {}
    local exchangeInfoList = gameData.getDataFromCache( "hero_change_card" ) or {}
    for i = 1, 16 do
        local posX = 120 + (math.floor((i-1)/4))*250
        local modI = (i-(math.floor((i-1)/4))*4 )%5
        local posY = posYList[modI]

        if i > 4 then
            --如果左或者右 有
            local _showLine = false
            if self._palceToData[i] or self._palceToData[i-4] then
                _showLine = true
            end
            if _showLine then
                local fengei = zc.createSprite("res/Main/pub/manual/fengei.png")
                fengei:setAnchorPoint(0.5, 0.5)
                fengei:setPosition(posX-125, posY)
                dropScrollView:addChild(fengei)
            end
        end
        if self._palceToData[i] then
            -- local modI = i <= 4 and (i-1) or ((i-1)%4)
            -- local posX = 111 + modI*250
            -- local posY = scaleSize.height-68-152*( math.floor((i-1)/4) )
            local generaldata = self._palceToData[i] or {}
            local generalInfo = gameData.getDataFromCacheWithPrimaryKey("hero",  generaldata.generalid) or {}
            generaldata.generalInfo = generalInfo
            if generalInfo and generalInfo.picture then
                local qualifications = generalInfo.qualifications
                if self._ownHeroList[tonumber(generaldata.generalInfo.id)] then 
                    local ownHeroInfo = self._ownHeroList[tonumber(generaldata.generalInfo.id)] or {}
                    qualifications = ownHeroInfo["newAdvance"] or 0
                end
                local mySprite = zc.createHeroListShow({
                    quality = qualifications,
                    -- iconId = generalInfo.picture,
                    heroId = generalInfo.picture,
                    size = cc.size(243*0.9, 137*0.9),
                    scaleX = 0.9,
                    scaleY = 0.9,
                    heroSide = 0.5,
                    -- heroSide = 0.5,
                    -- size = cc.size(243, 0),
                    -- heroSpScaleX = 1,
                    -- heroSpScaleY = 1,
                    showSide = false,
                })
                mySprite:setPosition(posX, posY)
                dropScrollView:addChild(mySprite)

                self._generalSpriteList[tonumber(generalInfo.id)] = {}
                self._generalSpriteList[tonumber(generalInfo.id)]._mySprite = mySprite
                self._generalSpriteList[tonumber(generalInfo.id)]._info = generaldata
                self._generalSpriteList[tonumber(generalInfo.id)]._pos = cc.p(posX, posY)

                local mySpriteSize = mySprite:getContentSize()
                -- local nameBg = zc.getScaleNode("res/Main/pub/manual/sp_nameBg.png", cc.size(80, 33))
                -- nameBg:setAnchorPoint(0, 0.5)
                -- nameBg:setPosition(mySpriteSize.width-87.5, mySpriteSize.height-27)
                -- mySprite:addChild(nameBg)

                -- local nameBg = zc.createSprite("res/Main/pub/manual/nameBg.png")
                local nameBg = zc.getScaleNode("res/Main/pub/manual/nameBg.png", cc.size(32, 64))
                nameBg:setAnchorPoint(1, 1)
                nameBg:setPosition(mySpriteSize.width-7, mySpriteSize.height-7)
                mySprite:addChild(nameBg)

                local weaponTypeBg = zc.createSprite("res/Main/pub/manual/weaponType_bg.png")
                weaponTypeBg:setAnchorPoint(0,1)
                weaponTypeBg:setPosition(5, mySpriteSize.height-7)
                mySprite:addChild(weaponTypeBg)

                local weaponType = zc.createSprite( zc.getHeroTypeImg(generalInfo.weaponType) )
                weaponType:setAnchorPoint(0.5, 0.5)
                weaponType:setPosition(weaponTypeBg:getContentSize().width/2-1, weaponTypeBg:getContentSize().height/2+1)
                weaponTypeBg:addChild(weaponType)

                local nameLab = zc.createLabel({
                    text = generalInfo.name,
                    fontSize = 18,
                    fontName = zc.getFont(1),
                    ap = cc.p(0, 1),
                    pos = cc.p(5, nameBg:getContentSize().height - 2),
                    -- color = cc.c3b(227,206,169),
                    color = cc.c3b(254,242,215),
                    width = 20,
                })
                nameBg:addChild(nameLab)
                nameLab:setLineSpacing(-4)

                -- local scaleSize = cc.size(235, 130)
                -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
                -- local myScale9 = zc.createSprite()
                -- myScale9:setContentSize( scaleSize )
                -- local touchBtn = zc.createPushButton({
                --     normalNode = myScale9,
                --     needSwallow = false,
                --     needEnableWhenMoving = true,
                --     touchScale = 0.9,
                --     endCallback = function()
                --         print("-----------log--------ad-------------")
                --         zc.createGenralCardGetPop(generaldata)
                --     end,
                --     anchor = cc.p(0.5, 0.5),
                -- })

                -- 资质
                local _zizhiPos = cc.p(20, 28)
                local qualificationsBg2 = cc.Sprite:create( "res/Main/role/qualifications_bg2.png" )
                qualificationsBg2:setScale( 1 )
                qualificationsBg2:setPosition( _zizhiPos )
                mySprite:addChild( qualificationsBg2 , 1)
                local qualificationsBg2Size = qualificationsBg2:getContentSize()
                local qualificationsBg = cc.Sprite:create( "res/Main/role/qualifications_bg.png" )
                qualificationsBg:setScale( 0.5 )
                qualificationsBg:setPosition( qualificationsBg2Size.width/2, qualificationsBg2Size.height/2)
                qualificationsBg2:addChild( qualificationsBg )
                local talentBg = zc.createSprite("res/Main/talent/talentBg.png")
                talentBg:setPosition(qualificationsBg:getPositionX(), qualificationsBg:getPositionY() )
                qualificationsBg2:addChild(talentBg)
                talentBg:setScale(0.2)
                local qualificationsSp = zc.createSprite( zc.getHeroQualificationsPath( generalInfo.qualifications, 2 ) )
                qualificationsSp:setPosition( qualificationsBg:getPositionX(), qualificationsBg:getPositionY()  )
                qualificationsSp:setScale( 0.55 )
                qualificationsBg2:addChild( qualificationsSp )

                --from
                local fromBg = zc.createSprite("res/Main/pub/manual/fromBg.png")
                fromBg:setAnchorPoint(0, 0)
                fromBg:setPosition(5, -2)
                mySprite:addChild(fromBg)

                local getWay = tonumber(generaldata.get) or 1

                if getWay == 2 then
                    local consumeImg = zc.createSprite(zc.getImgByType(generaldata.priceid))
                    consumeImg:setAnchorPoint(0.5, 0.5)
                    consumeImg:setPosition(66, fromBg:getContentSize().height/2+5)
                    fromBg:addChild(consumeImg)
                    consumeImg:setScale(0.8)

                    local consumeNumLab = zc.createLabel({
                        text = generaldata.pricenum,
                        fontSize = 20,
                        fontName = zc.getFont(1),
                        ap = cc.p(0, 0.5),
                        pos = cc.p(consumeImg:getPositionX()+24, fromBg:getContentSize().height/2+5),
                        color = display.COLOR_WHITE,
                        color2 = display.COLOR_BLACK,
                        align = kCCTextAlignmentCenter,
                        pixel = 1.3
                    })
                    fromBg:addChild(consumeNumLab)
                    self._consumeNumLabs[i] = consumeNumLab
                else
                    local fromPath = zc.createSprite("res/Main/pub/manual/sp_name_"..getWay..".png")
                    fromPath:setAnchorPoint(0.5, 0.5)
                    fromPath:setPosition(fromBg:getContentSize().width/2, fromBg:getContentSize().height/2+5)
                    fromBg:addChild(fromPath)
                end

                --数量
                local exchangeInfo = exchangeInfoList[tostring(generalInfo.qualifications)] or {}
                local compoundNum = tonumber(exchangeInfo.compoundNum) or 1
                local needNumLab1 = zc.createLabel({
                    text = "/".. compoundNum,
                    fontSize = 18,
                    outLine = true,
                    fontName = zc.getFont(1),
                    ap = cc.p(1, 0.5),
                    pos = cc.p(210, 13),
                    color = cc.c3b(254,242,215),
                })
                mySprite:addChild(needNumLab1)
                local needNumLab2 = zc.createLabel({
                    text = "0",
                    fontSize = 18,
                    outLine = true,
                    fontName = zc.getFont(1),
                    ap = cc.p(1, 0.5),
                    pos = cc.p(needNumLab1:getPositionX()-needNumLab1:getContentSize().width, needNumLab1:getPositionY() ),
                    color = display.COLOR_GREEN,
                })
                mySprite:addChild(needNumLab2)
                self._generalSpriteList[tonumber(generalInfo.id)]._needNumLab1 = needNumLab1
                self._generalSpriteList[tonumber(generalInfo.id)]._needNumLab2 = needNumLab2
                self._generalSpriteList[tonumber(generalInfo.id)]._compoundNum = compoundNum

                self._generalSpriteList[tonumber(generalInfo.id)]._weaponType = weaponType
                self._generalSpriteList[tonumber(generalInfo.id)]._nameBg = nameBg
                self._generalSpriteList[tonumber(generalInfo.id)]._qualificationsSp = qualificationsSp
                self._generalSpriteList[tonumber(generalInfo.id)]._nameLab = nameLab




                mySprite:setSwallowTouches( false )
                mySprite:setTouchBeganCallback(function()
                    mySprite:stopAllActions()
                    mySprite:runAction(cc.Sequence:create( cc.ScaleTo:create(0.1, 0.9),cc.ScaleTo:create(0.1, 1.0)) )
                    -- mySprite:setScale(0.9)
                end)
                mySprite:setTouchEndedCallback(function()
                    -- mySprite:runAction(cc.ScaleTo:create(0.1, 1.0))
                    self:openCardGetPop(generaldata)
                end)
            end
        end
    end


    self:refreshLineState()
end

--刷新连线状态
function GeneralManualListLayer:refreshLineState()

    --刷新拥有的武将
    if self._init then
        self:refreshOwnHero()
    end
    --
    for k,v in pairs(self._generalSpriteList) do
        local generaldata = v._info
        local condition = tonumber(generaldata.condition)
        if condition and condition > 0 then
            local conditionData = self._mainIdToData[condition] or {}
            if self._generalSpriteList[tonumber(conditionData.generalid)] then
                local conditionInfo = self._generalSpriteList[tonumber(conditionData.generalid)]
                local conditionSprite = conditionInfo._mySprite
                if not v._condition_line then

                    local condition_line = zc.getScaleNode("res/Main/pub/manual/line_light.png", cc.size(283, 41))
                    -- local condition_line = zc.createSprite("res/Main/pub/manual/line_light.png")
                    condition_line:setAnchorPoint(0.5, 0.5)
                    condition_line:setPosition( (conditionSprite:getPositionX()+v._pos.x)/2, (conditionSprite:getPositionY()+v._pos.y)/2)
                    self._dropScrollView:addChild(condition_line)

                    local dot_tail = zc.createSprite("res/Main/pub/manual/dot_tail_got.png")
                    dot_tail:setAnchorPoint(0.5, 0.5)
                    dot_tail:setPosition(0, condition_line:getContentSize().height/2 - 12)
                    condition_line:addChild(dot_tail)
                    local dot_head = zc.createSprite("res/Main/pub/manual/dot_head_light.png")
                    dot_head:setAnchorPoint(0.5, 0.5)
                    dot_head:setPosition(condition_line:getContentSize().width, condition_line:getContentSize().height/2 - 12)
                    condition_line:addChild(dot_head)

                    v._condition_line = condition_line
                    v._dot_tail = dot_tail
                    v._dot_head = dot_head
                end

                --刷新状态
                local _pathTail = "res/Main/pub/manual/dot_tail_none.png"
                local _pathHead = "res/Main/pub/manual/dot_head_gray.png"
                local _pathLine = "res/Main/pub/manual/line_gray.png"
                local _justY = 0
                local _lineSize = cc.size(283+20, 14)
                --
                if self._ownHeroList[tonumber(generaldata.generalid)] and self._ownHeroList[tonumber(conditionData.generalid)] then
                    _pathTail = "res/Main/pub/manual/dot_tail_got.png"
                    _pathHead = "res/Main/pub/manual/dot_head_light.png"
                    _pathLine = "res/Main/pub/manual/line_light.png"
                    _lineSize = cc.size(283+20, 41)
                    _justY = 0
                elseif self._ownHeroList[tonumber(conditionData.generalid)] and not self._ownHeroList[tonumber(generaldata.generalid)] then
                    _pathTail = "res/Main/pub/manual/dot_tail_can.png"
                    _pathHead = "res/Main/pub/manual/dot_head_gray.png"
                    _pathLine = "res/Main/pub/manual/line_gray.png"
                    _justY = 0
                end
                --向下
                if conditionSprite:getPositionX() == v._pos.x then
                    v._condition_line:setRotation(90)
                    -- v._condition_line:setScaleX( 205/283 )
                    _lineSize.width = 175
                end

                -- v._condition_line:setTexture(_pathLine)
                v._condition_line:initWithFile(_pathLine)
                v._condition_line:setContentSize(_lineSize)
                v._dot_tail:setTexture(_pathTail)
                v._dot_head:setTexture(_pathHead)

                -- print("-----------log--------ad-------------_justY ", _justY)
                -- print("-----------log--------ad-------------name ", conditionInfo._info.generalInfo.name )
                v._condition_line:setPosition((conditionSprite:getPositionX()+v._pos.x)/2, (conditionSprite:getPositionY()+v._pos.y)/2)
                v._dot_head:setPosition(v._condition_line:getContentSize().width, v._condition_line:getContentSize().height/2 + _justY)
                v._dot_tail:setPosition(0, v._condition_line:getContentSize().height/2 + _justY)

                --是否封(解锁条件未达成)
                if not self._ownHeroList[tonumber(conditionData.generalid)] then
                    if not v._lock then
                        local lock = zc.createSprite("res/Main/pub/manual/feng.png")
                        lock:setAnchorPoint(0.5, 0.5)
                        lock:setPosition(v._mySprite:getContentSize().width/2, v._mySprite:getContentSize().height/2)
                        v._mySprite:addChild(lock)
                        v._lock = lock
                    end
                else
                    if not tolua.isnull(v._lock) then
                        v._lock:removeFromParent()
                        v._lock = nil
                    end
                end
            end
        end

        --
        local _isOwnHero = false
        if self._ownHeroList[tonumber(generaldata.generalInfo.id)] then
            _isOwnHero = true
            if v._stateGray then
                zc.setGray( v._mySprite:getChildByName("_pathBg"):getSprite() , false)
                zc.setGray( v._mySprite:getChildByName("heroSp") , false )
                zc.setGray( v._weaponType , false )
                zc.setGray( v._nameBg:getSprite() , false )
                -- zc.setGray( v._nameBg , false )
                zc.setGray( v._qualificationsSp , false )
                v._nameLab:setColor( cc.c3b(254,242,215) )
                v._stateGray = false
            end  
        else
            zc.setGray( v._mySprite:getChildByName("_pathBg"):getSprite() )
            zc.setGray( v._mySprite:getChildByName("heroSp") )
            zc.setGray( v._weaponType )
            zc.setGray( v._nameBg:getSprite() )
            -- zc.setGray( v._nameBg )
            zc.setGray( v._qualificationsSp )
            v._nameLab:setColor(display.COLOR_WHITE)
            v._stateGray = true
        end

        --刷新数量
        local fragmentNum = PlayerData:getFragmentNumByHeroId(generaldata.generalInfo.id)
        v._needNumLab2:setString(fragmentNum)
        --是否拥有
        local _color = display.COLOR_RED
        if _isOwnHero then
            v._needNumLab1:setString("")
            v._needNumLab2:setPositionX(v._needNumLab1:getPositionX()-v._needNumLab1:getContentSize().width)
            if tonumber(fragmentNum) > 0 then
                _color = display.COLOR_GREEN
            end
        else
            if tonumber(fragmentNum) >= v._compoundNum then
                _color = display.COLOR_GREEN
            end
        end
        v._needNumLab2:setColor(_color)
    end
    
    self:freshConsumeNumLab()
end

function GeneralManualListLayer:freshConsumeNumLab()
    local fragmentExchangeData = PlayerData:getFragmentExchangeData()
    local _handBook = self._handbook or 1
    local _handBookInfo = fragmentExchangeData["handbook".._handBook] or {}
    for i=1, 16 do
        if self._palceToData[i] and self._consumeNumLabs[i] then
            local generaldata = self._palceToData[i] or {}
            local _base = tonumber(generaldata.pricenum) or 0
            local _more = tonumber(generaldata.morePrice) or 0
            local _time = tonumber(_handBookInfo[tostring(generaldata["id"])]) or 0
            self._consumeNumLabs[i]:setString(_base + _more*_time)
        end
    end
end

function GeneralManualListLayer:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end

function GeneralManualListLayer:openCardGetPop(generaldata)
    zc.createGenralCardGetPop({
        gData = generaldata,
        callback = function()
            self:refreshLineState()
        end
    })
end

function GeneralManualListLayer:onEnter( ... )
    if self._gotoHeroId then
        performWithDelay(self, function()
            self:openCardGetPop(self._heroIdToData[tonumber(self._gotoHeroId)])
            self._gotoHeroId = nil
        end,0.1)
    end

    if self._init then
        self:refreshLineState()

        local GeneralCardGetPop = zc.getPop("GeneralCardGetPop")
        if GeneralCardGetPop then
            GeneralCardGetPop:selfFresh()
        end
    end
    self._init = true
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14406 then
        getGuideManager():setHeroFuncCallBack(function()
            getGuideManager():setFuncGuideOver()
        end)
        getGuideManager():startGuide()
    end
end
function GeneralManualListLayer:onExit( ... )
end
return GeneralManualListLayer