--[[
	武将升星成功弹窗
	唐实聪
	2016.4.26
]]
local RoleStarupSuccessPop = class("RoleStarupSuccessPop", function()
	return ZCPopLayer:create({opacityValue=200})
end)

function RoleStarupSuccessPop:create( params )
	return RoleStarupSuccessPop.new( params )
end

function RoleStarupSuccessPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:show()
end

function RoleStarupSuccessPop:initData( params )
	self._heroData = params.heroData or {}
	self._skillData = params.skillData or {}
	self._size = self:getContentSize()
	self._record = params.record
	-- 武将信息存在并且奥义二存在
	if self._heroData then
		local heroData = gameData.getDataFromCacheWithPrimaryKey("hero",self._heroData.heroId)
		local comBineSkillID2 = tonumber(heroData.combineSkillId2)
		self.skillLevel = heroData.combineSkillLevel2
		
		local skillid = self._skillData.id
		local _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill",skillid)
		local _subType = tonumber(_skillDb.subType) or 1

		if comBineSkillID2 ~= 0 and _subType == 4 then
			local skillData = gameData.getDataFromCacheWithPrimaryKey("skill",comBineSkillID2)
			local desc_data = string.split( skillData.desc1, "%" )
			local str = ""
			for k,v in pairs(desc_data) do
				local n,m = string.find(v,"|")
		    	if n then
		    		local gongshi = string.split(v,"|")
		    		local func = loadstring("return "..string.gsub(gongshi[2],"lv",self.skillLevel))
		    		local str2 = func()
					str = str..str2.."%"
		    	else
		    		str = str..v
		    	end
			end
	        self._skillData1 = {
	            id = skillData.id,
	            desc = str or "",
	            name = skillData.name or "",
	            starLevel = self._heroData.star + 1,
	            skillLevel = self.skillLevel,
	        }
	        -- table.insert(self.list,self._skillData1)
		end
	end
end

function RoleStarupSuccessPop:initUI()
	-- 背景
	local bg = cc.Sprite:create( "res/Main/copy/copy_sweepbg2.png" )
	bg:setPosition( self._size.width/2, self._size.height/2 - 50 )
	self:addContent( bg )
	local bgSize = bg:getContentSize()
	local swallow = zc.createPushButton({
		touchSize = bgSize,
		pos = cc.p( bgSize.width/2, bgSize.height/2 ),
		endCallback = function()
			self:hide()
		end
	})
	bg:addChild( swallow )

	-- 升星成功背景
	local successBg = cc.Sprite:create( "res/Main/role/starup/success_bg.png" )
	successBg:setPosition( bgSize.width/2, bgSize.height + 7 )
	bg:addChild( successBg )
	successBg:runAction(
		cc.RepeatForever:create(
			cc.RotateBy:create(
				5, 360
			)
		)
	)
	-- 升星成功标题
	local successTitle = cc.Sprite:create( "res/Main/role/starup/success_title.png" )
	successTitle:setPosition( successBg:getPosition() )
	bg:addChild( successTitle )

	-- 底座
	local heroBase = cc.Sprite:create( "res/Main/smithy/make/make_weapon_bg.png" )
	heroBase:setPosition( bgSize.width/2, bgSize.height/2 )
	bg:addChild( heroBase )
	-- 英雄
    local _weaponData = PlayerData:getWeaponsInfoById( self._heroData.id ) or {}
	local armature = zc.battle.createHeroArmatureWithResId( self._heroData.modelId, _weaponData.weaponId )
	zc.soldierChangeWeapon( armature, _weaponData.weaponId )
	self._record[#self._record + 1] = {
        self._heroData.modelId, _weaponData.weaponId
    }
    armature:setPosition( bgSize.width/2, heroBase:getPositionY() + 20 )
    armature:setScaleX( -1 )
    bg:addChild( armature )
    armature:getAnimation():play( BATTLE_ANIMATION_ACTION.WIN )
	-- 星星
    zc.createHeroStar( bg, self._heroData.star - 1, cc.p( bgSize.width/2 - 160, bgSize.height - 40 ) )
    self:runAction(
    	cc.Sequence:create(
    		cc.DelayTime:create(
    			0.2
			),
			cc.CallFunc:create(
				function()
					local armature_star = zc.createArmature({
				        parentPath = "res/animation/shengxing_star/",
				        fileName = "shengxing_star",
				        autoRemove = true,
				        actName = "idle_"..( math.ceil( tonumber( self._heroData.star )/5 ) ),
				        eventCallback = function() end,
				        completeCallback = function()
				            zc.createHeroStar( bg, self._heroData.star, cc.p( bgSize.width/2 - 160, bgSize.height - 40 ) )
				        end
					})
					local starNum = ( tonumber( self._heroData.star ) - 1 )%5 + 1
					armature_star:setPosition( bgSize.width/2 - 160, bgSize.height - 40 - starNum*30 )
					bg:addChild( armature_star )
				end
			)
    	)
    )
    -- 称号
    local heroTitle = zc.createLabel({
        text = "<"..self._heroData.title..">",
        fontSize = 24,
        ttf = zc.getFont( 1 ),
        color = zc.COLOR_PURPLE,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( bgSize.width/2, heroBase:getPositionY() - 20 ),
        outLine = true,
    })
    bg:addChild( heroTitle )
    -- 技能
    local _spine_icon = nil
    if self._skillData.starLevel == tonumber( self._heroData.star ) then
    	-- 当前升星有技能解锁或者升级
    	if self._skillData.skillLevel == 1 then
    		-- 解锁
    		local icon = zc.createIconByData({
		        data = {
		            mainType=zc.mainTypeSkill,
		            type=self._skillData.id,
		            id=self._skillData.id,
		        },
		    })
    		icon:setScale( 0.8 )
    		icon:setPosition( bgSize.width/2 - 160, 160 )
    		bg:addChild( icon )
    		_spine_icon = icon
    		-- 技能
    		local skillName = zc.createRichLabel({
    			text = "[color=ffe6e0a3]" .. zc.lang("new") .. zc.lang("skill") .. ":[/color]"..self._skillData.name.." [color=ffff3644](1" .. zc.lang("level_1") .. ")[/color]",
    			fontSize = 22,
			})
			skillName:setAnchorPoint( 0, 0.5 )
			skillName:setPosition( icon:getPositionX() + 55, icon:getPositionY() + 36 )
    		bg:addChild( skillName )
    		local _desc = self:buildDesc()
    		local skillDesc = zc.createLabel({
    			text = _desc,
    			width = 260,
    			fontSize = 18,
    			ap = cc.p( 0, 1 ),
    			color = cc.c3b( 143, 125, 91 ),
    			pos = cc.p( skillName:getPositionX(), skillName:getPositionY() - 25 ),
			})
			bg:addChild( skillDesc )
		else
			print("**************0")
			if  self._skillData1 then
				local list_data = {self._skillData,self._skillData1}
				local posX = {300,-50}
				for i = 1,2 do
					local sp = zc.createSprite("res/Main/pub/aoyi.png")
					sp:setPosition(bgSize.width/2 - posX[i],160)
					bg:addChild(sp)
					local num_sp = zc.createSprite("res/Main/role/"..i..".png")
					num_sp:setPosition(sp:getContentSize().width/2 + 25,sp:getContentSize().height/2)
					sp:addChild(num_sp)
					-- 升级前技能
		    		local icon_bef = zc.createIconByData({
				        data = {
				            mainType=zc.mainTypeSkill,
				            type=list_data[i].id,
				            id=list_data[i].id,
				        },
				    })
		    		icon_bef:setScale( 0.8 )
		    		icon_bef:setAnchorPoint( 0.5, 0.5 )
		    		icon_bef:setPosition( sp:getPositionX() + 90, sp:getPositionY() )
		    		bg:addChild( icon_bef )
		    		local level_bef = zc.createLabel({
				        text = zc.getLevelTipShow()..(self._skillData.skillLevel - 1),
				        fontSize = 22,
				        ttf = zc.getFont( 1 ),
				        color = display.COLOR_WHITE,
				        ap = cc.p( 0, 0 ),
				        pos = cc.p( 10, 10 ),
				        outLine = true,
					})
					icon_bef:addChild( level_bef )
					-- 箭头
					local arrow = cc.Sprite:create( "res/Main/common/arrow_green.png" )
					arrow:setPosition( icon_bef:getPositionX() + 65, icon_bef:getPositionY() )
					bg:addChild( arrow )
					-- 升级后技能
		    		local icon_aft = zc.createIconByData({
				        data = {
				            mainType=zc.mainTypeSkill,
				            type=list_data[i].id,
				            id=list_data[i].id,
				        },
				    })
		    		icon_aft:setScale( 0.8 )
		    		icon_aft:setAnchorPoint( 0.5, 0.5 )
		    		icon_aft:setPosition( icon_bef:getPositionX() + 130, icon_bef:getPositionY() )
		    		bg:addChild( icon_aft )
		    		_spine_icon = icon_aft
		    		local level_aft = zc.createLabel({
				        text = zc.getLevelTipShow()..( self._skillData.skillLevel ),
				        fontSize = 22,
				        ttf = zc.getFont( 1 ),
				        color = display.COLOR_YELLOW,
				        ap = cc.p( 0, 0 ),
				        pos = cc.p( 10, 10 ),
				        outLine = true,
					})
					icon_aft:addChild( level_aft )
				end
			else
				-- 升级
	    		local label = zc.createLabel({
			        text =  zc.lang("upgrade") .. zc.lang("skill") .. ":",
			        fontSize = 20,
			        ttf = zc.getFont( 1 ),
			        ap = cc.p( 1, 0.5 ),
			        pos = cc.p( bgSize.width/2 - 120, 160 ),
			        stroke = true,
				})
	    		bg:addChild( label )
	    		-- 升级前技能
	    		local icon_bef = zc.createIconByData({
			        data = {
			            mainType=zc.mainTypeSkill,
			            type=self._skillData.id,
			            id=self._skillData.id,
			        },
			    })
	    		icon_bef:setScale( 0.8 )
	    		icon_bef:setAnchorPoint( 0.5, 0.5 )
	    		icon_bef:setPosition( label:getPositionX() + 60, label:getPositionY() )
	    		bg:addChild( icon_bef )
	    		local level_bef = zc.createLabel({
			        text = zc.getLevelTipShow()..(self._skillData.skillLevel - 1),
			        fontSize = 22,
			        ttf = zc.getFont( 1 ),
			        color = display.COLOR_WHITE,
			        ap = cc.p( 0, 0 ),
			        pos = cc.p( 10, 10 ),
			        outLine = true,
				})
				icon_bef:addChild( level_bef )
				-- 箭头
				local arrow = cc.Sprite:create( "res/Main/common/arrow_green.png" )
				arrow:setPosition( icon_bef:getPositionX() + 65, icon_bef:getPositionY() )
				bg:addChild( arrow )
				-- 升级后技能
	    		local icon_aft = zc.createIconByData({
			        data = {
			            mainType=zc.mainTypeSkill,
			            type=self._skillData.id,
			            id=self._skillData.id,
			        },
			    })
	    		icon_aft:setScale( 0.8 )
	    		icon_aft:setAnchorPoint( 0.5, 0.5 )
	    		icon_aft:setPosition( icon_bef:getPositionX() + 130, icon_bef:getPositionY() )
	    		bg:addChild( icon_aft )
	    		_spine_icon = icon_aft
	    		local level_aft = zc.createLabel({
			        text = zc.getLevelTipShow()..( self._skillData.skillLevel ),
			        fontSize = 22,
			        ttf = zc.getFont( 1 ),
			        color = display.COLOR_YELLOW,
			        ap = cc.p( 0, 0 ),
			        pos = cc.p( 10, 10 ),
			        outLine = true,
				})
				icon_aft:addChild( level_aft )
			end
		end
    else
    	-- 没解锁升级
    	if self._skillData.skillLevel == 1 then
    		-- 解锁
    		local label = zc.createLabel({
		        text = zc.lang("up_to") .. self._skillData.starLevel.. zc.lang("star_unlock_skill") .. ":",
		        fontSize = 20,
		        ap = cc.p( 1, 0.5 ),
		        pos = cc.p( bgSize.width/2 - 33, 160 ),
		        stroke = true,
			})
    		bg:addChild( label )
    		local icon = zc.createIconByData({
		        data = {
		            mainType=zc.mainTypeSkill,
		            type=self._skillData.id,
		            id=self._skillData.id,
		        },
		    })
    		icon:setScale( 0.8 )
    		icon:setAnchorPoint( 0.5, 0.5 )
    		icon:setPosition( label:getPositionX() + 10 + icon:getBoundingBox().width/2, label:getPositionY() )
    		bg:addChild( icon )
    		_spine_icon = icon
		else
			-- 升级
    		local label = zc.createLabel({
		        text = zc.lang("up_to") .. self._skillData.starLevel.. zc.lang("star_unlock_skill") .. ":",
		        fontSize = 20,
		        ap = cc.p( 1, 0.5 ),
		        pos = cc.p( bgSize.width/2 - 120, 160 ),
		        stroke = true,
			})
    		bg:addChild( label )
    		-- 升级前技能
    		local icon_bef = zc.createIconByData({
		        data = {
		            mainType=zc.mainTypeSkill,
		            type=self._skillData.id,
		            id=self._skillData.id,
		        },
		    })
    		icon_bef:setScale( 0.8 )
    		icon_bef:setAnchorPoint( 0.5, 0.5 )
    		icon_bef:setPosition( label:getPositionX() + 60, label:getPositionY() )
    		bg:addChild( icon_bef )
    		local level_bef = zc.createLabel({
		        text = zc.getLevelTipShow()..( self._skillData.skillLevel - 1 ),
		        fontSize = 22,
		        ap = cc.p( 0, 0 ),
		        pos = cc.p( 5, 5 ),
		        stroke = true,
			})
			icon_bef:addChild( level_bef )
			-- 箭头
			local arrow = cc.Sprite:create( "res/Main/common/arrow_green.png" )
			arrow:setPosition( icon_bef:getPositionX() + 65, icon_bef:getPositionY() )
			bg:addChild( arrow )
			-- 升级后技能
    		local icon_aft = zc.createIconByData({
		        data = {
		            mainType=zc.mainTypeSkill,
		            type=self._skillData.id,
		            id=self._skillData.id,
		        },
		    })
    		icon_aft:setScale( 0.8 )
    		icon_aft:setAnchorPoint( 0.5, 0.5 )
    		icon_aft:setPosition( icon_bef:getPositionX() + 130, icon_bef:getPositionY() )
    		bg:addChild( icon_aft )
    		_spine_icon = icon_aft
    		local level_aft = zc.createLabel({
		        text = zc.getLevelTipShow()..( self._skillData.skillLevel ),
		        fontSize = 22,
		        ttf = zc.getFont( 1 ),
		        color = display.COLOR_YELLOW,
		        ap = cc.p( 0, 0 ),
		        pos = cc.p( 5, 5 ),
		        stroke = true,
			})
			icon_aft:addChild( level_aft )
		end
    end
	local _spine = zc.getSpine( "shilianchou" )
	_spine:setScale( 0.9 )
	_spine:playAction( "start_4", false )
	_spine:setPosition( _spine_icon:getPosition() )
	bg:addChild( _spine )
    

    -- 点击空白区域继续
    local clickEmpty = cc.Sprite:create( "res/Main/common/click_empty.png" )
    clickEmpty:setPosition( bgSize.width/2, 60 )
    bg:addChild( clickEmpty )
    clickEmpty:runAction(
    	cc.RepeatForever:create(
    		cc.Sequence:create(
	    		cc.FadeTo:create(
	    			1, 150
				),
	    		cc.FadeTo:create(
	    			1, 255
				)
			)
		)
	)
end

function RoleStarupSuccessPop:buildDesc()
	local _desc = self._skillData.desc
	if string.find( _desc, "|" ) then
		local _strList = string.split( _desc, "|" )
		local _num = ( #_strList - 1 )/2
		for i = 1, _num do
			local _str = string.gsub( _strList[2*i], "lv", self._skillData.skillLevel == 0 and 1 or self._skillData.skillLevel )
			local _script = "return ".._str
			local _value = loadstring( _script )()
			_strList[2*i] = _value
		end
		_desc = "" 
		for i, v in ipairs( _strList ) do
			_desc = _desc..v
		end
	end
	return _desc
end

return RoleStarupSuccessPop