--[[
    FileName: SmithyGodMakePop.lua
    Author: andong
    Date: 2016-07-04
    Purpose: 打造成功弹窗
]]
local SmithyGodMakePop = class( "SmithyGodMakePop", function ()
    return zc.createNormalDialog({
        showBack = false,
        showFlower = false,
    })
end)
function SmithyGodMakePop:create(params)
    return SmithyGodMakePop.new(params)
end
function SmithyGodMakePop:ctor(params)
    self:initData(params)
    self:initUI()
end
function SmithyGodMakePop:initData(params)
    PlayerData:updateWeaponsInfoById({id=params.info.id,createTime = PlayerData:getTime(),status=0})
    zc.sendHttp({
        apiName = "Weapon_changeState",
        params = {weaponId = params.info.id},
        successCallback = function()
        end,
    })
    self._info = params.info
    self._before = params.before
    self._callback = params.callback
end
function SmithyGodMakePop:initUI()
    local _bian_1 = zc.getSprite({
        src = "res/Main/battle/battleresult/levelup_bian.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(0, zc.height*0.5),
    })
    local heightScale = zc.height/_bian_1:getContentSize().height
    _bian_1:setScaleY(heightScale)
    self:addChild(_bian_1)
    local _bian_2 = zc.getSprite({
        src = "res/Main/battle/battleresult/levelup_bian.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(zc.width, zc.height*0.5),
    })
    _bian_2:setScaleY(heightScale)
    _bian_2:setScaleX(-1*_bian_2:getScaleX())
    self:addChild(_bian_2)

    local _spine = zc.createSpine({
        fileName = "zhujueshengji_1",
        actName = "start4",
        loop = false,
    })
    _spine:setPosition(zc.width*0.5, zc.height*0.5 + 140)
    self:addChild(_spine)
    _spine:registerSpineEventHandler( function ( event )
        _spine:unregisterSpineEventHandler(sp.EventType.ANIMATION_COMPLETE)
        _spine:playAction("idle4", true)
    end, sp.EventType.ANIMATION_COMPLETE)

    local popBg = zc.createSprite()
    popBg:setContentSize(cc.size(500,300))
    popBg:setPosition(zc.width/2, zc.height/2-200)
    self:addChild(popBg)
    local popSize = popBg:getContentSize()
    local close = zc.createPushButton({
        touchSize = cc.size(10000,10000),
        needSwallow = true,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2, popSize.height/2),
        endCallback = function() end,
    })
    popBg:addChild(close)

    performWithDelay(popBg,function()
        close:setTouchEndedCallback(function() LayerManager.removeLayout(true) end)
    end,0.6)

    local dizhuo = zc.createSprite("res/Main/smithy/make/make_weapon_bg.png")
    dizhuo:setAnchorPoint(0.5, 0.5)
    dizhuo:setPosition(popSize.width/2, 245)
    popBg:addChild(dizhuo)

    local weaponToPath = {
        [1001]="qiang_1",[1002]="qiang_1",[1003]="qiang_2",[1004]="qiang_2",[1005]="qiang_3",[1006]="qiang_3",
        [2001]="shanzi_1",[2002]="shanzi_1",[2003]="shanzi_2",[2004]="shanzi_2",[2005]="shanzi_3",[2006]="shanzi_3",
    }
    local weaponPath = weaponToPath[tonumber(self._info.iconId)]
    local skeletonNode = zc.createSpine({
        path = "res/Main/smithy/shenbing/show/",
        fileName = weaponPath,
        actName = self._info.iconId,
    })
    skeletonNode:setPosition(dizhuo:getContentSize().width/2, dizhuo:getContentSize().height + 40)
    dizhuo:addChild(skeletonNode)
    skeletonNode:setScale(0.7)
    skeletonNode:runAction(cc.RepeatForever:create(cc.Spawn:create(
        cc.Sequence:create(
            cc.MoveBy:create(1.5, cc.p(0, 10)),
            cc.MoveBy:create(1.5, cc.p(0, -10))
        )
    )))

    local name = zc.createLabel({
        text = self._info.name,
        stroke = true,
        fontSize = 20,
        ap = cc.p(0.5, 0),
        pos = cc.p(dizhuo:getContentSize().width/2, 0),
        color = zc.getColorByQuality(self._info.color),
        pixel = 1.3
    })
    dizhuo:addChild(name)
        
    --检查是否有解锁新的技能
    local newSkill = {}
    for i = 1,4 do
        local skillName = ""
        local skillLevelName = ""
        if i < 4 then
            skillName = "commonSkillId"..i
            skillLevelName = "commonSkillLevel"..i
        else
            skillName = "moraleSkillId"
            skillLevelName = "moraleSkillLevel"
        end

        local toSkill = 0
        local beforeSkillid = tonumber(self._before[skillName]) or 0 
        local newSkillid = tonumber(self._info[skillName])
        if beforeSkillid and beforeSkillid == 0 then
            if newSkillid and newSkillid > 0 then
                toSkill = newSkillid
            end
        elseif beforeSkillid and tonumber(beforeSkillid) > 0 then
            if newSkillid and tonumber(newSkillid) > 0 then
                if beforeSkillid ~= newSkillid then
                    toSkill = newSkillid
                end
            end
        end
        if toSkill >= 0 then
            if self._info[skillName] and tonumber(self._info[skillName]) > 0 then
                local static = gameData.getDataFromCacheWithPrimaryKey("skill", toSkill)
                if static["subType"] and tonumber(static["subType"]) ~= 1 then
                    local idx = #newSkill + 1
                    newSkill[idx] = {}
                    newSkill[idx].skillid = self._info[skillName]
                    newSkill[idx].skillLevel = self._info[skillLevelName]
                    newSkill[idx].isBisha = false
                    if i == 4 then
                        newSkill[idx].isBisha = true
                    end
                end
            end
        end
    end

    if next(newSkill) then
        local skillTip = zc.createLabel({
            text = LANGUAGE_ROLE.unlock .. zc.lang("skill") ..  "：",
            stroke = true,
            fontSize = 22,
            ap = cc.p(1, 0.5),
            pos = cc.p(popSize.width/2 - 50, 160),
            pixel = 1.3
        })
        popBg:addChild(skillTip)
        
        for i = 1, #newSkill do
            local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(100, 100))
            local orangeBtn = zc.createPushButton({
                normalNode = myScale9,
                needSwallow = true,
                endCallback = function()
                end,
                pos = cc.p(skillTip:getPositionX()+55+(i-1)*110,skillTip:getPositionY())
            })
            popBg:addChild(orangeBtn, 10)
            local item = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSkill,
                    type = 1, 
                    id = newSkill[i].skillid,
                }, 
                pos = cc.p(orangeBtn:getContentSize().width/2, orangeBtn:getContentSize().height/2 ), 
                listener = function ()
                    zc.createSkillInfoPop({id = newSkill[i].skillid, level=newSkill[i].skillLevel})
                end
            })
            orangeBtn:addChild(item)
            item:setScale(0.8)

            if newSkill[i].isBisha then
                local bisha = zc.createSprite("res/Main/pub/critical.png")
                bisha:setAnchorPoint(0.5, 1)
                bisha:setPosition( item:getContentSize().width/2 , 10 )
                item:addChild(bisha)
            end
            item:setVisible(false)
            self:runAction(cc.Sequence:create(
                cc.DelayTime:create((i-1)*0.3+0.3), 
                cc.CallFunc:create(function()  
                    local _spine = zc.getSpine( "shilianchou" )
                    _spine:setScale( 0.9 )
                    _spine:playAction( "start_4", false )
                    _spine:setPosition( item:getPosition() )
                    orangeBtn:addChild( _spine )
                end),
                cc.CallFunc:create(function()
                    item:setVisible(true)
                end) 
            ))
        end
    end
    

    local closeLab = zc.createLabel({
        text = zc.lang("tips_click_empty_continue"),
        stroke = false,
        fontSize = 18,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2, 80),
    })
    popBg:addChild(closeLab, 11)
    local f_right = zc.createSprite("res/Main/synthesis/f_right.png")
    f_right:setAnchorPoint(0, 0.5)
    f_right:setPosition(closeLab:getPositionX()+closeLab:getContentSize().width/2+5,closeLab:getPositionY() )
    popBg:addChild(f_right)
    local f_left = zc.createSprite("res/Main/synthesis/f_right.png")
    f_left:setAnchorPoint(1, 0.5)
    f_left:setPosition(closeLab:getPositionX()-closeLab:getContentSize().width/2-5, closeLab:getPositionY())
    popBg:addChild(f_left)
    f_left:setFlipX(true)

end

function SmithyGodMakePop:onCleanup()
    if self._callback then
        self._callback()
    end
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/animation/shilianchou/shilianchou.png")
end

return SmithyGodMakePop