--[[
    FileName: WeaponCastLayer.lua
    Author: wangming
    Date: 2016-12-16
    Purpose: 兵器锻造
]]
local WeaponCastLayer = class( "WeaponCastLayer", function ()
    return zc.createNormalDialog({
    	src = "",
    	showFlowerFlag = {1, 0, 1, 0}
    })
end)

function WeaponCastLayer:create(params)
    return WeaponCastLayer.new(params)
end

function WeaponCastLayer:ctor(params)
	self._tagNames = LANGUAGE_get_weapon_type_name()
    table.insert(self._tagNames, 1, zc.lang("all"))

	self._tabBtns = {}
	self._nowTabDatas = {}
	self._nowTabSelected = 0

	self._nowSelectedMain = nil
	self._nowCastLimitInfo = {}
	self._nowCastCostInfo = {}
	self._nowSelectedCast = {}

	self:freshWeaponData()

	local _sp = zc.createSprite("res/Main/smithy/weaponCast/bg.jpg")
	_sp:setPosition(zc.width*0.5, zc.height*0.5)
	_sp:setScaleY(zc.height/_sp:getContentSize().height)
	self:addChild(_sp, -1)

	self:initRight()
	self:initLeft()

    self:changeTab(1)
end

function WeaponCastLayer:onEnter()
	self:addGuide()
end

function WeaponCastLayer:addGuide()
	local _currentGID = getGuideManager():getCurrentGID()
    local _flag = PlayerData:getFuncGuideInfo(42)
    if not _flag then
	    getGuideManager():sendFuncGuideTrigger(42)
    end
    if _currentGID == GuideKey.KEY_14203 then
    	zc.setGuideFuncNextStep(_currentGID)
        self:addGuide()
    elseif _currentGID == GuideKey.KEY_14204 then
    	if self._guideBtn1 then
	        getGuideManager():setObjTarget(self._guideBtn1)
	        getGuideManager():startGuide()
	    else
	    	getGuideManager():setFuncGuideOver()
	    end
    elseif _currentGID == GuideKey.KEY_14205 then
    	if self._guideBtn2 then
	        getGuideManager():setObjTarget(self._guideBtn2)
	        getGuideManager():startGuide()
	    else
	    	getGuideManager():setFuncGuideOver()
	    end
    elseif _currentGID == GuideKey.KEY_14206 then
    	if self._guideBtn3 then
	        getGuideManager():setObjTarget(self._guideBtn3)
	        getGuideManager():startGuide()
	    else
	    	getGuideManager():setFuncGuideOver()
	    end
    elseif _currentGID == GuideKey.KEY_14207 then
        getGuideManager():setObjTarget(self._castBtn)
        getGuideManager():startGuide()
    else
    	if _flag then
    		return
    	end
		getGuideManager():setCurrentGID(GuideKey.KEY_14209)
	    local function _callBack()
	    	getGuideManager():setFuncGuideOver()
	    end
	    getGuideManager():setHeroFuncCallBack(_callBack)
	    getGuideManager():startGuide()
    end
end

-------------------------data-----------------
function WeaponCastLayer:freshWeaponData()
	self._totleWeaponInfo = {{}, {}, {}, {}, {}, {}, {}}
	local _allDatas = clone(PlayerData:getWeaponsInfo())
	-- dump(_allDatas,"_allDatas")

	for k,v in pairs(_allDatas) do
		local _heroId = tonumber(v.heroId) or 0
		if tonumber(v.isUser) ~= 1 then
			local _type = tonumber(v.type) or 0
			_type = _type + 1
			if _type ~= 1 then
				table.insert(self._totleWeaponInfo[_type], v)
			end
			table.insert(self._totleWeaponInfo[1], v)
		end
	end

	local _flag = false
	local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14203 then
    	_flag = true
	end
	for k,v in pairs(self._totleWeaponInfo) do
		table.sort(v, function(a, b)
			if not a or not b then return false end
			if _flag then
				local _idA = tonumber(a.weaponId) or 0
				local _idB = tonumber(b.weaponId) or 0
				if _idA ~= _idB then
					if _idA == GuideWeaponId.weapone14204 then
						return true
					end 
					if _idB == GuideWeaponId.weapone14204 then
						return false
					end 
				end
			end

			local _heroIdA = tonumber(a.heroId)
			local _heroIdB = tonumber(b.heroId)
			if _heroIdB ~= _heroIdA then
				return _heroIdA > _heroIdB
			end

			local _gradeA = tonumber(a.grade) or 0
			local _gradeB = tonumber(b.grade) or 0
			
			if _gradeA ~= _gradeB then
				return _gradeA > _gradeB
			end
			local _qualityA = tonumber(a.quality) or 0
			local _qualityB = tonumber(b.quality) or 0
			if _qualityA ~= _qualityB then
				return _qualityA > _qualityB
			end
			local _idA = tonumber(a.weaponId) or 0
			local _idB = tonumber(b.weaponId) or 0
			if _idA ~= _idB then
				return _idA > _idB
			end
			local _zizhiA = tonumber(self:getWeaponLevelById(a.id)) or 0
			local _zizhiB = tonumber(self:getWeaponLevelById(b.id)) or 0
			return _zizhiA > _zizhiB
		end)
	end

	self:freshNowTableData()
end

function WeaponCastLayer:freshNowTableData()
	if self._nowSelectedMain == nil then
		self._nowTabDatas = self._totleWeaponInfo
		return 
	end

	local _level = tonumber(self._nowCastCostInfo.weaponLv) or 0

	self._nowTabDatas = {{}, {}, {}, {}, {}, {}, {}}
	for k, v in pairs(self._totleWeaponInfo) do
		for _k, _v in pairs(v) do
			local _grade = tonumber(_v.grade) or 0
			if _grade == _level and _v.id ~= self._nowSelectedMain.id and _v.heroId == 0 then
				table.insert(self._nowTabDatas[k], _v)
			end
		end
	end

	local _flag = false
	local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14205 or _currentGID == GuideKey.KEY_14206 then
    	_flag = true
	end
	for k,v in pairs(self._nowTabDatas) do
		table.sort(v, function(a, b)
			if not a or not b then return false end
			if _flag then
				local _idA = tonumber(a.weaponId) or 0
				local _idB = tonumber(b.weaponId) or 0
				if _idA ~= _idB then
					if _idA == GuideWeaponId.weapone14205 then
						return true
					end 
					if _idB == GuideWeaponId.weapone14205 then
						return false
					end
					if _idA == GuideWeaponId.weapone14206 then
						return true
					end
					if _idB == GuideWeaponId.weapone14206 then
						return false
					end
				end
			end

			local _qualityA = tonumber(a.quality) or 0
			local _qualityB = tonumber(b.quality) or 0
			if _qualityA ~= _qualityB then
				return _qualityA < _qualityB
			end
			local _idA = tonumber(a.weaponId) or 0
			local _idB = tonumber(b.weaponId) or 0
			if _idA ~= _idB then
				return _idA > _idB
			end
			local _zizhiA = tonumber(self:getWeaponLevelById(a.id)) or 0
			local _zizhiB = tonumber(self:getWeaponLevelById(b.id)) or 0
			if _zizhiA ~= _zizhiB then
				return _zizhiA > _zizhiB
			end
		end)
	end
end

function WeaponCastLayer:getWeaponLevelById(_id) --主键id
    if not self._weaponLevelInfo then
        self._weaponLevelInfo = {}
    end
    if self._weaponLevelInfo[tonumber(_id)] then
        return self._weaponLevelInfo[tonumber(_id)]
    else
        local _level = zc.getWeaponLevel(_id)
        self._weaponLevelInfo[tonumber(_id)] = _level
        return _level
    end
end

function WeaponCastLayer:showCastResult()
    getGuideManager():removeMaskLayer()
	local backData = self._backData
	if tonumber(backData.success) == 1 then
    	self._weaponLevelInfo[tonumber(self._nowSelectedMain.id)] = nil
    	local _params = {
    		level = self:getWeaponLevelById(self._nowSelectedMain.id),
        	beforeData = self._nowSelectedMain,
        }
        PlayerData:updateWeaponsInfoById(backData.weaponInfo)
        _params.afterData = PlayerData:getWeaponInfoInfoById(self._nowSelectedMain.id)
		zc.createSourcePop("WeaponCastAttr", "src/layer/smithyHouse/WeaponCastAttrPop.lua", _params)
		
		self._nowSelectedMain = nil
		self._nowCastLimitInfo = {}
		self._nowCastCostInfo = {}
	else
		local _dialog = ZCPopLayer:create({opacityValue = 255*0.8})
		LayerManager.addNode(_dialog, {isPop = true})
		local _y = -110
		local _bg = zc.getSprite({
	        src = "res/Main/battle/battleresult/battle_bg.png",
	        ap = cc.p(0.5, 0),
	        pos = cc.p(zc.width/2, _y),
	    })
	    _dialog:addChild(_bg)
	    local _h = _bg:getContentSize().height
	    local _failboy = zc.getSpine("failboy")
	    _failboy:playAction("idle",true)
	    _failboy:setPosition(zc.width/2, zc.height*0.5 - 40)
	    _dialog:addChild(_failboy)
	    local _fail =  zc.getSprite({
	        src = "res/Main/smithy/weaponCast/fail.png",
	        pos = cc.p(zc.width/2, zc.height*0.855),
	    })
	    _dialog:addChild(_fail)
	    local tip =  zc.getSprite({
	        src = "res/Main/smithy/weaponCast/failTip.png",
	        pos = cc.p(zc.width/2, _y + _h - 30),
	    })
	    _dialog:addChild(tip)
	    _dialog:show()
	end
	self._backData = nil
	self._nowSelectedCast = {}
	self:freshWeaponData()
	self:freshUI(false)
end

function WeaponCastLayer:doCast()
	local _targetWeaponId = {}
	for k,v in pairs(self._nowSelectedCast) do
		table.insert(_targetWeaponId, v.id)
	end
	_targetWeaponId = table.concat(_targetWeaponId, "|")
	zc.sendHttp({
		apiName = "Weapon_cast",
		params = {weaponId = self._nowSelectedMain.id, targetWeaponId = _targetWeaponId},
		successCallback = function(backData)
	        if tolua.isnull(self) then
	        	return
	        end
			for k,v in pairs(self._nowSelectedCast) do
				PlayerData:subWeapon(v.id)
			end
			backData.noAnimation = false
        	PlayerData:updataData(backData)
	        self._backData = backData
	        getGuideManager():addMaskLayer()
			local _currentGID = getGuideManager():getCurrentGID()
		    if _currentGID == GuideKey.KEY_14207 then
		    	zc.setGuideFuncNextStep(_currentGID)
		    end
	        self._circle:playAction("start", false)
	    end,
	})
end

function WeaponCastLayer:doReset()
	self._nowSelectedMain = nil
	self._nowCastLimitInfo = {}
	self._nowCastCostInfo = {}
	self._nowSelectedCast = {}
	self:freshUI()
end

--------------------------ui-----------------

function WeaponCastLayer:initLeft()

	local _mainNode = cc.Node:create()
	_mainNode:setPosition(zc.width*0.25 + 12, zc.height*0.5 + 35)
	self:addChild(_mainNode)
	self._mainNode = _mainNode

	local _catHeadSpine = zc.getSpine("maoyan")
	_catHeadSpine:playAction("start", true)
	_catHeadSpine:setPosition(zc.width*0.25 + 35, zc.height - 80)
	self:addChild(_catHeadSpine, 1)

	local _circle = zc.getSpine("duanzhao")
	_circle:playAction("idle", true)
	_circle:registerSpineEventHandler( function ( event )
		local name  = event.animation
		if name == "start" then
			self:showCastResult()
			_circle:playAction("idle", true)
		end
	end, sp.EventType.ANIMATION_COMPLETE)
	_mainNode:addChild(_circle)
	self._circle = _circle

	local function _createPlus( parSp )
		local _plus = zc.createSprite("res/Main/smithy/weaponCast/plus.png")
		parSp:addChild(_plus)
		_plus:setPosition(parSp:getContentSize().width*0.5, parSp:getContentSize().height*0.5)
		_plus:runAction(cc.RepeatForever:create(cc.Sequence:create(
			cc.FadeTo:create(1.0, 255*0.3),
			cc.FadeTo:create(1.0, 255)
		)))
		parSp._plus = _plus
	end

	local _mainDi = zc.createSprite("res/Main/smithy/weaponCast/mainDi.png")
	_mainNode:addChild(_mainDi)
	_createPlus(_mainDi)
	local _mainWeapon = zc.createSprite()
	_mainWeapon:setPositionY(2)
	_mainNode:addChild(_mainWeapon)
	self._mainNode["mainWeapon"] = _mainWeapon

	local _startX = -50-100*2.5
	local _startY = -155
	for i = 1, 5 do
		local _pos = cc.p(_startX + i*100, _startY)
		local _diSp = zc.createSprite("res/Main/home/avator_bg.png")
		_diSp:setPosition(_pos)
		_mainNode:addChild(_diSp)
		local _openSp = zc.createSprite()
		_openSp:setPosition(_pos.x, _pos.y + 2)
		_mainNode:addChild(_openSp, 1)
		self._mainNode["open"..i] = _openSp
		_createPlus(_openSp)
		local _lockSp = zc.createSprite("res/Main/drillField/drillField_head_sock.png")
		_lockSp:setPosition(_pos)
		_mainNode:addChild(_lockSp)
		self._mainNode["lock"..i] = _lockSp
	end

	local _btnPartW = 120
	local _resetBtn = zc.createCommomBtn({
	    tag = 2,
        text = zc.lang("re_choose"),
    	pos = cc.p(zc.width*0.25 - _btnPartW, zc.height*0.5 - 320 + 35),
    	endCallback = function()
	    	self:doReset()
    	end
	})
	self:addChild(_resetBtn, 1)
	self._resetBtn = _resetBtn

	local _castBtn = zc.createCommomBtn({
	    tag = 1,
        text = zc.lang("weapon_cast"),
    	pos = cc.p(zc.width*0.25 + _btnPartW, _resetBtn:getPositionY()),
    	endCallback = function()
	    	self:doCast()
    	end
	})
	self:addChild(_castBtn, 1)
	self._castBtn = _castBtn

	local _costLab = zc.createRichLabel({
        fontSize = 20,
        anchor = cc.p(0.5, 0),
        pos = cc.p(_castBtn:getPositionX(), _castBtn:getPositionY() + _castBtn:getContentSize().height*0.5 + 5)
    })  
    self:addChild(_costLab, 1)
    self._costLab = _costLab


    local _tipDi = zc.createSprite("res/Main/smithy/weaponCast/tipDi.png")
	_tipDi:setPosition(zc.width*0.25, _resetBtn:getPositionY() + 85)
	self:addChild(_tipDi, 1)
	local _pScale = 0.5
	local _tipImg = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(-5, _tipDi:getContentSize().height*0.5 + 5),
        scale = _pScale,
    })
    _tipDi:addChild(_tipImg)
    _tipImg._pScale = _pScale
	local _tipLab = zc.createRichLabel({
		text = "",
		anchor = cc.p(0, 0.5),
		color = cc.c3b(184, 148, 115),
		pos = cc.p(_tipImg:getPositionX() + _tipImg:getContentSize().width*_pScale - 5, _tipImg:getPositionY()),
		fontSize = 20,
	})
	_tipDi:addChild(_tipLab)
	self._tipDi = _tipDi
	self._tipImg = _tipImg
	self._tipLab = _tipLab

    local _preViewBtn = zc.createPushButton({
    	normalFile = "res/Main/smithy/weaponCast/yulan.png",
        pos = cc.p(zc.width*0.5 - 20, zc.height*0.5 + 150),
        endCallback = function()
	        if not self._nowSelectedMain then
	        	zc.tipInfo(zc.lang("tips_not_selected_weapon"))
	        	return
	        end
        	zc.sendHttp({
        		apiName = "Weapon_castPreview",
				params = {weaponId = self._nowSelectedMain.id},
        		successCallback = function( backData )
	        		local _params = {
	        			isPreview = true,
	        			beforeData = self._nowSelectedMain,
	        			level = self:getWeaponLevelById(self._nowSelectedMain.id),
	        			afterData = backData.weaponInfo,
	        		}
					zc.createSourcePop("WeaponCastAttr", "src/layer/smithyHouse/WeaponCastAttrPop.lua", _params)
        		end
        	})
        end
    })  
    self:addChild(_preViewBtn, 1)


	self:freshBtnStatus()
end

function WeaponCastLayer:initRight()
	-- 右侧主体
	local _rightSize = cc.size(418, 551)
	local right_bg = zc.createNormalPop({
        srcTag = 2,
        width = _rightSize.width,
        height = _rightSize.height,
    })
    right_bg:setAnchorPoint(0, 0.5)
    right_bg:setPosition(zc.width*0.5 + 30, zc.height*0.5)
    self:addChild(right_bg, 1)

    --顶部
    local _topBg = zc.createSprite("res/Main/role/common/top_bg.jpg")
    _topBg:setAnchorPoint(0.5, 1)
    _topBg:setPosition(_rightSize.width*0.5, _rightSize.height - 33)
    right_bg:addChild(_topBg, 1)
    _topBg:setScaleX(409/_topBg:getContentSize().width)

    local _nameBgSize = cc.size(211, 32)
    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", _nameBgSize)
    nameBg:setPosition(_topBg:getPositionX(), _topBg:getPositionY() - _topBg:getContentSize().height*0.5)
    right_bg:addChild(nameBg, 1)
    local titleName = zc.createLabel({
        text = zc.lang("weapon_list"),
        outLine = true,
        fontSize = 22,
        pos = cc.p(_nameBgSize.width*0.5, _nameBgSize.height*0.5),
        color = cc.c3b(219, 212, 167),
    })
    nameBg:addChild(titleName)

    local _descBtn = zc.createPushButton({
		normalFile = "res/Main/common/button/exclamation_u.png",
		selectedFile = "res/Main/common/button/exclamation_d.png",
		pos = cc.p(_nameBgSize.width + 70, _nameBgSize.height*0.5),
		endCallback = function()
			-----玩法说明
            zc.createRulePop(11)
		end
	})
	nameBg:addChild(_descBtn)

    -- 列表
    local _tableSize = cc.size(_rightSize.width, _rightSize.height - 85)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    right_bg:addChild(_tableView)

    local _cellSize = cc.size(_tableSize.width, 105)
    local function numberOfCellsInTableView()
    	local _num = math.ceil((#self._nowTabDatas[self._nowTabSelected])/4)
        return _num
    end
    local function cellSizeForTable(table, idx) 
        return _cellSize.height , _cellSize.width
    end

    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        if not cell then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end
        cell:removeAllChildren()
        self:updateCell(cell, cellIndex)
        return cell 
    end
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)

    self._tableView = _tableView

    -- 边栏按钮
    local initPosY = 509 - 70/2
    for i=1,#self._tagNames do
        local tabBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/tab_btn_noraml.png",
            needSwallow = false,
            touchScale = 0.9,
            anchor = cc.p(0, 0.5),
            pos = cc.p(right_bg:getContentSize().width, initPosY-(i-1)*72),
            endCallback = function()
            	self:changeTab(i)
            end,
        })
        right_bg:addChild(tabBtn)
        self._tabBtns[#self._tabBtns + 1] = tabBtn

        local labPos = cc.p(42, 36)
        local labAnchor = cc.p(0,0.5)
        if i == 1 then
            labPos = cc.p(123/2-15,36)
            labAnchor = cc.p(0.5, 0.5)
        end

        local normalLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 23,
            ap = labAnchor,
            pos = labPos,
            outLine = true,
            color = zc.tabLabNormalColor1,
            color2 = display.COLOR_WHITE,
            pixel = 0.5,
        })
        tabBtn:addChild(normalLab, 2)
        local selectedLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 23,
            ap = labAnchor,
            pos = labPos,
            outLine = true,
            color = display.COLOR_WHITE,
            color2 = zc.tabLabselectColor2 ,
            pixel = 1,
        })
        tabBtn:addChild(selectedLab, 2)
        selectedLab:setVisible(false)
        tabBtn._normalLab = normalLab
        tabBtn._selectLab = selectedLab

        if i > 1 then
            local itemimg = zc.getSprite({
                src = zc.getHeroTypeImg(i-1),
                pos = cc.p(5, tabBtn:getContentSize().height/2),
                ap = cc.p(0,0.5),
            })
            tabBtn:addChild(itemimg, 2)
        end
    end
end

function WeaponCastLayer:updateCell( cell, idx )
	local _tabDatas = self._nowTabDatas[self._nowTabSelected]
	for i=1, 4 do
		local _idx = idx*4 + i
		local _data = _tabDatas[_idx]
		if _data then
	        local item
	        local _weaponId = tonumber(_data.weaponId) or 0
	        item = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeWeapon,
                    type = 1, 
                    id = _weaponId,
                    quality = _data.color,
                    grade = _data.grade,
                    level = (zc.getLevelTipShow()..self:getWeaponLevelById(_data.id)),
                },
                showLevel = true,
                showDetailPop = true,
                primaryId = _data.id,
                listener = function() 
                	if self._nowSelectedMain == nil then
                		print("-------1")
                		local _quality = tonumber(_data.quality) or 1
				        local _grade = tonumber(_data.grade or 0)
				        self._nowCastLimitInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_foundry_level", _quality)
				        local _limitLevel = tonumber(self._nowCastLimitInfo.level) or 0
				        local _currentGID = getGuideManager():getCurrentGID()
				        if _grade >= _limitLevel then
				        	zc.tipInfo(zc.lang("tips_weapon_cast_to_limit"))
						    if _currentGID == GuideKey.KEY_14204 then
						    	getGuideManager():setFuncGuideOver()
						    end
				        	return
				        end    
				        _grade = _grade + 1
					    if _currentGID == GuideKey.KEY_14204 then
					    	zc.setGuideFuncNextStep(_currentGID)
					    end
				        self._nowCastCostInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_foundry_info", _grade)
                		self._nowSelectedMain = _data
                		self:freshUI()
                		self:addGuide()
				    elseif self._nowSelectedMain.id ~= _data.id then
				    	local _flag = 0
				    	for k,v in pairs(self._nowSelectedCast) do
				    		if v.id == _data.id then
				    			_flag = tonumber(k)
				    			break
				    		end
				    	end
				    	if _flag ~= 0 then
				    		self._nowSelectedCast[_flag] = nil
			    			if item.effect then
			    				item.effect:removeFromParent()
			    			end
						    self:freshBtnStatus()
				    	else
				    		local _limitNum = tonumber(self._nowCastCostInfo.weaponNum) or 0
				    		local _currentGID = getGuideManager():getCurrentGID()
						    if table.nums(self._nowSelectedCast) >= _limitNum then
						        if _currentGID == GuideKey.KEY_14205 or _currentGID == GuideKey.KEY_14206 then
							    	getGuideManager():setFuncGuideOver()
							    end
					    		return
				    		end 
				    		if _currentGID == GuideKey.KEY_14205 or _currentGID == GuideKey.KEY_14206 then
						    	zc.setGuideFuncNextStep(_currentGID)
						    end
				    		for i=1, _limitNum do
				    			if not self._nowSelectedCast[i] then
				    				self._nowSelectedCast[i] = _data
				    				break
				    			end
				    		end
				    		self:createSelectEffect(cell, item)
						    self:freshBtnStatus()
					    	self:addGuide()
				    	end
				    end
                end,
	            pos = cc.p(59+(i-1)*99, 55), 
	        })
	        item:setScale(87/120)
	        cell:addChild(item)
	        -- 已装备
	        if _data.heroId ~= 0 then
				local _equiped = cc.Sprite:create( "res/Main/role/attribute/equiped.png" )
				_equiped:setAnchorPoint( 0, 1 )
				_equiped:setPosition( -3, item:getContentSize().height + 3 )
			    item:addChild( _equiped )
			end
			-- _cellBg._equiped = _equiped

	        local _currentGID = getGuideManager():getCurrentGID()
	        if _currentGID == GuideKey.KEY_14203 and _weaponId == GuideWeaponId.weapone14204 and not self._guideBtn1 then
	        	self._guideBtn1 = item
	        elseif _currentGID == GuideKey.KEY_14205 and _weaponId == GuideWeaponId.weapone14205 and not self._guideBtn2 then
	        	self._guideBtn2 = item
	        elseif _currentGID == GuideKey.KEY_14205 and _weaponId == GuideWeaponId.weapone14206 and not self._guideBtn3 then
	        	self._guideBtn3 = item
	        end
	    	for k,v in pairs(self._nowSelectedCast) do
	    		if v.id == _data.id then
	    			self:createSelectEffect(cell, item)
	    			break
	    		end
	        end
	    end
    end
end

--创建选中效果
function WeaponCastLayer:createSelectEffect(cell, item)
    local effect = zc.getItemClickEffect(2)
    effect:setPosition(item:getPositionX(), item:getPositionY())
    cell:addChild(effect, 1)
    effect:setScale(87/120)
    item.effect = effect
end

function WeaponCastLayer:changeTab( idx, isFresh )
	local _node = self._tabBtns[idx]
    local function getNormal()
        return zc.createSprite("res/Main/common/button/tab_btn_noraml.png")
    end
    local function getSelect()
        return zc.createSprite("res/Main/common/button/tab_btn_select.png")
    end
    if isFresh or not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        else
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn._normalLab:setVisible(true)
            self._selectedBtn._selectLab:setVisible(false)
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        end
        self._nowTabSelected = idx
        self._tableView:reloadData()
    end
end

function WeaponCastLayer:freshBtnStatus()
    local _flag1 = self._nowSelectedMain ~= nil
	self._castBtn:setVisible(_flag1)
	self._resetBtn:setVisible(_flag1)
	self._costLab:setVisible(_flag1)

	local _limitNum = tonumber(self._nowCastCostInfo.weaponNum) or 0
	local _flag2 = table.nums(self._nowSelectedCast) >= _limitNum
	self._castBtn:setEnable(_flag2)

	local _costInfo = self._nowCastCostInfo.expend or ""
	_costInfo = string.split(_costInfo, "|")
	self._costLab:setString(zc.getResRichText(_costInfo[2] or zc.dataTypeGold, _costInfo[3] or 0))

	local _mainNode = self._mainNode
	_mainNode.mainWeapon:removeAllChildren()
	local _showString = zc.lang("tips_click_right_to_choose_weapon_cast")
	if _flag1 then
		local _data =self._nowSelectedMain
		local _grade = tonumber(_data.grade) or 0
		local _item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = _data.weaponId,
                quality = _data.color,
                grade = _data.grade,
                level = (zc.getLevelTipShow()..self:getWeaponLevelById(_data.id)),
            },
            showLevel = true,
            showDetailPop = true,
            primaryId = _data.id,
            listener = function() 
            	self:doReset()
            end,
        })
        _item:setScale(0.95)
        _mainNode.mainWeapon:addChild(_item)
        if _grade == 0 then
        	_showString = zc.lang("need ") .. "[color=ffff0000]" .. _limitNum .. "[/color]" .. zc.lang("num_ba") .. "[color=ffffffff]" .. zc.lang("un_casted") .. "[/color]" .. zc.lang("de_weapon")
        else
        	_showString = zc.lang("need ") .. "[color=ffff0000]" .. _limitNum .. "[/color]" .. zc.lang("num_ba") .. "[color=ffffffff]+" .. _grade .. "[/color]" .. zc.lang("de_weapon")
        end
	end
	self._tipLab:setString(_showString)
	local _width = self._tipImg:getContentSize().width*self._tipImg._pScale - 5 + self._tipLab:getContentSize().width
	self._tipImg:setPositionX((self._tipDi:getContentSize().width - _width)*0.5)
	self._tipLab:setPositionX(self._tipImg:getPositionX() + self._tipImg:getContentSize().width*self._tipImg._pScale - 5)

	for i=1, 5 do
		local _lockSp = _mainNode["lock" .. i]
		local _openSp = _mainNode["open" .. i]
    	if _openSp.item then
    		_openSp.item:removeFromParent()
    	end
    	if _openSp.bicheng then
    		_openSp.bicheng:removeFromParent()
    	end
    	_openSp.item = nil
		_openSp.bicheng = nil
		if i <= _limitNum then
			_lockSp:setVisible(false)
			_openSp:setVisible(true)
			_openSp._plus:setVisible(not self._nowSelectedCast[i])
			if self._nowSelectedCast[i] then
				local _data =self._nowSelectedCast[i]
				local _item = zc.createIconByData({
	                data = {
	                    mainType = zc.mainTypeWeapon,
	                    type = 1, 
	                    id = _data.weaponId,
	                    quality = _data.color,
	                    grade = _data.grade,
	                    level = (zc.getLevelTipShow()..self:getWeaponLevelById(_data.id)),
	                },
	                pos = cc.p(_openSp:getContentSize().width*0.5, _openSp:getContentSize().height*0.5),
	                showLevel = true,
	                primaryId = _data.id,
	                showDetailPop = true,
	                listener = function() 
	                	self._nowSelectedCast[i] = nil
	                	self._tableView:reloadDataAndScrollToCurrentCell()
					    self:freshBtnStatus()
	                end,
		        })
		        _item:setScale(0.64)
		        _openSp:addChild(_item)
		        _openSp.item = _item
		        if _data.weaponId == self._nowSelectedMain.weaponId then
		        	local _bicheng = zc.createSprite("res/Main/smithy/weaponCast/bicheng.png")
			        _bicheng:setPosition(_item:getPosition())
			        _bicheng:runAction(cc.RepeatForever:create(cc.Sequence:create(
						cc.FadeTo:create(0.5, 255*0.3),
						cc.FadeTo:create(0.5, 255)
					)))
			        _openSp:addChild(_bicheng)
			        _openSp.bicheng = _bicheng
		        end
			end
		else
			_lockSp:setVisible(true)
			_openSp:setVisible(false)
		end
	end
end

function WeaponCastLayer:freshUI( freshData )
	local _freshData = freshData == nil and true or freshData
	if _freshData then
		self:freshNowTableData()
	end
    self:freshBtnStatus()
    -- self:changeTab(1, true)
    self._tableView:reloadData()

end

return WeaponCastLayer	