--[[
FileName 		TalentPop.lua
ProjectName		HJ2

Created by wangming on 16-03-29

]]

local TalentPop = class("TalentPop", function ()
    return ZCPopLayer:create()
end)

function TalentPop:create( params )
    local _pop = TalentPop.new( params )
    _pop:show(false)
	return _pop
end

function TalentPop:ctor( params )
    local bg_sp = zc.createNormalPop({
        tag = 4,
        showSide = false,
        bianZOrder = 1,
        height = 570,
    }) 
    self.containerBg = bg_sp
    bg_sp:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(bg_sp)

    local width = bg_sp:getContentSize().width
    local height = bg_sp:getContentSize().height

    local _title = zc.getTipPopTitle("minggeshuxing")
    _title:setPosition(width*0.5, height - 30)
    bg_sp:addChild(_title, 1)

    local close = zc.createBackButton({
        pos = cc.p(bg_sp:getContentSize().width-10, bg_sp:getContentSize().height-10),
        listener = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12113 
              or _currentGID == GuideKey.KEY_12114
              then
                zc.setGuideFuncNextStep(_currentGID, false)
                local _talentLayer = zc.getScene("Talent")
                if _talentLayer then
                    _talentLayer:guideFunc()
                end
            end 
            self:hide({noAction=true})
        end,
    })
    bg_sp:addChild(close, 1)
    self._close = close

    -------up
    local _equipCircle = zc.getSpine("jsxxyxg", 0.9)
    _equipCircle:setPosition( width/2, height - 140)
    _equipCircle:playAction("animation", true)
    bg_sp:addChild(_equipCircle)

    local _equipBg = ccui.Scale9Sprite:create( cc.rect( 20, 20, 78, 81 ), "res/Main/role/fetter/fetterItemBg.png" )
    _equipBg:setPosition( _equipCircle:getPosition() )
    bg_sp:addChild( _equipBg )

    local _equip_arrow_l = cc.Sprite:create( "res/Main/role/equip/arrow_1.png" )
    _equip_arrow_l:setPosition( _equipCircle:getPositionX() - 105, _equipCircle:getPositionY() )
    bg_sp:addChild( _equip_arrow_l )
    local _equip_arrow_r = cc.Sprite:create( "res/Main/role/equip/arrow_1.png" )
    _equip_arrow_r:setPosition( _equipCircle:getPositionX() + 105, _equipCircle:getPositionY() )
    _equip_arrow_r:setFlippedX( true )
    bg_sp:addChild( _equip_arrow_r )

    --icon
    local _di = zc.createSprite("res/Main/hero/hero_item6.png")
    _di:setPosition(_equipBg:getPositionX(), _equipBg:getPositionY() + 2)
    _di:setScale(0.8)
    bg_sp:addChild(_di)
    
    local _iconImg = self:createOneSprite("res/Main/talent/icon/", params.icon)
    _iconImg:setPosition(_di:getPosition())
    bg_sp:addChild(_iconImg)
    self._iconImg = _iconImg

    -------middle
    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = width - 26,
        height = 175,
    })
    _middleBg:setAnchorPoint( 0.5, 0 )
    _middleBg:setPosition( width/2, 125 )
    bg_sp:addChild( _middleBg )
    self._middleBg = _middleBg

    --------bottom
    local bottom = ccui.Scale9Sprite:create(cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png")
    bottom:setContentSize(width - 6, 115)
    bottom:setAnchorPoint(0.5, 0)
    bottom:setPosition(width*0.5, 5)
    bg_sp:addChild( bottom )

    local btn_right = zc.createCommomBtn({
        tag = 1,
        text = "",
        pos = cc.p(bg_sp:getContentSize().width - 85, 50),
        endCallback = function() end,
    })
    bg_sp:addChild(btn_right, 1)
    self._guide_btn = btn_right

    local _star = cc.Sprite:create( "res/Main/common/common_hero_star_1.png" )
    _star:setAnchorPoint(0, 0.5)
    bg_sp:addChild(_star)
    self._star = _star
    local _costLab = zc.createLabel({
        text = "",
        fontSize = 20,
        outLine = true,
        ap = cc.p(0, 0.5),
    })
    bg_sp:addChild(_costLab)
    self._costLab = _costLab

    local _star2 = cc.Sprite:create( "res/Main/common/common_hero_star_1.png" )
    _star2:setScale(0.8)
    _star2:setAnchorPoint(0, 0.5)
    bg_sp:addChild(_star2)
    self._star2 = _star2
    local _costLab2 = zc.createLabel({
        text = "",
        fontSize = 20,
        outLine = true,
        ap = cc.p(0, 0.5),
    })
    bg_sp:addChild(_costLab2)
    self._costLab2 = _costLab2

    self:freshAll(params)

    local _di = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(240, 45))
    _di:setAnchorPoint(0, 0.5)
    _di:setPosition(40, btn_right:getPositionY())
    bg_sp:addChild(_di)

    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    local _tip = zc.getSprite({
        src = "home_icon_info.png",
        plist = true,
        pos = cc.p(15, _di:getContentSize().height*0.5),
        scale = 0.5
    })
    _di:addChild(_tip)
    -- 激活作用对象
    local text = LANGUAGE_talent_showinfo()
    local _text = text[params.effectTarget]
    -- 如果是更改天赋的
    if params.effectId == 109 then
        _text = text[2]
    end
    local labTxt = zc.createRichLabel({
        text = _text,
        fontSize = 22,
        anchor = cc.p(0, 0.5),
        pos = cc.p(35, _di:getContentSize().height*0.5),
    })
    _di:addChild( labTxt )
end

function TalentPop:freshAll( params )
    self._params = params
    local nowLevelData = gameData.getDataFromCache("castle_grid_level", {gridId = params.id, level = params.nowLevel})
    local nextLevelData = gameData.getDataFromCache("castle_grid_level", {gridId = params.id, level = tonumber(params.nowLevel) + 1})
    if next(nextLevelData) == nil then
        nextLevelData = nowLevelData
    end

    self._activeStatus = params.activeStatus
    self._isNeedActive = params.nowLevel == 0 and true or false
    self._isMaxLevel = false
    if nowLevelData.level and nowLevelData.level >= nextLevelData.level then
        self._isMaxLevel = true
    end

    self:freshIcon()
    self:freshMiddle(nowLevelData, nextLevelData)
    self:freshBottom(nextLevelData)
end

function TalentPop:freshIcon()
    if self._isNeedActive then
        zc.setGray(self._iconImg, true)
    else
        zc.setGray(self._iconImg, false)
    end
end

function TalentPop:freshMiddle(nowLevelData, nextLevelData)
    local _bottomBg = self._middleBg
    local params = self._params
    _bottomBgWidth = self._middleBg:getContentSize().width
    _bottomBgHeight = self._middleBg:getContentSize().height
    _bottomBg:removeAllChildren()
    local _title = {
        zc.lang("curr_property"),
        zc.lang("next_level"),
    }
    
    if self._activeStatus == 0 or self._activeStatus == 1 then
        _title[2] = zc.lang("active_condition")
    end

    if params.effectId == 109 then
        _title[2] = zc.lang("next_level")
    end

    local _v1 = tonumber(nowLevelData.effectValue) or 0
    local _v2 = tonumber(nextLevelData.effectValue) or 0
    local _num1 = tostring(zc.getAttributeNumById(params.effectId, _v1))
    local _tmp = tostring(zc.getAttributeNumById(params.effectId, _v2))
    local _num2 = 0
    local _num3 = 0
    if string.sub(_num1, -1) == "%"
      or string.sub(_tmp, -1) == "%" then
        local _tmp1 = _num1
        if string.sub(_tmp1, -1) == "%" then
            _tmp1 = string.sub(_tmp1, 1, -2)
        end
        local _tmp2 = _tmp
        if string.sub(_tmp2, -1) == "%" then
            _tmp2 = string.sub(_tmp2, 1, -2)
        end
        _tmp2 = tonumber(_tmp2) or 0
        _tmp1 = tonumber(_tmp1) or 0
        _num2 = (_tmp2 - _tmp1).."%"
        _num3 = _tmp2 .. "%"
    else
        if math.modf(_v1, 1) == 0 then
            _num1 = 0
        else
            _num1 = tonumber(_num1) or 0
        end
        if math.modf(_v2, 1) == 0 then
            _tmp = 0
        else
            _tmp = tonumber(_tmp) or 0
        end
        _num2 = _tmp - _num1
        _num3 = _tmp
    end

    local _text1, _text2
    local _text1, _text2, _color, _color2
    if self._activeStatus ~= 2 and self._isNeedActive then
        local _text = ""
        if self._activeStatus == 1 then
            -- 命格没开启
            local _cengData = gameData.getDataFromCache("houseEffect_castle", {layerId = params.layerId})
            -- dump( _cengData, _ceng )
            if #_cengData == 0 and next( _cengData ) then
                _cengData = { _cengData }
            end
            local minLevel = nil
            for i, v in ipairs( _cengData ) do
                local _level = tonumber( v.id ) or 0
                if minLevel then
                    minLevel = minLevel > _level and _level or minLevel
                else
                    minLevel = _level
                end
            end
            local _houseLevel = gameData.getDataFromCache("house_level", {houseId = 1, effectId = minLevel})
            _text = zc.lang("house_level") ..(_houseLevel.level or 1)..zc.lang("level_unlock")
        else
            if tonumber(params.activateId) ~= 0 then
                local _tb = string.split(params.activateId, ",")
                -- dump(_tb,"tb=====")
                for i=1,#_tb do
                    local _data = gameData.getDataFromCacheWithPrimaryKey("castle_grid", _tb[i])
                    local tmp = _data.name .. _data.maxLevel .. zc.lang("level_1")
                    if i ~= #_tb then
                         tmp = tmp .. "\n"
                    end
                    _text = _text..tmp
                end
            end
        end
        if _text ~= "" then
            _text2 = _text
        end
    end
    for i, v in ipairs( PlayerData:getGeneralInfo() ) do
        if ( tonumber( v.status ) or 0 ) == 1 and tonumber( PlayerData.info.heroId ) == tonumber(v.id) then
            self.heroInfo = v
            break  
        end
    end
    _leftColor = display.COLOR_RED

    if params.effectId == 109 then
        if self._isMaxLevel then
            _leftColor = display.COLOR_GREEN
            _text1 = self:getSoliderTalentName(nextLevelData.effectValue)
        else
            _text1 = _text2
            _title[1] = zc.lang("active_condition")
            local _data = gameData.getDataFromCacheWithPrimaryKey("hero_talent", nextLevelData.effectValue) or {}
            local _lastId = _data.lastconvertId or self.heroInfo.talentId
            _text2 = self:getSoliderTalentName(_lastId) .. "->" .. self:getSoliderTalentName(nextLevelData.effectValue)
        end
    end 

    for i = 1, 2 do
        local _attrBgWidth = ( _bottomBgWidth - 36 )/2
        local _attrBgHeight = 154
        local _attrBg = zc.createGeneralPopScale({
            tag = 2,
            width = _attrBgWidth,
            height = _attrBgHeight,
        })
        _attrBg:setAnchorPoint( 2 - i, 1 )
        _attrBg:setPosition( _bottomBgWidth/2 + 6*( 2*i - 3 ), _bottomBgHeight - 10 )
        _bottomBg:addChild( _attrBg )

        -- 属性标题背景
        local _attrTitle = zc.createLabel({
            text = _title[i],
            fontSize = 20,
            color = cc.c3b(53, 39, 18),
            pos = cc.p( _attrBgWidth/2, _attrBgHeight - 30 ),
        })
        _attrBg:addChild( _attrTitle )
        local _attrTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleLeft:setAnchorPoint( 1, 0.5 )
        _attrTitleLeft:setPosition( _attrTitle:getPositionX() - _attrTitle:getContentSize().width/2, _attrTitle:getPositionY() )
        _attrBg:addChild( _attrTitleLeft )
        local _attrTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleRight:setAnchorPoint( 0, 0.5 )
        _attrTitleRight:setPosition( _attrTitle:getPositionX() + _attrTitle:getContentSize().width/2, _attrTitle:getPositionY() )
        _attrTitleRight:setFlippedX( true )
        _attrBg:addChild( _attrTitleRight )

        if i == 1 then
            if _text1 then
                local _cost = zc.createLabel({
                    text = _text1,
                    fontSize = 20,
                    color = _leftColor,
                    outLine = true,
                    pos = cc.p(_attrBgWidth*0.5, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_cost)
            else
                local _levelTip = zc.createLabel({
                    text = zc.lang("level") .. "：",
                    fontSize = 20,
                    outLine = true,
                    color = cc.c3b(230, 224, 163),
                    ap = cc.p(0, 0.5),
                    pos = cc.p(15, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_levelTip)
                local _level = zc.createLabel({
                    text = params.nowLevel,
                    fontSize = 20,
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(110, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_level)
                local _attrTip = zc.createLabel({
                    text = LANGUAGE_getAttributeTextById(params.effectId) .. "：",
                    fontSize = 20,
                    color = cc.c3b(230, 224, 163),
                    outLine = true,
                    ap = cc.p(0, 0.5),
                    pos = cc.p(15, _attrBgHeight*0.25),
                })
                _attrBg:addChild(_attrTip)
                local _attrValue = zc.createLabel({
                    text = _num1,
                    fontSize = 20,
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(110, _attrBgHeight*0.25),
                })
                _attrBg:addChild(_attrValue)
            end
        elseif i == 2 then
            if self._isMaxLevel then
                local _cost = zc.createLabel({
                    text = zc.lang("tips_max_level_only"),
                    fontSize = 20,
                    color = display.COLOR_GREEN,
                    outLine = true,
                    pos = cc.p(_attrBgWidth*0.5, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_cost)
            elseif _text2 then
                local _cost = zc.createLabel({
                    text = _text2,
                    fontSize = 20,
                    color = display.COLOR_RED,
                    outLine = true,
                    pos = cc.p(_attrBgWidth*0.5, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_cost)
            else
                local _levelTip = zc.createLabel({
                    text = zc.lang("level") .. "：",
                    fontSize = 20,
                    color = cc.c3b(230, 224, 163),
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(15, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_levelTip)
                local _level = zc.createLabel({
                    text = (tonumber(params.nowLevel) or 0) + 1,
                    fontSize = 20,
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(75, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_level)
                local _green = zc.getSprite({
                    src = "res/Main/common/arrow_green.png",
                    pos = cc.p(190, _attrBgHeight*0.5),
                    ap = cc.p(0.5, 1),
                })
                _green:setRotation(-90)
                _attrBg:addChild(_green)
                local _levelAdd = zc.createLabel({
                    text = "+1",
                    fontSize = 20,
                    color = display.COLOR_GREEN,
                    ap = cc.p(1, 0.5),
                    outLine = true,
                    pos = cc.p(_green:getPositionX() - _green:getBoundingBox().height*0.5 + 2, _attrBgHeight*0.5),
                })
                _attrBg:addChild(_levelAdd)
                local _attrTip = zc.createLabel({
                    text = LANGUAGE_getAttributeTextById(params.effectId) .. "：",
                    fontSize = 20,
                    color = cc.c3b(230, 224, 163),
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(15, _attrBgHeight*0.25),
                })
                _attrBg:addChild(_attrTip)
                local _attrValue = zc.createLabel({
                    text = _num3,
                    fontSize = 20,
                    ap = cc.p(0, 0.5),
                    outLine = true,
                    pos = cc.p(75, _attrBgHeight*0.25),
                })
                _attrBg:addChild(_attrValue)
                local _green = zc.getSprite({
                    src = "res/Main/common/arrow_green.png",
                    pos = cc.p(190, _attrBgHeight*0.25),
                    ap = cc.p(0.5, 1),
                })
                _green:setRotation(-90)
                _attrBg:addChild(_green)
                local _attrAdd = zc.createLabel({
                    text = "+" .. _num2,
                    fontSize = 20,
                    outLine = true,
                    color = display.COLOR_GREEN,
                    ap = cc.p(1, 0.5),
                    pos = cc.p(_green:getPositionX() - _green:getBoundingBox().height*0.5 + 2, _attrBgHeight*0.25),
                })
                _attrBg:addChild(_attrAdd)
            end
        end
    end
end

function TalentPop:freshBottom(nextLevelData)
    local btn_right = self._guide_btn
    local _star = self._star
    local _costLab = self._costLab
    local _star2 = self._star2
    local _costLab2 = self._costLab2
    if self._isMaxLevel then
        btn_right:setEnable(false)
        _star:setVisible(false)
        _costLab:setVisible(false)
        _star2:setVisible(false)
        _costLab2:setVisible(false)
        btn_right:setString(self._isNeedActive and zc.lang("activated") or zc.lang("upgrade"))
        return
    end
    if self._activeStatus ~= 2 then
        btn_right:setEnable(false)
    else
        btn_right:setEnable(true)
    end
    btn_right:setString(self._isNeedActive and zc.lang("activated") or zc.lang("upgrade"))
    local params = self._params
    btn_right:setTouchEndedCall(function()
        --功能引导 --结束
        if self._activeStatus == 2 then
            local _str = "Talent_Upgrade"
            local _id = params.keyId
            if self._isNeedActive then
                _str = "Talent_Active"
                _id = params.id
            end
            local _num = tonumber(PlayerData:getResourcesInfoById(nextLevelData.expendType1)) or 0
            local _num2 = 0
            local _cost2 = 0
            if nextLevelData.item ~= 0 and string.len(nextLevelData.item) > 0 then
                local _info = string.split(nextLevelData.item, "|")
                _num2 = tonumber(zc.getNumByTypeId(_info[1], _info[2])) or 0
                _cost2 = tonumber(_info[3]) or 0
            end

            if _num >= nextLevelData.expendNum1 and _num2 >= _cost2 then
                local _nowHeroInfo = nil
                if params.effectId == 109 then
                    _nowHeroInfo = clone(PlayerData:getPlayerHero())
                end 
                zc.sendHttp({
                    apiName = _str,
                    params = {id = _id},
                    successCallback = function (data)
                        PlayerData:updataData(data)
                        btn_right:setEnable(false)
                        local _talentLayer = zc.getScene("Talent")
                        if _talentLayer then
                            _talentLayer:freshData(params.id, data)
                        end
                        params.nowLevel = data.level
                        if data.id then
                            params.keyId = data.id
                        end
                        if self._iconImg then
                            local armature= zc.createAnimationArmature({
                                fileName = "ef_mingge",
                                autoRemove = true,
                            })
                            armature:getAnimation():playWithIndex(0)
                            armature:setScale( 0.95 )
                            armature:setPosition( self._iconImg:getContentSize().width*0.5, self._iconImg:getContentSize().height*0.5 )    
                            self._iconImg:addChild( armature )
                        end

                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_12106 
                         or _currentGID == GuideKey.KEY_12108 
                         or _currentGID == GuideKey.KEY_12111 then
                            zc.setGuideFuncNextStep(_currentGID, false)
                            if _currentGID == GuideKey.KEY_12111 then
                                self:hide({noAction=true})
                            else
                                self:freshAll(params)
                                getGuideManager():setObjTarget(self._close, 0.6)
                                getGuideManager():startGuide()
                            end
                        else
                            self:freshAll(params)
                        end

                        if params.effectId == 109 and data.mainInfo then
                            xpcall(function()
                                data.nowHeroInfo = _nowHeroInfo
                                zc.createSourceScene("TalentChange", "src/layer/talent/TalentChangePop.lua", data)
                            end, function() end)
                            PlayerData:updateGeneralInfo(data.mainInfo)
                        end
                    end,
                })
            else
                zc.tipInfo(zc.lang("tips_castle_need_resource_unenough"))
            end
        elseif _activeStatus == 1 then
            zc.tipInfo(zc.lang("tips_castle_ceng_unopen"))
        else
            zc.tipInfo(zc.lang("tips_need_active_prefore_castle"))
        end
    end)

    _star:setVisible(true)
    _costLab:setVisible(true)
    _costLab:setString("x" .. tostring(nextLevelData.expendNum1))
    local _startY = btn_right:getPositionY() + 44
    if nextLevelData.item ~= 0 and string.len(nextLevelData.item) > 0 then
        local _info = string.split(nextLevelData.item, "|")
        local _iconInfo = zc._getIconInfo({
            data = {
                mainType = _info[1],
                type = _info[2],
                id = _info[2],
            }
        })
        local _cost2 = tonumber(_info[3]) or 0
        _star2:setVisible(true)
        _costLab2:setVisible(true)
        _star2:setTexture(_iconInfo.img)
        _star2:setScale(0.35)
        _costLab2:setString("x" .. _cost2)

        local _startX = btn_right:getPositionX() - 10
        local _width = _costLab:getContentSize().width + _star:getContentSize().width + _star2:getContentSize().width*_star2:getScale() + _costLab2:getContentSize().width + 5
        _star:setPosition( _startX - _width/2, _startY)
        _costLab:setPosition( _star:getPositionX() +  _star:getContentSize().width, _startY)
        _star2:setPosition( _costLab:getPositionX() +  _costLab:getContentSize().width + 5, _startY)
        _costLab2:setPosition( _star2:getPositionX() +  _star2:getContentSize().width*_star2:getScale(), _startY)
    else
        local _startX = btn_right:getPositionX() - 10
        local _width = _costLab:getContentSize().width + _star:getContentSize().width
        _star:setPosition( _startX - _width/2, _startY)
        _costLab:setPosition( _star:getPositionX() +  _star:getContentSize().width, _startY)
    end
    
end

function TalentPop:createOneSprite( src, num )
    local _s = cc.Sprite:create(src .. num .. ".png")
    if not _s then
        _s = zc.createSprite(src .. "1.png")
    end
    return _s
end

  -- 如果是更改天赋的--获取武将天赋名称
function TalentPop:getSoliderTalentName(talentId)
    local _name = ""
    local _data = gameData.getDataFromCacheWithPrimaryKey("hero_talent", talentId)
    if next(_data) ~= nil then
        _name = _data.name
    end
    return _name
end

function TalentPop:onEnter()
    self:addGuide()
end
function TalentPop:addGuide()
    --功能引导
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12105 
      or _currentGID == GuideKey.KEY_12107 
      or _currentGID == GuideKey.KEY_12110 then
        zc.setGuideFuncNextStep(_currentGID)
        getGuideManager():addMaskLayer()
        performWithDelay(self,function ()
            self:addGuide()
        end, 0.3)
    elseif _currentGID == GuideKey.KEY_12106
      or _currentGID == GuideKey.KEY_12108
      or _currentGID == GuideKey.KEY_12111 then
        getGuideManager():removeMaskLayer()
        if self._guide_btn and self._guide_btn:isEnable() then
            getGuideManager():setObjTarget(self._guide_btn)
            getGuideManager():startGuide() 
        else
            getGuideManager():setFuncGuideOver()
        end
    end
end

return TalentPop