
zc = zc or {}
zc.bgm = zc.bgm or {}

zc.bgm = {
    login = "res/audio/bgm/Login.mp3",
    city = "res/audio/bgm/city_bgm.mp3",
    battle = "res/audio/bgm/battlebgm.mp3",
    battleBoss = "res/audio/bgm/bossbattle.mp3",
    battlePvp = "res/audio/bgm/pvpFight.mp3",
    mainChapter = "res/audio/bgm/zhuxian.mp3",
    farm = "res/audio/bgm/yewai.mp3",
}
zc.effect = {
    battleWin = "res/audio/ui/battleSucceed.mp3",
    battleLose = "res/audio/ui/battleDefeat.mp3",
    btnClick = "res/audio/ui/dianji_btn.mp3",
    btnClose = "res/audio/ui/gongnengclose_btn.mp3",
    btnOpen = "res/audio/ui/gongnengopen_btn.mp3",
    btnFight = "res/audio/ui/fightStart_btn.mp3",
    btnBubble = "res/audio/ui/dianjiqipao_btn.mp3",
    btnActive = "res/audio/ui/huodongopen_btn.mp3",

    effWood = "res/audio/ui/shouwood.mp3",
    effStone = "res/audio/ui/shoushitou.mp3",
    effLevy1 = "res/audio/ui/zhengshou.mp3", --征收1
    effLevy2 = "res/audio/ui/mucaizhengshou.mp3", --征收2
    effLevy3 = "res/audio/ui/kuangshizhengshou.mp3", --征收3
    zhaomu = "res/audio/ui/zhaomu.mp3", --招募
    hecheng = "res/audio/ui/hecheng.mp3", --合成武器
    equipStrengthen = "res/audio/ui/qianghuaEffect.mp3", -- 装备强化
    equipStrengthenCrit = "res/audio/ui/qianghuabaoji.mp3", -- 装备强化暴击
    equipAdvance = "res/audio/ui/jinjie.mp3", -- 装备进阶
    btnFetch = "res/audio/ui/lingquAward_Btn.mp3", -- 领奖
    heroStarup = "res/audio/ui/shengxing.mp3", -- 武将升星
    weaponOn = "res/audio/ui/weaponOn.mp3", -- 拿武器
    weaponOff = "res/audio/ui/weaponUp.mp3", -- 脱武器
    levelUp = "res/audio/ui/levelUp.mp3", -- 升级
    shopBuy = "res/audio/ui/ShopBuy.mp3", -- 商店购买
    juanzhou = "res/audio/ui/juanzhouchuxian.mp3", -- 战斗中卷轴出现
    gouyufei = "res/audio/ui/gouyufei.mp3", -- 勾玉合成飞音效
    gouyuhecheng = "res/audio/ui/gouyuhecheng.mp3", -- 勾玉合成音效
    chongsheng = "res/audio/ui/chongsheng.mp3", -- 武将重生
    yanxi = "res/audio/ui/yanxi.mp3", -- 研习
    shengbingqianghua = "res/audio/ui/shenbingqianghua_l.mp3", -- 神兵强化
    shengbingshengji = "res/audio/ui/shenbingshengji.mp3", -- 神兵升级

}

zc.visibleSize = cc.size(922,576)
function zc.getWritablePath()
    return cc.FileUtils:getInstance():getWritablePath()..___GAME_PATH___
end

function zc.showErrorDialog(msg)
    if APP_ENV ~= "dev" then
        print("error_msg : ", msg)
        return
    end
    local _scene = cc.Director:getInstance():getRunningScene()
    if not _scene then
        return
    end
    local _file = requires("src/pop/bugPop.lua")
    local _lay = _file:create({msg = msg..debug.traceback()})
    _scene:addChild(_lay, 999999)
    cc.Director:getInstance():pause()
end

function zc.luaBridgeCall(className,functionName,args,sigs)
    local platform = cc.Application:getInstance():getTargetPlatform()
    local ok,ret
    if platform == cc.PLATFORM_OS_ANDROID then
        local luaj = requires("src/cocos/cocos2d/luaj.lua")
        ok,ret  = luaj.callStaticMethod(className,functionName,args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local luaoc = requires("src/cocos/cocos2d/luaoc.lua")
        ok,ret  = luaoc.callStaticMethod(className, functionName, args)
    end
    if not ok then
        print("luaoc error:"..tostring(ret)..",className="..tostring(className)..",methodName="..tostring(functionName))
    else
        print("The oc ret is:"..tostring(ret)..",className="..tostring(className)..",methodName="..tostring(functionName))
    end
end

function zc.getGameInfoFromSdk( callback )
    local platform = cc.Application:getInstance():getTargetPlatform()
    local callbackLua = function ()
    end
    local args = {}
    local sigs = nil

    local _manifest = zc.getManifest(0, true) or {}
    PACKAGE_VERSION = _manifest.version or "0.1"
    print("wm----PACKAGE_VERSION : ", PACKAGE_VERSION)
    --初始化SDK平台
    if (cc.PLATFORM_OS_ANDROID == platform) then
        --渠道号默认为官网渠道
        GAME_CHANNEL = CHANNEL.Android.CHANNEL_CODE_CN
        GAME_SDK     = GAMESDK.SDK_ZHANYOU--[[默认展游sdk]]
        callbackLua =  function (param)
            local _param_ = json.decode(param)
            GAME_CHANNEL        = tostring(_param_["channel"])
            GAME_MAC            = tostring(_param_["macAddr"])
            GAME_MODEL          = tostring(_param_["model"])
            GAME_IMEI           = tostring(_param_["imei"])
            GAME_OS_VERSION     = tostring(_param_["os_version"])
            GAME_ANDROIDID      = tostring(_param_["androidId"])
            GAME_PACKAGENAME    = tostring(_param_["packageName"])
            GAME_DEVICE_SIGN    = GAME_ANDROIDID
            GAME_SDK            = tostring(_param_["gameSdk"])
            print("GAME_CHANNEL="..tostring(GAME_CHANNEL)
                ..",GAME_MAC="..tostring(GAME_MAC)
                ..",GAME_OS_VERSION="..tostring(GAME_OS_VERSION)
                ..",GAME_SDK="..tostring(GAME_SDK)
                ..",GAME_PACKAGENAME="..tostring(GAME_PACKAGENAME))
            if callback then
                callback()
            end
        end
        args = { callbackLua }
        sigs = "(I)V"
    elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then
        callbackLua = function( param )
            if param["channel"] ~= nil then
                GAME_CHANNEL            = tostring(param["channel"]) 
                GAME_IDFA               = tostring(param["idfa"])
                GAME_OS_VERSION         = tostring(param["os_version"])
                GAME_PACKAGENAME        = tostring(param["packageName"])
                GAME_DEVICE_SIGN        = GAME_IDFA
                GAME_SDK                = GAMESDK.SDK_ZHANYOU--[[默认展游sdk]]
            end
            local _id = zc.getChannelPackageId() 
            if GAME_CHANNEL == "appstore" and _id == 5 then
                GAME_CHANNEL = CHANNEL.IOS.CHANNEL_CODE_APPSTORE_QLWZ
            end
            print("GAME_CHANNEL="..tostring(GAME_CHANNEL)..",GAME_OS_VERSION="..GAME_OS_VERSION..",GAME_IDFA="..GAME_IDFA..",GAME_PACKAGENAME="..GAME_PACKAGENAME)
            if callback then
                callback()
            end
        end
        args = { callback = callbackLua }
    else
        if callback then
            callback()
        end
    end
    zc.luaBridgeCall(LUA_SDKHELPER_CLASS,"getGameInfo",args,sigs)
end


function zc.enterCustomerServiceCenter()
    local _param_ = {
                        uid = tostring(PlayerData["info"]["userId"]),
                        nickName = tostring(PlayerData["info"]["userName"]),
                        level = tostring(PlayerData["info"]["level"]), 
                        serverId = tostring(PlayerData["serverInfo"]["serverId"]),
                        serverName = tostring(PlayerData["serverInfo"]["serverName"]),
                        vip = tostring(PlayerData["info"]["vip"]),
                        appUId = tostring(GAMETOKEN),
                    }
    local platform = cc.Application:getInstance():getTargetPlatform()
    local args = {}
    local sigs = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        --玩家角色ID，玩家角色名，玩家角色等级，游戏区服ID,游戏服务器名字,vip
        local param = json.encode(_param_)
        args = {param}
        sigs = "(Ljava/lang/String;)V"
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD) then
        args = _param_
    end
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"enterCustomerServiceCenter",args,sigs)
end

function zc.getSDKNeedParams(isLogin)
    local _tssTime = isLogin and -1 or tostring(PlayerData:getTssTime())
    local _param_ = {}
    xpcall(function()
        _param_ = {
            uid = tostring(PlayerData["info"]["userId"]),
            nickName = tostring(PlayerData["info"]["userName"]),
            level = tostring(PlayerData["info"]["level"]), 
            serverId = tostring(PlayerData["serverInfo"]["tab"]),
            serverName = tostring(PlayerData["serverInfo"]["serverName"]),
            vip = tostring(PlayerData["info"]["vip"]),
            gold = tostring(PlayerData["resourcesInfo"]["gold"]) or 0,
            country = PlayerData:getBaseInfoByTag("countryName") or "无帮派",
            appUId = tostring(GAMETOKEN),
            roleCTime = tostring(PlayerData:getCreateTime()),
            roleLevelMTime = _tssTime
        }
    end, function() end)
    return _param_
end
--[[--登录成功的sdk回调，有些sdk是需要游戏中的角色信息，所以在获取游戏数据后需要回调给sdk端]]
function zc.loginSuccessCallback(isLogin)
    local _param_ = zc.getSDKNeedParams(isLogin)
    local platform = cc.Application:getInstance():getTargetPlatform()
    local args = {}
    local sigs = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        if GAME_SDK == GAMESDK.SDK_ZHANYOU or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
            --玩家角色ID，玩家角色名，玩家角色等级，游戏区服ID,游戏服务器名字,vip
            local param = json.encode(_param_)
            args = {param}
            sigs = "(Ljava/lang/String;)V"
        end
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD) then
        args = _param_
    end
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"ZCSdkSubmitExtendData",args,sigs)
end


--返回登录界面
function zc.doSdkExit(callback)
    local platform = cc.Application:getInstance():getTargetPlatform()
    local args = {}
    local sigs = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        if CHANNEL.Android.CHANNEL_CODE_UC == GAME_CHANNEL
        or CHANNEL.Android.CHANNEL_CODE_BD == GAME_CHANNEL
        or CHANNEL.Android.CHANNEL_CODE_OP == GAME_CHANNEL
        or CHANNEL.Android.CHANNEL_CODE_LX == GAME_CHANNEL then
            if callback then
                args = {callback}
            end
            sigs = "(I)V"
            zc.luaBridgeCall(LUA_BRIDGE_CLASS,"doSdkExit",args,sigs)
        elseif CHANNEL.Android.CHANNEL_CODE_YJ == GAME_CHANNEL then
            if callback then
                args = {zc.getSDKNeedParams(true), callback}
            end
            sigs = "(Ljava/lang/String;I)V"
            zc.luaBridgeCall(LUA_BRIDGE_CLASS,"doSdkExit",args, sigs)
        else
            if callback then
                callback()
            end
        end
    end
end

--[[
    src,
    opacity,
    showYun,
    yunTag,
    yunType,
    yunZorder,
    yunOffY,
    showBack,
    showFlower,
    showFlowerFlag,
    closeCallBack,
    floweZorder,
]]
function zc.createNormalDialog( params )
    local _params = params or {}
    local _src = _params.src or "res/Main/common/common_bg.jpg"
    local _lay = ZCDialog:create(_params.opacity)
    local background = zc.getSprite({
        src = _src,
        name = "background",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
    })
    zc.createSprite(_src)
    _lay:addChild(background, -1)
    zc.setBgSize(background)

    local _showYun = _params.showYun == nil and false or _params.showYun
    if _showYun then
        local _yunTag = _params.yunTag
        local _yunType = _params.yunType
        local _yunZorder = _params.yunZorder or {}
        local _yunOffY = _params.yunOffY or {}
        --添加云动画    
        zc.getYunDongTai(_yunTag, _yunType, function(armUp, armDown)
            if tolua.isnull(_lay) then
                return
            end
            if armUp then
                _lay._yunUp = armUp
                _lay:addChild(armUp, (_yunZorder[1] or -1))
                armUp:setPositionY(armUp:getPositionY() + (_yunOffY[1] or 0))
            end
            if armDown then
                _lay._yunDown = armDown
                _lay:addChild(armDown, (_yunZorder[2] or -1))
                armDown:setPositionY(armDown:getPositionY() + (_yunOffY[2] or 0))
            end
        end)
    end

    --边缘装饰花
    local _showFlower = _params.showFlower == nil and true or _params.showFlower
    if _showFlower then
        local _showFlowerFlag = _params.showFlowerFlag or {1,1,1,1}
        local _floweZorder = _params.floweZorder or {}
        if _showFlowerFlag[1] == 1 then
            local _flower_l_u = zc.getSprite({
                src = "res/Main/common/flower_l_u.png",
                pos = cc.p(0, zc.height),
                ap = cc.p(0, 1),
                name = "flower_l_u",
            })
            _lay:addChild(_flower_l_u, (_floweZorder[1] or 3))
        end
        if _params.limittimehot ~= true then
            if _showFlowerFlag[2] == 1 then
                local _flower_l_d = zc.getSprite({
                    src = "res/Main/common/flower_l_d.png",
                    pos = cc.p(0, 0),
                    ap = cc.p(0, 0),
                    name = "flower_l_d",
                })
                _lay:addChild(_flower_l_d, (_floweZorder[2] or 3))
            end
        end
        if _showFlowerFlag[3] == 1 then
            local _flower_r_u = zc.getSprite({
                src = "res/Main/common/flower_r_u.png",
                pos = cc.p(zc.width, zc.height),
                ap = cc.p(1, 1),
                name = "flower_r_u",
            })
            _lay:addChild(_flower_r_u, (_floweZorder[3] or 3))
        end
        if _showFlowerFlag[4] == 1 then
            local _flower_r_d = zc.getSprite({
                src = "res/Main/common/flower_r_d.png",
                pos = cc.p(zc.width, 0),
                ap = cc.p(1, 0),
                name = "flower_r_d",
            })
            _lay:addChild(_flower_r_d, (_floweZorder[4] or 3))
        end
    end

    --关闭按钮
    local _showBack = _params.showBack == nil and true or _params.showBack
    if _showBack then
        _lay._closeCallBack = _params.closeCallBack
        local _backBtn = zc.createTopBackButton({
            pos = cc.p(zc.width - 60, zc.height - 40), 
            listener = function()
                if _lay._closeCallBack then
                    _lay._closeCallBack()
                else
                    LayerManager.removeLayout()
                end
            end,
        })
        _lay._closeBtn = _backBtn
        _lay:addChild(_backBtn, 5)
    end
    return _lay
end

--[[
    tag, 需要橘色花纹头的时候1，2两个尺寸，此时有width则对应x轴拉伸宽度
    width, 指定宽度，有tag时无效
    height, 指定高度，没有时为默认高度
    src, 背景资源，没有时为默认资源
    srcTag, 默认背景资源标签1，2，3有src时不生效
    showSide: 显示右侧和下边的阴影边
    bianZOrder: 边框层级，默认5
    titleTag: 1信息, 2提示
    titleSrc: 标题图
]]
function zc.createNormalPop( params )
    local params = params or {}
    local _bianZOrder = params.bianZOrder or 5
    local _width = params.width
    local _height = params.height or 539
    local _partBian = cc.size(32, 31)
    local _partFram = cc.size(6, 6)
    _height = _height - _partBian.height
    local _titleImg = nil
    if params.tag then
        local _tag = params.tag or 1
        local _src = "titleBg" .. _tag .. ".jpg"
        _titleImg = zc.getSprite({
            src = "res/Main/common/popBg/" .. _src,
            ap = cc.p(0.5, 1),
            name = "titleImg",
        })
        if _width then
            local _scale = _width/_titleImg:getContentSize().width
            _titleImg:setScaleX(_scale)
        else
            _width = _titleImg:getContentSize().width
        end
    end

    local _src = params.src
    local _srcTag = params.srcTag == nil and 1 or params.srcTag
    _srcTag = _src == nil and _srcTag or nil
    if _srcTag then
        _src = "res/Main/common/popBg/bg" .. _srcTag .. ".jpg"
    end
    local _bgImg = zc.getSprite({
        src = _src,
        name = "bgImg",
        ap = cc.p(0.5, 0),
        -- pos = cc.p(_width*0.5, _partFram.height*0.5),
    })

    _width = _width or _bgImg:getContentSize().width
    _bgImg:setPosition(_width*0.5, _partFram.height*0.5)
    
    local _diNode = cc.Node:create()
    _diNode:setAnchorPoint(0.5, 0.5)
    _diNode:setContentSize(_width, _height)
    _diNode:setPosition(zc.width*0.5, zc.height*0.5)

    local _size = _bgImg:getContentSize()
    local __width = _width
    local __height = _height
    if _titleImg then
        __width = __width - _partFram.width
        __height = _height - _titleImg:getContentSize().height - _partFram.height
    end
    _bgImg:setScaleX(__width/_size.width)
    _bgImg:setScaleY(__height/_size.height)
    _diNode:addChild(_bgImg, -1)

    local _showSide = params.showSide == nil and true or params.showSide
    if _showSide then
        local _b_sideImg = zc.getScaleNode("res/Main/common/popBg/shadow_b.png", cc.size(_width + _partFram.width, _partBian.height))
        _b_sideImg:setAnchorPoint(0, 1)
        _b_sideImg:setPosition(0 - _partFram.width, 0)
        _b_sideImg:setName("b_sideImg")
        _diNode:addChild(_b_sideImg, -1)
        local _r_sideImg = zc.getScaleNode("res/Main/common/popBg/shadow_r.png", cc.size(_partBian.width, _height + _partBian.height))
        _r_sideImg:setAnchorPoint(0, 1)
        _r_sideImg:setPosition(_width - 2, _height)
        _r_sideImg:setName("r_sideImg")
        _diNode:addChild(_r_sideImg, -1)
    end

    if _titleImg then
        _titleImg:setPosition(_width*0.5, _height - _partFram.height*0.5)
        _diNode:addChild(_titleImg, _bianZOrder)
    end

    local _bianImg = zc.getScaleNode("res/Main/common/frame.png", cc.size(_width + 6, _height + 6))
    _bianImg:setPosition(_width*0.5, _height*0.5)
    _bianImg:setName("bianImg")
    _diNode:addChild(_bianImg, _bianZOrder)

    if _titleImg and (params.titleTag or params.titleSrc) then
        
        local _titleSrc = params.titleSrc
        local _tag = params.titleTag or 1
        _tag = _titleSrc == nil and _tag or nil
        if _tag then
            local _tagTable = {"xinxi", "tishi","chenghao","zhanfa"}
            _titleSrc = "res/Main/common/tipTitle/" .. tostring( _tagTable[_tag]  ) .. ".png"
        end
        local _titleTextDi = zc.getSprite({
            src = "res/Main/common/popBg/tipDi.png",
            name = "titleTextDi",
            pos = cc.p(_width*0.5, _height - _titleImg:getContentSize().height*0.5),
        })
        _diNode:addChild(_titleTextDi, _bianZOrder)
        local _titleText = zc.getSprite({
            src = _titleSrc,
            name = "titleText",
            pos = cc.p( _titleTextDi:getPosition() ),
        })
        _diNode:addChild(_titleText, _bianZOrder)
    end
    
    return _diNode
end

--[[
    tag, 1双层套底， 2淡信息底， 3深信息底
    width, 指定宽度，没有时为默认
    height, 指定高度，没有时为默认
]]
function zc.createGeneralPopScale( params )
    local params = params or {}
    local _tag = params.tag or 1
    local _width = params.width or 355
    local _height = params.height or 130
    _tag = _tag + 1
    local _scaleNode = ccui.Scale9Sprite:create(
        cc.rect(22, 22, 5, 5), 
        "res/Main/common/popBg/di_" .. _tag ..".png"
    )
    _scaleNode:setContentSize(_width, _height)
    if _tag == 2 then
        local _scaleInner = zc.getScaleNode(
            "res/Main/common/popBg/di_2_1.png",
            cc.size(_width - 15, _height - 15)
        )
        _scaleInner:setPosition(_width*0.5, _height*0.5 + 3)
        _scaleNode:addChild(_scaleInner)
    end

    return _scaleNode
end

function zc.createCleanBtn( ... )
    local director = cc.Director:getInstance()
    --[[清除缓存 ]]
    local clear_btn = zc.createPushButton({
        normalFile = "res/image/update/game_remove_cache.png",
        scale = 0.4,
        pos = cc.p(zc.width - 30, 30),
        endCallback = function()
            local confirmDialog = ZCConfirmDialog:createWithParams({msg = zc.lang("tips_clean_warning")})
            director:getRunningScene():addChild(confirmDialog)
            confirmDialog:setCallbackRight(function ()
                -- zc.logoutSdk()
                cc.FileUtils:getInstance():removeDirectory(zc.getWritablePath())
                helper.reloadAllFile()
                requires("src/main.lua")
            end)

            confirmDialog:setCallbackLeft(function (  )
                confirmDialog:removeFromParent()
            end)
        end
    })
    return clear_btn
end


function zc.createVersionBtn()
    local manifest      = zc.getManifest() or {}
    local manifest2      = zc.getManifest(1) or {}
    local version_str   = tostring(manifest["version"]) .. "." .. string.sub(tostring(manifest2["version"]), 3)
    local versionId = ZCLabel:createWithParams({
        text = version_str,
        fontSize = 20,
        ttf = zc.getFont(1),
        color = cc.c3b(255, 255, 255),
    })
    versionId:setAnchorPoint(cc.p(0, 0))
    versionId:setPosition(cc.p(5, 5))
    return versionId
end

--返回登录界面
function zc.logoutSdk( isForce )
    local platform = cc.Application:getInstance():getTargetPlatform()
    if platform == cc.PLATFORM_OS_ANDROID then
    else
    end
    local args = {}
    local sigs = "()V"
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"ZCLogout",args,sigs)
end

function zc.getManifest(isStaticData, isPackage)
    local _isStaticData = tonumber(isStaticData) or 0
    --解析本地Manifest文件
    if APP_SERVER == 0 and _isStaticData == 0 and not isPackage then
        return nil
    end

    local file = nil
    local manifest = nil
    local fileUtils = cc.FileUtils:getInstance()
    local cachedManifest = zc.getWritablePath() 
    if _isStaticData == 1 then
        cachedManifest = cachedManifest .. "src/staticData/"
    elseif _isStaticData == 2 then
        cachedManifest = cachedManifest .. "res/"
    end
    cachedManifest = cachedManifest .. "project.manifest"
    if not isPackage and fileUtils:isFileExist(cachedManifest) then
        file = fileUtils:getStringFromFile(cachedManifest)
    else
        cachedManifest = "src/"
        if _isStaticData == 1 then
            local platform = cc.Application:getInstance():getTargetPlatform()
            cachedManifest = cachedManifest .. "staticData/"
            if APP_SERVER == 0 then
                cachedManifest = cachedManifest .. "nei_"        
            elseif platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD then
                cachedManifest = cachedManifest .. "ios_" 
            end
            if APP_SERVER ~= 0 and zc.isGt() then
                cachedManifest = cachedManifest .. "gt_"
            end
        elseif _isStaticData == 2 then
            cachedManifest = "res/google_"
        end 
        cachedManifest = cachedManifest .. "project.manifest"
        local _file = fileUtils:getSearchPaths() or {}
        local _file2 = {}
        for k,v in pairs(_file) do
            if string.find(tostring(v), ".zctech") then
            else
                _file2[#_file2 + 1] = v
            end
        end
        fileUtils:setSearchPaths(_file2)
        file = fileUtils:getStringFromFile(cachedManifest)
        fileUtils:setSearchPaths(_file)
    end
    if file ~= nil then
        manifest = json.decode(file)
    end

    return manifest
end

function zc.checkUpdate( sParams )
    local params = sParams or {}
    -- if not sParams.par then
    --     if params.failCall then
    --         params.failCall()
    --     end
    --     return
    -- end
      --解析本地Manifest文件
    local file = nil
    local table = nil
    local manifest = zc.getManifest()
    
    if not CHECK_UPDATA or manifest == nil then
        if params.failCall then
            params.failCall()
        end
        return
    end

    local version_str = manifest["version"] .. "." .. manifest["svn"]

    local testing = ""
    if manifest["testing"] ~= nil then
        testing = "&testing=" .. manifest["testing"]
    end

    -- local GAME_UPDATE_CHANNEL = "appstore"
    -- 请求最新的版本信息
    local lastVersionParams = {
        url = manifest["lastVersionUrl"] .. "&bundle=" .. manifest["bundle"] .. "&version=" .. manifest["version"] .. "&update_channel=" .. manifest["update_channel"] .. testing,
        successCallback = function(data)
            if data ~= nil then
                if tonumber(data.status) == 1 or tonumber(data.status) == 5 then --
                    if params.succCall then
                        params.succCall(data)
                    end
                    return
                end
            end 
            if params.failCall then
                params.failCall()
            end
        end,
        failedCallback = function()
            if params.failCall then
                params.failCall()
            end
        end,
        errorCallback = function()
            if params.failCall then
                params.failCall()
            end
        end,
        isGameApi = false,
        targetNeedsToRetain = params.par,
        loadingParent = params.par,
        loadingType   = params.loadingType,
        responseType  = HTTP_RESPONSE_TYPE.JSON,
        encrypt = HTTP_ENCRYPT_TYPE.NONE,
    }
    ZCHttp:requestAsyncWithParams(lastVersionParams)
    return manifest
end

function zc.createMatrixBattle( params )
    zc.createSourceScene( "BattleUIMatrixLayer", "src/layer/battle/ui/BattleUIMatrixLayer.lua", params )
end
--战斗场景
function zc.getFightScene( _fightScene )
    local _fightScene = tonumber(_fightScene) or 1
    local checkTable = {
        [1] = {
            file = "1.jpg",
            spineFile = "zhandouchangjing_7",
            particleFile = "fy_1.plist",
            particlePos = cc.p(400, 608),
            particleScale = 0.6,
            isSpine = false,

        },
        [2] = {
            file = "zhandouchangjing_6",
            isSpine = true,
        },
        [3] = {
            file = "skeleton",
            isSpine = true,
        },
        [4] = {
            file = "sz",
            isSpine = true,
        },
        [5] = {
            file = "zhandouchangjing_3",
            isSpine = true,
        },
        [6] = {
            file = "6.jpg",
            isSpine = false,
        },
        [7] = {
            file = "changjing_8.jpg",
            spineFile = "zhandouchangjing_8",
            isSpine = false,
        },
        [8] = {
            file = "8.jpg",
            spineFile = "xuejing",
            isSpine = false,
            particleFile = "snow.plist",
            particlePos = cc.p(620, 700),
            particleScale = 3
        },
        [9] = {
            file = "9.jpg",
            spineFile = "zhandouchangjing_9",
            isSpine = false,
        },
        [10] = {
            file = "10.jpg",
            isSpine = false,
        },
        [11] = {
            file = "11.jpg",
            isSpine = false,
        },
        [12] = {
            file = "12.jpg",
            isSpine = false,
        },
        [13] = {
            file = "13.jpg",
            spineFile = "zhandouchangjing_10",
            isSpine = false,
        },
        [14] = {
            file = "14.jpg",
            spineFile = "zhandouchangjing_14",
            isSpine = false,
        },
        [15] = {
            file = "15.png",
            spineFile = "changjing_hedeng",
            isSpine = false,
        },
        [16] = {
            file = "16.png",
            spineFile = "changjing_junying",
            isSpine = false,
        },
        [17] = {
            file = "17.png",
            spineFile = "changjing_qingshan",
            isSpine = false,
        },

    } --容错检查，_fightScene没有在这个列表->表示错误
    if not checkTable[_fightScene] then
        _fightScene = 1
    end
    local _fScene
    local isSpine = checkTable[_fightScene].isSpine 
    local widthScale  = zc.width/1136
    local heightScale = zc.height/700
    if widthScale <= heightScale then 
        widthScale = heightScale
    end

    local _path = "res/Main/copy/fightScene/"
    if isSpine then
        _path = _path .. _fightScene .."/"
        _fScene = zc.createSpine({
            path = _path,
            fileName = checkTable[_fightScene].file,
            scale = widthScale,
            actName = "idle"
        })
    else
        _path = _path .. _fightScene .. "/"
        _fScene = zc.createSprite(_path .. tostring(checkTable[_fightScene].file))
        _fScene:setScale(widthScale)
        _fScene:setAnchorPoint(cc.p(0.5, 0))

        if checkTable[_fightScene].spineFile then
            local _spine = zc.createSpine({
                path = _path,
                fileName = checkTable[_fightScene].spineFile,
                actName = "idle",
            })
            _spine:setPositionX(_fScene:getContentSize().width*0.5)
            _fScene:addChild(_spine)
        end
        if checkTable[_fightScene].particleFile then
            local particle = cc.ParticleSystemQuad:create(_path .. checkTable[_fightScene].particleFile)
            particle:setPosition(checkTable[_fightScene].particlePos)
            _fScene:addChild(particle)
            particle:setScale(checkTable[_fightScene].particleScale or 1.0)
        end
    end
    return _fScene
end


-- 接入战斗
function zc.createBattle( params )
    local _director = cc.Director:getInstance()
    local _scene = nil
    if USE_PUSH_BATTLE then
        if params.data.__isQunXiongRevive then --群雄复活特殊处理，在当前scene上直接添加
            _scene = cc.Director:getInstance():getRunningScene()
            _scene:removeAllChildren()
        else
            _scene = cc.Scene:create()
            _scene:setName(LAYER_NAME_TAG.LAYER_BATTLE)
            _director:pushScene(_scene)
        end
    end
    local default = {
        battleEndCallback = function(data)
            local function _battleEndCallback()
                local _params = {
                    -- 数据
                    data = data,
                    -- 重播回调
                    replay = function(_canShare)
                        zc.dispatchEvent({name = EVENT_NAME_BATTLE_REPLAY,data = {canShare = _canShare}})
                    end,
                    -- 退出回调
                    quit = function()
                        if USE_PUSH_BATTLE then
                            _director:popScene()
                        else
                            LayerManager.addShieldLayout(nil, 0.3)
                            LayerManager.removeLayout() 
                        end
                        local manager = ccs.ArmatureDataManager:getInstance()
                        manager:removeArmatureFileInfo( "res/Main/battle/battleresult/win/win.csb", true )
                        manager:removeArmatureFileInfo( "res/animation/eff_leverUp/eff_leverUp.csb", true )
                        if params.data.guide3 then
                            manager:removeArmatureFileInfo("res/image/battle/hero/zhangfei.csb", true )
                        elseif params.data.guide5 then
                            manager:removeArmatureFileInfo("res/image/battle/hero/liru_atk.csb", true )
                            manager:removeArmatureFileInfo("res/image/battle/hero/liru.csb", true )
                        elseif params.data.guide6 then
                            manager:removeArmatureFileInfo("res/image/battle/hero/guojia_atk.csb", true )
                            manager:removeArmatureFileInfo("res/image/battle/hero/guojia.csb", true )
                            manager:removeArmatureFileInfo("res/image/battle/hero/caocao_atk3.csb", true )
                            manager:removeArmatureFileInfo("res/image/battle/hero/caocao.csb", true )
                            manager:removeArmatureFileInfo("res/image/battle/hero/change.csb",true)
                            manager:removeArmatureFileInfo("res/image/battle/hero/chuchang.csb",true)
                            manager:removeArmatureFileInfo("res/image/battle/hero/change_2.csb",true)
                        end
                        helper.collectMemory(true)
                    end,
                }
                if USE_PUSH_BATTLE then
                    local _resultPop = requires("src/layer/battle/ui/BattleUIResultPop.lua"):create(_params)
                    _scene:addChild(_resultPop)
                else
                    zc.createSourcePop("BattleUIResultPop", "src/layer/battle/ui/BattleUIResultPop.lua", _params)
                end
            end 
            local function _doFirst()
                local _battleStatus = 0
                xpcall(function() 
                    _battleStatus = tonumber(params.data.data.warModel[5][1]) or 0
                end, function() end)
                if inArray(_battleStatus, {2,3,4}) and params.data.battleType == BattleType.PVE and (params.data.clickFight ~= true and not params.data.havePopDrop)then
                    local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", params.data.enemyid)
                    if _tollDb.afterBattletalk and _tollDb.afterBattletalk ~= "" then    
                        local scene = cc.Director:getInstance():getRunningScene()
                        local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = _tollDb.afterBattletalk, callback = function ( ... )
                            local _currentGID = getGuideManager():getCurrentGID()
                            if _currentGID == GuideKey.KEY_2005 then
                                getGuideManager():setNextGID(_currentGID)
                                --新手引导奖励贾诩
                                zc.createPubShowGetHero({id=GuideHeroId.KEY_2005, callback = _battleEndCallback, scene = _scene})
                                return
                            elseif _currentGID == GuideKey.KEY_1007 then
                                getGuideManager():setNextGID(_currentGID)
                                --新手引导奖励周仓
                                zc.createPubShowGetHero({id=GuideHeroId.KEY_1007, callback = _battleEndCallback, scene = _scene})
                                return
                            end
                            _battleEndCallback()
                        end})
                        scene:addChild(guideScriptLayer)
                    else
                        _battleEndCallback()
                    end
                else
                    _battleEndCallback()
                end
            end
            --新手引导
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_11508 then
                _battleEndCallback()
            else
                _doFirst()
            end
        end
    }
    for k, v in pairs( default ) do
        params[k] = params[k] or v
    end
    if params.data.havePopDrop then
        local _star = 0
        xpcall(function() 
            _star = tonumber(params.data.data.warModel[5][6]) or 0
        end, function() end)
        if _star > 0 then
            local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", params.data.enemyid)
            local _talk = _tollDb.afterBattletalk 
            if _talk and _talk ~= "" then
                params.data.afterBattletalk = _talk
            end
        end
    end
    local _time_ = socket.gettime()
    print("before check .... --------------------", socket.gettime() )
    local battle = requires("src/layer/battle/core/BattleLayer.lua"):createWithParams( params )
    battle:setName(LAYER_NAME_TAG.LAYER_BATTLE)
    if USE_PUSH_BATTLE then
        _scene:addChild(battle)
    else
        LayerManager.addNode( battle, {layerName = "battle"})
    end
    helper.collectMemory(true)
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_MAICITY_CHANGE, data = {isShow = false}})
    print("after check .... ---------------------"..socket.gettime().."-------diff------".. (socket.gettime() - _time_))
    return battle
end


--多人副本队伍主界面
function zc.createMultiCopyMainScene(_tollid)
    if APP_REVIEW then
        zc.tipInfo(zc.lang("tips_function_not_open"))
        return
    end
    local _flag = zc.getFunctionStatus(19,true) --多人FB
    if not _flag then
        return
    end
    zc.sendHttp({
        apiName = "MultiCopy_Main",
        successCallback = function (result)
            result.toTollId = _tollid
            zc.createSourceScene("MultiCopyList", "src/layer/multicopy/MultiCopyListLayer.lua", result)
        end,
    }) 
end

--加入多人副本
function zc.joinOneMultiCopyTeam( teamId, tollgateId, successCallback )
    if APP_REVIEW then
        zc.tipInfo(zc.lang("tips_function_not_open"))
        return
    end
    if not PlayerData:getHouseInfoByHouseId(15) then
        zc.tipInfo(zc.lang("tips_multicopy_unopen"))
        return 
    end
    local toData = gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", tollgateId)
    local _activeIds = string.split(toData.activateId, "|")
    local _flag = true
    if _activeIds and #_activeIds > 0 then
        for k,v in pairs(_activeIds) do
            _status = PlayerData:getCurTollGateStatus(v)
            if _status ~= 2 then 
                _flag = false
                break
            end
        end
    end
    if not _flag then
        zc.tipInfo(zc.lang("tips_chapter_unlock"))
        return
    end
    if zc.getScene("MultiCopyTeam") then
        return
    end

    local _houseData = PlayerData:getHouseInfoByHouseId(15)
    zc.sendHttp({
        apiName = "MultiCopy_join", 
        params = {teamId = teamId, houseId = _houseData.id},
        successCallback = function (result)
            local _data = result or {}
            local _teamInfo = {}
            for k,v in pairs(_data.teams or {}) do
                if tonumber(v.teamId) == teamId then
                    _teamInfo = v
                    break
                end
            end
            _teamInfo.tollgateId = tollgateId
            if successCallback then
                successCallback()
            end
            zc.createMultiCopyTeamScene(_teamInfo, _data.challengeNum, _data.challengeNumLimit)
        end,
    })
end

--多人副本队伍界面
function zc.createMultiCopyTeamScene( teamInfo, challengeNum, challengeNumLimit )
    if APP_REVIEW then
        zc.tipInfo(zc.lang("tips_function_not_open"))
        return
    end
    if zc.getScene("MultiCopyTeam") then
        return
    end
    zc.createSourceScene("MultiCopyTeam", "src/layer/multicopy/MultiCopyTeamLayer.lua", {teamInfo, challengeNum, challengeNumLimit})
end

--多人副本队伍列表界面
function zc.createMultiCopyScene( tollgateId, call )
    if APP_REVIEW then
        zc.tipInfo(zc.lang("tips_function_not_open"))
        return
    end
    if zc.getScene("MultiCopyMain") then
        return
    end
    local _tollgateId = tonumber(tollgateId) or 1
    zc.sendHttp({
        apiName = "MultiCopy_info", 
        params = {tollgateId = _tollgateId},
        successCallback = function (result)
            local _infoData = result or {}
            if tonumber(_infoData.selfIeamId) then
                local _teams = _infoData.teams
                local _teamInfo 
                for k,v in pairs(_teams) do
                    if v.teamId == _infoData.selfIeamId then
                        _teamInfo = v
                        break
                    end
                end
                if _teamInfo then
                    _teamInfo.tollgateId = _tollgateId
                    if call then
                        call()
                    end
                    zc.createMultiCopyTeamScene(_teamInfo, _infoData.challengeNum, _infoData.challengeNumLimit)
                    return
                end
            end
            _infoData.tollgateId = _tollgateId
            if call then
                call()
            end
            zc.createSourceScene("MultiCopyMain", "src/layer/multicopy/MultiCopyMainLayer.lua", _infoData)
        end,
    })
end

--创建国家界面
function zc.createCountryScene(_params)
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    local _params           = _params or {}
    local _goToTab          = _params.goToTab   --切换到国家右边tab
    local _toFun            = _params.toFun     --跳转国家总览的具体功能
    local _isShowList       = _params.showList == nil and true or _params.showList --未加入国家是否显示国家列表（默认显示）

    --请求国家信息，如果没有国家，请求国家列表
    zc.sendHttp({
        apiName = "Country_info",
        params = {info=hascountry},
        successCallback = function ( net_data)
            if net_data["id"] then
                net_data._goToTab = _goToTab
                net_data._gotoFun = (_toFun and _toFun ~= 1) and nil or _toFun
                zc.createSourceScene("Country", "src/layer/country/CountryMainLayer.lua", net_data)
            else
                if _isShowList then
                    zc.sendHttp({
                        apiName = "Country_countryList",
                        params = {info = 0},
                        successCallback = function (data)
                            zc.createSourcePop( "CountryList", "src/layer/country/CountryListPop.lua", data)
                        end,
                    })
                else
                    zc.tipInfo(zc.lang("tips_unjoin_country"))
                end
            end
        end,
    })
end

--创建通用够买弹窗
function zc.createCommonBuyPop(params)
    if not params.info then
        return
    end
    zc.createSourcePop("WushenBuy", "src/layer/wushenshilian/WushenBuyPop.lua", params or {})
end

function zc.createHeroListLayer()
    zc.createSourceScene("HeroListLayer", "src/layer/role/HeroListLayer.lua")
end

-- 武将界面，isMainRole表示是否是主角，id表示英雄的主键id，tab表示页签
function zc.createRoleScene( params )
    local _tab = ( params or {} ).tab or 1
    local _tag = {0, 13, 18, 14, 37}
    local _openTag = _tag[_tab] or 0
    local _open = true
    if _openTag ~= 0 then
        _open = zc.getFunctionStatus( _openTag, true )
    end
    local _layerName = {
        "RoleAttributeLayer",
        "RoleCultureLayer",
        "RoleFetterLayer",
        "RoleStarupLayer",
        "RoleGemLayer",
    }
    if _open then
        zc.createSourceScene(_layerName[_tab], "src/layer/role/RoleLayer.lua", params or {})
    end
end

-- 演武榜主界面
function zc.createTalentScene()
    local _flag = zc.getFunctionStatus(21,true) --命格是否开启
    if _flag then
        zc.sendHttp({
            apiName = "Talent_Info",
            successCallback = function(data)
                zc.createSourceScene("Talent", "src/layer/talent/TalentLayer.lua", data)
            end,
        })
    end
end

-- 演武榜主界面
function zc.createArenaScene()
    local _flag = zc.getFunctionStatus(22,true) --演武榜是否开启
    if _flag then
        local function _overGuide()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12202 then
                getGuideManager():setFuncGuideOver()
            end
        end
        zc.sendHttp({
            apiName = "Arena_main", 
            successCallback = function(data)
                local status = tonumber( data.timeInfo.status )
                if status == 1 then
                    -- 预赛前
                    if data.conf and data.conf.prelimTime then
                        local _preTime = string.split( data.conf.prelimTime, "-" )
                        local _time = string.split( _preTime[1], ";" )
                        zc.tipInfo( LANGUAGE_ARENA_OVER( _time[1], _time[2] ) )
                    end
                    _overGuide()
                elseif status == 3 then
                    -- 决赛前
                    if data.conf and data.conf.finalsTime then
                        local _finalTime = string.split( data.conf.finalsTime, "-" )
                        local _time = string.split( _finalTime[1], ";" )
                        zc.tipInfo( LANGUAGE_ARENA_FINAL( _time[1], _time[2] ) )
                    end
                    _overGuide()
                else
                    zc.createSourceScene("ArenaMain", "src/layer/arena/ArenaMainLayer.lua", data)
                end
            end,
            failCallback = _overGuide, 
            errorCallback = function( errorCode, errorMsg )
                zc.tipInfo( errorMsg )
                _overGuide()
            end,
        })
    end
end

-- 武神榜
function zc.createGodFightScene()
    local _flag = zc.getFunctionStatus(45, true) --演武榜是否开启
    if not _flag then
        return
    end
    zc.sendHttp({
        apiName = "GodFight_main",
        successCallback = function(data)
            data.noAnimation = true
            PlayerData:updataData(data)
            zc.createSourceScene("GodFightList", "src/layer/arena/GodFightListLayer.lua", data)
        end,
    })
end

-- 军功商店
function zc.createArenaShopLayer()
    -- 查找演武榜的建筑id
    local _houseId = ( PlayerData:getHouseInfoByHouseId( 12 ) or {} ).id
    local _arenaHouseId = ( PlayerData:getHouseInfoByHouseId( 13 ) or {} ).id
    local function _failCall()
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_12207 then
            getGuideManager():setFuncGuideOver()
        end
    end
    if _houseId and _arenaHouseId then
        
        zc.sendHttp({
            apiName = "HouseShop_goods",
            params = {type=2, houseId = _houseId, arenaHouseId = _arenaHouseId},
            successCallback = function(data)
                zc.createSourceScene( "ArenaShopLayer", "src/layer/shop/ShopLayer.lua", {data = data, index = 2} )
            end,
            failCallback = _failCall,
            errorCallback = _failCall,
        })
    else
        --提示
        zc.tipInfo(zc.lang("tips_armyshop_unopen"))
        _failCall()
    end
end
-- 商店购买弹窗
function zc.createShopBuyPop( params )
    zc.createSourcePop("ShopBuyPop", "src/layer/shop/ShopBuyPop.lua", params)
end
-- 演武榜排行榜，type是分组
function zc.createArenaRankPop( params )
    local _flag = zc.getFunctionStatus(22,true) --演武榜是否开启
    if _flag then
        local _type = params.type or 1
        zc.sendHttp({
            apiName = "Arena_rank",
            params = {types=_type},
            successCallback = function(data)
                zc.createSourcePop("ArenaRank", "src/layer/arena/ArenaRankPop.lua", {data = data, type = _type, rank = params.rank, score = params.score})
            end,
        })
    end
end
-- 演武榜奖励预览弹窗
function zc.createArenaRewardPop( params )
    zc.createSourcePop( "ArenaReward", "src/layer/arena/ArenaRewardPop.lua", params )
end
-- 演武榜战报
function zc.createArenaRecordPop( _type )
    local _flag = zc.getFunctionStatus(22,true) --演武榜是否开启
    if _flag then
        zc.sendHttp({
            apiName = "Arena_record",
            successCallback = function(data)
                data.type = _type
                zc.createSourcePop("ArenaRecord", "src/layer/arena/ArenaRecordPop.lua", {data = data})
            end,
        })
    end
end
-- 演武榜名人堂
function zc.createArenaHallFamePop()
    zc.sendHttp({
        apiName = "Arena_hallFame", 
        successCallback = function(data)
            if data.hallFames and #data.hallFames > 0 then
                zc.createSourcePop("ArenaHallFame", "src/layer/arena/ArenaHallFamePop.lua", {data = data})
            else
                zc.tipInfo( LANGUAGE_ARENA.no_hallFame )
            end
        end,
    })
end
-- 演武榜查看信息弹窗
function zc.createArenaLookupPop( data )
    zc.createSourcePop( "ArenaLookup", "src/layer/arena/ArenaLookupPop.lua", data )
end

-- 突飞卡商城
function zc.createExpCardShopLayer()
    local _houseId = ( PlayerData:getHouseInfoByHouseId( 12 ) or {} ).id
    if _houseId then
        zc.sendHttp({
            apiName = "Timelimit_shop_main",
            successCallback = function (data)
                zc.createSourceScene("TimeLimitShopLayer", "src/layer/shop/ShopLayer.lua", {data = data, index = 1} )
            end,
        })
    else
        zc.tipInfo(zc.lang("tips_expcardshop_unopen"))
    end
end

-- 建筑商城
function zc.createShopLayer()
    local _houseId = ( PlayerData:getHouseInfoByHouseId( 12 ) or {} ).id
    if _houseId then
        zc.sendHttp({
            apiName = "Timelimit_shop_main",
            successCallback = function (data)
                zc.createSourceScene("TimeLimitShopLayer", "src/layer/shop/ShopLayer.lua", {data = data, index = 1} )
            end,
        })
    else
        zc.tipInfo(zc.lang("tips_shop_unopen"))
    end
end
-- 限时商城
function zc.createTimelimitShopLayer()
    local _houseId = ( PlayerData:getHouseInfoByHouseId( 12 ) or {} ).id
    if _houseId then
        zc.sendHttp({
            apiName = "Activity_open_info",
            successCallback = function (net_data)
                if net_data and next(net_data) then
                    PlayerData:setActivityInfo(net_data)
                    local _activityInfo = PlayerData:getActivityInfoById(13)
                    if next(_activityInfo) == nil then
                        zc.tipInfo(zc.lang("tips_activity_finished"))
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activityShow"}}) 
                    else
                        zc.sendHttp({
                            apiName = "Timelimit_shop_main",
                            successCallback = function (data)
                                zc.createSourceScene("TimeLimitShopLayer", "src/layer/shop/ShopLayer.lua", {data = data, index = 1} )
                            end,
                        })
                    end
                end
            end
        })
    else
        zc.tipInfo(zc.lang("tips_shop_unopen"))
    end
end
-- 规则说明弹窗
function zc.createRulePop(index,otherParams)
    zc.createSourcePop( "Rule", "src/layer/common/RulePop.lua", {index=index,otherInfo=otherParams} )
end

-- 招募积累弹出页
function zc.createRecruitAccumulationPop( params )
    local _info = PlayerData:getActivityInfoById(14)
    if next(_info) ~= nil then
        zc.createSourcePop("RecruitAccumulate", "src/layer/activity/RecruitAccumulationPop.lua", params)
    else
        if params.callback then
            params.callback()
        end
    end
end
-- 封测活动弹出
function zc.createFengcePop( params )
    local _info = PlayerData:getActivityInfoById(33)
    if next(_info) ~= nil then
        zc.createSourcePop("FengcePop", "src/layer/activity/FengcePop.lua", params)
    else
        if params.callback then
            params.callback()
        end
    end
end

-- 查看信息详细页
function zc.createOtherPlayerInfoPop(userName)
    zc.sendHttp({
        apiName = "User_main",
        params = {userName=userName},
        successCallback = function(data)
            zc.createPop("otherPlayerDetail", data)
        end,
    })
end

-- 购买提示,params = {tip=, special={begin=, length=, color=}, consume={type=, num=}, callback=}
function zc.createBuyPop( params )
    zc.createSourcePop( "Buy", "src/layer/common/BuyPop.lua", params )
end

function zc.createCopyTimeBuyPop( params )
    local _enemyData = params.enemyData or {}
    local _tollDb = params.tollDb or {}
    local _callBack = params.callback
    local _tip = string.format(zc.lang("tips_buyTollgate_times"), tostring(_tollDb.numLimit))
    local buyNum = tonumber(_enemyData.buyNum) or 0  --付费类型 26
    local costnum = 10 + math.floor(buyNum/10)*10
    zc.createBuyPop({
        tip = _tip,
        consume = {
            {type = 1, num = costnum}
        },
        clickHide = true,
        callback = function()
            zc.sendHttp({
                apiName = "Tollgate_challengeNum",
                params = {id = _enemyData.tollgateId},
                successCallback = function ( backData )
                    PlayerData:updataData(backData)
                    --刷新关卡状态数据
                    PlayerData:setCurTollGateStatus(_enemyData.tollgateId, {buyNum = backData.buyNum})
                    if _callBack then
                        _callBack(backData.buyNum)
                    end
                end,
            })
        end
    })
end

-- 名将副本
function zc.createTollgateHeroMainLayer()
    local _flag = zc.getFunctionStatus(16, true) --名将FB
    if not _flag then
        return
    end
    zc.sendHttp({
        apiName = "TollgateHero_main",
        successCallback = function(data) 
            zc.createSourceScene("TollgateHeroMain", "src/layer/tollgateHero/TollgateHeroMainLayer.lua", data )
        end,
    })
end

-- vip弹窗
function zc.createVipPop()
    zc.createSourcePop( "RechargePop", "src/layer/recharge/RechargePop.lua", {index = 1})
end

-- 充值弹窗
function zc.createRechargePop()
    if APP_REVIEW or APP_SERVER == 2 then
        zc.tipInfo(zc.lang("tips_recharge_unopen"))
        return
    end
    zc.sendHttp({
        apiName = "EveryDayCard_main",
        successCallback = function(backData)
            zc.createSourcePop( "RechargePop", "src/layer/recharge/RechargePop.lua", {index = 2, rechargeStatusData = backData} )
        end
    })
end

function zc.setBgSize(bg)
    local widthScale  = zc.width/bg:getBoundingBox().width
    local heightScale = zc.height/bg:getBoundingBox().height
    if widthScale <= heightScale then 
        widthScale = heightScale
    end
    bg:setScale(widthScale)
end

--秒转成时间("00:00:00", "00:00")
function zc.getTimeHMS(time, timeType)
    local H = math.floor(time/3600)
    local M = math.floor(time/60 - H*60)
    local S = math.floor(time%60)
    local showH = 0
    local showM = 0
    local showS = 0
    if H <= 9 then
        showH = "0"..H
    else
        showH = H
    end
    if M <= 9 then
        showM = "0"..M
    else
        showM = M
    end
    if S <= 9 then
        showS = "0"..S
    else
        showS = S
    end
    local M_S = "00:00" --分秒
    if M == 0 then
        M_S =  "00:"..showS
    else
        M_S = showM..":"..showS
    end

    local H_M = "00:00" --时分
    if H == 0 then
        H_M = "00:"..showM
    else
        H_M = showH..":"..showM
    end

    --timeType(1-->分和秒，2-->小时和分，全部)
    if timeType and timeType == 1 then
        return M_S
    elseif timeType and timeType == 2 then
        return H_M
    else
        return (H_M..":"..showS)
    end
end

-- 倒计时(天时分秒) 例如zc.getTimer( time, 2 )只返回时间差的分以上单位
function zc.getTimer( time, beginUnit, unitFlag )
    -- 默认时间0
    local timeBef = tonumber( time ) or 0
    local timeTrn = { 60, 60, 24 }
    local timeAft = {}
    for i, v in ipairs( timeTrn ) do
        if timeBef >= v then
            timeAft[i] = timeBef%v
            timeBef = math.floor( timeBef/v )
        elseif timeBef > 0 then
            timeAft[i] = timeBef
            timeBef = 0
            break
        else
            break
        end 
    end
    -- 超出一天
    if #timeAft == #timeTrn and timeBef > 0 then
        timeAft[#timeAft + 1] = timeBef
    end
    -- 默认从分钟开始返回
    local timeUnt = { "", ":", ":", zc.lang("date_day") .. " "}
    if unitFlag then
        timeUnt = { zc.lang("date_seconds"), zc.lang("minute"), zc.lang("date_hours"), zc.lang("date_day") .. " "}
    end
    local beginUnit = tonumber( beginUnit or 2 )
    beginUnit = #timeAft >= beginUnit and beginUnit or #timeAft
    -- 边界
    beginUnit = beginUnit < 1 and 1 or beginUnit
    beginUnit = beginUnit > #timeUnt and #timeUnt or beginUnit
    local timeStr = ""
    for i = beginUnit, #timeAft do
        if unitFlag then
            -- 文字，不需要为0的部分
            if timeAft[i] > 0 then
                timeStr = tostring( timeAft[i] )..tostring( timeUnt[i] )..timeStr
            end
        else
            -- 冒号，个位数补全
            if i < 4 and timeAft[i] < 10 then
                timeStr = "0"..tostring( timeAft[i] )..tostring( timeUnt[i] )..timeStr
            else
                timeStr = tostring( timeAft[i] )..tostring( timeUnt[i] )..timeStr
            end
        end
    end
    return timeStr
end

-- 计算多长时间前，beginUnit是返回的字符串的开始单位
function zc.calculateTime( time, beginUnit, unitFlag )
    local _time = tonumber( time ) or 0
    _time = PlayerData:getTime() - _time
    local _str = zc.getTimer(_time, beginUnit, unitFlag)
    return _str .. zc.lang("front")
end

function zc.createHeroListShow( info )
    local _qualifications = tonumber(info.quality) or 1
    local _heroId = tonumber(info.heroId) or 1
    local _iconId = tonumber(info.iconId) or 0
    local _heroSide = tonumber(info.heroSide) or 0
    local _showSide = info.showSide == nil and true or info.showSide
    local _heroSpScaleX = info.scaleX == nil and 1 or info.scaleX
    local _heroSpScaleY = info.scaleY == nil and 1 or info.scaleY
    -- if _heroSide ~= 0 and _heroSide ~= 1 then
    --     _heroSide = 0
    -- end
    local _bgSize = info.size
    if _iconId >= 1 and _iconId <= 4 then
        _heroId = 100 + _iconId
    end
    local _cellBg = ZCSprite:create()
    _cellBg:setAnchorPoint(0.5, 0.5)

    -- 武将
    local _heroPath = string.format("res/Main/hero/list/%s.png", _heroId)
    if not zc.checkFileExist(_heroPath) then
        _heroPath = "res/Main/hero/list/1.png"
    end
    local heroSp = zc.createSprite(_heroPath)
    heroSp:setName("heroSp")
    --底
    local _path = "res/Main/role/list/"..zc.getHeroColorByQuality( _qualifications )..".png"

    local scaleSize = cc.size(463, 137)
    local _pathBg = zc.getScaleNode(_path, scaleSize)
    _pathBg:setName("_pathBg")
    local _pathSize = _pathBg:getContentSize()
    local _bg = nil
    local _flag = true
    if _bgSize then
        if _bgSize.width ~= 0 and _bgSize.width < _pathSize.width then
            _flag = false
        end
        local _heroW = heroSp:getBoundingBox().width 
        -- _bgSize.width = _bgSize.width < _heroW + 4 and _heroW + 4 or _bgSize.width
        _bgSize.width = _bgSize.width == 0 and _pathSize.width or _bgSize.width
        -- _bgSize.width = _bgSize.width > _pathSize.width and _pathSize.width or _bgSize.width
        _bgSize.height = _bgSize.height == 0 and _pathSize.height or _bgSize.height
    end
    if _flag then
        _bg = _pathBg
        _bgSize = _pathSize
        _cellBg:setContentSize(_bgSize)
    else
        _pathBg:setContentSize(_bgSize)
        _bg = _pathBg
        _cellBg:setContentSize(_bgSize)
    end
    _bg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5)
    _cellBg:addChild(_bg)
    heroSp:setAnchorPoint(_heroSide, 0.5)
    local _heroX = 0
    if _heroSide == 0 then
        _heroX = 1
    elseif _heroSide == 1 then
        _heroX = _bgSize.width - 5
    else
        _heroX = _bgSize.width/2 - 1
    end
    heroSp:setPosition(_heroX, _bgSize.height*0.5+1)
    heroSp:setScaleY(0.96*_heroSpScaleY*0.4436)
    heroSp:setScaleX(_heroSpScaleX*0.4436)

    _cellBg:addChild(heroSp)

    if _showSide then
        local frame = ccui.Scale9Sprite:create(cc.rect(13, 60, 9, 62), "res/Main/common/frame_s.png")
        frame:setContentSize(_bgSize.width, _bgSize.height + 2)
        frame:setPosition(_bgSize.width*0.5, _bgSize.height*0.5)
        _cellBg:addChild(frame, 1)
    end
    return _cellBg
end

function zc.createPlayerHead(params)
    local iconId                = params.iconId or 1
    local touchListener         = params.callback
    local needSwallow           = params.needSwallow
    local needEnableWhenMoving  = params.needEnableWhenMoving
    local level                 = params.level
    local scale                 = params.scale or 1
    local headBg, iconsrc
    local _partX, _partY = 0, 0
    if params.isNew then
        headBg = zc.createSprite()
        headBg:setContentSize(cc.size(109,109))
        iconsrc = "res/Main/hero/head/hero_head_new10"..iconId..".png"
        if not zc.checkFileExist(iconsrc) then
            iconsrc = "res/Main/hero/head/hero_head_new101.png"
        end
        _partX = -1
        _partY = 1
    else
        headBg = zc.createSprite("res/Main/home/avator_bg.png")
        iconsrc = "res/Main/hero/head/hero_head_10"..iconId..".png"
        if not zc.checkFileExist(iconsrc) then
            iconsrc = "res/Main/hero/head/hero_head_101.png"
        end
    end
    local headSprite = zc.createSprite(iconsrc)
    headSprite:setScaleY(0.9)
    if not params.isNew then
        headSprite:setScaleX(-0.9)
    end
    headSprite:setName("headSprite")
    headSprite:setPosition( cc.p(headBg:getContentSize().width/2 + _partX, headBg:getContentSize().height/2 + _partY) )
    headBg:addChild(headSprite)
    
    if level then
        local levelLab = zc.createLabel({
            text = zc.getLevelTipShow()..level,
            outLine = true,
            fontSize = 20,
            fontName = zc.getFont(1),
            ap = cc.p(0, 0),
            pos = cc.p(7, 7),
            pixel = 1.3
        })
        levelLab:setName("levelLab")
        headBg:addChild(levelLab)
    end

    headBg:setScale(scale)
    local headTouch = zc.createPushButton({
        normalNode = headBg,
        needSwallow = needSwallow,
        endCallback = touchListener,
        needEnableWhenMoving = needEnableWhenMoving,
    })

    return headTouch
end
function zc.updatePlayerHead( params )
    local headBg                  = params.headBg
    if not headBg then
        return
    end
    local iconId                = params.iconId or 1
    local touchListener         = params.callback
    local needSwallow           = params.needSwallow
    local needEnableWhenMoving  = params.needEnableWhenMoving
    local level                 = params.level
    local iconsrc = "res/Main/hero/head/hero_head_10"..iconId..".png"
    if not zc.checkFileExist(iconsrc) then
        iconsrc = "res/Main/hero/head/hero_head_101.png"
    end
    
    if touchListener then
        headBg:setTouchEndedCall(function()
            touchListener()
        end)
    end
    local _normal = headBg:getStateNormal()
    local headImg = _normal:getChildByName("headSprite")
    headImg:setTexture(iconsrc)
    local levelLab = _normal:getChildByName("levelLab")
    if levelLab and level then
        levelLab:setText(zc.getLevelTipShow()..level)
    end
end
--[[创建pushbutton，为之后预留写默认播放音效做准备
noScaleAction: 默认false， true时不处理缩放的效果
]]
function zc.createPushButton( params )
    if params.plist then
        if params.normalFile then
            params.normalNode = zc.createSpriteWithFrameName(params.normalFile)
            params.normalFile = nil
        end
        if params.selectedFile then
            params.selectedNode = zc.createSpriteWithFrameName(params.selectedFile)
            params.selectedFile = nil
        end
        if params.disableFile then
            params.disableNode = zc.createSpriteWithFrameName(params.disableFile)
            params.disableFile = nil
        end
    end
    local _endCall = params.endCallback
    local _beganCall = params.beganCallback
    local _scaleFlag = params.noScaleAction
    if _endCall and not _scaleFlag then
        params.touchScale = 1.0
    end
    local _btn = ZCPushButton:createWithParams(params)
    if params.scale then
        _btn:setScale(params.scale)
    end
    local _pScale = params.scale
    function _btn:setTouchBeganCall(call)
        if not _pScale then
            _pScale = _btn:getScale()
        end
        _btn:setTouchBeganCallback(function()
            if not _scaleFlag then
                if _btn._scaleAction then
                    _btn:stopAction(_btn._scaleAction)
                end
                _btn:setScale(_pScale)
                _btn._scaleAction = nil
                _btn._scaleAction = cc.Sequence:create(
                    cc.ScaleTo:create(0.05, _pScale*0.9),
                    cc.CallFunc:create(function()
                        _btn._scaleAction = nil
                    end)
                )
                _btn:runAction(_btn._scaleAction)
            end
            if call then
                call()
            end
        end)
    end
    function _btn:setTouchEndedCall(call)
        if not _pScale then
            _pScale = _btn:getScale()
        end 
        _btn:setTouchEndedCallback(function()
            if params.btnEff then
                musicManager.playEffect(params.btnEff)
            else
                musicManager.playEffect(zc.effect.btnClick)
            end
            if not _scaleFlag then
                if _btn._scaleAction then
                    _btn:stopAction(_btn._scaleAction)
                end
                _btn._scaleAction = nil
                _btn:setScale(_pScale*0.9)
                _btn._scaleAction = cc.Sequence:create(
                    cc.ScaleTo:create(0.05, _pScale*0.9),
                    cc.ScaleTo:create(0.05, _pScale*0.8),
                    cc.ScaleTo:create(0.05, _pScale*1.1),
                    cc.ScaleTo:create(0.05, _pScale*0.9),
                    cc.ScaleTo:create(0.1, _pScale*1.0),
                    cc.CallFunc:create(function()
                        _btn._scaleAction = nil
                    end)
                )
                _btn:runAction(_btn._scaleAction)
            end
            if call then
                call()
            end
        end)
    end

    if _beganCall then
        _btn:setTouchBeganCall(_beganCall)
    end
    if _endCall then
        _btn:setTouchEndedCall(_endCall)
        if not _beganCall then
            _btn:setTouchBeganCall(function() end)
        end
    end
    if params.text then
        local _label = _btn:getLabel()
        if _label then
            local _config = _label:getTTFConfig()
            _config.fontSize = params.fontSize or 20
            _config.fontFilePath = zc.getFont(1)
            _label:setTTFConfig(_config)
            if params.fontColor == display.COLOR_BLACK then
                params.shadow = false
            end
            if params.shadow then
                local outlineColor = params.fontColor2 or display.COLOR_BLACK
                local shadowSize    = params.shadowSize or cc.size(2, -2)
                _label:enableShadow(cc.c4b(outlineColor.r,outlineColor.g,outlineColor.b,255), shadowSize)
            end
            if params.outLine then
                local outlineColor  = params.color2 or display.COLOR_BLACK
                local pixel = params.pixel or 2
                _label:enableOutline(cc.c4b(outlineColor.r,outlineColor.g,outlineColor.b,255), pixel)  
            end
            if params.text_pos then
                _label:setPosition(params.text_pos)
            end
        end
    end
    return _btn
    -- body
end
--[[Composite --- translation ---  复合的
        1.返回一个复合的节点，比如创建一个按钮的时候，需要给按钮传递美术字，
            字体需要显示再按钮上面，此情景适用于ZCPushButton的情况比较多，按钮需要传递两个节点的创建方式
        2.适用于简单的节点拼接，比如一个节点上面需要添加一个子节点，
        3.上面的节点默认添加再下面节点的中间，大多数应该是这种需求吧啊啊~

    注：1.子节点默认添加在父节点的中心点上
        2.本方法不负责验证资源的有效性，即不负责验证节点是否创建成功
]]
function zc.getCompositeNodeWithImg(lowerImgPath,higherImgPath,higher_node_pos)
    local lowerNode  = cc.Sprite:create(lowerImgPath)
    local higherNode = cc.Sprite:create(higherImgPath)
    if higher_node_pos and higher_node_pos.x and higher_node_pos.y then
        higherNode:setPosition(higher_node_pos.x, higher_node_pos.y)
    else
        higherNode:setPosition(lowerNode:getContentSize().width/2, lowerNode:getContentSize().height/2)
    end
    lowerNode:setCascadeOpacityEnabled(true)
    lowerNode:setCascadeColorEnabled(true)
    lowerNode:addChild(higherNode)
    return lowerNode
end

--创建好友界面
function zc.createFriendScene()
    zc.sendHttp({
        apiName = "Friend_friendList",
        successCallback = function (net_data)
            --好友修改：每次进入好友界面，拉一次数据，重新设置一次好友数据；
            PlayerData:setFriendInfo(net_data)
            zc.createSourceScene("Friend", "src/layer/friend/FriendPop.lua", net_data)
        end
    })
end

function zc.getHeroInfo( seigniorId )
    local heroId = gameData.getDataFromCacheWithPrimaryKey("user", seigniorId).heroId
    local _data = gameData.getDataFromCacheWithPrimaryKey("hero", heroId)
    if next(_data) ~= nil then
        return _data
    end
    return gameData.getDataFromCacheWithPrimaryKey("hero", 1)
end

--创建任务界面
function zc.createTaskView(params)
    --功能开放 --任务 id 11
    if not zc.getFunctionStatus(11, true) then
        return
    end
    zc.sendHttp({
        apiName = "Task_taskList", 
        successCallback = function (data)
            PlayerData:setTaskData(data)
            local _params = params or {}
            _params.doExit = false
            zc.createSourceScene("task", "src/layer/task/TaskListPop.lua", _params)
            --同步主城任务tips
            local mainCity = zc.getScene("mainCity")
            if mainCity then
                mainCity:updateTaskLeadTips(false)
            end
        end,
    })
end

--武神试练
function zc.createWushenshilian()
    if not zc.getFunctionStatus(23, true) then
        return
    end
    zc.sendHttp({
        apiName = "Wushenshilian_main",
        params = {},
        successCallback = function (net_data)
            zc.createSourceScene("WushenshilianLayer", "src/layer/wushenshilian/WushenshilianLayer.lua", net_data)
        end
    })
end

--创建兵器副本界面
function zc.createWeaponCopy(_id)
    if not zc.getFunctionStatus(32, true) then
        return
    end
    zc.sendHttp({
        apiName = "WeaponCopy_main",
        successCallback = function (net_data)
            net_data.gotoTollid = _id
            net_data.noAnimation = true
            PlayerData:updataData(net_data)
            zc.createSourceScene("WeaponCopyLayer", "src/layer/weaponCopy/WeaponCopyMainLayer.lua", net_data)
        end,
    })
end

--创建研究院界面（群雄）
function zc.createResearchQunXiong()
    if not zc.getFunctionStatus(25,true) then
        return
    end
    zc.sendHttp({
        apiName = "Captain_captainInfo",
        successCallback = function (net_data)
            zc.createSourceScene("ResearchQunXiong", "src/layer/research/ResearchQunXiongLayer.lua", net_data)
        end,
    })
end
--创建研究院界面（兵法）
function zc.createResearchBingFa()
    --兵法开启条件
    local _flag = zc.getFunctionStatus(20, true) 
    if not _flag then 
        return
    end
    zc.sendHttp({
        apiName = "Captain_bookInfo",
        successCallback = function (net_data)
            zc.createSourceScene("ResearchBingFa", "src/layer/research/ResearchBingFaLayer.lua", net_data)
        end,
    })
end
--创建布阵页面
function zc.createBuzhenLayer(params)
    --布阵开启条件
    if not zc.getFunctionStatus(2, true)  then 
        return
    end
    local _params = params or {}
    _params.doExit = false
    zc.createSourceScene("Buzhen", "src/layer/buzhen/BuzhenLayer.lua", _params)
end

--兵器谱 主界面
function zc.createSmithLayer(params)
end

--兵器谱 打造
function zc.createSmithMakeLayer(params)
end

--兵器谱 强化
function zc.createSmithCastingLayer(params)
end

--兵器谱 洗练
function zc.createSmithClearLayer(params)
    local _flag = zc.getFunctionStatus(29, true) 
    if not _flag then 
        return
    end 
    zc.createSourceScene("SmithyClear", "src/layer/smithyHouse/SmithyClearLayer.lua", params or {})
end

--兵器谱 神兵
function zc.createSmithGodWeaponLayer(params)
    --神兵开启条件
    local _flag = zc.getFunctionStatus(7,true) 
    if not _flag then 
        return
    end
    zc.createSourceScene("SmithyGodWeapon", "src/layer/smithyHouse/SmithyGodWeaponLayer.lua",params or {})
end

--兵器锻造
function zc.createWeaponCastLayer(params)
    --神兵开启条件
    local _flag = zc.getFunctionStatus(42, true) 
    if not _flag then 
        return
    end
    zc.createSourceScene("WeaponCast", "src/layer/smithyHouse/WeaponCastLayer.lua",params or {})
end
-- 兵器谱 图鉴
function zc.createSmithBookLayer(params)
    --兵器谱开启条件
    local _flag = zc.getFunctionStatus(12,true) 
    if not _flag then 
        return
    end
    zc.sendHttp({
        apiName = "Weapon_achievementInfo",
        successCallback = function (net_data)
            zc.createSourceScene("SmithyBook", "src/layer/smithyHouse/SmithyBookLayer.lua", net_data)
        end
    })
end
-- 兵器谱 熟练度
function zc.createSmithPracticeLayer(params)
    --兵器谱开启条件
    local _flag = zc.getFunctionStatus(35,true) 
    if _flag then 
        zc.createSourceScene("SmithyPracticeLayer", "src/layer/smithyHouse/SmithyPracticeLayer.lua" )
    end
end
--排行榜
function zc.createRankListPop(params)
    zc.sendHttp({
        apiName = "RankList_main",
        params = {types =  "1"},
        successCallback = function (net_data)
            zc.createSourceScene("RankListPop", "src/layer/rankList/RankListPop.lua", net_data)
        end
    })
end

--抽卡界面
function zc.createCardExtract(params)
    local _params = params or {}
    zc.sendHttp({
        apiName = "Hero_tenLuckDrawMain",
        successCallback = function (net_data)
            for k,v in pairs(net_data) do
                _params[k] = v
            end
            zc.createSourceScene("CardExtract", "src/layer/pub/CardExtractLayer.lua", _params)
        end,
    })
end

--创建酒馆界面 
function zc.createPubLayer(_heroId, _callback)
    zc.createGenralManualLayer(_heroId, _callback)
end

--招将弹出页面
function zc.createPubShowGetHero(params)
    local heroInfo = gameData.getDataFromCacheWithPrimaryKey("hero", params.id)
    if not heroInfo or not heroInfo.id then
        return
    end
    local _params = {
        scene = params.scene,
        info = heroInfo,
        callback = params.callback
    }
    if params.scene then
        local _lay = requires("src/layer/pub/PubShowHeroPop.lua"):create(_params)
        params.scene:addChild(_lay)
    else
        zc.createSourcePop("PubShowHero", "src/layer/pub/PubShowHeroPop.lua", _params)
    end
end

--创建新酒馆界面 
function zc.createGenralManualLayer(_heroId, _callback)
    if _heroId and tonumber(_heroId) > 0 then
        local gotoHeroInfo = gameData.getDataFromCache("hero_handbook_info", {generalid=_heroId} )
        if gotoHeroInfo and gotoHeroInfo.handbook then
            local handbook = gotoHeroInfo.handbook
            local handbookCard = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card", handbook)
            local _playerLevel = tonumber(PlayerData:getUserLevel()) or 1
            local _houseInfo = PlayerData:getHouseInfoByHouseId(9) or {}
            local _houseLevel = tonumber(_houseInfo["level"]) or 1
            if tonumber(handbookCard.plevel) > _playerLevel or tonumber(handbookCard.level) > _houseLevel then
                zc.tipInfo(zc.lang("tips_general_unopen"))
                return
            end
        end
    end
    zc.sendHttp({
        apiName = "Hero_heroFragmentExchangeMain",
        successCallback = function (net_data)
            PlayerData:setFragmentExchangeData(net_data)
            zc.createSourceScene("GeneralManualLayer", "src/layer/pub/GeneralManualLayer.lua",{gotoHeroId=_heroId,callback=_callback})
        end
    })
end
--抽将预览
function zc.createGeneralPreviewLayer(_params)
    zc.createSourceScene("GeneralPreviewLayer", "src/layer/pub/GeneralPreviewLayer.lua", {data=_params or {}})
end
function zc.createGenralCardGetPop(_params)
    zc.createSourcePop("GeneralCardGetPop", "src/layer/pub/GeneralCardGetPop.lua", _params)
end
--创建征收界面
function zc.createLevy(houseInfo)
    local _houseInfo = nil
    if not _houseInfo then
        _houseInfo = PlayerData:getHouseInfoByHouseId(16)
    end
    zc.sendHttp({
        apiName = "Levy_main",
        successCallback = function (net_data)
            net_data["houseInfo"] = _houseInfo
            zc.createSourceScene("Levy", "src/layer/levy/LevyPop.lua", net_data)
        end,
    })
end
--奖励展示页面
function zc.createShowReward(params)
    zc.createSourcePop("ShowReward", "src/layer/showItem/ShowRewardPop.lua", params or {})
end

--创建章节
function zc.createChapter(params)
    zc.createSourceScene("ChapterNew", "src/layer/chapter/ChapterMainLayer.lua", params or {})
end

--跳转到关卡界面
function zc.createTollgateLayer(params)
    local _tollgateId = tonumber(params.tollgateId) or 1
    local _chapterDb = gameData.getDataFromCacheWithPrimaryKey("chapter", _tollgateId)
    if not _chapterDb or next(_chapterDb) == nil then
        return
    end
    local function _jumpTollgate(_params)
        zc.createSourceScene("tollgate", "src/layer/chapter/TollgateMainLayer.lua", _params)
    end
    local _nationId = _chapterDb.nationId or 1
    if _nationId == 1 and _tollgateId ~= 1 then
        local _chapterData = PlayerData:getCopyInfoByChapterId(_tollgateId) or {}
        local _inlog = tonumber(_chapterData.inlog) or 0
        -- _inlog = 0
        if _inlog == 0 then 
            do 
                _chapterData.inlog = 1
                zc.sendHttp({
                    apiName = "Tollgate_setInChapter",
                    params = {chapterId = _tollgateId, info = 1},
                    successCallback = function() end,
                })

                local function _endJuanzhou()
                    params.isAnimationEnterShow = true
                    _jumpTollgate(params)   
                end
                zc.createJuanzhouTips({
                    name = _chapterDb.name,
                    desc = _chapterDb.desc,
                    enCall = _endJuanzhou
                })
            end
            return
        end
    end
    _jumpTollgate(params)
end
--创建战前奖励显示界面
function zc.createEnemyInfoPop(params)
    local _params = params or {}
    zc.createSourcePop("EnemyInfo", "src/layer/chapter/EnemyInfoPop.lua", _params)
end
--创建战前奖励显示界面
function zc.createDropIntroducePop(params)
    local _params = params or {}
    zc.createSourcePop("DropIntroduce", "src/layer/chapter/DropIntroducePop.lua", _params)
end

local function _makeFriendDo( opStr, _uid, tipStr, _callback )
    if not _uid then return end
    zc.sendHttp({
        apiName = opStr,
        params = {uid=_uid},
        successCallback = function (data)
            performWithDelay(cc.Director:getInstance():getRunningScene(), function()
                zc.tipInfo(tipStr)
            end, 0.3)
            if _callback and type(_callback) == "function" then
                _callback()
            end
        end,
    })
end
--添加好友
function zc.addFriend(_uid, _callback)
    _makeFriendDo("Friend_apply", _uid, zc.lang("tips_add_friend_send_already"), _callback)
end
--屏蔽玩家(拉黑)
function zc.maskThePlayer(_uid, _callback)
    _makeFriendDo("Friend_blacklisted", _uid, zc.lang("tips_black_player_already"), _callback)
end
--移出黑名单
function zc.removePlayerFromBlacklist(_uid, _callback)
    _makeFriendDo("Friend_delete_blacklisted", _uid, zc.lang("tips_unblack_player_already"), _callback)
end

function zc.getScaleNode(_path, _nodeSize, plist)
    local _flag = plist == nil and false or plist
    local _node = _flag and ccui.Scale9Sprite:createWithSpriteFrameName(_path) or ccui.Scale9Sprite:create(_path)
    _node:setContentSize(_nodeSize)
    return _node
end

function zc.addFullMask()
    local _scene = cc.Director:getInstance():getRunningScene()
    if not _scene:getChildByName("layer_full_mask___") then
        local maskBtn = zc.createPushButton({
            touchSize = cc.size(10000, 10000),
            endCallback = function()
                print("clicked ... ======================")
            end,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(zc.width/2, zc.height/2),
        })
        maskBtn:setName("layer_full_mask___")
        _scene:addChild(maskBtn)
    end
end
function zc.hideFullMask()
    local _scene = cc.Director:getInstance():getRunningScene()
    if _scene:getChildByName("layer_full_mask___") then
        _scene:getChildByName("layer_full_mask___"):removeFromParent()
    end
end

--[[
    btnColor = "blue" or "yello"
    btnText = ""
]]
function zc.createNormalBtnWithText( params )
    local _params = params or {}
    if  params.btnColor == "yellow" then
        _params.tag = 1
    else
        _params.tag = 2
    end

    local _btn = zc.createCommomBtn(_params)
    return _btn
end

--检查文件是否存在
function zc.checkFileExist(_path)
    local filePath = cc.FileUtils:getInstance():fullPathForFilename(_path)
    return cc.FileUtils:getInstance():isFileExist(filePath)
end

-- 创建技能信息弹窗，需要技能id
function zc.createSkillInfoPop( params )
    zc.createSourcePop("SkillInfoPop", "src/layer/common/SkillInfoPop.lua", params)
end
-- 创建武将信息弹窗，需要武将主键id
function zc.createHeroInfoPop( params )
    zc.createSourcePop("HeroInfoPop", "src/layer/common/HeroInfoPop.lua", params)
end
-- 创建物品掉落弹窗，需要itemType = 主类型，itemId = id，needNum = 需要数量，还有各种回调
function zc.createItemDropPop( params )
    zc.createSourcePop("ItemDropPop", "src/layer/common/ItemDropPop.lua", params)
end

--物品合成
function zc.createItemSynthesisPop( params )
    if not params.itemType or not params.itemId then
        return
    end
    zc.createSourcePop("ItemSynthesis", "src/layer/smithyHouse/ItemSynthesisPop.lua", params)
end
--武器合成
function zc.createWeaponSynthesisPop( params )
    if not params.itemType or not params.itemId then
        return
    end
    if tonumber(params.itemType) ~= zc.mainTypeProp then
        return
    end
    zc.createSourcePop("WeaponSynthesisPop", "src/layer/bag/WeaponSynthesisPop.lua", params)
end
-- 骨骼动画置灰
function zc.setArmatureGray( armature, gray )
    if armature then
        for k, v in pairs( armature:getBoneDic() ) do
            if v and k ~= "root" and k ~= "top" and k ~= "mid" and k ~= "rect_atk" and k ~= "rect_atk0" and k ~= "rect_atk3" then
                local node = v:getDisplayRenderNode()
                if node then
                    zc.setGray( node, gray )
                end
            end
        end
    end
end

function zc.createLevelUpPop( level )
    local _runningScene = cc.Director:getInstance():getRunningScene()
    if not _runningScene then
        return
    end
    local _name = _runningScene:getName()
    if _name == LAYER_NAME_TAG.LAYER_MAINCITY then
        zc.createSourcePop("BattleUILevelUpPop", "src/layer/battle/ui/BattleUILevelUpPop.lua", {level = level})
    else
        local BattleUILevelUpPop = requires("src/layer/battle/ui/BattleUILevelUpPop.lua"):create({level = level, isAdd = true})
        BattleUILevelUpPop:setName("BattleUILevelUpPop")
        _runningScene:addChild(BattleUILevelUpPop, 1)
    end
end

--设置界面
function zc.createSettingPop(params)
    zc.createSourceScene("SelfInfo", "src/layer/setting/SelfInfoPop.lua", params)
end
--邮箱界面
function zc.createEmailPop(params)
    zc.createSourceScene("emailPanel", "src/layer/email/EmailPanelPop.lua", params or {})
end
--公告界面
function zc.createNoticePop(params)
    local function _doEndCall()
        if params and params.callBack then
            params.callBack()
        end
    end
    if ZC_targetPlatform == cc.PLATFORM_OS_MAC then
        _doEndCall()
        return
    end
    local _scene = cc.Director:getInstance():getRunningScene()
    if tolua.isnull(_scene) then
        return
    end 
    local _notice = _scene:getChildByName("NoticePop")
    if _notice then
        return
    end
    _notice = _scene:getChildByName("reloginTip")
    if _notice then
        return
    end
    local _notice = _scene:getChildByName("BackKeyPop")
    if _notice then
        return
    end
    local announce = PlayerData["announcement"]
    if not announce or not next(announce) then
        _doEndCall()
        return
    end
    local _scene = cc.Director:getInstance():getRunningScene()
    if tolua.isnull(_scene) then
        _doEndCall()
        return
    end 
    local tipPop = _scene:getChildByName("reloginTip")
    if tipPop then
        _doEndCall()
        return
    end
    local noticePop = requires("src/layer/notice/NoticePop.lua"):create(params)
    noticePop:setName("NoticePop")
    _scene:addChild(noticePop, 10000000)
end

function zc.createOtherPlayerSelect( uid )
    local _uid = tonumber(uid) or -1
    if tonumber( _uid ) < 0 then
        zc.tipInfo(zc.lang("tips_unable_look_player"))
        return
    elseif tonumber( _uid ) == tonumber( PlayerData.info.userId ) then
        zc.tipInfo(zc.lang("tips_unable_look_self"))
        return
    end
    zc.sendHttp({
        apiName = "User_otherPlayer",
        params = {targetUserId = _uid},
        successCallback = function (data)
            if data.heros then
                zc.createPop("otherPlayerSelect", data)
            end
        end,
    })
end
-- 创建校场界面
function zc.createDrillFieldLayer()
    local _flag = zc.getFunctionStatus(27, true) 
    if not _flag then
        return
    end
    local houseData = PlayerData:getHouseInfoByHouseId(8)
    zc.sendHttp({
        apiName = "Training_main", 
        params = {houseId=houseData.id}, 
        successCallback = function (data)
            zc.createSourceScene("DrillFieldLayer", "src/layer/drillField/DrillFieldLayer.lua", {data = data,houseInfo = houseData,tss = PlayerData:getTssTime()})
        end,
    })
end

-- 创建将魂界面
function zc.createHeroSoul()
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.createSourceScene("HeroSoul", "src/layer/heroSoul/HeroSoulLayer.lua", data)
end

-- 创建祭魂界面
function zc.createHeroSoulRand()
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.sendHttp({
        apiName = "HeroSoul_main", 
        successCallback = function (data)
            zc.createSourceScene("HeroSoulRand", "src/layer/heroSoul/HeroSoulRandLayer.lua", data)
        end,
    })
end

function zc.createHeroSoulInfoPop( params )
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.createSourcePop("HeroSoulInfo", "src/layer/heroSoul/HeroSoulInfoPop.lua", params)
end 

function zc.createHeroSoulSelectedPop( params )
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.createSourcePop("HeroSoulSelected", "src/layer/heroSoul/HeroSoulSelectedPop.lua", params)
end 

function zc.createHeroSoulUpgradePop( params )
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.createSourcePop("HeroSoulUpgradePop", "src/layer/heroSoul/HeroSoulUpgradePop.lua", params)
end 

-- 创建将魂商店界面
function zc.createHeroSoulShop()
    local _flag = zc.getFunctionStatus(47, true) 
    if not _flag then
        return
    end
    zc.createSourceScene("HeroSoulShop", "src/layer/heroSoul/HeroSoulShopLayer.lua")
end

-- 创建铜雀台界面
function zc.createTradeLayer(_callback)
end
-- 铜雀台好友度
function zc.createTradeFriendshipLayer( _params )
end

-- 创建活动界面
function zc.createActivityPop(params)
    local entrance_ = 1
    if not params then
        entrance_ = 1
    else
        local _entrance = params.entrance
        if not _entrance then
            entrance_ = 0
        else
        	entrance_ = _entrance
        end
    end
    zc.sendHttp({
        apiName = "Activity_open_info",

        params = {entrance = entrance_},
        successCallback = function (net_data)
            PlayerData:setActivityInfo(net_data)
            local _params = params or {}
            local _activityType = tonumber(_params.sType) or 0
            local _popName = _activityType == 0 and "ActivityPop" or "ActivityNewPop"
            zc.createSourceScene(_popName, "src/layer/activity/ActivityPop.lua", _params)
        end
    })
end

-- 创建购买体力弹窗
function zc.createBuyEnergyPop(params)
    zc.createSourcePop("BuyEnergyPop", "src/layer/mainCity/BuyEnergyPop.lua", params)
end

--现在云只有yundongtai2 默认是只有下面的云，上面的云需要翻转，不要改变锚点 (0.5,0.5)
function zc.getYunDongTai(_tag,_animationType,_callback,_dontStart)
    local showTag       = _tag or 3 -- 1表示只要上面的 2表示只要下面的 3表示上下都要(默认)
    local animType      = _animationType or 1
    local _dontStart    = _dontStart == nil and true or _dontStart --不播放start动作(默认不播放)
    
    
    -- zc.getOtherArmature("yundongtai2", function( bAsync )
        local function getYunArmature()
            local arm = zc.createAnimationArmature({
                fileName = "yundongtai2",
                autoRelease = true
            })
            local _action = {
                [1]={start="start",idle="idle"},
                [2]={start="start_2",idle="idle_2"},
                [3]={start="start_3",idle="idle_3"},
            }
            if _dontStart then --不播放start动作
                arm:getAnimation():play( _action[animType]["idle"] )
            else
                arm:getAnimation():play( _action[animType]["start"] )
                arm:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
                    if 1 == tonumber(movementType) then
                        arm:getAnimation():play( _action[animType]["idle"] )
                    end
                end)
            end
            arm:setAnchorPoint( cc.p( 0.5, 0.5 ) )

            local widthScale  = zc.width/1136
            if widthScale > 1 then 
                arm:setScale(widthScale)
            end
            return arm
        end
        local armature1,armature2
        if showTag == 1 then
            armature1 = getYunArmature()
            armature1:setScale(-1*armature1:getScale())
        elseif showTag == 2 then
            armature2 = getYunArmature()
        elseif showTag == 3 then
            armature1 = getYunArmature()
            armature2 = getYunArmature()
            armature1:setScale(-1*armature1:getScale())
        end
        if animType == 1 then
            if armature1 then
                armature1:setPosition( cc.p( zc.width/2 , zc.height - 82 ) )
            end
            if armature2 then
                armature2:setPosition( cc.p( zc.width/2 , 82 ) )
            end
        elseif animType == 2 then
            if armature1 then
                armature1:setPosition( cc.p( zc.width/2 , zc.height - 70 ) )
            end
            if armature2 then
                armature2:setPosition( cc.p( zc.width/2 , 70 ) )
            end
        elseif animType == 3 then
            if armature1 then
                armature1:setPosition( cc.p( zc.width/2 , zc.height - 82 ) )
            end
            if armature2 then
                armature2:setPosition( cc.p( zc.width/2 , 82 ) )
            end
        end
        if _callback then
            _callback(armature1,armature2)
        end
    -- end)
end

-- 世界boss
function zc.createWorldBossLayer()
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "BossPve_main",
        successCallback = function(data)
            zc.createSourceScene("WorldBossLayer", "src/layer/country/WorldBossLayer.lua", data)
        end,
    })
end

-- 总览换装红点
function zc.getChangeWeaponRedDotStatus( heroList )
    if #heroList == 0 then
        return false
    end
    local _weaponList = {}
    -- 先计算每种兵器类型的武将最高等级
    local _maxLevel = {}
    for i, v in ipairs( heroList ) do
        if v.id ~= PlayerData:getBaseInfoByTag("heroId") then
            local _type = tonumber( v.weaponType )
            local _level = tonumber( v.level ) or 0
            local _reincarnate = tonumber( v.reincarnate ) or 0
            if _maxLevel[_type] then
                if _maxLevel[_type].reincarnate < _reincarnate then
                    _maxLevel[_type] = {
                        level = _level,
                        reincarnate = _reincarnate,
                    }
                elseif _maxLevel[_type].reincarnate == _reincarnate and _maxLevel[_type].level <= _level then
                    _maxLevel[_type] = {
                        level = _level,
                        reincarnate = _reincarnate,
                    }
                end
            else
                _maxLevel[_type] = {
                    level = _level,
                    reincarnate = _reincarnate,
                }
            end
        end
    end
    -- 没人穿的装备的最强战力
    for i, v in ipairs( PlayerData:getWeaponsInfo() ) do
        if ( tonumber( v.isUser ) or 0 ) == 0 and ( tonumber( v.heroId ) or 0 ) == 0 then
            -- 非主角而且没人穿
            local _type = tonumber( v.type )
            if _maxLevel[_type] then
                -- 有对应类型的武将
                local _needLevel = tonumber( v.needLevel ) or 0
                local _needReincarnate = tonumber( v.needReincarnate ) or 0
                local _level = _maxLevel[_type].level or 0
                local _reincarnate = _maxLevel[_type].reincarnate or 0
                if ( _reincarnate > _needReincarnate ) or ( _reincarnate == _needReincarnate and _level >= _needLevel ) then
                    -- 有武将满足穿戴等级
                    local _fight = zc.calculateCombatValue( v )
                    if _weaponList[_type] then
                        if _weaponList[_type] < _fight then
                            _weaponList[_type] = _fight
                        end
                    else
                        _weaponList[_type] = _fight
                    end
                end
            end
        end
    end
    for index, _heroData in ipairs( heroList ) do
        if _heroData.id ~= PlayerData:getBaseInfoByTag("heroId") then
            local _weaponData = PlayerData:getWeaponsInfoById( _heroData.id )
            local _fight = zc.calculateCombatValue( _weaponData )
            local _type = tonumber( _heroData.weaponType )
            if _fight < ( _weaponList[_type] or 0 ) then
                return true
            end
        end
    end
    return false
end
-- 总览装备强化进阶红点
function zc.getEquipRedDotStatus( heroList, type )
    if #heroList == 0 then
        return false
    end
    -- 类型，0检查强化和进阶，1检查强化，2检查进阶
    local _type = tonumber(type) or 0
    -- 玩家银币
    local _myMoney = zc.getNumByTypeId( 1, 2 )
    -- 所有装备数据
    local _equipInfo = PlayerData:getEquipInfo()
    for index, _heroData in ipairs( heroList ) do
        -- 获取武将的装备列表
        local _equipList = {}
        local _heroId = tonumber( _heroData.id ) or 0
        local _heroLevel = tonumber( _heroData.level ) or 0
        for i, v in ipairs( _equipInfo ) do
            local __heroId = tonumber( v.heroId ) or 0
            if _heroId == __heroId then
                _equipList[#_equipList + 1] = v
            end
        end

        for i, _equipData in ipairs( _equipList ) do
            if _type == 0 or _type == 1 then
                -- 强化
                local _flag = zc.getEquipStrengthenStatus( _equipData, _heroLevel )
                if _flag then
                    return true, _heroId, _equipData.position
                end
            end
            if _type == 0 or _type == 2 then
                -- 进阶
                local _flag = zc.getEquipAdvanceStatus( _equipData )
                if _flag then
                    return true, _heroId, _equipData.position
                end
            end
        end
    end
    return false
end
-- 单件装备强化红点
function zc.getEquipStrengthenStatus( equipData, heroLevel )
    -- 玩家银币
    local _myMoney = zc.getNumByTypeId( 1, 2 )
    -- 装备强化等级
    local _level = tonumber( equipData.strengthenLevel ) or 0
    local _advance = tonumber( equipData.advanceLevel ) or 0
    -- 强化
    if _level < heroLevel*2 then
        local _strengthenData = gameData.getDataFromCacheWithPrimaryKey( "equip_strengthen", _level + 1 )
        if next(_strengthenData) then
            -- 可以继续强化
            local _needAdvance = tonumber( _strengthenData.needQuality ) or 0
            local _price = tonumber( _strengthenData.needMoney1 ) or 0
            if _advance >= _needAdvance and _price <= _myMoney then
                return true
            end
        else
            -- 强化至满级
            return false
        end
    end

    return false
end
-- 单件装备进阶红点
function zc.getEquipAdvanceStatus( equipData )
    -- 装备强化等级
    local _level = tonumber( equipData.strengthenLevel ) or 0
    -- 进阶
    local _advanceData = gameData.getDataFromCacheWithPrimaryKey("equip_advanced", equipData.equipmentId)
    if next(_advanceData) then
        -- 可以继续进阶
        for i = 1, 8 do
            local _stuff = tostring( _advanceData["stuff"..i] )
            local _stuffs = string.split( _stuff, "|" )
            if #_stuffs == 3 then
                local _needNum = tonumber( _stuffs[3] ) or 0
                local _ownNum = zc.getNumByTypeId( _stuffs[1], _stuffs[2] )
                if _ownNum < _needNum then
                    return false
                end
            end
        end
        return true
    else
        -- 进阶到满级
        return false
    end
end
-- 羁绊红点
function zc.getFetterRedDotStatus( heroList )
    return false
end
-- 饰品红点
function zc.getTrinketRedDotStatus()
    -- 功能未开启
    if not zc.getFunctionStatus( 9 ) then
        return false
    end
    -- print("刷新饰品红点")
    -- 数据
    local _roleTrinketData = {}
    local _bagTrinketData = {}
    local _trinketData = {}
    for i, v in ipairs( PlayerData:getTrinketsInfo() ) do
        local _trinketId = tonumber( v.trinketId ) or 0
        local _data = _trinketData[_trinketId]
        if not _data then
            _data = gameData.getDataFromCacheWithPrimaryKey("trinket", _trinketId)
            _trinketData[_trinketId] = _data
        end
        if tonumber( v.status or 0 ) == 5 then
            -- 已穿戴
            v.color = tonumber( _data.color ) or 0
            v.position = tonumber( _data.position ) or 0
            _roleTrinketData[v.position] = v
        elseif tonumber( v.status or 0 ) == 0 then
            -- 未穿戴
            v.color = tonumber( _data.color ) or 0
            v.position = tonumber( _data.position ) or 0
            _bagTrinketData[#_bagTrinketData + 1] = v
        end
    end
    if #_bagTrinketData == 0 then
        return false
    end
    -- 计算已穿戴饰品的最小属性
    local _mainData = {}
    local _roleTrinket = {}
    for k, v in pairs( _roleTrinketData ) do
        local _trinketId = tonumber( v.trinketId )
        local _min = nil
        if v.color >= 3 then
            -- 计算已穿戴饰品的最小战斗力属性
            for i = 1, 6 do
                if tonumber(v["effectId"..i]) ~= 0 then
                    local _value = zc.attrCompareFormula(v["effectId"..i], v["effectValue"..i])
                    if _min then
                        _min = _min > _value and _value or _min
                    else
                        _min = _value
                    end
                else
                    _min = 0
                    break
                end
            end
        end
        -- 主属性
        local _main = _mainData[_trinketId]
        if not _mainData[_trinketId] then
            local _data = gameData.getDataFromCacheWithPrimaryKey("trinket", _trinketId)
            _main = zc.attrCompareFormula(_data.effectId, _data.effectValue, true)
            _mainData[_trinketId] = _main
        end
        _roleTrinket[v.position] = {
            _min = _min,
            _main = _main,
        }
    end
    -- dump( _roleTrinket, "_roleTrinket" )
    
    for i, v in ipairs( _bagTrinketData ) do
        if _roleTrinket[v.position] then
            -- 判断饰品列表的饰品能否装备
            local _roleValue = _roleTrinket[v.position]._main
            local _bagValue = _mainData[tonumber( v.trinketId )]
            if not _bagValue then
                local _data = gameData.getDataFromCacheWithPrimaryKey("trinket", v.trinketId)
                _bagValue = zc.attrCompareFormula(_data.effectId, _data.effectValue, true)
                _mainData[tonumber( v.trinketId )] = _bagValue
            end
            if _bagValue > _roleValue then
                return true
            end
            -- 判断饰品列表的饰品能否洗练
            if v.color >= 3 then
                local _roleValue = _roleTrinket[v.position]._min
                if _roleValue then
                    if _roleValue == 0 then
                        -- 已穿戴装备属性不够6条
                        return true
                    else
                        for i = 1, 6 do
                            if tonumber(v["effectId"..i]) ~= 0 then
                                local _value = zc.attrCompareFormula(v["effectId"..i], v["effectValue"..i])
                                if _value > _roleValue then
                                    return true
                                end
                            end
                        end
                    end
                end
            end
        else
            -- 可装备
            return true
        end
    end
    return false
end
-- 升星红点
function zc.getStarupRedDotStatus( heroList )
    -- 功能未开启
    if not zc.getFunctionStatus( 14 ) then
        return false
    end
    -- print("刷新升星红点")
    for index, _heroData in ipairs( heroList ) do
        local _grid = tostring( _heroData.grid )
        if #_grid == 7 then
            local _actAllFlag = true
            -- 下一等级的升星数据
            local _starupData = gameData.getDataFromCache("hero_star_level", {heroId = _heroData.heroId, level = ( tonumber(_heroData.star) or 0 ) + 1})
            if next(_starupData) == nil then
                -- 已经升到最高
                break
            end
            for i = 1, 6 do
                local _actFlag = tonumber( string.sub( _grid, i + 1, i + 1 ) ) == 1
                _actAllFlag = _actAllFlag and _actFlag
                if not _actFlag then
                    -- 没有激活，检查激活材料
                    if _starupData["gridType"..i] and _starupData["gridStuffs"..i] then
                        local _type = tonumber( _starupData["gridType"..i] ) or 0
                        if _type ~= 0 then
                            local _enoughFlag = false
                            for j, v in ipairs( string.split( _starupData["gridStuffs"..i], "," ) ) do
                                local _consume = string.split( v, "|" )
                                _enoughFlag = zc.getNumByTypeId( _consume[1], _consume[2] ) >= ( tonumber( _consume[3] ) or 0 )
                                if not _enoughFlag then
                                    break
                                end
                            end
                            if _enoughFlag then
                                return true, _heroData.id
                            end
                        end
                    end
                end
            end
            if _actAllFlag then
                -- 全都激活了，检查升星材料
                local _enoughFlag = false
                for i, v in ipairs( string.split( _starupData["stuffs"] or "", "," ) ) do
                    local _consume = string.split( v, "|" )
                    _enoughFlag = zc.getNumByTypeId( _consume[1], _consume[2] ) >= ( tonumber( _consume[3] ) or 0 )
                    if not _enoughFlag then
                        break
                    end
                end
                if _enoughFlag then
                    return true, _heroData.id
                end
            end
        end
    end
    return false
end
-- 培养红点
function zc.getCultureRedDotStatus( heroList )
    if #heroList == 0 then
        return false
    end

    local _maxFlag = true
    local _heroId = 0
    for _index, _heroData in ipairs( heroList ) do
        local _cultureData = _heroData.culture
        if tonumber( _cultureData.force ) >= tonumber( _cultureData.forceLimit ) and
            tonumber( _cultureData.wisdom ) >= tonumber( _cultureData.wisdomLimit ) and
            tonumber( _cultureData.soma ) >= tonumber( _cultureData.somaLimit ) then
            _maxFlag = true
        else
            _maxFlag = false
            _heroId = _heroData.id
            break
        end
    end
    if not _maxFlag then
        -- 属性没满，可以培养
        local _myVip = tonumber( PlayerData:getBaseInfoByTag( "vip" ) ) or 0
        local _cultureList = gameData.getDataFromCache( "hero_culture" )
        for i, v in ipairs( _cultureList ) do
            local _needVip = tonumber( v.needVip ) or 0
            if _myVip >= _needVip then
                local _consumeNum = 0
                local _type = tonumber( v.expendType ) or 1
                if _type == 1 then
                    -- 元宝根据次数递增
                    _consumeNum = tonumber( v.expendNum ) + tonumber( v.expendAddNum )*tonumber( PlayerData:getLimitInfoById( "culture"..i ) )
                elseif _type == 2 then
                    -- 银币根据主角等级递增
                    _consumeNum = tonumber( v.expendNum )*tonumber( PlayerData.info.level )
                end
                local _myNum = zc.getNumByTypeId( zc.mainTypeResource, _type )
                if _myNum >= _consumeNum then
                    -- 材料满足
                    return true, _heroId, _type
                end
            end
        end
    end
    return false
end
-- 校场变强
function zc.getDrillFieldStrongerStatus( heroList )
    if #heroList == 0 then
        return false
    end

    -- 突飞卡数量
    local _myCardNum = zc.getNumByTypeId( zc.mainTypeProp, 1 )
    if _myCardNum <= 0 then
        return false
    end
    -- 主角武将信息
    local _mainHeroId = tonumber( PlayerData.info.heroId ) or 0
    local _mainHeroLevel = tonumber( PlayerData.info.level ) or 0
    -- 每张突飞卡经验值
    local _cardExpNum = math.floor( _mainHeroLevel*50*45*5/24 )
    _cardExpNum = _cardExpNum*_myCardNum

    for i, v in ipairs( heroList ) do
        -- 武将
        local _level = tonumber( v.level ) or 0
        -- 判断转生
        local _rnct = tonumber( v.reincarnate ) or 0
        local _rnctData = gameData.getDataFromCache("hero_reincarnate", {level = _rnct, heroType = 1})
        local _rnctLevel = tonumber( _rnctData.level ) or 0
        if _level >= _rnctLevel then
            -- 可以转生
            return true
        elseif _level < _mainHeroLevel then
            -- 可以升级
            local _exp = tonumber( v.exp ) or 0
            local _expLimit = tonumber( v.expLimit ) or 0
            if _cardExpNum + _exp >= _expLimit then
                return true
            end
        end
    end

    return false
end

-- 创建七日活动
function zc.createSevenDayPop()
    zc.sendHttp({
        apiName = "SevenDay_main", 
        successCallback = function(data)
            zc.createSourceScene("SevenDayPop", "src/layer/activity/SevenDayPop.lua", data)
        end
    })
end

function zc.createTenEvenPumpLayer( wushenTower )
end

function zc.createReLoginTip( noticeText )
    local _scene = cc.Director:getInstance():getRunningScene()
    if tolua.isnull(_scene) then
        return
    end 
    local _name = _scene:getName()
    if _name ~= LAYER_NAME_TAG.LAYER_MAINCITY
        and _name ~= LAYER_NAME_TAG.LAYER_BATTLE then
        return
    end
    local tipPop = _scene:getChildByName("reloginTip")
    if tipPop then
        return
    end
    getNetManager():closeHeartBeat()
    local _notice = _scene:getChildByName("NoticePop")
    if _notice then
        _notice:removeFromParent()
    end
    local _email = zc.getPop("emailPanel")
    if _email then
        LayerManager.backToMainCity(false)
    end
    if not getGuideManager():guideIsOver() then
        getGuideManager():guideOver()
    end
    if _name == LAYER_NAME_TAG.LAYER_BATTLE then
        local _battle = _scene:getChildByName(LAYER_NAME_TAG.LAYER_BATTLE)
        if _battle then
            _battle:pauseBattle()
        end
    end
    local tipPop = ZCConfirmDialog:createWithParams({
        title = zc.lang("prompt"),
        showDi = true,
        leftVisible = false,
        msg = noticeText or zc.lang("tips_relogin"),
        rightCallback = function()
            zc.goReturnLogin(true)
        end
    })
    clearGlobalObject()
    tipPop:setName("reloginTip")
    _scene:addChild(tipPop, 200000)
    if tipPop._containerLayer then
        tipPop._containerLayer:setTouchEndedCallback(function()
        end)
    end
    if tipPop._close_btn then
        tipPop._close_btn:setVisible( false )
    end
end

-- 用warkey查看战报
function zc.debugBattle(node, _id)
    -- 合体技
    local _warKeys = {
        -- 孙策孙坚
        [1] = "VkN3S2V3Y3pWV2hWYlZKdERVaFFNd0l1QkNvRlBGWnhWV1FDWUFCcUJ6UUdOUVpsQVdjRENGTTJCZ05iWkZSaUMyOEFVd0l3RERGU1pncHFBZ2RTWlZSbkNta0hZRlV4VlRGU1BBMWNVR2NDWXdRL0JUUldhMVZrQW1jQWFnYzJCamNHZHdGL0EzVlRkUVk5V3p0VU5ndDhBRFlDTlF3NlVtWUtiUUpoVW14VVlRcHFCMk5WZkE9PQ&tokenUid=1842&key=0037a690dc4f57a87d410764d7bf6bbf4112768d",
        -- 颜良文丑
        [2] = "Qm41VUpWZGpCanNKTVFNOEFFVlJNbFo2VUg0QU9RTWtWbWNBWWxzd1VHVlhaRkF5QjJGV1hWRTBBUVJiWkZObFVEUUdWVkJtQVQwSU9Bc0dBR3NBTmdZMFZEUlhOUVpqQ1drREJnQS9VV05XTkZCdUFEc0RQMVpnQUdaYk4xQmtWM1pRTHdkM1ZuQlJaQUUxV3pGVGQxQS9CanhRYXdFeENEb0xZUUJpQUQ0R01WUXlWM2c9",
        -- 张昭张纮
        [3] = "Vnk4Q2MxWmlBRDBGUFFNOFdCMVFNd1lxQnlrRVBRQW5CamNIWlFCcUJEWUZOZ0poVXpoWFhGTTJWbE5ZWndReUMyOVhCRlprVkdsVVlsVTJVbGRUWkZka0FtRldNQUJrQldFRFlGZ0pVR2NHWndjOEJEUUFOUVl5QjJFQWJnUXdCVFlDYzFNdFZ5RlRkVlp0V0RnRVpndDhWMkZXWjFSaFZHVlZQMUk5VTJCWFpnSmtWallBYlFVcw&tokenUid=1861&key=fa3a1953ef1e2afb9dd70c74e7d6757fec9dc69c",
        -- 关羽刘备
        [4] = "Qm41UklGRmxCRGtFUEFZNVh4cFdOUXNuVkhwWVlRWWhBRE5STmxaVEFERlREd1ZuQVdOU053RUtCMnhhYlZkalVqRUdWVlZsVjJjSVZ3RmlWamdCTUFZMlVUSlJOUVJpQkdNR2ExOXBWbklMY2xSNldDa0dZZ0J1VVdkV0xnQThVMlFGWkFGalVqTUJiUWR0V21KWFpsSjY",
        -- 吕布貂蝉
        [5] = "VlMwS2UxeG9VbThDT2xGdVdCMVdOUVlxQmlnRlBGTjBDVDFSTTFWUUF6SU9VbEF5QVdNRVlRa0NWendLUFZKbVVUSUdWUU0wRFRoV0NRRmlCV3NHTjFWbENtbGNPRkkwQW1OUk9WaGhWbklHZndZb0JYUlROd2xuVVdkVkxRTS9EamhRTmdGaUJHY0piRmMxQ2pOU1lWRXdCbmM9",
        -- 郭嘉曹操
        [6] = "Qkh4WEpsTm5WMm9HUGxCdkRrdFZObFY1RENKVmJBTWtVV1VCWTFaVEFqTUFYQUZqQUdJSFlsRmFCMndMUEZWaFZUWUNVUUkxVkdGVERBSmhCMmtETWdRMFZ6UlROMWN4Qm1SUVBBNDRWWEZWTEF3aVZTUURaMUUvQVRkV0xnSStBRElCWVFCa0IyVlJQQWRxQ3pkVmExVXlBajBDZkE9PQ",
        -- 贾诩李儒
        [7] = "VlMwR2QxQmtVMjRCT1FNOENVd0haQUl1RENKUWFRQW5DVDFYTlFVQUJqY0NYbEF5QjJVQVpWWmRCbTBJUDF0dkJtVlJBbEJuQURVRFhBTmdBbXdGTkZWbEJtVlFORk0xQVdJRFlRa3lCeU1DZXd3aVVDRUFaQWxuVjJFRmZRWTZBakpRTUFka0FHVldOd1pzQ0RCYmJRWnJVU0E9",
        
        [8] = "VTJFSFpBUm1CMkpTV1FOb0FUOVdZRkUwQkRsWUJBVXlBVjVXTmxveUR6RlFZUXNIQm1WUk5RVmhXakVOWEZkZ1ZUUUJPbGxqRFRzSVBnZGpVRGhUWVZObkIyWUVad2RnVWo0RGJRRTdWbVJSTlFRNFdHcz0",
        [9] = "QmpRQVl3ZGxBMllCQ2dOb0FUOEFObEUwQnpvQVhBSTFDVllCWVFadUJUc0VOVk5mWFQ0SFl3bHRCbTBNWFZWaVVERUhQRmhpQmpCU1pBQmtWejhQUFFZeUFHSUhad051QVdjRGJ3RTZBRFZSUFFjeUFEQT0",
        [10] = "QWpBQ1lWdytCbU5UV0ZJNUR6RlNaQUpuRERGWkJRTTBDVllEWTFJNkJUc0JNRk5mVkRkWE13ZGpXakVMV2dFMkEySU1OMU5wRFRzQ05BVmhVenNPUEFJMkFtQmNQUVpyVXpaU1BBOHlVbXdDWXd3NFdXMD0",
        [11] = "RGp3TGFBZGxYRGxWWGxJNVdHWlVZbFV3QXo0RldRUXpCVm9EWTFZK1VHNVRZZ01QVmpVQlpWVXhBMmdKV0FRekFtTU5OZ0E2QnpGVVlsQTBCVzFYWlE0NkMya0haRncrVlROU01WaGlWR3BWTlFNNkJUTT0",
        [12] = "VkdZRVoxUTBBV0ZTTmxRL1dHQmJBZ0ptQlZZRU5nWXpVbU1GQ0ZVK1UyWlZiZ3BvQmd0Uk5BUmdCR3dPTkZWalVqWUNPRkFNQmpKUlpWSTRVRDRCUDFSbkJHUlVNd0ZtVWpSVVBGaGhXMjBDWmdVNkJERUdOVkpnQldVPQ",
        
        [13] = "VkdZR1pRUmtVREVDWmxveEFEaFhEZ1ppVndSWmF3RTBWbWNHQzFzd0FqY1BOQVZuVVZ3QVpRbHRVRGhkWmxKa0FXVUFPZ0JjQWpZRk1WYzlVanhRWVZSdUJtUUVaRkE4QW01YU5RQStWMlFHWlZkaVdXSUJNMVpn",
        [14] = "QXpGV05WUTJBV2NJYVZaVEFUNEdYd0ZsVkdoVlp3MVhVbUJXTmdGcEF6VUJYVk14VkRZRVlGRTNWemhhQzFwdEJXUlRad1V5VTJFQ01RdG9XekFITUFNMVZqSlVOd0ZzQ0cxV09BRStCakVCWmxSdA",
        [15] = "QVROVU4xRXpWakJVTlFNR1cyUUFXVmN6QUR4VVpnZGRCalJTTWxjOUFqMVNEbFkwVmpSVU1BRm5VVDRKV0Z0c0FtTUVNQUEzQURNSE5BQmdVVGtFTmdFMVZEWlJORll4VkRnRGJsdGhBREZYT3dBNlZHND0",
    }

    print("-----------log--------ad-------------_id ", _id)
    _warKey = _warKeys[_id]

    zc.sendHttp({
        apiName = "War_play",
        params = {warKey=_warKey},
        successCallback = function (data) 
            local _data = {} 
            _data["warModel"] = {}
            _data["warModel"] = data
            _data["isreplay"] = 1


            local battle
            performWithDelay(node,function()
                battle = zc.createBattle({data = {data = _data}})
                performWithDelay(battle, function()
                    battle:play()
                end, 0.2)
            end,0.9)
            local armature      = zc.createArmature({fileName = "guochang", actName = "idle", autoRemove = true})
            armature:setPosition(cc.p(zc.width / 2 , zc.height / 2))
            node:addChild(armature)
        end,
    })
end

function zc.debugBattleFromFightData(_id)
    local _id = _id or 1
    local _fileName = zc.getFightDatasFilePath() .. "battle" .. _id .. ".data"
    if zc.checkFileExist(_fileName) then
        local data = cc.FileUtils:getInstance():getStringFromFile(_fileName)
        local _data = zc.jsondecode(data)
        local battle = zc.createBattle({data = _data})
        battle:play()
    else
        zc.tipInfo(zc.lang("tips_fight_data_unexit"))
    end
end
-- 押镖主界面
function zc.createCountryDartMainLayer()
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "CountryDart_getDartList",
        successCallback = function (result)
            zc.createSourceScene("CountryDartMainLayer", "src/layer/country/CountryDartMainLayer.lua", result)
        end,
    })
end
-- 押镖接镖界面
function zc.createCountryDartGetPop( timeData, supportData )
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "CountryDart_dartMain",
        successCallback = function (result)
            result.timeData = timeData
            result.supportData = supportData
            zc.createSourcePop("CountryDartGetPop", "src/layer/country/CountryDartGetPop.lua", result)
        end,
    })
end
-- 押镖请求支援界面
function zc.createCountryDartHelpPop( supportData, _callback )
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "CountryDart_supportList",
        successCallback = function (result)
            if _callback then
                _callback()
            end
            result.supportData = supportData
            zc.createSourcePop("CountryDartHelpPop", "src/layer/country/CountryDartHelpPop.lua", result)
        end,
    })
end
-- 劫镖界面
function zc.createCountryDartRobPop( timeData )
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "CountryDart_lootedDartMain",
        successCallback = function (result)
            result.timeData = timeData
            zc.createSourcePop("CountryDartRobPop", "src/layer/country/CountryDartRobPop.lua", result)
        end,
    })
end
-- 通缉界面
function zc.createCountryDartWantedPop()
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.sendHttp({
        apiName = "CountryDart_getWantedList",
        successCallback = function (result)
            zc.createSourcePop("CountryDartWantedPop", "src/layer/country/CountryDartWantedPop.lua", result)
        end,
    })
end
-- 押镖结束，劫镖成功，被劫镖界面
function zc.createCountryDartResultPop( data )
    local _flag = zc.getFunctionStatus(24, true)
    if not _flag then
        return
    end
    -- 没有国家
    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
        zc.tipInfo(zc.lang("tips_unjoin_country"))
        return 
    end
    zc.createSourcePop("CountryDartResultPop", "src/layer/country/CountryDartResultPop.lua", data)
end

function zc.showEntityTouchPop( house )
    local _topLay = LayerManager.getTopInfoLayer()
    if not _topLay then
        return
    end
    if _topLay._entitypop then
        _topLay._entitypop:removeFromParent()
        _topLay._entitypop = nil
    end
    if not house then
        return
    end
    if house.checkCanBuild then
        if not house:checkCanBuild(true) then
            return
        end
    end
    local _entitypop = requires("src/layer/mainCity/HouseEntityPop.lua"):create(house)
    _topLay:addChild(_entitypop)
    _topLay._entitypop = _entitypop
end


--保存战斗力显示动画
function zc.saveFightingChange(_params)
    PlayerData._saveFightingChage = _params or {}
end
--手动显示战斗力改变动画
function zc.autoShowFightingChange()
    local showParams = PlayerData._saveFightingChage or {}
    if not showParams["_before"] or not showParams["_now"] then
        return
    end
    zc.showFightingChange(showParams["_before"],showParams["_now"],showParams["_isHero"],showParams["_heroName"],true)
    PlayerData._saveFightingChage = {}
end
-- _before(之前战力),_now(现在战力),_isHero(是否是单个英雄 未上阵的),_heroName(英雄名字), forceShow强制显示
function zc.showFightingChange(_before,_now,_isHero,_heroName,forceShow)
    local BattleUIMatrixLayer = zc.getScene("BattleUIMatrixLayer")
    local _scene = cc.Director:getInstance():getRunningScene()
    if not _scene or _scene:getName() ~= LAYER_NAME_TAG.LAYER_MAINCITY or BattleUIMatrixLayer then
        --如果当前scene不是mainCity(表示在战斗scene中)直接返回,也不能是在战前布阵界面
        return
    end
    --在饰品洗练和武器洗练时，战斗力展示需要延迟显示
    if not forceShow then
        if zc.getPop("trinketReplaceAttr") or
            zc.getScene("WeaponClear") then
            zc.saveFightingChange({_before=_before,_now=_now,_isHero=_isHero,_heroName=_heroName})
            return
        end
    end

    local node = cc.Director:getInstance():getNotificationNode()
    local fighting = (tonumber(_now)-tonumber(_before))
    if fighting == 0 then
        return
    end
    local fightingBg = zc.createSprite("res/Main/common/show_fighting.png")
    fightingBg:setPosition(zc.width/2, zc.height - 52 + 100 )
    node:addChild(fightingBg)
    fightingBg:setName("fightingBg")
    fightingBg:setCascadeOpacityEnabled(true)

    local posX = 110
    if _isHero then
        local heorName = zc.createLabel({
            text = _heroName,
            stroke = true,
            fontSize = 30,
            fontName = zc.getFont(1),
            ap = cc.p(0, 0.5),
            pos = cc.p(posX, fightingBg:getContentSize().height/2),
            color = display.COLOR_GREEN,
        })
        fightingBg:addChild(heorName)
        posX = posX + heorName:getContentSize().width+5
    end
    local powerNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight_change.fnt",
        text = _before,
        ap = cc.p(0, 0.5),
        pos = cc.p(posX, fightingBg:getContentSize().height/2),
        addwidth = -12,
    })
    fightingBg:addChild(powerNum)
    local fightingStr = fighting > 0 and "+"..fighting or ""..fighting
    local fightColor = fighting > 0 and display.COLOR_GREEN or display.COLOR_RED

    local powerAdd = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight_change.fnt",
        text = fightingStr,
        ap = cc.p(0, 0.5),
        pos = cc.p(powerNum:getPositionX()+powerNum:getContentSize().width+0, fightingBg:getContentSize().height/2 ),
        addwidth = -12,
    })
    fightingBg:addChild(powerAdd)


    local _seq = cc.Sequence:create(
        cc.MoveBy:create(0.1, cc.p(0, -110)),
        cc.MoveBy:create(0.05, cc.p(0, 10)),
        cc.DelayTime:create(1.0),
        cc.FadeOut:create(0.4),
        cc.RemoveSelf:create(true)
    )
    fightingBg:runAction(_seq)
end

function zc.createRoleEquipPop( data )
    zc.createSourcePop("RoleEquipPop", "src/layer/role/RoleEquipPop.lua", data)
end
function zc.createRoleWeaponPop( data )
    zc.createSourcePop("RoleWeaponPop", "src/layer/role/RoleWeaponPop.lua", data)
end

--tableview中选中效果
function zc.getItemClickEffect(_action)
    local effect = sp.SkeletonAnimation:create("res/animation/dianji_ui/dianji_ui.json", "res/animation/dianji_ui/dianji_ui.atlas", 1.0)
    effect:setAnimation(0, "dianji_".._action, true)
    return effect
end

function zc.createRoleTrinket()
    local _flag = zc.getFunctionStatus(10, true)
    if not _flag then
        return
    end
    zc.createSourceScene("RoleTrinket", "src/layer/role/RoleTrinketLayer", {})
end
--获取其它未领取的饰品
function zc.createGetOtherTrinketsPop(data)
    if not data or not data.trinketsBag or not next(data.trinketsBag) then
        return
    end
    zc.createSourcePop("GetOtherTrinketsPop", "src/layer/chapter/GetOtherTrinketsPop.lua", data)
end

function zc.createFightEnter()
    zc.sendHttp({
        apiName = "FightEnter_main",
        successCallback = function(backData)
            zc.createSourceScene("FightEnter", "src/layer/activity/FightEnterLayer", backData)
        end,
    })
end

-- 抢粮
function zc.createGrabFoodMain()
    if not zc.getFunctionStatus(46, true) then
        return
    end
    zc.sendHttp({
        apiName = "GrabFood_main",
        successCallback = function(backData)
            zc.createSourceScene("GrabFoodMain", "src/layer/grabFood/GrabFoodMainLayer.lua", backData)
        end,
    })
end


function zc.initBattleHeroInfo( battleData, showAnimation)
    if not battleData or not battleData.data or not battleData.data.warModel then
        zc.tipInfo(zc.lang("tips_fight_report_outoftime"))
        return
    end
    local _herosInfo = battleData.data.warModel[6][2]
    local _totle = table.nums(_herosInfo)
    if _totle == 0 then
        zc.tipInfo(zc.lang("tips_fight_report_outoftime"))
        return
    end
    local _now = 0
    local _enemys = {}
    local _heros = {}
    local _heroList = {}

    local _runningScene = cc.Director:getInstance():getRunningScene()                
    local _loadingNode = LoadingCircleLayer:create(true)
    _runningScene:addChild(_loadingNode, 100)
    
    for k,v in pairs(_herosInfo) do
        local _data = {}
        _data.id = v[1]
        _data.type = v[2]
        _data.pos = v[3]
        _data.modelId = v[12]
        _data.weaponId = v[13]
        local _hero = zc.battle.createHeroArmature({
            fileName = _data.modelId,
            heroDataWeaponId = _data.weaponId or 0,
            async = true,
            asyncCallback = function ( _armature, fileName, num )
                _now = _now + 1
                if not _armature then
                    if not tolua.isnull(_loadingNode) then
                        _loadingNode:removeFromParent()
                        _loadingNode = nil
                        zc.tipInfo(zc.lang("tips_fight_report_outoftime"))
                    end
                    return
                end
                _armature:getAnimation():play( "idle" )
                _armature.resFile = zc.battle.getHeroArmaturePathByResId(_data.modelId, _data.weaponId or 0)
                _armature.weaponFile = zc.soldierChangeWeapon( _armature, _data.weaponId or 0 )
                local _place = tostring(_data.pos)
                if _data.type ~= 0 then
                    _enemys[_place] = _armature
                else
                    _heros[_place] = _armature
                end
                if _now == _totle then
                    if not tolua.isnull(_loadingNode) then
                        _loadingNode:removeFromParent()
                        _loadingNode = nil
                    end

                    local function _createBattle()
                        xpcall(function()
                            local _createData = {
                                data = battleData,
                                leftTeams = {
                                    _heros,
                                },
                                rightTeams = {
                                    _enemys,
                                },
                            }
                            if battleData.isreplay == 1 then
                                _createData.battleEndCallback = function()
                                    cc.Director:getInstance():popScene()
                                    helper.collectMemory(true)
                                end
                            end
                            local battle = zc.createBattle(_createData)
                            
                            for k,v in pairs(_heroList) do
                                v:release()
                            end
                            performWithDelay(battle, function()
                                battle:play()
                            end, 0.2)
                        end, function()
                            zc.tipInfo(zc.lang("tips_fight_report_outoftime"))
                            for k,v in pairs(_heroList) do
                                if not tolua.isnull(v) then
                                    v:release()
                                end
                            end
                        end)
                    end
                    if showAnimation then
                        local armature = zc.createArmature({
                            fileName = "guochang",
                            actName = "idle",
                            autoRemove = true,
                        })
                        armature:setPosition(cc.p(zc.width / 2 , zc.height / 2))
                        _runningScene:addChild(armature)

                        performWithDelay(_runningScene, _createBattle, 0.93)
                    else
                        _createBattle()
                    end
                end
            end,
        })
        _hero:retain()
        _heroList[#_heroList + 1] = _hero
    end   
end

-- 切磋
function zc.kahei( userId )
    zc.sendHttp({
        apiName = "User_kahei",
        params = {uid=userId},
        successCallback = function(backData)
            local _battleData = {
                data = backData,
                battleType = BattleType.KaHei,
                canShare = true,
            }
            zc.initBattleHeroInfo(_battleData, true) 
        end,
    })
end

function zc.createBattleByWarKey( warKey )
    if not warKey then
        zc.tipInfo(zc.lang("tips_fight_report_outoftime"))
        return
    end

    zc.sendHttp({
        apiName = "War_play",
        params = {warKey=warKey},
        successCallback = function (backData)
            local _battleData = {
                data = {
                    warModel = backData,
                },
                isreplay = 1,
                fightScene = 1
            }
            --后端对应的战斗类型 1(普通、精英副本) 2(校场) 9(演武榜)
            if backData then
                local fightType = tonumber(backData[2])
                if fightType == 1 then --普通、精英副本
                    local tollgateInfo = gameData.getDataFromCacheWithPrimaryKey("tollgate", backData[9] or 0)
                    _battleData.fightScene = tollgateInfo["scene"] or 1
                elseif fightType == 9 then
                    _battleData.fightScene = 6
                elseif fightType == 2 then
                    _battleData.fightScene = 6
                end
            end
            zc.initBattleHeroInfo(_battleData, true)   
        end,
    })
end
-- 我要变强
function zc.createStrongerLayer()
    zc.sendHttp({
        apiName = "Stronger_main",
        params = {ids=1},
        successCallback = function(backData)
            zc.createSourceScene( "StrongerLayer", "src/layer/mainCity/StrongerLayer.lua", backData )
        end,
    })
end
-- 次日登陆
function zc.createSecondDayLayer()
    local _status = PlayerData:getSecondDaySignStatus()
    if _status ~= 2 then
        zc.createSourceScene("SecondDayLayer", "src/layer/activity/SecondDayLayer.lua", {status = _status})
        return
    end
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activityShow"}})
end

-- 更新数据，保存成战斗结果页需要的格式，部分不需要布阵的界面使用
function zc.saveData( data )
    -- 保存阵法
    if data.formations then
        PlayerData:setFormationsInfo( data.formations )
    end
    -- 结果类型(1 平局, 2 攻击方完胜, 3 攻击方大胜, 4 攻击方小胜, 5 攻击方完败, 6 攻击方大败, 7 攻击方小败)
    local battleStatus = 2
    local star = 0
    if data.warModels then
        local warModel = data.warModels
        battleStatus = tonumber( warModel[#warModel][5][1] ) or 2
        star = warModel[#warModel][5][6]
    else
        local _warModel = nil
        if data.warModel then
            _warModel = data.warModel
        end

        if _warModel then
            battleStatus = tonumber( _warModel[5][1] ) or 2
            star = _warModel[5][6]
        end
    end

    -- 获取的银币 元宝 加到item里面
    data.items = PlayerData:getShowIconDatas(data)

    -- 获得的经验
    data.addExp = {}
    if data.clientItems then
        for i, v in ipairs( data.clientItems ) do
            local itemType = tonumber(v.type) or 0
            if itemType == 5 then
                -- 武将经验
                local _num = tonumber(v.changeNum) or 0
                if _num > 0 then
                    local _index = tonumber( v.primaryId ) or 0
                    data.addExp[_index] = {
                        changeNum = v.changeNum,
                        levelUp = tonumber( v.levelUp ) or 0,
                    }
                end
            elseif itemType == 6 then
                -- 主角经验
                local _num = tonumber(v.changeNum) or 0
                if _num > 0 then
                    local _index = tonumber( PlayerData.info.heroId ) or 0
                    data.addExp[_index] = {
                        changeNum = v.changeNum,
                        levelUp = tonumber( v.levelUp ) or 0,
                    }
                end
            end
        end
    end
    
    -- 更新获得物品和资源
    PlayerData:updataData({
        clientResources = data.clientResources,
        clientItems = data.clientItems,
        eliteTollgate = data.eliteTollgate,
        noAnimation = true
    })
    -- 解析武将
    for k,v in pairs(data.heros or {}) do 
        PlayerData:setGeneralInfoById(v.id, v)
    end

    return battleStatus, star
end

function zc.getGodNameById( id )
    local _id = tonumber( id ) or 0
    local _godName = gameData.getDataFromCacheWithPrimaryKey("title", _id).name or ""
    if _godName == "" then
        _godName = gameData.getDataFromCacheWithPrimaryKey("hero", 101).title or ""
    end
    return _godName
end
--获取 chnId
function zc.getSDkchnId()
    --内网测环境
    local key_id = {
        [CHANNEL.Android.CHANNEL_CODE_UC] = {
            -- --内网
            -- appkey = "f7d9717d6b1582cdf0ebc4ac5941030a",
            -- chnId = "24",
            --外网
            appkey = "efd5e9bc8f0000a355c629f5ed649022",
            chnId  = "23",
            chnType         = tostring("uc"),
            chnVersion      = tostring("2"),
        },
        [CHANNEL.Android.CHANNEL_CODE_360] = {
            -- --内网
            -- appkey = "09e2eeac41691158481dc1fdcc8ebd74",
            -- chnId = "38",
            --外网
            appkey = "d61bc864669b0822553ca8ae11d06f0e",
            chnId = "30",
            chnType         = tostring("360"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_XM] = {
            -- --内网
            -- appkey = "af48686adb27ea6e35ed01480a85881e",
            -- chnId = "27",
            --外网
            --qlzj
            appkey          = "bac9698f9f28d5602f13334de3726e89",
            chnId           = tostring("31"),
            --kzsg
            -- appkey          = "3a90cbe3fd0a7d8a18a88938ac998bc0",
            -- chnId           = tostring("39"),
            -- chnType         = tostring("xiaomi1"),
            chnType         = tostring("xiaomi"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_BD] = {
            -- --内网
            -- appkey = "7aafc6822374c185eee3eda934bef0b3",
            -- chnId = "28",
            --外网
            appkey          = "1cacccc3d7e6a922b79658235707469e",
            chnId           = tostring("32"),
            chnType         = tostring("baidu"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_HW] = {
            -- --内网
            -- appkey = "e67db5128cf325246d7b42b493bf4884",
            -- chnId = "39",
            --外网
            appkey          = "bf3045d9c13f6e8968b5f2a557f19d9d",
            chnId           = tostring("33"),
            chnType         = tostring("huawei"),
            chnVersion      = tostring("2"),
        },
        [CHANNEL.Android.CHANNEL_CODE_VV] = {
            -- --内网
            -- appkey = "3e464ad3655badd1fe0ccd71b617e4d9",
            -- chnId = "33",
            --外网
            appkey          = "5cea1c424e365f8ea98f570e006f2192",
            chnId           = tostring("34"),
            chnType         = tostring("vivo"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_LX] = {
            -- --内网
            -- appkey = "ae29b13b8cf9e55c4648df83620ce472",
            -- chnId = "40",
            --外网
            appkey = "2ff2bf1ab1d4dd25f752a8e540802d06",
            chnId = "38",
            chnType         = tostring("lenovo"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_OP] = {
            -- -- 内网
            -- appkey = "6074bb2c234e8b96224af5066cdcce19",
            -- chnId = "41",
            --外网
            appkey = "81e2b281d21aa3abc9dffff8ac1878ef",
            chnId = "37",
            chnType         = tostring("oppo"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_TX] = {
            -- --内网
            -- appkey = "9c50f075103c5a0f542664d6a16f826e",
            -- chnId = "42",
            --外网
            appkey = "54f5b95b1455a9a12c1305d39d4f0902",
            chnId = "36",
            chnType         = tostring("tencent"),
            chnVersion      = tostring("1"),
        },
        [CHANNEL.Android.CHANNEL_CODE_YJ] = {
            -- --内网
            -- appkey = "95b59ad37ff57877834a3bce779f0441",
            -- chnId = "44",
            --外网
            appkey = "4b72106ea7373b763799479494836aab",
            chnId = "45",
            chnType         = tostring("yijie"),
            chnVersion      = tostring("1"),
        },
    }
    local _packageId = zc.getChannelPackageId()
    if _packageId == 10 then
        return {
            appkey = "73da7cd151b11e8f6f560363d0336c29",
            chnId = "43",
            chnType         = tostring("qlzjGt"),
            chnVersion      = tostring("1"),
        }
    elseif _packageId == 11 then
        return {
            appkey = "39483be6fe4daf060ba32bf64d5fd971",
            chnId = "42",
            chnType         = tostring("qlzjGt"),
            chnVersion      = tostring("1"),
        }
    end
    if GAME_SDK == GAMESDK.SDK_ZHANYOU then
        local obj = {
            --内网
            appkey = "6f813598632e95ce099ca7ffa8321b20",
            chnId = "24",
            chnType         = tostring("qlzj"),
            chnVersion      = tostring("1"),
        }
        return obj
    end
    return key_id[GAME_CHANNEL]
end

function zc.getChannelPackageId()
    local platform = cc.Application:getInstance():getTargetPlatform()
    if platform ~= cc.PLATFORM_OS_ANDROID then
        local _flag = 2
        if GAME_PACKAGENAME == "com.zctech.qlwz.zy"
          or GAME_PACKAGENAME == "com.zctech.qlwzS.zy" then
          -- or GAME_PACKAGENAME == "com.zctech.qlwzS.zhanyou" then--青龙纹章
            return 5
        elseif GAME_PACKAGENAME == "com.zctech.qlwzS.zhanyou" then --青龙战纪
            return 2
        elseif GAME_PACKAGENAME == "com.zctech.qlzjGt.zy"
          or GAME_PACKAGENAME == "com.zctech.jzws.zy" --青龙战纪港台
          or GAME_PACKAGENAME == "com.zy.qlzr.gt" then
            return 10
        end
        return _flag
    end 
    if GAME_SDK == GAMESDK.SDK_ZHANYOU then
        if GAME_PACKAGENAME == "com.zctech.qlzjGt.zy" then
            return 11
        elseif GAME_CHANNEL == "zht_xj" then
            return 12
        end
        -- 在这里判断一下是否是封测包
        PlayerData._isFengce = 0
        zc.getIsFengce()
        if PlayerData._isFengce ~= 0 then
            return 7
        end
        return 6
    end
    local key_id = {
        [CHANNEL.Android.CHANNEL_CODE_UC] = 7,
        [CHANNEL.Android.CHANNEL_CODE_360] = 7,
        [CHANNEL.Android.CHANNEL_CODE_XM] = 7,
        [CHANNEL.Android.CHANNEL_CODE_BD] = 7,
        [CHANNEL.Android.CHANNEL_CODE_HW] = 7,
        [CHANNEL.Android.CHANNEL_CODE_VV] = 7,
        [CHANNEL.Android.CHANNEL_CODE_LX] = 7,
        [CHANNEL.Android.CHANNEL_CODE_OP] = 7,
        [CHANNEL.Android.CHANNEL_CODE_YJ] = 7,
        [CHANNEL.Android.CHANNEL_CODE_TX] = 1,
    }

    return key_id[GAME_CHANNEL] or 0
end
-- 获取是否是封测
function zc.getIsFengce()
    local args = {}
    local sigs = nil
    function getCallback( flag )
        print("xmgetCallback data: -----"..flag)
        PlayerData._isFengce = tonumber(flag)
        print("得到是否是封测flag："..flag)
    end
    local platform = cc.Application:getInstance():getTargetPlatform()
    --平台判断，进行不同的SDK登录
    if (cc.PLATFORM_OS_ANDROID == platform) then
        --调用SDK登录
        args = {getCallback}
        sigs = "(I)V"
    elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then
        args = { callback = getCallback }
    end
    print(LUA_BRIDGE_CLASS,"LUA_BRIDGE_CLASS")
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"getIsFengce",args,sigs)
end

function zc.getAndroidChangedPackageId()
    local platform = cc.Application:getInstance():getTargetPlatform()
    if platform ~= cc.PLATFORM_OS_ANDROID or GAME_SDK ~= GAMESDK.SDK_ZHANYOU then
        return zc.getChannelPackageId()
    end
    local _flag = 6
    if zc.isGt() then
        _flag = 11
    elseif string.find(GAME_CHANNEL, "Qlwz") then
        _flag = 5
    elseif string.find(GAME_CHANNEL, "Qlzj")
      or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ
      or GAME_CHANNEL == "zht_xj"
      then
        _flag = 2
    end
    return _flag
end

function zc.getSDKParams( data, authkey )
    -- ts|uuid|apiv|net|pf|chnId|ver|chnType|chnVersion 
    local ts            = tostring(os.time())
    local uuid          = tostring(GAME_ANDROIDID)
    local apiv          = tostring(1)--接口版本，当前为2
    local net           = tostring(4)--网络类型（1:2G, 2:3G, 3:4G, 4:WLAN, 5:蜂窝）
    local pf            = tostring(2)--平台（1:ios, 2:and, 3:wp, 4:游戏服务器, 5:PC）
    local chnId         = tostring("23")
    local ver           = tostring("1.0_zhCN_2_zh")
    local chnType       = tostring("uc")
    local chnVersion    = tostring("3.5.3.1")

    --平台判断，进行不同的SDK登录
    local platform      = cc.Application:getInstance():getTargetPlatform()
    if (cc.PLATFORM_OS_ANDROID == platform) then
    else
        pf              = tostring(1)
    end
    local appkey        = "efd5e9bc8f0000a355c629f5ed649022"

    local key_id = zc.getSDkchnId()
    appkey      = key_id.appkey
    chnId       = key_id.chnId
    chnType     = key_id.chnType
    chnVersion  = key_id.chnVersion

    local sys           = ts..
                            "|"..uuid..
                            "|"..apiv..
                            "|"..net..
                            "|"..pf..
                            "|"..chnId..
                            "|"..ver..
                            "|"..chnType..
                            "|"..chnVersion
    local sortedData = {
        {
            key = "sys",
            value = sys
        }
    }
    for k, v in pairs( data ) do
        sortedData[#sortedData + 1] = {key = k, value = v}
    end
    table.sort(sortedData, function( a, b )
        return a.key < b.key
    end)
    -- dump( sortedData, "sortedData" )
    local str           = ""
    for i, v in ipairs( sortedData ) do
        str = str..v.value
    end
    print("str="..str,"ts=",ts,"appkey=",appkey,"authkey=",authkey)
    local sig           = cc.sha1(cc.sha1(str..ts..cc.sha1(appkey)..(authkey or ""))..ts)

    local postStr = "sig="..sig
    for i,v in ipairs( sortedData ) do
        postStr = postStr.."&"..v.key.."="..v.value
    end
    local postData = crypto.encodeBase64(postStr)
    
    return postData, chnId, chnType
end

function zc.doPayFinish(_param_)
    local _scene = cc.Director:getInstance():getRunningScene()
    if tolua.isnull(_scene) then
        return
    end
    xpcall(function()
        local _node = _scene:getChildByName("PayFinishNode")
        if _node then
            _node:removeFromParent()
        end
    end, function() end)
    if not APP_ORDERID then
        return
    end
    local _appOrderId = APP_ORDERID
    local _node = ZCDialog:create(255*0.3)
    _node:setName("PayFinishNode")
    _scene:addChild(_node)
    _node:onNodeEvent("cleanup", function()
        APP_ORDERID = nil
    end)
    print("_appOrderId},.",_appOrderId)
    performWithDelay(_node, function()
        _node:removeFromParent()
        APP_ORDERID = nil
        zc.sendHttp({
            apiName = "Recharge_affirm",
            params = {orderId = _appOrderId},
            successCallback = function(backData)
                PlayerData:updataData(backData)
                local _newVip = tonumber(backData.vip) or 0
                if _newVip > 0 then
                    PlayerData:setBaseInfoByTag("vip", _newVip)
                end
                local _rechargeGold = tonumber(backData.rechargeGold) or 0
                if _rechargeGold > 0 then
                    PlayerData.resourcesInfo.rechargeGold = _rechargeGold
                end
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_RECHARGE_SUCCESS})
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_VIP_CHANGED})
            end,
            failCallback = function() end,
            errorCallback = function() end,
        })
    end, 10)
    local _circle = LoadingCircleLayer:create()
    _node:addChild(_circle)
    local _label = zc.createLabel({
        fontSize = 28,
        text = zc.lang("tips_synchronization_info"),
        outLine = true,
        pixel = 2,
        pos = cc.p(zc.width*0.5, zc.height*0.5 - 100)
    })
    _node:addChild(_label)
end
-- 创建宝石镶嵌界面
function zc.createGemSetPop( data)
    -- 首先查询有没有可以镶嵌的宝石
    local _gemList = PlayerData:getGemInfo()
    local _flag = false
    for k, v in pairs( _gemList ) do
        local _place = tonumber( v.place ) or 0
        if _place == 0 then
            _flag = true
            break
        end
    end
    if _flag then
        zc.createSourcePop("RoleGemSetPop", "src/layer/role/RoleGemSetPop.lua", {data = data})
    else
        zc.tipInfo(zc.lang("tips_have_no_uninlay_gem"))
    end
end
-- 创建宝石升级界面
function zc.createGemUpgradePop( data)
    zc.createSourcePop("RoleGemUpgradePop", "src/layer/role/RoleGemUpgradePop.lua", {data = data})
end

function zc.getGemPosStatus( quality, pos )
    local _quality = tonumber(quality) or 0
    local _pos = tonumber(pos) or 1
    local _config = {
        [1] = 1,
        [2] = 3,
        [3] = 5,
        [4] = 6,
    }
    local _need = _config[_pos] or 0
    return _quality >= _need
end

-- 宝石镶嵌红点
function zc.getGemSetRedDotStatus( objList )
    -- 功能未开启
    if not zc.getFunctionStatus( 37 ) then
        return false
    end
    if not objList or #objList == 0 then
        return false
    end
    local _allGem = PlayerData:getGemInfo()
    -- 可镶嵌的宝石类型
    local _typeExist = {}
    for k, v in pairs( _allGem ) do
        local _place = tonumber( v.place ) or 0
        if _place == 0 then
            -- 空闲宝石
            local _type = tonumber( v.type ) or 0
            _typeExist[_type] = true
        end
    end
    -- dump(_typeExist,"_typeExist")

    -- 遍历列表
    for index, data in ipairs( objList or {} ) do
        -- dump(data,"data")
        -- 解锁位置
        local _unlock = 0
        local _quality = tonumber( data.quality ) or 0
        for i = 1, 4 do
            local _flag = zc.getGemPosStatus( _quality, i )
            if _flag then
                _unlock = _unlock + 1
            end
        end
        -- print("_unlock=",_unlock)
        -- 已解锁数量
        if _unlock > 0 then
            -- 已镶嵌的宝石类型
            local _typeSet = {}
            for i = 1, 4 do
                local _key = "gemId"..i
                local _gemId = tonumber( data[_key] ) or 0
                if _gemId ~= 0 then
                    local _gemData = PlayerData:getGemInfoById( _gemId ) or {}
                    local _type = tonumber( _gemData.type ) or 0
                    _typeSet[_type] = true
                end
            end
            -- dump(_typeSet,"_typeSet")
            if _unlock > table.nums( _typeSet ) then
                -- 还有可镶嵌的位置
                for k, v in pairs( _typeExist ) do
                    if not _typeSet[k] then
                        return true, data.objId, data.isWeapon
                    end
                end
            end
        end
    end

    return false
end
-- 检查武将的宝石红点
function zc.getGemSetRedDotStatusByHero( heroList )
    -- 功能未开启
    if not zc.getFunctionStatus( 37 ) then
        return false
    end
    if #heroList == 0 then
        return false
    end

    for index, _heroData in ipairs( heroList ) do
        local _heroId = tonumber( _heroData.id ) or 0
        local _objList = {}
        -- 武器
        local _weaponData = PlayerData:getWeaponsInfoById( _heroId )
        if _weaponData then
            -- dump(_weaponData,"_weaponData")
            local _objData = {}
            _objData.isWeapon = true
            _objData.objId = _weaponData.id
            for i = 1, 4 do
                local _key = "gemId"..i
                _objData[_key] = _weaponData[_key]
            end
            _objData.quality = _weaponData.quality
            _objList[#_objList + 1] = _objData
        end
        -- 装备
        for i = 1, 6 do
            local _equipData = PlayerData:getEquipInfoByHeroIdAndPos( _heroId, i )
            if _equipData then
                -- dump(_equipData,"_equipData")
                local _objData = {}
                _objData.isWeapon = false
                _objData.objId = _equipData.id
                for i = 1, 4 do
                    local _key = "gemId"..i
                    _objData[_key] = _equipData[_key]
                end
                _objData.quality = gameData.getDataFromCacheWithPrimaryKey("equip", _equipData.equipmentId).quality
                _objList[#_objList + 1] = _objData
            end
        end
        local _flag, _objId, _isWeapon = zc.getGemSetRedDotStatus( _objList )
        if _flag then
            return true, _heroId, _objId, _isWeapon
        end
    end
    return false
end

-- 创建重生塔
function zc.createInheritanceTowerLayer()
    -- 功能未开启
    if zc.getFunctionStatus( 38, true ) then
        zc.createSourceScene("InheritanceTower", "src/layer/inheritanceTower/InheritanceTowerLayer.lua")
    end
end

-- 地域羁绊界面
function zc.createRoleFettersRegionalMapLayer( params )
    -- if APP_SERVER ~= 0 then
    --     zc.tipInfo(zc.lang("tips_function_not_open"))
    --     return
    -- end
    if not zc.getFunctionStatus( 40, true ) then
        return
    end
    zc.sendHttp({
        apiName = "RegionalFetters_main",
        successCallback = function (result)
            if type(result.mapGroup) == "table" and next(result.mapGroup) ~= nil then
                PlayerData:setFettersRegionalInfo(result.mapGroup)
            end
            zc.createSourceScene("RoleFettersRegionalMap", "src/layer/role/RoleFettersRegionalMapPop.lua", params)
        end,
    })
end

-- 极限挑战副本
function zc.createLimitChallengeCopy( goIdx )
    if not zc.getFunctionStatus(39, true) then
        return
    end
    zc.sendHttp({
        apiName = "LimitChallenge_main",
        successCallback = function (result)
            result.goIdx = goIdx
            zc.createSourceScene("LimitChallengeCopy", "src/layer/limitChallengeCopy/LimitChallengeCopy.lua", result)
        end,
    }) 
end
    
----------抢矿-----------
function zc.createGrabMineMain()
    zc.sendHttp({
        apiName = "CountryMine_main",
        params = {},
        successCallback = function (net_data)
            PlayerData:initCountryMineData(net_data)
            zc.createSourceScene("GrabMineMapFirstLayer", "src/layer/country/grabMine/GrabMineMapFirstLayer.lua" )
        end
    })
end
--创建抢矿队伍
function zc.createGrabMineTeam(_teamInfo, _mineInfo)
    zc.createSourceScene("GrabMineFightTeamLayer", "src/layer/country/grabMine/GrabMineFightTeamLayer.lua", {teamInfo=_teamInfo,mineInfo=_mineInfo})
end
--邀请国家成员列表
function zc.createGrabCountryList(_data)
    local _data = _data or {}
    local countryInfo = PlayerData:getCountryInfo() or {}
    _data._type = _data._type or 1 --type:1邀请成员占矿、2邀请成员抢矿
    zc.sendHttp({
        apiName = "Country_memberList",
        params = {id=countryInfo.id},
        successCallback = function (data)
            local playerOnlineList = {}
            if data and next(data) then
                for k,v in pairs(data) do
                    -- if v and v.online and tonumber(v.online) and tonumber(v.online) == 1 then
                    if v and v.online and tonumber(v.online) then
                        if v.userId and tonumber(v.userId) ~= tonumber(PlayerData.info.userId) then 
                            playerOnlineList[#playerOnlineList+1] = v
                        end
                    end
                end
            end
            zc.createSourcePop("GrabMineInviteListPop", "src/layer/country/grabMine/GrabMineInviteListPop.lua" ,{data=playerOnlineList,extraData=_data})
        end,    
    })

end

--邀请加入队伍
function zc.jionCountryMineTeam(_chatData)
    local _text = _chatData.text or {}
    local _tag = tonumber(_text._tag) or 0
    if _tag ~= 0 then
        --1占矿、2抢矿
        if _tag == 1 then
            zc.sendHttp({
                apiName = "CountryMine_occupy",
                params = {mineId=_text._mineId, id=_text._id},
                successCallback = function (net_data)
                    zc.tipInfo(zc.lang("tips_occupation_success"))
                end
            })
        elseif _tag == 2 then
            zc.sendHttp({
                apiName = "CountryMine_main",
                successCallback = function (main_data)
                    PlayerData:initCountryMineData(main_data)
                    zc.sendHttp({
                        apiName = "CountryMine_joinTeam",
                        params = {mineId=_text._mineId,teamId=_text._teamId},
                        successCallback = function (net_data)
                            zc.createGrabMineTeam(net_data)
                        end
                    })
                end
            })
        end
    end
end
--矿信息pop
function zc.createGrabMineInfoPop(params)
    if not params then return end
    zc.createSourcePop(params.popName, "src/layer/country/grabMine/GrabMineInfoPop.lua", params)
end
--抢矿战报 
function zc.createGrabMineRecordPop()
    zc.createSourcePop("GrabMineRecordPop", "src/layer/country/grabMine/GrabMineRecordPop.lua")
end
--------------------------------------------------------------充值--------------------------------------------------------------
function zc.recharge(params)
    local _data = params.data
    local _goodsType = params.goodsType
    local _appGoodsId = _data.id

    zc.sendHttp({
         apiName = "Recharge_main",
         params = {
             appGoodsId = _appGoodsId,
             goodsType = _goodsType, --热卖礼包 type 固定为3
             chnId = zc.getSDkchnId()["chnId"],
             serverId = tostring(PlayerData["serverInfo"]["serverId"])},
         successCallback = function(backData)
            dump(backData)
            zc.rechargeSDK( _data, backData , _goodsType)
         end,
    }) 
end
function zc.rechargeSDK( data, backData ,_goodsType)
    if GAME_SDK == GAMESDK.SDK_ZHANYOU then
        zc.rechargeAppStore(data, backData, _goodsType)
        return 
    end
    local session, authkey = PlayerData:getSession()

    local _param_ = {
        session = tostring(session),
        -- 商品信息
        appGoodsId = tostring(data.id),
        appGoodsName = tostring(data.desc),
        appGoodsPrice = tostring(tonumber(data.price)*100),
        -- 后端给sdk的回调地址
        appCallback = tostring(backData.appCallback),
        -- 后端给的订单id
        appOrderId = tostring(backData.appOrderId)
    }
    local addGold = data.addGold

    local _url_ = "https://chn-platform.zhanchenggame.com/pay/chninitiate"
    -- if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
    --     _url_ = "http://192.168.21.34:12360/pay/chninitiate"
    -- elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD then -- 百度内网测试
    --     _url_ = "http://192.168.21.34:12360/pay/chninitiate"
    -- elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC then -- UC内网测试
    --     _url_ = "http://192.168.21.34:12360/pay/chninitiate"
    -- end
    if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX then
        _param_ = {
            session = tostring(session),
            -- 商品信息
            appGoodsId = tostring(data.id),
            appGoodsName = tostring(data.desc),
            appGoodsPrice = tostring(tonumber(data.price)*100),
            -- 后端给sdk的回调地址
            appCallback = tostring(backData.appCallback),
            -- 后端给的订单id
            appOrderId = tostring(backData.appOrderId),
            type = tostring(PlayerData._sdkData.type),--登录类别(qq or wechat)
            openId = tostring(PlayerData._sdkData.openid),--登录是获取的openid
            openkey = tostring(PlayerData._sdkData.openkey),--登录时获取的openkey
            pf = tostring(PlayerData._sdkData.pf),--登录是获取的pf
            pfkey = tostring(PlayerData._sdkData.pfkey),--登录是获取的pfkey
            zoneId = "1",--tostring("1_"..string.urlencode(PlayerData:getBaseInfoByTag("userId"))),
            amt = tonumber(data.price) * 10
        }
        -- _url_ = "http://192.168.21.34:12360/pay/chntencentinit"
        _url_ = "https://chn-platform.zhanchenggame.com/pay/chntencentinit"
    end

    local function _addPayFinishNode()
        local _scene = cc.Director:getInstance():getRunningScene()
        if not tolua.isnull(_scene) then
            local _node = ZCDialog:create(255*0.3)
            _node:setName("PayFinishNode")
            _scene:addChild(_node)
            performWithDelay(_node, function()
                _node:removeFromParent()
            end, 30)
        end
    end
    local bd_orderID = backData.appOrderId
    print("----1 bd_orderID. ",bd_orderID,"backData.appOrderId. ",backData.appOrderId)
    -- dump(_param_,"xxxxxxxxxxxxx")
    -- 整合传给sdk的参数
    local postData, chnId, chnType = zc.getSDKParams(_param_, authkey)
    -- 先跟展游sdk交互，再调用渠道sdk打开充值弹窗
    local params = {
        -- url = "http://chn-platform.zhanchenggame.com/pay/chninitiate",
        url     = _url_,
        postData = postData,
        isGameApi = false,
        successCallback = function(backData)
            local code = backData.code
            if code == 0 then
                print("bd_orderID.1 ",bd_orderID)
                dump(backData,"充值成功")
                --充值成功回调，但是有些渠道充值成功不回调,以及像uc取消充值也走这个回调，所以统一把充值成功的回调放在socket推送回来
                APP_ORDERID = tostring(backData.appOrderId)
                local _rechargeSuccess = function()
                    dump(backData,"---test----")   
                    if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD or
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC or 
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_XM or
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_360 or 
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_HW or 
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_VV or
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_LX or 
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_OP or
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ or
                        GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX then
                        print("bd_orderID.2 ",bd_orderID)
                        APP_ORDERID = tostring(bd_orderID)
                        zc.doPayFinish({id=data.id, appOrderId = tostring(bd_orderID)})
                    else
                        zc.doActionStatisticsEvent(StatisticsEvent.EVENT_PURCHASE, args.itemPrice)
                        zc.doPayFinish({id=data.id, appOrderId = tostring(backData.appOrderId)})
                    end
                end
                local callbackLua = _rechargeSuccess
                
                local appExt1 = tostring(chnId)
                local appExt2 = tostring(chnType)
                local appExt3 = ""
                local waresid = 0 --联想充值都需要waresid(商品编码，只有联想需要，商品编码有误与徐飞对接)
                if CHANNEL.Android.CHANNEL_CODE_XM == GAME_CHANNEL then
                    appExt3 = tostring(backData.data.cpUserInfo)
                elseif CHANNEL.Android.CHANNEL_CODE_HW == GAME_CHANNEL then
                    appExt3 = tostring(backData.data.extReserved)
                elseif CHANNEL.Android.CHANNEL_CODE_LX == GAME_CHANNEL then
                    appExt3 = tostring(backData.data.cpprivateinfo)
                    local waresidToId = {[1]="98947",[2]="98948",[3]="98949",[4]="98950",[5]="98951",[6]="98952",[7]="100923",[8]="100924"}
                    waresid = waresidToId[tonumber(data.id)]
                elseif CHANNEL.Android.CHANNEL_CODE_360 == GAME_CHANNEL then
                    appExt1 = tostring(backData.data.app_ext1)
                    appExt2 = tostring(backData.data.app_ext2)
                elseif CHANNEL.Android.CHANNEL_CODE_UC == GAME_CHANNEL then
                    appExt3 = tostring(backData.data.setCustomInfo)
                elseif CHANNEL.Android.CHANNEL_CODE_VV == GAME_CHANNEL then
                    appExt1 = tostring(backData.data.accessKey)
                    appExt2 = tostring(backData.data.orderNumber)
                    appExt3 = tostring(backData.data.orderAmount)
                elseif CHANNEL.Android.CHANNEL_CODE_OP == GAME_CHANNEL then
                    appExt3 = tostring(backData.data.attach)
                end

                local args = {
                    -- 商品信息
                    itemId        = tostring(data.id),
                    itemName      = tostring(data.desc),
                    itemPrice     = tostring(data.price),
                    -- itemPrice     = "1",
                    -- 订单id
                    orderId       = tostring(backData.data.orderId),
                    -- sdk给的回调地址
                    callbackUrl   = tostring(backData.data.callbackUrl),
                    -- 玩家的id
                    accountId     = tostring(PlayerData["info"]["userId"]),
                    -- 角色id，暂时没用
                    roleId        = tostring(1),
                    -- 玩家的渠道账号，sdk提供
                    platfromId    = tostring(backData.data.uId),
                    -- 玩家昵称
                    nickName      = tostring(PlayerData["info"]["userName"]),
                    -- 服务器id
                    serverId      = tostring(PlayerData["serverInfo"]["serverId"]),
                    -- 服务器名字
                    serverName    = tostring(PlayerData["serverInfo"]["serverName"]),
                    -- 等级
                    level         = tostring(PlayerData["info"]["level"]),
                    -- vip
                    vip           = tostring(PlayerData["info"]["vip"]),
                    -- 当前元宝
                    ingot         = tostring(zc.getNumByTypeId(1,1)),
                    -- 额外参数
                    appExt1       = appExt1,
                    appExt2       = appExt2,
                    -- 额外参数 (sdk 需要的参数，每个渠道各自需要的都由sdk返回，不用前端手动拼)
                    appExt3       = appExt3,
                    --联想需要的参数
                    waresid       = waresid,
                }
                if (GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX and backData.data ~= nil) then
                    if tonumber(backData.data.status) == 1 then--[[支付成功]]
                        local comfirm = ZCConfirmDialog:createWithParams({
                            msg = string.format(LANGUAGE_RECHARGE.recharge_success_tx, 
                                    tostring((tonumber(backData.data.amt) / 10)),
                                    tostring(addGold),
                                    tostring((tonumber(backData.data.balance) / 10))
                                ),
                            showDi = true,
                            leftVisible = false,
                            rightCallback = function()
                                
                            end
                        })
                        cc.Director:getInstance():getRunningScene():addChild(comfirm, 11)
                        -- self:getScene():addChild(comfirm, 11)
                    elseif tonumber(backData.data.status) == 2 then--[[余额不足]]
                        local comfirm = ZCConfirmDialog:createWithParams({
                            title = zc.lang("prompt"),
                            msg = string.format(LANGUAGE_RECHARGE.recharge_unenough, tostring((tonumber(backData.data.needAmt) / 10))),
                            showDi = true,
                            rightCallback = function()
                                args = {
                                    -- 商品信息
                                    itemPrice     = tostring(backData.data.needAmt),
                                    -- itemPrice     = "0.01",
                                    -- 订单id
                                    orderId       = tostring(backData.data.orderId)
                                }
                                --[[回调，说明充值支付成功，该回调中开始发起扣除游戏币的请求]]
                                callbackLua = function (param_from_java)
                                    _param_ = {
                                        session = tostring(session),
                                        -- 后端给的订单id
                                        orderId = tostring(backData.data.orderId),
                                        type = tostring(PlayerData._sdkData.type),--登录类别(qq or wechat)
                                        openId = tostring(PlayerData._sdkData.openid),--登录是获取的openid
                                        openkey = tostring(PlayerData._sdkData.openkey),--登录时获取的openkey
                                        pf = tostring(PlayerData._sdkData.pf),--登录是获取的pf
                                        pfkey = tostring(PlayerData._sdkData.pfkey),--登录是获取的pfkey
                                        zoneId = "1",--tostring("1_"..string.urlencode(PlayerData:getBaseInfoByTag("userId"))),
                                        amt = tonumber(data.price) * 10
                                    }
                                    local dataFromJava  = json.decode(param_from_java) or {}
                                    local realSaveNum = dataFromJava.realSaveNum--[[支付金额]]
                                    local payChannel = dataFromJava.payChannel--[[使用渠道]]
                                    local provideState = dataFromJava.provideState--[[发货状态]]
                                    
                                    -- local comfirm = ZCConfirmDialog:createWithParams({
                                    --     msg = string.format(LANGUAGE_RECHARGE.recharge_success, tostring(tonumber(realSaveNum)/10)),
                                    --     showDi = true,
                                    --     leftVisible = false,
                                    --     rightCallback = function()
                                            
                                    --     end
                                    -- })
                                    -- cc.Director:getInstance():getRunningScene():addChild(comfirm, 11)
                                    -- self:getScene():addChild(comfirm, 11)

                                    local postData, chnId, chnType = zc.getSDKParams(_param_, authkey)
                                    local params = {
                                        url = "https://chn-platform.zhanchenggame.com/pay/chntencentpay",
                                        -- url     = "http://192.168.21.34:12360/pay/chntencentpay",
                                        postData = postData,
                                        isGameApi = false,
                                        successCallback = function(backData)
                                            local code = backData.code
                                            if code == 0 then
                                                local comfirm = ZCConfirmDialog:createWithParams({
                                                    msg = string.format(LANGUAGE_RECHARGE.recharge_success2, tostring(addGold), tostring(tonumber(backData.data.balance) / 10)),
                                                    showDi = true,
                                                    leftVisible = false,
                                                    rightCallback = function()
                                                        
                                                    end
                                                })
                                                cc.Director:getInstance():getRunningScene():addChild(comfirm, 11)
                                                -- zc.tipInfo("恭喜您，充值已到账！")
                                            elseif backData.msg then
                                                local _msg = backData.msg == "" and LANGUAGE_RECHARGE.recharge_fail or backData.msg
                                                zc.tipInfo(_msg)
                                            else
                                                zc.tipInfo(LANGUAGE_RECHARGE.recharge_fail)
                                            end
                                        end,
                                        failedCallback = function()
                                            zc.tipInfo(LANGUAGE_RECHARGE.recharge_fail)
                                        end,
                                        targetNeedsToRetain = self,
                                        responseType  = HTTP_RESPONSE_TYPE.JSON,
                                        encrypt = HTTP_ENCRYPT_TYPE.NONE,
                                        -- loadingParent = self,
                                    }
                                    ZCHttp:requestAsyncWithParams(params)
                                end
                                
                                if (cc.PLATFORM_OS_ANDROID == ZC_targetPlatform) then
                                    --[[--此处需要json.encode转换成字符串，否则java端获取到的是null]]
                                    args = { json.encode(args) , callbackLua }
                                else
                                    --[[--再安卓平台上如果传入callbackLua会报json无法序列化的bug，所以此处单独处理]]
                                    args.callback      = callbackLua
                                end
                                local sigs = "(Ljava/lang/String;I)V"
                                zc.luaBridgeCall(LUA_BRIDGE_CLASS,"pay",args,sigs)
                            end
                        })
                        cc.Director:getInstance():getRunningScene():addChild(comfirm, 11)
                        -- self:getScene():addChild(comfirm, 11)
                    end
                    return
                end
                if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD then
                    args.extInfo = backData.data.extInfo or ""
                end
                -- 易接多出一个callBackInfo参数，由后台返回
                if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
                    args.callBackInfo = tostring(backData.data.callBackInfo) or ""   
                end
                local sigs = "(Ljava/lang/String;I)V"
                if (cc.PLATFORM_OS_ANDROID == ZC_targetPlatform) then
                    --[[--此处需要json.encode转换成字符串，否则java端获取到的是null]]
                    if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
                        _addPayFinishNode()
                        local _rechargeFail = function()
                            zc.tipInfo(LANGUAGE_RECHARGE.recharge_fail2)
                            APP_ORDERID = nil
                            xpcall(function()
                                local _scene = cc.Director:getInstance():getRunningScene()
                                if not tolua.isnull(_scene) then
                                    local _node = _scene:getChildByName("PayFinishNode")
                                    if _node then
                                        _node:removeFromParent()
                                    end
                                end
                            end, function() end)
                        end
                        args = { json.encode(args) , callbackLua, _rechargeFail}
                        sigs = "(Ljava/lang/String;II)V"
                    else
                        args = { json.encode(args) , callbackLua }
                    end
                else
                    --[[--再安卓平台上如果传入callbackLua会报json无法序列化的bug，所以此处单独处理]]
                    args.callback      = callbackLua
                end
                zc.luaBridgeCall(LUA_BRIDGE_CLASS, "pay", args, sigs)
            elseif backData.msg then
                local _msg = backData.msg == "" and LANGUAGE_RECHARGE.order_fail or backData.msg
                zc.tipInfo(_msg)
                APP_ORDERID = nil
            else
                zc.tipInfo(LANGUAGE_RECHARGE.order_fail)
                APP_ORDERID = nil
            end
        end,
        failedCallback = function()
            zc.tipInfo(LANGUAGE_RECHARGE.order_fail)
            APP_ORDERID = nil
        end,
        targetNeedsToRetain = self,
        responseType  = HTTP_RESPONSE_TYPE.JSON,
        encrypt = HTTP_ENCRYPT_TYPE.NONE,
        -- loadingParent = self,
    }
    ZCHttp:requestAsyncWithParams(params)
end

function zc.rechargeAppStore( data, backData ,_goodsType)
    local _itemId = tonumber(data.id) or 1
    if _goodsType == 1 or _goodsType == 2 then
        if _itemId == 7 then
            _itemId = 2
        elseif _itemId == 8 then
            _itemId = 3
        end
    else
        _itemId = 0
        local _price = tonumber(data.price) or 0
        if _price == 6 then
            _itemId = 1
        elseif _price == 30 then
            _itemId = 2
        elseif _price == 98 then
            _itemId = 3
        elseif _price == 198 then
            _itemId = 4
        elseif _price == 328 then
            _itemId = 5
        elseif _price == 648 then
            _itemId = 6
        end
    end
    local args = {
        itemId = tostring(_itemId),
        itemName = tostring(data.desc),
        itemPrice = tostring(data.price),
        callbackUrl = tostring(backData.appCallback),
        orderId = tostring(backData.appOrderId),
        -- payType = "alipay",
    }
    if IS_EX_TEST_SERVER then
        -- args.itemPrice = "0.01"
    end
    if GAME_CHANNEL == CHANNEL.IOS.CHANNEL_CODE_APPSTORE
      or GAME_CHANNEL == CHANNEL.IOS.CHANNEL_CODE_APPSTORE_QLWZ then
        if data.isAliPay then
            args.payType = "alipay"
        elseif data.isWeixin then
            args.payType = "weixin"
        end
    elseif GAME_SDK == GAMESDK.SDK_ZHANYOU then
         --用于内网包android的充值类型(枚举)，GOOGLEPLAY(google充值)、ZGamePay(展游充值)、MyCard、WechatPay
        if data.isWeixin then
            args.payType = "WechatPay"
        else
            if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_AD_MYCARD then
                args.payType = "MyCard"
            elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_AD_GOOGLE then
                args.payType = "Google"
            else
                args.payType = "ZGamePay"
            end
        end
    end

    APP_ORDERID = tostring(backData.appOrderId)
    local _rechargeSuccess = function()
        zc.doActionStatisticsEvent(StatisticsEvent.EVENT_PURCHASE, args.itemPrice)
        zc.doPayFinish({id=data.id, appOrderId = tostring(backData.appOrderId)})
    end
    local _rechargeFail = function()
        zc.tipInfo(LANGUAGE_RECHARGE.recharge_fail2)
        APP_ORDERID = nil
        xpcall(function()
            local _scene = cc.Director:getInstance():getRunningScene()
            if not tolua.isnull(_scene) then
                local _node = _scene:getChildByName("PayFinishNode")
                if _node then
                    _node:removeFromParent()
                end
            end
        end, function() end)
    end

    local function _addPayFinishNode()
        local _scene = cc.Director:getInstance():getRunningScene()
        if not tolua.isnull(_scene) then
            local _node = ZCDialog:create(255*0.3)
            _node:setName("PayFinishNode")
            _scene:addChild(_node)
            performWithDelay(_node, function()
                _node:removeFromParent()
            end, 30)
        end
    end
    
    local sigs = "(Ljava/lang/String;I)V"
    if (cc.PLATFORM_OS_ANDROID == ZC_targetPlatform) then
        --[[--此处需要json.encode转换成字符串，否则java端获取到的是null]]
        _addPayFinishNode()
        args = { json.encode(args) , _rechargeSuccess, _rechargeFail}
        sigs = "(Ljava/lang/String;II)V"
    else
        _addPayFinishNode()
        --[[--再安卓平台上如果传入callbackLua会报json无法序列化的bug，所以此处单独处理]]
        args.callback = _rechargeSuccess
        args.fallCallback = _rechargeFail
    end

    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"pay", args, sigs)
end

function zc.doActionStatisticsEvent( event, num )
    if not zc.isGt() then
        return
    end
    local sigs = "(Ljava/lang/String;)V"
    local args = {
        eventname = event,
        num = tostring(num),
    }
    if (cc.PLATFORM_OS_ANDROID == ZC_targetPlatform) then
        args = { json.encode(args) }
    end
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"customEventWithHash", args, sigs)
end

function zc.isGt()
    local _packageId = zc.getChannelPackageId()
    if _packageId == 10 or _packageId == 11 then
        return true
    end
    return false
end

function zc.getGtMoneyFlag()
    return zc.isGt() == true and "$" or "￥"
end

function zc.getActivityGtChangeTest( text )
    local _text = string.split(text or "", "$_$")
    if zc.isGt() then
        _text = _text[2] or _text[1]
    else
        _text = _text[1]
    end
    return _text
end

function zc.changeGtMoney( price )
    if not zc.isGt() then
        return price
    end
    local _price = tonumber(price)
    if not _price then
        return price
    end
    if _price == 6 then
        return 0.99
    elseif _price == 30 then
        return 4.99
    elseif _price == 98 then
        return 14.99
    elseif _price == 198 then
        return 29.99
    elseif _price == 328 then
        return 49.99
    elseif _price == 648 then
        return 99.99
    end
    return _price
end

function zc.getActivity17AddInfo( id, infoTab )
    local _info = PlayerData:getActivityInfoById(17)
    if next(_info) ~= nil  and _info.staticTable and _info.staticTable[tostring(id)] then
        local _drop = _info.staticTable[tostring(id)].dropItem
        local _infos = string.split(_drop or "", ",")
        if #_infos > 0 then
            for i=#_infos, 1, -1 do
                local __info = string.split(_infos[i] or "", "|")
                if tonumber(__info[1]) and tonumber(__info[2]) and tonumber(__info[3]) then
                    table.insert(infoTab, 1, {
                        itemType = tonumber(__info[1]),
                        itemId = tonumber(__info[2]),
                        itemNum = tonumber(__info[3]),
                    })
                end
            end
        end
        return infoTab
    end
    return infoTab
end
--创建分享按钮
function zc.createShareBtn(isPop, info)
    local width = cc.Director:getInstance():getWinSize().width
    local height = cc.Director:getInstance():getWinSize().height
    local btn_normal = cc.Sprite:create("res/Main/share/btn_share_n.png")
    local btn_selected = cc.Sprite:create("res/Main/share/btn_share_s.png")
    -- zc.setGray(btn_disable)
    local shareBtn = zc.createPushButton({
        normalFile = "res/Main/share/btn_share_n.png",
        selectedFile = "res/Main/share/btn_share_s.png",
        pos = cc.p(width - 50, 50),
        endCallback = function ()
            -- zc.captureScreenToShare({_isPop = isPop, _info = info, _btn = shareBtn})
        end
    })
    if info == nil then
        info = {
            ["subType"] = 4,
            ["reward"] = "1|1|100",
            ["type"] = 1,
            ["id"] = 1,
            ["desc"] = "首次获得A将",
        }
    end
    
    local reward = info.reward or ""
    local tbreward = string.split(reward, "|")
    local rewardBg = zc.createSprite("res/Main/share/qipao_di.png")
    rewardBg:setScale(0.6)
    rewardBg:setPosition(cc.p(-15, 110))
    shareBtn:addChild(rewardBg)
    local labelTxt = zc.createLabel({
        text = zc.lang("reward"),
        color = cc.c3b(115, 41, 12),
        ap = cc.p(0.5, 1),
        fontSize = 22,
        pos = cc.p(rewardBg:getPositionX() , rewardBg:getPositionY() + 30),
        })
    shareBtn:addChild(labelTxt)
    local num = tbreward[3]
    local numlabel = zc.createLabel({
        text = num,
        outLine = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(labelTxt:getPositionX() - 50, labelTxt:getPositionY() - 40),
        })
    shareBtn:addChild(numlabel)
    local iconGold = zc.createSprite("res/Main/common/common_icon_gold.png")
    iconGold:setAnchorPoint(cc.p(0, 0.5))
    iconGold:setPosition(cc.p(numlabel:getPositionX() + numlabel:getContentSize().width + 5, numlabel:getPositionY()))
    shareBtn:addChild(iconGold)
    shareBtn:setTouchEndedCall(function ( )
        zc.captureScreenToShare({_isPop = isPop, _info = info, _btn = shareBtn})
    end)
    return shareBtn
end
-- 分享功能
function zc.captureScreenToShare(params)
    local params = params or {}
    if params._btn then
        params._btn:setVisible(false)
    end
    -- print("-------------------")
    -- print(type(params._btn))
    cc.Director:getInstance():getTextureCache():removeTextureForKey("share1.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("share2.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("share3.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("share4.png")
    local function writeImage(path,name)

        local function write(path,name)
            local spr = cc.Sprite:create(path)
            local size = spr:getContentSize()
            local render = cc.RenderTexture:create(size.width, size.height)
            spr:setPosition(cc.p(size.width/2, size.height/2))
            render:begin()
            spr:visit()
            render:endToLua()
            render:saveToFile(name, cc.IMAGE_FORMAT_PNG)          --写到文件
        end

        local writablePath = cc.FileUtils:getInstance():getWritablePath()
        write(path,name)
        return writablePath.."/"..name
    end

    local function writeLabel(text)
        local spr = zc.createLabel({
            text = text,
            pos = cc.p(zc.width/2, zc.height/2),
            size = 18,
            color = cc.c3b(159,141,90)
        })
        local size = spr:getContentSize()
        local render = cc.RenderTexture:create(size.width, size.height)
        spr:setPosition(cc.p(size.width/2, size.height/2))
        render:begin()
        spr:visit()
        render:endToLua()
        render:saveToFile("share4.png", cc.IMAGE_FORMAT_PNG)
        local writablePath = cc.FileUtils:getInstance():getWritablePath()
        return writablePath.."/".."share4.png"
    end
    local _src = "res/Main/share/share.jpg"
    if zc.isGt() then
        _src = "res/Main/share/share_gt.jpg"
    end
    local path1 = writeImage("res/Main/share/share.jpg","share1.png")
    local path2 = writeImage("res/Main/share/Qrcode.png","share2.png")
    --此处内容需要获取当前的实际数据
    local nickName = tostring(PlayerData["info"]["userName"])
    local serverName = tostring(PlayerData["serverInfo"]["serverName"])
    local path4 = writeLabel(zc.lang("share_part_1")..serverName .. "   ID  "..nickName.."  "..zc.lang("share_part_2"))

    local function afterCaptured(succeed, outputFile)
        if succeed then
            print("Capture screen success outputFile is "..outputFile)
            params.imageURL1 = path1
            params.imageURL2 = path2
            params.imageURL3 = outputFile
            params.imageURL4 = path4
            if params._btn then
                params._btn:setVisible(true)
            end
            --创建弹窗
            zc.createSourcePop("SharePopLayer", "src/layer/share/SharePopLayer.lua",params)
        else
            if params._btn then
                params._btn:setVisible(true)
            end
            print("Capture screen failed.")
        end
    end

    cc.utils:captureScreen(afterCaptured, "share3.png")
end
-- 获得分享item的数据
function zc.getShareItemInfo(type, subType, isZizhi)
    local heroType = tonumber(type)
    local shareData = gameData.getAllDataWithNoClone("share")
    -- dump(PlayerData.shareReceived, "test ---- shareReceived:")
    local function checkV( v )
        -- 判断如果已经领取了PlayerData.shareReceived中的Id则不用进入
        for _,vvvv in pairs(PlayerData.shareReceived) do
            if tonumber(vvvv) == tonumber(v.id) then
                -- print("id相同了，返回nil")
                return nil
            end
        end
        return v
    end
    for k,v in pairs(shareData) do
        local t_type = v.type
        local subTypes = tostring(v.subType)
        local tbSubType = string.split(subTypes, ",")
        -- dump(tbSubType, "tbsubType:")
        -- print("传入的subType:"..subType)
        if tonumber(t_type) == heroType then
            -- print("type相等"..heroType..":"..t_type)
            for k1,v1 in pairs(tbSubType) do
                if isZizhi and tonumber(subType) >= tonumber(v1) then
                    -- dump(v, "返回的分享内容资质 :")
                    return checkV(v)
                end
                if tonumber(subType) == tonumber(v1) then
                    -- dump(v, "返回的分享内容 :")
                    return checkV(v)
                end     
            end
        end
    end
    return nil
end

-- 战神殿英雄切图
function zc.createBattleShrineHead( params )
    local pic = zc.createSprite()
    local clippNode = cc.ClippingNode:create()
    clippNode:setInverted(false)
    clippNode:setAlphaThreshold(0.5)
    pic:addChild(clippNode)
    local template = zc.createSprite("res/hehe.png")--模板
    clippNode:setStencil(template)
    local content = zc.createSprite("res/1.png")--底板
    clippNode:addChild(content)
    template:setPosition(cc.p(35, 70))
    return pic 
end

function zc.createHeroSoulSpine( params )
    local _params = params or {}
    local _node = _params.spine
    if not _node then
        _node = zc.createSpine({
            fileName = "hundenglong",
            needInit = false,
        })
        if _params.par then
            _params.par:addChild(_node)
        end
    end

    if _params.quality then
        _quality = zc.getQualityByQualifications(_params.quality)
        _node:playAction(_quality, true)
    end

    if _params.pos then
        _node:setPosition(_params.pos)
    end

    if _params.iconId then
        local _iconId = tonumber(_params.iconId) or 1
        local _slotName = ""
        for i=1, 11 do
            _slotName = "zitipifu/zi_" .. i
            if i == _iconId then
                _node:setAttachment(_slotName, _slotName)
            else
                _node:setAttachment(_slotName, "")
            end
        end
    end

    if _params.scale then
        local _scale = tonumber(_params.scale) or 1
        _node:setScale(_scale)
    end

    return _node
end