--[[
-- 售出确认界面 
-- 饰品及其单件物品的售出确,洗练确认
-- @author lph
-- Creation  2015-12-15
]]

local sellConfirmOtherPop = class("sellConfirmOtherPop",function()
	return ZCPopLayer:create()
end);

function sellConfirmOtherPop:create(data)
    -- dump(data.info )
    local layer = sellConfirmOtherPop.new(data)
    layer:show()
    return layer
end

function sellConfirmOtherPop:ctor(data)
    self._title = data.title or "chushou"
    self._info = data.info--物品信息
    self._info_now = data.info_now
    self._leftBtnText = data.leftBtnText or zc.lang("cancel")
    self._rightBtnText = data.rightBtnText or zc.lang("confirm")
    self._leftFunc = data.leftFunc or nil
    self._rightFunc = data.rightFunc or nil

    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2, zc.height/2 - 50),
    })
    self:addContent(bg)
    local _bgSize = bg:getContentSize()

    local bg_s = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    bg_s:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(bg_s)

    local title = zc.getTipPopTitle( self._title )
    title:setPosition( _bgSize.width*0.5, _bgSize.height - 30 )
    bg:addChild(title)

    if data.title == "chushou" then
	   self:initUI(bg, bg_s)
    elseif data.title == "yijianchushou" then
        self:initUI_2(bg, bg_s)
    elseif data.title == zc.lang("xilian_finish") then
       self:initUI_3(bg, bg_s)
    end
end
--出售确认
function sellConfirmOtherPop:initUI(bg, bg_s)
    --道具
	local item = zc.createIconByData({
        data = {
            type = 1, 
            id = self._info.id,
            hideCount = true,
            mainType = 9,
            quality = self._info.color,
        }, 
        pos = cc.p(bg:getBoundingBox().width/2, bg:getBoundingBox().height/2+30), 
    })
    item:setScale(0.75)
    bg:addChild(item)

    --获得金币
    local get1 = zc.createLabel({
        text = zc.lang("sell_can_gain")..":",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(160, item:getPositionY() - 80),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild(get1)
    local getImg = zc.getSprite({
        src = "res/Main/common/common_icon_money.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(get1:getPositionX() + get1:getContentSize().width + 2, get1:getPositionY())
    })
    bg:addChild(getImg)
    local get2 = zc.createLabel({
        text = tonumber(self._info["price"]),
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(getImg:getPositionX() + getImg:getContentSize().width + 2, get1:getPositionY()),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    bg:addChild(get2)
    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width - 130, 70), 
        text = self._rightBtnText,
        endCallback = function () 
            if self._rightFunc then 
                self._rightFunc()   
            end
            self:hide()
        end,
    })
    bg:addChild(useBtn)
    --取消按钮
    local cancelBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(130, 70), 
        text = self._leftBtnText,
        endCallback = function () 
            if self._leftFunc then 
                self._leftFunc()
            end
            self:hide()
        end,
    })
    bg:addChild(cancelBtn)
end

--一键出售
function sellConfirmOtherPop:initUI_2(bg, bg_s)
    --多选框
    self._chooseBox_list = {}
    local _width,_height = 100,20
    for i=1,5 do
        if i <= 2 then
            _height = 150
        elseif i <= 4 then
            _height = 100
        else
            _height = 50
        end
        if i%2 == 0 then
            _width = 300
        else
            _width = 120
        end
        
        local _selectedImg = zc.createImageView({
            src = "res/Main/common/check.png",
            pos = cc.p(20, 20),
        })
        _selectedImg:setVisible(false)
        local sellchooseBtn = zc.createPushButton({
            normalFile = "res/Main/ornaments/trinket_sellchoose_box.png",
            selectedFile = "res/Main/ornaments/trinket_sellchoose_box.png",
            pos = cc.p(_width, _height), 
            endCallback = function () 
                if _selectedImg:isVisible() then
                    _selectedImg:setVisible(false)
                else
                    _selectedImg:setVisible(true)
                end
            end,
        })
        bg_s:addChild(sellchooseBtn)
        sellchooseBtn:addChild(_selectedImg)
        local _trinketType = zc.createLabel({
            text = LANGUAGE_getTipColorNameByType(i),
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(60, 16),
            outLine = true,
            pixel = 1.5,
            color = zc.getColorByQuality( i ),
        })
        sellchooseBtn:addChild(_trinketType)
        table.insert(self._chooseBox_list,_selectedImg)
    end

    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width - 130, 70), 
        text = self._rightBtnText,
        endCallback = function () 
            self:sureOneKeySell()
        end,
    })
    bg:addChild(useBtn)
    --取消按钮
    local cancelBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(130, 70), 
        text = self._leftBtnText,
        endCallback = function () 
            if self._leftFunc then 
                self._leftFunc()
            end
            self:hide()
        end,
    })
    bg:addChild(cancelBtn)
end
--确认一键出售
function sellConfirmOtherPop:sureOneKeySell()
    self:updateSellTrinketList()
    --info :1|2|3,1|2|3 // 出售物品信息(物品类型|主键id|数量,物品类型|主键id|数量)
    local selldata = ""
    local _nums = #self.sellTrinketList
    if _nums > 0 then
        for k,v in pairs(self.sellTrinketList) do
            if k == _nums then
                selldata = selldata .. string.format("9|%s|1",v.id) 
            else
                selldata = selldata .. string.format("9|%s|1,",v.id)
            end
        end
        zc.sendHttp({
            apiName ="Bag_sell",
            params = {info = selldata},
            successCallback = function (data)
                --卖出成功-- 增加银币
                PlayerData:updataData(data)
                for k,v in pairs(self.sellTrinketList) do
                    PlayerData:subTrinketsInfo(v.id)
                end
                if self._rightFunc then 
                    self._rightFunc()
                    self:hide()
                end
        end})
    else
        zc.tipInfo(zc.lang("tips_no_trinkets_sell"))
    end
end

--洗炼成功确认
function sellConfirmOtherPop:initUI_3(bg, bg_s)
    local _revoke_replaceAttr_price = "20" 
    local _data = gameData.getDataFromCache("consume_price", {type = 10})
    if next(_data) ~= nil then
        _revoke_replaceAttr_price = _data.price
    end

    --原属性
    local oldAttr_name = zc.createLabel({
        text = zc.lang("origin_property"),
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(100, 70),
        shadow = true,
        -- color = zc.getColorByQuality(self._info[_str_effectColor]),
    })
    bg_s:addChild(oldAttr_name)
    local oldAttr = zc.lang("empty")
    local _str_effectId = "effectId" .. self._info_now.index
    local _str_effectValue = "effectValue" .. self._info_now.index
    local _str_effectColor = "effectColor" .. self._info_now.index
    if tonumber(self._info[_str_effectId]) == 0 then 
        oldAttr = zc.lang("empty") 
    else
        oldAttr = zc.getEquipAttriNameByEffectType(self._info[_str_effectId])..":".. self._info[_str_effectValue]
    end
    
    local oldAttr = zc.createLabel({
        text = oldAttr,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(100, 40),
        shadow = true,
        color = zc.getColorByQuality(self._info[_str_effectColor]),
    })
    bg_s:addChild(oldAttr)
    --新属性
    local newAttr_name = zc.createLabel({
        text = zc.lang("new_property"),
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(300, 70),
        shadow = true,
        color = zc.getColorByQuality(self._info_now.effectColor),
    })
    bg_s:addChild(newAttr_name)
    local newAttr = zc.createLabel({
        text = zc.getEquipAttriNameByEffectType(self._info_now.effectId).. ":" .. self._info_now.effectValue,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(300, 40),
        shadow = true,
        color = zc.getColorByQuality(self._info_now.effectColor),
    })
    bg_s:addChild(newAttr)

    --撤销消耗元宝背景
    local _gold_bg = zc.createImageView({
        src = "res/Main/copy/copy_di.png",
        pos = cc.p(bg:getBoundingBox().width/2-130, 90)
    })
    bg:addChild(_gold_bg)
    
    --元宝icon
    local _gold_icon = zc.createImageView({
        src = "res/Main/common/common_icon_gold.png",
        pos = cc.p(20, 10)
    })
    _gold_bg:addChild(_gold_icon)
    --洗炼撤销所需元宝
    local _need_gold = zc.createLabel({
        text = tostring(_revoke_replaceAttr_price),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(60, 10),
        --color = display.COLOR_BROWN,
    })
    _gold_bg:addChild(_need_gold)

    self._revokeEnable = tonumber(PlayerData:getResourcesInfo()["gold"]) >= tonumber(_revoke_replaceAttr_price)
   

    --完成按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width - 100, 50), 
        text = zc.lang("finish"),
        endCallback = function () 
            if self._rightFunc then 
                self._rightFunc()
            end
            self:hide()
        end,
    })
    bg:addChild(useBtn)
    self._guideBtn = useBtn
    --撤销按钮
    local cancelBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(100, 50), 
        text = zc.lang("revoke"),
        endCallback = function () 
            if self._leftFunc then 
                self._leftFunc()
            end
            self:hide()
        end,
    })
    bg:addChild(cancelBtn)
    cancelBtn:setEnable(self._revokeEnable)
end

--卖出数组
function sellConfirmOtherPop:updateSellTrinketList(index)
    self.sellTrinketList = {}
    self.bagTrinketsList = {}
    self.trinketsInfo = PlayerData:getTrinketsInfo()
    for k,v in pairs(self.trinketsInfo) do
        if tonumber(v.status) == 0 then 
            table.insert(self.bagTrinketsList,v)
        end
    end
    for k,v in pairs(self._chooseBox_list) do
        if v:isVisible() then
            for _k,_v in pairs(self.bagTrinketsList) do
                if tonumber(_v.color) == k then
                    table.insert(self.sellTrinketList,_v)
                end
            end
        end
    end
end

return sellConfirmOtherPop